#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
from __future__ import division
#   import                                  sys
import                                      os
from Cookie import                          _getdate
from Cookie import SimpleCookie as          _Cookie
from Cookie import Morsel as                _Morsel
#-----------------------------------------------------------------------------------------------------------
_Misfit                                     = lambda:None

############################################################################################################
#
#
#
#===========================================================================================================
class EzCookie( _Cookie ):

    #-------------------------------------------------------------------------------------------------------
    secondsPerMinute                        = 60
    secondsPerHour                          = 3600
    secondsPerDay                           = 86400
    secondsPerWeek                          = 604800
    secondsPerMonth                         = 2592000
    secondsPerYear                          = 31557600
    #-------------------------------------------------------------------------------------------------------
    domain                                  = 'localhost'
    path                                    = '/'
    pathhint                                = '/configtool'
    maxage                                  = 2 * secondsPerWeek

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, domain = None, path = None, maxage = None, input = None ):
        _Cookie.__init__( self, input )
        if domain   is not None: self.domain = domain
        if path     is not None: self.path   = path
        if maxage   is not None: self.maxage = maxage

    #-------------------------------------------------------------------------------------------------------
    def __setitem__( self, name, value ):
        _Cookie.__setitem__( self, name, value )
        morsel = _Cookie.__getitem__( self, name )
        self._setMorselDefaults( morsel )

    #-------------------------------------------------------------------------------------------------------
    def _BaseCookie__set(self, key, real_value, coded_value):
        """Private method for setting a cookie's value. This hacks the standard library's
        ``Cookie.BaseCookie.__set()`` method by adding default values for the morsel defaults. Result is
        that each ``Set-Cookie`` line printed to HTTP headers will contain all of ``max-age``, ``expires``,
        ``domain``, and ``path``."""
        Misfit = lambda:None
        morsel = self.get( key, Misfit )
        if morsel is Misfit:
            morsel = _Morsel()
        morsel.set( key, real_value, coded_value )
        self._setMorselDefaults( morsel )
        dict.__setitem__( self, key, morsel )

    #-------------------------------------------------------------------------------------------------------
    def _setMorselDefaults( self, morsel ):
        morsel[ 'max-age' ] = morsel[ 'expires' ] = self.maxage
        #morsel[ 'domain'  ] = self.domain
        #morsel[ 'path'    ] = self.path

    #-------------------------------------------------------------------------------------------------------
    def setMorselMaxage( self, name, value ):
        morsel = self[ name ]
        morsel[ 'max-age' ] = morsel[ 'expires' ] = value

    #-------------------------------------------------------------------------------------------------------
    def setMorselDomain( self, name, value ):
        morsel = self[ name ]
        morsel[ 'domain' ] = value

    #-------------------------------------------------------------------------------------------------------
    def setMorselPath( self, name, value ):
        morsel = self[ name ]
        morsel[ 'path' ] = value

    #-------------------------------------------------------------------------------------------------------
    def guessPathAndDomain( self ):
        self.domain = os.environ.get( 'SERVER_NAME', 'localhost' )
        path = os.environ.get( 'REQUEST_URI', '/' )
        #print path
        path = path.split( '?', 1 )[ 0 ]
        _p = path.find( self.pathhint )
        if _p > 0: path = path[ : _p + len( self.pathhint ) ]
        #print path
        self.path = path

    #-------------------------------------------------------------------------------------------------------
    def getvalue( self, name, default = _Misfit, convert = None ):
        R = self.get( name, default )
        if R is _Misfit:
            raise KeyError( ''
                "Unknown key: %r." % ( name, )
                )
        if isinstance( R, _Morsel ):
            R = R.value
        if convert is not None:
            try:
                R = convert( R )
            except:
                if default is _Misfit:
                    raise ValueError( ''
                        +   "Inconvertible cookie value %r; no default set." % ( R, )
                        )
                R = default
        return R

    #-------------------------------------------------------------------------------------------------------
    def getint( self, name, default ):
        return self.getvalue( name, default, int )

    #-------------------------------------------------------------------------------------------------------
    def getMetaTags( self ):
        X = g.configtool.utilities.XmlMaker.XmlMaker()
        R = []
        for name in self.iterkeys():
            value   = self.getvalue( name )
            morsel  = self[ name ]
            expires = _getdate( morsel[ 'expires' ] )
            maxage  = morsel[ 'max-age' ]
            path    = morsel[ 'path' ]
            content = '%(name)s=%(value)s;Expires=%(expires)s;Max-Age=%(maxage)s;Path=%(path)s' % vars()
            R.append( X.meta( http_equiv='Set-Cookie', content = content ) )
        return R

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys
    sys.setrecursionlimit(50)

    sep0                                    = '#' * 108
    sep1                                    = '=' * 108
    sep2                                    = '-' * 108

    print sep1
    print 'secondsPerMinute     =',      60
    print 'secondsPerHour       =',      60 * 60
    print 'secondsPerDay        =',      60 * 60 * 24
    print 'secondsPerWeek       =',      60 * 60 * 24 * 7
    print 'secondsPerMonth      =',      60 * 60 * 24 * 30
    print 'secondsPerYear       =', int( 60 * 60 * 24 * 365.25 )

    print sep0
    c = _Cookie()
    c[ 'foo' ] = 'bar'
    c[ 'blah' ] = 'oops'
    c[ 'foo' ][ 'max-age' ] =  c[ 'foo' ][ 'expires' ] = EzCookie.maxage
    print c

    print sep0
    c = EzCookie( 'example.com', '/' )
    c[ 'foo' ] = 'bar'
    c[ 'blah' ] = 'oops'
    #c[ 'foo' ][ 'max-age' ] =  c[ 'foo' ][ 'expires' ] = dt
    print c

    print sep0
    c = EzCookie( input = 'HTTP_COOKIE: fig=newton; sugar=wafer;' )
    print c

    print sep0
    c = EzCookie()
    c.maxage = c.secondsPerYear
    c.domain = 'foo.com'
    c.path = '/path/to/wherever'

    c.load( 'HTTP_COOKIE: fig=newton; sugar=wafer;' )
    c.setMorselMaxage( 'fig', 0 )
    print c

    print sep0
    c = EzCookie()
    c.load( '' )
    print c

    print sep0
    c = EzCookie()
    os.environ[ 'REQUEST_URI' ] = '/foo/unknown/biocase/configtool/whatever?x=9'
    os.environ[ 'SERVER_NAME' ] = 'www.mission-impossible.com'
    c.guessPathAndDomain()
    c.load( 'HTTP_COOKIE: fig=newton; sugar=wafer; count=45' )
    print c.getvalue( 'fig', 'unknown value' )
    print c.getvalue( 'neverset', 'unknown value' )
    print c.getvalue( 'neverset', 1088, lambda x: int( x ) )
    try:                    print c.getvalue( 'neverset', convert = lambda x: int( x ) )
    except Exception, e:    print '(%s) %s' % ( e.__class__, e, )
    try:                    print c.getvalue( 'count', convert = lambda x: int( x ) )
    except Exception, e:    print '(%s) %s' % ( e.__class__, e, )
    print c.getint( 'count', 0 )
    print c.getint( 'neverset', 0 )
    #print dir( _Cookie )

    c[ 'difficult' ] = 'xxx'
    name = 'difficult'
    value   = c.getvalue( name )
    morsel  = c[ name ]
    expires = _getdate( morsel[ 'expires' ] )
    maxage  = morsel[ 'max-age' ]
    path    = morsel[ 'path' ]
    content = '%(name)s=%(value)s;Expires=%(expires)s;Max-Age=%(maxage)s;Path=%(path)s' % vars()

    X = g.configtool.utilities.XmlMaker.XmlMaker()
    print X.meta( http_equiv='Set-Cookie', content = content )






