#
# -*- coding: utf-8 -*-


"""




"""



############################################################################################################
#
#   FUNDAMENTALS ENABLER
#
#===========================================================================================================
try:                g
except NameError:   import _biocaseFundamentalsCaller

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
import sys
import warnings
import re
import urllib
#-----------------------------------------------------------------------------------------------------------
publish                                 = g.publish
#-----------------------------------------------------------------------------------------------------------
internalencoding                        = g.cfg.internalencoding
outputencoding                          = g.cfg.outputencoding
#-----------------------------------------------------------------------------------------------------------


############################################################################################################
#
#
#
#===========================================================================================================
class _Uunquote( object ):

    jsQuerystringUnicodeLiteralRxPattern = '%u([0-9a-fA-F]{4})'
    jsQuerystringUnicodeLiteralRx = re.compile( jsQuerystringUnicodeLiteralRxPattern )

    #-------------------------------------------------------------------------------------------------------
    def f( this, mo ):
        """Callback function for regular expression replacement of JavaScript ``%uXXXX`` style Unicode
        literals in HTTP querystrings."""
        hexliteral = mo.group( 1 )
        return unichr( int( hexliteral, 16 ) )
    _unquoteJavascriptUnicodeEscapes = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, querystring ):
        return this.jsQuerystringUnicodeLiteralRx.sub(
            this._unquoteJavascriptUnicodeEscapes, urllib.unquote( querystring ) )
    uunquote = classmethod( f ); del f

#-----------------------------------------------------------------------------------------------------------
def uunquote( querystring ):
    return _Uunquote.uunquote( querystring )

############################################################################################################
#
#
#
#===========================================================================================================
def E( obj, encoding = None ):
    """(to be written)"""
    #-------------------------------------------------------------------------------------------------------
    if isinstance( obj, str ):
        return obj
    #-------------------------------------------------------------------------------------------------------
    if not isinstance( obj, unicode ):
        return E( unicode( obj ), encoding )
    #-------------------------------------------------------------------------------------------------------
    if encoding is None:
        encoding = internalencoding
    #-------------------------------------------------------------------------------------------------------
    try:
        return obj.encode( encoding, 'strict' )
    #-------------------------------------------------------------------------------------------------------
    except UnicodeEncodeError, e:
        R = obj.encode( encoding, 'replace' )
        msg = _getWarnMsg( R, obj, encoding )
        warnings.warn( msg )
        return R

#===========================================================================================================
def EC( obj, encoding = None ):
    """(to be written)"""
    if not isinstance( obj, basestring ):
        return obj
    return E( obj, encoding )

#===========================================================================================================
def UC( obj, encoding = None ):
    """(to be written)"""
    if not isinstance( obj, basestring ):
        return obj
    return U( obj, encoding )

#===========================================================================================================
def U( obj, encoding = None ):
    """If ``obj`` is a ``unicode`` object, return it as-is. If it is not an instance of ``basestring``,
    return the application of the built-in function ``unicode`` to it. Otherise, assuming it must be an
    octet sequence, return the application of the string method ``~.decode(encoding)``, where ``encoding``,
    if not given in the function call, defaults to the global symbol ``internalencoding``."""
    #-------------------------------------------------------------------------------------------------------
    if isinstance( obj, unicode ):
        return obj
    #-------------------------------------------------------------------------------------------------------
    if not isinstance( obj, basestring ):
        return unicode( obj )
#           try: ###DEBUG###
#               return unicode( obj ) ###DEBUG###
#           except UnicodeDecodeError: ###DEBUG###
#               return '((%s)%s)' % ( outputencoding, `obj`, ) ###DEBUG###
    #-------------------------------------------------------------------------------------------------------
    if encoding is None:
        encoding = internalencoding
    #-------------------------------------------------------------------------------------------------------
    try:
        return obj.decode( encoding, 'strict' )
    #-------------------------------------------------------------------------------------------------------
    except UnicodeDecodeError, e:
        R = obj.decode( encoding, 'replace' )
        msg = _getWarnMsg( R, obj, encoding )
        warnings.warn( msg )
        return R


#   #===========================================================================================================
#   def jsU( text ):
#       """This is the first throw at a method to include a unicode string in JavaScript source text. Since
#       Python and JavaScript share a lot of conventions about strings, it is possible to go a long way with
#       little code. However, not all strings converted by this function are guranteed to be legal JavaScript
#       string constants."""
#       #assert isinstance( text, unicode )
#       text = U( text )
#       return `text`[1:]

#===========================================================================================================
class jsU( unicode ):

    def __str__( self ):
        return self.__repr__()

    def __unicode__( self ):
        return self.__repr__()

    def __repr__( self ):
        return super( jsU, self ).__repr__()[1:]

#       def encode( self, encoding ):
#           return self.__repr__()


#===========================================================================================================
def jsUC( obj, quote = None ):
    """Similar to ``jsU()``, but delivering representations of everything except basestring instances
    without surrounding quotes, in the hope that would be legal JavaScript literals (which is true in the
    case of (many) numbers)."""
    #assert isinstance( obj, unicode )
    R = `U( obj )`[ 1 : ]
    if not isinstance( obj, basestring ):
        R = R[ 1 : -1 ]
    elif quote is not None:
        R = R[ 1 : -1 ]
        R = '%s%s%s' % ( quote, R, quote, )
    return R

#===========================================================================================================
def iterableJsU( iterable ):
    """Produces a string that may be interpolated into a JavaScript source text and yields a (hopefully)
    correct representation of a Javascript list literal."""
    return '[%s]' % ( ', '.join( [ jsUC( x ) for x in iterable ] ) )

#===========================================================================================================
def UC( obj, encoding = None ):
    """(to be written)"""
    if not isinstance( obj, basestring ):
        return obj
    return U( obj, encoding )

#===========================================================================================================
def Eout( obj ):
    return E( obj, outputencoding )

#===========================================================================================================
def _getWarnMsg( rendering, obj, encoding ):
    obj = '%r' % ( obj, )
    rendering = '%r' % ( rendering, )
    if len( obj ) > 100: obj = obj[:90] + '...'
    if len( rendering ) > 100: rendering = rendering[:90] + '...'
    msg = '\n'.join((
        "Detected problem with encoding %(obj)s as %(rendering)s using %(encoding)r." % vars(),
        "===IMAGINE STACKTRACE HERE===." ))
    return msg


############################################################################################################
#
#   GUARDIANS OF THE UNICODE-REVOLUTION
#
#===========================================================================================================
def _getNanasWarningMsg( x ):
    if len( x ) > 255:
        x = x[ : 255 ]
        ellipsis = '[...]'
    else:
        ellipsis = ''
    return "This string contains non-us-ascii characters: %r%s." % ( x, ellipsis, )

#-----------------------------------------------------------------------------------------------------------
def notANonAsciiString( x ):
    if not isinstance( x, str ):
        return False
    try:
        x.decode( 'us-ascii' )
    except UnicodeDecodeError:
        return True
    return False

#-----------------------------------------------------------------------------------------------------------
def assertNotANonAsciiString( x ):
    if notANonAsciiString( x ):
        raise UnicodeError( _getNanasWarningMsg( x ) )

#-----------------------------------------------------------------------------------------------------------
def warnNonAsciiString( x ):
    if notANonAsciiString( x ):
        warnings.warn( _getNanasWarningMsg( x ) )

#-----------------------------------------------------------------------------------------------------------
nanaS       = notANonAsciiString
ananaS      = assertNotANonAsciiString
warnaS      = warnNonAsciiString


#   ############################################################################################################
#   #
#   #
#   #
#   #===========================================================================================================
#   publish( 'internalencoding',    internalencoding )
#   publish( 'outputencoding',      outputencoding )
#   publish( 'E',                   E )
#   publish( 'EC',                  EC )
#   publish( 'U',                   U )
#   publish( 'UC',                  UC )


############################################################################################################
#
#
#
#===========================================================================================================
def iounicode( x ):
    try:
        return unicode( x ).encode( encoding )
    except UnicodeDecodeError:
        print `x`

############################################################################################################
#
#   UNICODE-AWARE OBJECT DISPLAY
#
#===========================================================================================================
class ReprMx( object ):
    """Unicode-aware pretty printer. Consumers only define a ``~.__unicode__()`` method that returns a
    Unicode string with the desired image; the methods ``~.__repr__()`` and ``~.str()`` are taken care of by
    this mix-in."""

    #-------------------------------------------------------------------------------------------------------
    def __repr__( self ):
        """Return string as returned by ``~.__unicode__()``, but without the leading ``u`` and without the
        surrounding quotes."""
        R = repr( self.__unicode__() )
        if R.startswith( 'u' ): R = R[1:]
        return R[1:-1]

    #-------------------------------------------------------------------------------------------------------
    def __str__( self ):
        return self.__unicode__().encode( outputencoding )
        #return '%s%s' % ( outputencoding, self.__unicode__().encode( outputencoding, 'replace' ), ) ###DEBUG###
        #return u'ä'.encode( outputencoding )

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        return '<%s instance @ %s>' % ( str( self.__class__ )[ 1 : -1 ], id( self ), )

    #-------------------------------------------------------------------------------------------------------
    def __getstate__( self ):
        """Method to make instances ``pickle``\ able."""
        return self.__dict__
#           R = {}
#           for name in 'name', 'nodes', 'grove', '_nodesByMraNameCache', '_tempfact':
#               R[ name ] = getattr( self, name )
#           return R

    #-------------------------------------------------------------------------------------------------------
    def __setstate__( self, getstate ):
        """Method to make instances ``pickle``\ able."""
        for name, value in getstate.iteritems():
            setattr( self, name, value )








############################################################################################################
#
#   UNIOCDE-AWARE HTTP QUERY STRING HANDLING
#
#===========================================================================================================

import urllib as url
import cgi

#cgi.parse_qsl(  qs[, keep_blank_values[, strict_parsing]])

#-----------------------------------------------------------------------------------------------------------
def querystring( items, strict = False ):#, acceptMultipleValues = False ):
    """Return a query string (i.e. 'a sequence of octets', not a Unicode object) for HTTP ``GET`` requests
    for all the names and values contained in ``items``, much as ``url.urlencode()`` does. **Added value**:
    uses ``E()`` to encode names and values. OBS.: this method expects either a dictionary for ``items`` or
    an iterable that yields ``(name,value)`` pairs. In both cases, derivatives of ``tuple`` and ``list``
    that appear as values are treated as *multiple values* of the same name (it being rather useless to try
    to directly pass such objects as a query string; if you really intend to beam objects by modulating them
    into the HTTP request string, use ``pickle`` to serialize these objects)."""
    #-------------------------------------------------------------------------------------------------------
    def iteritems( x ):
        try:
            iterator = x.iteritems()
        except AttributeError:
            iterator = x
        for element in iterator:
            assert len( element ) == 2
            yield element
    #-------------------------------------------------------------------------------------------------------
    Q = {}
    for name, values in iteritems( items ):
        name = E( name )
        target = Q.setdefault( name, [] )
        if not isinstance( values, ( list, tuple ) ):
            values = [ values ]
        for value in values:
            if strict:
                ananaS( value )
            else:
                warnaS( value )
            target.append( E( value ) )
    #print Q
    return url.urlencode( Q, True )

#-----------------------------------------------------------------------------------------------------------
def querydict( querystring ):
    """Return a query string from an HTTP ``GET`` request as a dictionary of lists of values, much as
    ``cgi.parse_qs()`` does. Added value: uses ``U()`` to turn all the name and value strings into unicode
    objects."""
    cgiQuerydict = cgi.parse_qs( querystring )
    return querydictFromCgiQuerydict( cgiQuerydict )

#-----------------------------------------------------------------------------------------------------------
def querydictFromCgiQuerydict( cgiQuerydict ):
    R = {}
    for name, values in cgiQuerydict.iteritems():
        name = U( name )
        target = []
        for value in values:
            target.append( uunquote( U( value ) ) )
            #target.append( U( value ) )
            #target.append( value )
        R[ name ] = target
    return R

#-----------------------------------------------------------------------------------------------------------
def getUrlWithQuerystring( url, Q ):
    return '%s?%s' % ( url, querystring( Q ) )

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit(50)

    print nanaS( 'abc' )
    print nanaS( 'abcä' )
    print nanaS( u'abc' )
    print nanaS( u'abcä' )

    warnaS( 'abc' )
    warnaS( 'abcä' )
    warnaS( u'abc' )
    warnaS( u'abcä' )
    ananaS( 'abc' )
    try:
        ananaS( 'abcä' )
    except UnicodeError, e:
        print '(%s) %s' % ( e.__class__, e, )


    d1 = dict( meaning = 'hello world?', semantics = 42, difficult = u'ä\u4e8b' )
    d2 = [
        ( 'meaning', 'hello world?' ), ( 'meaning', ':-)' ),
        ( 'semäntics', 42 ), ( u'difficultä\u4e8b', u'ä\u4e8b' ) ]
    d3 = dict( x = [ 1, 2, 3 ], y = 42 )
    #d = dict( meaning = 'hello world?', semantics = 42, )
#       print `url.urlencode( d0 )` #query[, doseq])
#       print `url.urlencode( d1 )` #query[, doseq])
#       print `url.urlencode( d2, False )` #query[, doseq])
#       print `url.urlencode( d2, True )` #query[, doseq])
#       print `url.urlencode( d3, False )` #query[, doseq])
#       print `url.urlencode( d3, True )` #query[, doseq])

    #   R = cgi.parse_qsl( url.urlencode( d1 ) )
    #   for name, value in R:
    #       print `U( name )`, `U( value )`
    #
    #   R = cgi.parse_qs( url.urlencode( d1 ) )
    #   for name, value in R.iteritems():
    #       print `U( name )`, `U( value )`
    print
    print `querystring( d1 )`
    print `querystring( d2 )`
    print `querystring( d3 )`
    print querydict( querystring( d1 ) )
    print querydict( querystring( d2 ) )
    print querydict( querystring( d3 ) )


