#
# -*- coding: utf-8 -*-



############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
import                                  sys
import os.path as                       ospath
import                                  os
import                                  re
import xml.dom.ext as                   domext
import                                  xml.sax.handler
from xml.sax import parse as            parseXml
from urllib2 import URLError as         urllib2UrlError
from xml.sax import                     SAXParseException
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
S                                       = u.EzSet.S
veryBasicSaxParser                      = u.veryBasicSaxParser
DataSourceAttributeDescription          = u.DataSourceAttributeDescription
fsi                                     = u.filesystemIdioms
#-----------------------------------------------------------------------------------------------------------
#   from biocase.wrapper.psf import         ProviderSetup                           # imported @ runtime
#   databaseMetadataReader                  = g.configtool.utilities.databaseMetadataReader    # imported @ runtime
#   querystring                             = g.configtool.utilities.IOU.querystring
#-----------------------------------------------------------------------------------------------------------
DsatDescription                         = DataSourceAttributeDescription.DsatDescription
DsatDescriptions                        = DataSourceAttributeDescription.DsatDescriptions

############################################################################################################
#
#   EXCEPTIONS
#
#===========================================================================================================
class DsaAlreadyExistsError( Exception ): pass
class PsfError( Exception ): pass
class PsfParseError( PsfError, SAXParseException ): pass
class PsfIoError( PsfError, urllib2UrlError ): pass
class CmfError( Exception ): pass
class SchemaInstanceAlreadyExistsError( CmfError, NameError, KeyError, ValueError ): pass
class UnknownSchemaIdentifier( CmfError, NameError, KeyError, ValueError ): pass
class UnknownSchemaTemplateError( CmfError, NameError, KeyError, ValueError ): pass





#   from biocase.wrapper import cmf_base


#   class Cmfx( cmf_base.CMFClass ):
#
#       # _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
#       def loadCMFdata(self, filename, psfObj=None, pickle=None):
#           '''Loads this CMF object from a file.
#           If pickling is enabled it first tries to find a pickled version of the CMF.
#           If this is outdated it parses the real xml file and creates a new pickle for it.
#           If the optional psf object is passed, the CMF object is initiated for output
#           and it is checked that the pickled cmf object is newer than the PSF file.
#           '''
#           import os
#           from stat import ST_MTIME
#           # check pickling policy
#           if psfObj is not None and pickle is None:
#               pickle = psfObj.pickleCMF
#           elif psfObj is None and pickle is None:
#               # by default turn pickling on
#               pickle = 1
#           # define the pickled version of the file. make it invisible...
#           CMFpick = os.path.join(os.path.split(filename)[0], '.'+os.path.split(filename)[1]+'.pick')
#           # does a pickled file exist and was it modified later than the CMF and the PSF (if supplied) ?
#           if pickle > 0 and os.path.isfile(CMFpick) and os.stat(CMFpick)[ST_MTIME] > os.stat(filename)[ST_MTIME] and (psfObj is None or os.stat(CMFpick)[ST_MTIME] > os.stat(psfObj.PSF)[ST_MTIME]):
#               isGood = self.__unpickle__(CMFpick)
#               # does the unpickled object match with this version of the class?
#               if not isGood:
#                   # no, reload from xml file
#                   self.__readCMF__(filename, psfObj=psfObj)
#                   if pickle > 0:
#                       # pickle this new object
#                       self.__pickle__(CMFpick)
#           else:
#               # CMF is newer than pickled version. Create a new object:
#               self.__readCMF__(filename, psfObj=psfObj)
#               if pickle > 0:
#                   # pickle this new object
#                   self.__pickle__(CMFpick)
#
#       #-------------------------------------------------------------------------------------------------------
#       def wal_buildPhash( self ):
#           R = {}
#           R['revision']           = self.__class__.__revision__
#           R['rec_definitions']    = self.recIdents
#           R['tabletree']          = self.tableTreeObj
#           R['root_cmf_object']    = self.rootCMFElementObj
#           R['path2elem_obj']      = self.path2ElemObj
#           R['path2mappings']      = self.path2mappings
#           R['all_db_attr']        = self.allDBAttr
#           return R
#
#       # _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
#       def __pickle__(self, filename):
#           '''pickles all content of an CMF object instance into a file
#           using a hash for storing all important properties.'''
#
#           #---------------------------------------------------------------------------------------------------
#           #   #   old
#           #   import cPickle as pickle
#           #   pickleHash = {}
#           #---------------------------------------------------------------------------------------------------
#
#           #---------------------------------------------------------------------------------------------------
#           #   #   new
#           import cPickle as pickle
#           # remove all log object references first:
#           for elemObj in self.path2ElemObj.values():
#               elemObj.logObj = None
#           # create hash to pickle
#           #---------------------------------------------------------------------------------------------------
#           pickleHash = self.wal_buildPhash()
#           try:
#               pickleFile = file(filename,'w')
#               pickle.dump(pickleHash, pickleFile)
#               pickleFile.close()
#               self.logObj + (3, "Pickled CMF object '%s'"%(filename))
#           except '#': ###DEBUG###
#               self.logObj + (0, "Could not pickle the CMF object '%s'"%(filename))






























############################################################################################################
#
#
#
#===========================================================================================================
class WrapperConfigPasswordHandler( xml.sax.handler.ContentHandler ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self ):
        self.password = 'root'
        self._value = ''
        xml.sax.handler.ContentHandler.__init__( self )

    #-------------------------------------------------------------------------------------------------------
    def endElement( self, name ):
        self._value = self._value.strip()
        if name == 'Password':
            self.password = self._value
        self._value = ''

    #-------------------------------------------------------------------------------------------------------
    def characters( self, ch ):
        self._value += ch


############################################################################################################
#
#
#
#===========================================================================================================
class Commonsense( object ):

    #-------------------------------------------------------------------------------------------------------
    PsfError            = PsfError
    PsfParseError       = PsfParseError
    PsfIoError          = PsfIoError

    #-------------------------------------------------------------------------------------------------------
    biocaseDir                          = g.cfg.libbiocaseLocator
    #databasesDirectoryname              = 'datasources'
    configurationDirectoryname          = 'config'
    psfFilename                         = 'provider_setup_file.xml'
    psfxFilename                        = 'psfx.xml'
    wcfFilename                         = 'wrapper_config.xml'
    templatesDirectoryname              = 'templates'
    templatesRepositoryDirectoryname    = 'config-files'
    cmfFilenamePrefix                   = 'cmf_'
    cmfFilenameDotExtension             = '.xml'

    #-------------------------------------------------------------------------------------------------------
    _rdbmsHash      = {"ODBC FoxPro":"odbc_foxpro", "MySQL":"mysql", "PostgreSQL":"postgres",
    "PostgreSQL psycopg":"psycopg", "Firebird":"firebird", "Sybase":"sybase", "Oracle 8":"oracle8",
    "Oracle 9&10":"oracle", "ODBC generic":"odbc", "ODBC Access":"odbc_access",
    "ODBC SQL Server":"odbc_tsql", "ODBC Filemaker":"odbc_filemaker" }

    #-------------------------------------------------------------------------------------------------------
    _encodingsHash  = {"ascii":"ascii", "base64-codec":"base64_codec", "charmap":"charmap", "cp037":"cp037",
    "cp1006":"cp1006", "cp1026":"cp1026", "cp1140":"cp1140", "cp1250":"cp1250", "cp1251":"cp1251", "cp1252":
    "cp1252", "cp1253":"cp1253", "cp1254":"cp1254", "cp1255":"cp1255", "cp1256":"cp1256", "cp1257":"cp1257",
    "cp1258":"cp1258", "cp424":"cp424", "cp437":"cp437", "cp500":"cp500", "cp737":"cp737", "cp775":"cp775",
    "cp850":"cp850", "cp852":"cp852", "cp855":"cp855", "cp856":"cp856", "cp857":"cp857", "cp860":"cp860",
    "cp861":"cp861", "cp862":"cp862", "cp863":"cp863", "cp864":"cp864", "cp865":"cp865", "cp866":"cp866",
    "cp869":"cp869", "cp874":"cp874", "cp875":"cp875", "hex-codec":"hex_codec", "idna":"idna", "iso8859-1":
    "iso8859_1", "iso8859-10":"iso8859_10", "iso8859-13":"iso8859_13", "iso8859-14":"iso8859_14",
    "iso8859-15":"iso8859_15", "iso8859-2":"iso8859_2", "iso8859-3":"iso8859_3", "iso8859-4":"iso8859_4",
    "iso8859-5":"iso8859_5", "iso8859-6":"iso8859_6", "iso8859-7":"iso8859_7", "iso8859-8":"iso8859_8",
    "iso8859-9":"iso8859_9", "koi8-r":"koi8_r", "koi8-u":"koi8_u", "latin-1":"latin_1", "mac-cyrillic":
    "mac_cyrillic", "mac-greek":"mac_greek", "mac-iceland":"mac_iceland", "mac-latin2":"mac_latin2",
    "mac-roman":"mac_roman", "mac-turkish":"mac_turkish", "mbcs":"mbcs", "palmos":"palmos", "punycode":
    "punycode", "quopri-codec":"quopri_codec", "raw-unicode-escape":"raw_unicode_escape", "rot-13":"rot_13",
    "string-escape":"string_escape", "undefined":"undefined", "unicode-escape":"unicode_escape",
    "unicode-internal":"unicode_internal", "utf-16":"utf_16", "utf-16-be":"utf_16_be", "utf-16-le":
    "utf_16_le", "utf-7":"utf_7", "utf-8":"utf_8", "uu-codec":"uu_codec", "zlib-codec":"zlib_codec"}

    #-------------------------------------------------------------------------------------------------------
    _typesHash      = {'unicode':'unicode','string':'string','integer':'int','float':'float','date':'date'}

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        return g.cfg.configtool.applicationPassword
#           handler = WrapperConfigPasswordHandler()
#           wrapperConfigFilelocator = fsi.join(
#               this.biocaseDir, this.configurationDirectoryname, 'wrapper_config.xml'
#               )
#           parseXml( wrapperConfigFilelocator, handler )
#           return handler.password
    getApplicationPassword = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        """Return the full filesystem path of the directory under which one dedicated directory for each
        data source is entertained."""
        #return fsi.join( this.biocaseDir, this.databasesDirectoryname )
        return g.cfg.datasourcesLocator
    getDatasorcesBaseLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        """Return the full filesystem path of the dedicated data source directory."""
        return fsi.join( this.getDatasorcesBaseLocator(), dsa )
    getDatasourceLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        """Return the full filesystem path of the directory that holds the CMF and PSF templates."""
        return fsi.join( this.getTemplatesBaseLocator(), this.templatesRepositoryDirectoryname )
    getTemplatesRepositoryLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        """Return the full filesystem path of the directory that holds the data source configuration
        templates."""
        return fsi.join( this.biocaseDir, this.templatesDirectoryname, )
    getTemplatesBaseLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        return fsi.join( this.biocaseDir, this.configurationDirectoryname, this.wcfFilename )
    getWcfLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        return fsi.join( this.getDatasourceLocator( dsa ), this.configurationDirectoryname )
    getDatasourceConfigurationLocator = classmethod( f ); del f


############################################################################################################
#
#
#
#===========================================================================================================
class PsfIdioms( Commonsense ):

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        return ospath.join( this.getDatasourceConfigurationLocator( dsa ), this.psfFilename )
    getPsfLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        R = this._psfForDsa( dsa )
        try:
            this.parseXml( R )
        except '#':
            pass
        return R
    psfForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa = None ):
        ProviderSetup = g.biocase.wrapper.psf.ProviderSetup
        R = ProviderSetup()
        #---------------------------------------------------------------------------------------------------
        if dsa is None: return R
        #---------------------------------------------------------------------------------------------------
        psfLocator  = this.getPsfLocator( dsa )
        logDir      = None
        wcfLocator  = this.getWcfLocator()
        #---------------------------------------------------------------------------------------------------
        #   TRY NEW WAY
        try:
            R.setConfigDirs( PSFpath = psfLocator, logDir = logDir, WCFpath = wcfLocator )
        #---------------------------------------------------------------------------------------------------
        #   TRY OLD WAY
        except AttributeError:
            R.setDirPathOfDatabase( this.getDatasourceLocator( dsa ) )
        return R
        #---------------------------------------------------------------------------------------------------
    _psfForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        """Hacky way to obtain the actual locator from a psf object even if it assumes old-style file
        layout."""
        path, filename = ospath.split( psf.PSF )
        #print '~~~~~~~~~~~~~~~~~~~~~~~', parts
        path2, dirname2 = ospath.split( path )
        if dirname2 == 'config':
            path = path2
        R = ospath.join( path, filename )
        return R
    getFilelocatorForPsf = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf, filelocator = None ):
        """Use SAX to parse a ``providersetup.xml`` file and fill the ``psf`` instance. If ``filelocator``
        is omitted or ``None``, fall back to ``psf.PSF``. -- The functionality of this method reproduces
        that of ``//site-packages/biocase/wrapper/psf.py/readPSFile()``, version 1.21, but provides more
        lucid error handling: In case the XML file cannot be opened, a ``PsfIoError`` (also catchable as
        ``PsfError``, ``urllib2.URLError``, or ``IOError``) is raised; in case the file can be opened but
        not parsed, a ``PsfParseError`` (also catchable as ``PsfError`` or ``xml.sax.SAXParseException``) is
        raised."""
        #---------------------------------------------------------------------------------------------------
        if filelocator is None:
            filelocator = this.getFilelocatorForPsf( psf )
        #---------------------------------------------------------------------------------------------------
        providerConfigHandler = g.biocase.wrapper.psf.providerConfigHandler
        handler = providerConfigHandler( psf )
        #---------------------------------------------------------------------------------------------------
        try:
            parseXml( filelocator, handler)
        except SAXParseException, e:
            raise this.PsfParseError(
                'Problem parsing file %s: (%s) %s' % ( filelocator, e.__class__, e, ) )
        except IOError, e:
            raise this.PsfIoError(
                'Problem opening file %s: (%s) %s' % ( filelocator, e.__class__, e, ) )
    parseXml = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator, dsa = None ):
        """Return a PSF instance for a given ``filelocator`` of an existing and valid XML Provider Setup
        File and an optional Data Source Alias (``dsa``). If ``dsa`` is omitted or ``None``, path settings
        of the returned PSF instance (including ``psf.PSF``) will not make much sense."""
        R = this._psfForDsa( dsa )
        this.parseXml( R, filelocator )
        return R
    psfForXml = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf, target = None ):
        """Write ``psf`` object to file ``target`` (by default, a file is opened for writing based on the
        filename in ``psf.PSF``). -- The preferred method is ``~.safewriteToFilename()``."""
        #   HACK to make sure we do have an XML Writer instance in the psf object:
        if getattr( psf, 'XMLwriter', None ) is None:
            from biocase.tools.xmlwriter import XMLwriterClass
            psf.XMLwriter = XMLwriterClass( psf.__class__.PSFnamespace[0] )
        doClose = False
        if target is None:
            target = file( psf.PSF, 'w' )
            doClose = True
        domext.PrettyPrint( psf.createPSFDOM(), target )
        if doClose:
            target.close()
    write = classmethod( f ); del f


    #-------------------------------------------------------------------------------------------------------
    def f( this, psf, filename = None ):
        """Write ``psf`` to file as named in ``filename``, or to the one named in ``psf.PSF`` by default,
        using the safewrite policy defined in module ``filesystemIdioms``."""
        if filename is None:
            filename = psf.PSF
        fsi.createBackup( filename )
        forwardFilename = fsi.getForwardFilename( filename )
        target = file( forwardFilename, 'w' )
        this.write( psf, target )
        target.close()
        fsi.applyForward( filename )
    safewriteToFilename = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        from StringIO import StringIO
        s = StringIO()
        this.write( psf, s )
        print s.getvalue()
    show = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        R = dict( dsn = psf.datasource, user = psf.user, password = psf.password, clear_auto_commit = True )
        return R
    getOdbcDsCredentials = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        return this.getOdbcDsCredentials( psf )
    getDsCredentials = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        dsCredentials = this.getOdbcDsCredentials( psf )
        databaseMetadataReader = g.configtool.utilities.databaseMetadataReader
        R = databaseMetadataReader.DatabaseDescription.fromDsCredentials( dsCredentials )
        return R
    getOdbcDsDescription = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        return this.getOdbcDsDescription( psf )
    getDsDescription = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        psf = this.psfForDsa( dsa )
        return this.getDsDescription( psf )
    getDsDescriptionForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( self, psf ):
        """Return a list of all the table aliases in a ``psf``, sorted in the standard order."""
        return [ tableAliasObject.alias for tableAliasObject in psf.getTableAliasList() ]
    getNameIndex = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        R = {}
        for name in """encoding dbIP dbms datasource password user""".split():
            R[ name ] = getattr( psf, name )
        return R
    HACK_getDictOfKeepYourselfValues = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf, d ):
        for name, value in d.iteritems():
            setattr( psf, name, value )
    HACK_setKeepYourselfValuesFromDict = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf, tablealias ):

        del psf.tablegraph.alias2tableObj[  tablealias ]
        del psf.tablegraph.alias2tablename[ tablealias ]
        psf.tablegraph.clearGraph()
        psfx = this.getPsfxForPsf( psf )
        psfx.removeTablealias( tablealias )
        psfx.write()
    deleteTableAlias = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        return DsatDescriptions()
    getEmptyDsatDescriptions = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf, psfx = None ):
        R = this.getEmptyDsatDescriptions()
        tableAliasObjects = psf.getTableAliasList()
        if psfx is None: psfx = this.getPsfxForPsf( psf )
        seen = S()
        #---------------------------------------------------------------------------------------------------
        for tanr, tableAliasObject in enumerate( tableAliasObjects ):
            tablealias  = tableAliasObject.alias
            #-----------------------------------------------------------------------------------------------
            for pknr, primaryKeyObject in enumerate( tableAliasObject.pk ):
                attributename   = primaryKeyObject.attr
                termref         = ( tablealias, attributename )
                seen.add( termref )
                description = DsatDescription(
                    id              = this.getPrimarykeyIdForNumbers( tanr, pknr ),
                    attributename   = attributename,
                    tablealias      = tablealias,
                    )
                R.append( description )
            #-----------------------------------------------------------------------------------------------
            for fknr, foreignKeyObject in enumerate( tableAliasObject.fks ):
                fktargetalias       = foreignKeyObject.target
                for afknr, dBAttributeObject in enumerate( foreignKeyObject.attrList ):
                    termref = ( tablealias, attributename )
                    seen.add( termref )
                    description = DsatDescription(
                        id              = this.getForeignkeyIdForNumbers( tanr, fknr, afknr ),
                        attributename   = dBAttributeObject.attr,
                        tablealias      = tablealias,
                        fktargetalias   = fktargetalias,
                        )
                    R.append( description )
            #---------------------------------------------------------------------------------------------------
            psfxattributes = psfx.attributesByTableAlias.get( tablealias, [] )
            for psfxanr, psfxattribute in enumerate( psfxattributes ):
                attributename   = psfxattribute.name
                termref         = ( tablealias, attributename )
                if termref in seen: continue
                seen.add( termref )
                description = DsatDescription(
                    id              = this.getPsfxattributeIdForNumbers( tanr, psfxanr ),
                    attributename   = attributename,
                    tablealias      = tablealias,
                    )
                R.append( description )
        #---------------------------------------------------------------------------------------------------
        R.sort()
        return R
    getAllDsatDescriptionsSortedForPsf = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, tanr ):
        return 'ta%s' % ( tanr, )
    getTableAliasIdForNumbers = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, tanr, pknr ):
        taid = this.getTableAliasIdForNumbers( tanr )
        return 'pk%s_%s' % ( pknr, taid, )
    getPrimarykeyIdForNumbers = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, tanr, fknr, afknr ):
        taid = this.getTableAliasIdForNumbers( tanr )
        return 'afk%s_fk%s_%s' % ( afknr, fknr, taid, )
    getForeignkeyIdForNumbers = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, tanr, psfxanr ):
        taid = this.getTableAliasIdForNumbers( tanr )
        return 'psfxa%s_%s' % ( psfxanr, taid, )
    getPsfxattributeIdForNumbers = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        return fsi.join( this.getDatasourceLocator( dsa ), this.psfxFilename )
    getPsfxLocatorForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator ):
        #print '+++++++++++++++++++', filelocator ###DEBUG###
        getPsfx = g.configtool.utilities.psfx.getPsfx
        return getPsfx.forFilelocator( filelocator )
    getPsfxForFilelocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        return this.getPsfxForFilelocator( this.getPsfxLocatorForDsa( dsa ) )
    getPsfxForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, psf ):
        psfxlocator = fsi.join( ospath.dirname( psf.PSF ), this.psfxFilename )
        return this.getPsfxForFilelocator( psfxlocator )
    getPsfxForPsf = classmethod( f ); del f


#       #-------------------------------------------------------------------------------------------------------
#       def f( this, psf, tablealias ):
#           tableAliasObjects = psf.getTableAliasList()
#           for tableAliasObject in tableAliasObjects:
#               for foreignKeyObject in tableAliasObject.fks:
#                   if foreignKeyObject.target != tablealias: continue
#                   print 'delete', foreignKeyObject
#       deleteForeignKeysToTableAlias = classmethod( f ); del f

    ########################################################################################################
    #   RETRIEVE LIST OF EXISTING DATA SOURCE ALIAS DIRECTORIES
    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        databaseDir = this.getDatasorcesBaseLocator()
        R = list(
            fsi.iterateNameLocatorPairsOfDirectories(
                databaseDir,
                filter = lambda locator: not locator.endswith( '/CVS' ),
                ) )
        R.sort()
        return R
    getDsaliasLocatorPairs = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        dsdir = os.path.join(g.cfg.datasourcesLocator, dsa)
        if os.path.isdir(dsdir):
            raise DsaAlreadyExistsError()
        # copy skeleton folder
        os.copytree(os.path.join(g.cfg.configurationLocator,'configtool','sda_skeleton'), dsdir)
        # update metadata.xml with DSA name
        from xml.dom.minidom import parse
        metaFile = os.path.join(dsdir,'metadata.xml')
        metaDOM = parse(metaFile)
        # update label
        labelNode = metaDOM.getElementsByTagName("label")[0]
        textNode  = metaDOM.createTextNode(dsa)
        labelNode.appendChild(textNode)
        # update access point
        apNode = metaDOM.getElementsByTagName("accesspoint")[0]
        textNode  = metaDOM.createTextNode(g.cfg.host + g.cfg.webroot + '/pywrapper.cgi?dsa=' + dsa)
        apNode.appendChild(textNode)
        # write file
        file(metaFile, 'w').write( metaDOM.toprettyxml() )

    createDatasourceDirectoriesForDsa = classmethod( f ); del f

############################################################################################################
#
#
#
#===========================================================================================================
class CmfIdioms( Commonsense ):

    #-------------------------------------------------------------------------------------------------------
    cmflocatorAttributename     = '__wal_cmflocator__'
    cmfPickleFilenamePrefix     = '.'
    cmfPickleFilenamePostfix    = '.pick'
    timeoutForCmfReading        = 25

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmflocator, action ):
        #---------------------------------------------------------------------------------------------------
        def fTimeout():
            lockfilelocator = fsi.getLockfileLocator( cmflocator )
            raise IOError( ''
                +   "Attempt to %s CMF at %s has timed out. " % ( action, cmflocator, )
                +   "This is possibly due to a lockfile that has not been removed for some reason; "
                +   "you may want to try to remove file %s " % ( lockfilelocator, )
                +   "manually if it exists and retry."
                )
        #---------------------------------------------------------------------------------------------------
        fsi.waitForLockReleased(
            cmflocator,
            timeout         = this.timeoutForCmfReading,
            lockedCallback  = None,
            timeoutCallback = fTimeout,
            )
    waitForLockReleaseOnCmfPickle = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmflocator ):
        cmf_base = g.biocase.wrapper.cmf_base
        R = cmf_base.CMFClass()
        picklefilelocator = this.getPicklefilelocatorForFilelocator( cmflocator )
        fsi.establishLock( cmflocator )
        fsi.establishLock( picklefilelocator )
        try:
            R.loadCMFdata( cmflocator )
            #import time; time.sleep( 5 ) ###DEBUG###
        finally:
            fsi.releaseLock( cmflocator )
            fsi.releaseLock( picklefilelocator )
        setattr( R, this.cmflocatorAttributename, cmflocator ) # Hack: store filename for later writing
        return R
    cmfForCmflocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, charcount = 3000 ):
        import xml.dom.ext as domext
        from StringIO import StringIO
        target = StringIO()
        domext.PrettyPrint( cmf.createCMFDOM(), target )
        R = target.getvalue()[ : charcount ] + '...'
        del target
        return R
    __exp_getSnapshot__ = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator = None ):
        directorylocator, filename = ospath.split( filelocator )
        if filename.startswith( this.cmfPickleFilenamePrefix ) \
            and filename.endswith( this.cmfPickleFilenamePostfix ):
            return filelocator
        picklefilename = '%s%s%s' % (
            this.cmfPickleFilenamePrefix, filename, this.cmfPickleFilenamePostfix )
        R = ospath.join( directorylocator, picklefilename )
        #R = ospath.join( ospath.split( filelocator )[ 0 ], '.' + ospath.split( filename )[ 1 ] + '.pick' )
        return R
    getPicklefilelocatorForFilelocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, cmflocator = None, toXml = True, toPickle = True ):
        if cmflocator is None:
            cmflocator = getattr( cmf, this.cmflocatorAttributename, None ) # Hack
        if cmflocator is None:
            raise ValueError( ''
                "Unable to persist CMF: no file locator given and no one stored in instance."
                )
        picklefilelocator = this.getPicklefilelocatorForFilelocator( cmflocator )
        fsi.establishLock( cmflocator )
        fsi.establishLock( picklefilelocator )
        try:
            if toXml:
                import xml.dom.ext
                cmfdom = cmf.createCMFDOM()
                fsi.createBackup( cmflocator )
                forwardFilename = fsi.getForwardFilename( cmflocator )
                target = file( forwardFilename, 'w' )
                xml.dom.ext.PrettyPrint( cmfdom, target )
                target.close()
                fsi.applyForward( cmflocator, removeForward = True )
            if toPickle:
                cmf.__pickle__( picklefilelocator )
        finally:
            #print 'lock released'
            fsi.releaseLock( cmflocator )
            fsi.releaseLock( picklefilelocator )
    safewrite = classmethod( f ); del f


#       #-------------------------------------------------------------------------------------------------------
#       def f( this, psf, filename = None ):
#           """Write ``psf`` to file as named in ``filename``, or to the one named in ``psf.PSF`` by default,
#           using the safewrite policy defined in module ``filesystemIdioms``."""
#           if filename is None:
#               filename = psf.PSF
#           fsi.createBackup( filename )
#           forwardFilename = fsi.getForwardFilename( filename )
#           target = file( forwardFilename, 'w' )
#           this.write( psf, target )
#           target.close()
#           fsi.applyForward( filename )
#       safewriteToFilename = classmethod( f ); del f



    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, cmflocator = None ):
        this.write( cmf, cmflocator, toXml = False, toPickle = True )
    safewriteToPickle = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, cmflocator = None ):
        this.write( cmf, cmflocator, toXml = True, toPickle = False )
    safewriteToXml = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, cmf ):
#           return this.writeToPickle( cmf )
#       write = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, cmf, cmflocator = None ):
#           import xml.dom.ext
#           if cmflocator is None:
#               cmflocator = getattr( cmf, this.cmflocatorAttributename, None ) # Hack
#           if cmflocator is None:
#               raise ValueError( ''
#                   "Unable to persist CMF: no file locator given and no one stored in instance."
#                   )
#           xml.dom.ext.PrettyPrint( cmf.createCMFDOM(), file(cmf['file'], 'w'))
#           # free memory
#           cmfObj = None
#           # read this file again for displaying:
#           readCMFFile(cmf)
#       writeToXml = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, directorylocator ):
        for filename in os.listdir( directorylocator ):
            if not filename.startswith( this.cmfFilenamePrefix          ): continue
            if not filename.endswith(   this.cmfFilenameDotExtension    ): continue
            locator = fsi.join( directorylocator, filename )
            if not fsi.isfile( locator                                  ): continue
            yield locator
    iterAllLikelyCmfLocators = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        directorylocator = g.cfg.rawCmfTemplateLocator
        for filename in os.listdir( directorylocator ):
            locator = fsi.join( directorylocator, filename )
            if not fsi.isfile( locator                                  ): continue
            yield locator
    iterAllLikelyCmfLocators2 = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        directorylocator = this.getDatasourceConfigurationLocator( dsa )
        for locator in this.iterAllLikelyCmfLocators( directorylocator ):
            yield locator
    iterAllLikelyCmfLocatorsForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator, _HACK_bracketed = False ):
        lx2i = g.configtool.utilities.libxml2Idioms.libxml2Idioms
        interestingElementNames = S( 'dataElement', 'attribute' )
        document = lx2i.getDocument.forFilelocator( filelocator )
        for child in document.children:
            if child.name in interestingElementNames:
                locator = lx2i.getAttributeValue( child, 'path' )
                if _HACK_bracketed: locator = this._HACK_normalizeConceptlocatorToBracketed( locator )
                else:               locator = this._HACK_normalizeConceptlocatorToBracketless( locator )
                yield locator
    iterConceptLocatorsForFilelocator = classmethod( f ); del f

    #-----------------------------------------------------------------------------------------------------------
    def f( this, gauge, cmflocator ):
        _EzGraph = u.EzGraph
        R = _EzGraph.Graph( gauge )
        locators = list( this.iterConceptLocatorsForFilelocator( cmflocator ) )
        locators.sort()
        for locator in locators:
            R.newNodeForLocator( locator )
        return R
    getGraphForGaugeAndCmflocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, locator, _HACK_bracketed ):
        if _HACK_bracketed:
            return this._HACK_normalizeConceptlocatorToBracketed( locator )
        return this._HACK_normalizeConceptlocatorToBracketless( locator )
    _normalizeLocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator, _HACK_bracketed = False ):
        lx2i = g.configtool.utilities.libxml2Idioms.libxml2Idioms
        interestingElementNames = S( 'dataElement', 'attribute' )
        document = lx2i.getDocument.forFilelocator( filelocator )
        for child in document.children:
            if child.name in interestingElementNames:
                locator = lx2i.getAttributeValue( child, 'path' )
                if _HACK_bracketed: locator = this._HACK_normalizeConceptlocatorToBracketed( locator )
                else:               locator = this._HACK_normalizeConceptlocatorToBracketless( locator )
                yield locator
    iterConceptLocatorsForFilelocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmflocators, schemaDescriptionsByScm = None, isTemplate = True ):
        messages = []
        problems = []
        #---------------------------------------------------------------------------------------------------
        if schemaDescriptionsByScm is None:   R = {}
        else:                                 R = schemaDescriptionsByScm
        #---------------------------------------------------------------------------------------------------
        for cmflocator in cmflocators:
            schemaDescription, messages, problems = \
                veryBasicSaxParser.getCmfSchemaDescriptionForCmflocatorPlus(
                    cmflocator,
                    isTemplate = isTemplate,
                    )
            messages.extend( messages )
            problems.extend( problems )
            if schemaDescription is not None:
                #print schemaDescription.namespacePrefix, schemaDescription
                target = R.setdefault( schemaDescription.namespacePrefix, [] )
                target.append( schemaDescription )
            else:
                pass # OR DO SOMETHING ABOUT THIS
        return R, messages, problems
    _getSchemaDescriptionsByScmForCmfLocatorsPlus = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, yieldExceptions = False, useDefaultPrefixes = True, useDefaultNamespaces = False ):
        #---------------------------------------------------------------------------------------------------
        prefixesByNamespaces                    = g.cfg.prefixesByNamespaces
        namespacesByPrefix                      = g.cfg.namespacesByPrefix
        _getCmfSchemaDescriptionForCmflocator   = u.veryBasicSaxParser.getCmfSchemaDescriptionForCmflocator
        number                                  = -1
        #---------------------------------------------------------------------------------------------------
        legalCharacterPattern   = r'[^-a-zA-Z_0-9.]'
        legalCharacterRe        = re.compile( legalCharacterPattern )
        def legalize( name ):
            #return ''.join( [ word.capitalize() for word in legalCharacterRe.sub( ' ', name ).split() ] )
            return '_'.join( [ word for word in legalCharacterRe.sub( ' ', name ).split() ] )
        #---------------------------------------------------------------------------------------------------
        for locator in this.iterAllLikelyCmfLocators2():
            number += 1
            #-----------------------------------------------------------------------------------------------
            try:
                sd = _getCmfSchemaDescriptionForCmflocator( locator )
            except Exception, e:
                if yieldExceptions:
                    yield e
                    continue
                raise
            #-----------------------------------------------------------------------------------------------
            prefix      = sd.namespacePrefix
            namespace   = sd.namespaceUri
            if namespace is None:
                if not useDefaultNamespaces: continue
                namespace   = 'unidentified-namespace-%d' % ( namespace, number, )
            if prefix is None:
                if not useDefaultPrefixes: continue
                prefix = legalize( namespace )
            yield prefix, locator, namespace
        #---------------------------------------------------------------------------------------------------
        for prefix, locator in g.cfg.additionalGraphsourcesByPrefix.iteritems():
            number += 1
            namespace = namespacesByPrefix.get( prefix, None )
            yield prefix, locator, namespace
    iterPrefixLocatorAndNamespacesForAllSchemas = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator, _HACK_bracketed = False ):
        lx2i = g.configtool.utilities.libxml2Idioms.libxml2Idioms
        interestingElementNames     = S( 'dataElement', 'attribute' )
        #documentationElementNames = S( 'FullName', 'Content', 'annot', 'Comments', 'ExistingStandards' )
        documentationElementNames   = S( 'Content', 'annot', 'Comments', )
        document                    = lx2i.getDocument.forFilelocator( filelocator )
        locator                     = None
        annotations                 = []
        #---------------------------------------------------------------------------------------------------
        def yieldResults( locator, annotations ):
            if locator is not None:
                #annotations.extend( [ (0,''), (0,''), ] )
                annotations.sort()
                annotations.reverse()
                shortdoc = longdoc = ''
                if len( annotations ) == 1:
                    shortdoc = annotations[ 0 ][ 1 ]
                elif len( annotations ) > 1:
                    longdoc  = annotations[ 0 ][ 1 ]
                    shortdoc = annotations[ 1 ][ 1 ]
                    if shortdoc == longdoc:
                        longdoc = ''
                yield locator, shortdoc, longdoc
                del annotations[:]
        #---------------------------------------------------------------------------------------------------
        for child in document.children:
            #-----------------------------------------------------------------------------------------------
            childname = child.name
            #-----------------------------------------------------------------------------------------------
            if childname in interestingElementNames:
                for whatever in yieldResults( locator, annotations ): yield whatever
                #-------------------------------------------------------------------------------------------
                locator = lx2i.getAttributeValue( child, 'path' )
                locator = this._normalizeLocator( locator, _HACK_bracketed )
                continue
            #-----------------------------------------------------------------------------------------------
            if childname in documentationElementNames:
                content = lx2i.normalize( child.content )
                if not content: continue
                annotations.append( ( len( content ), content ) )
        for whatever in yieldResults( locator, annotations ): yield whatever
    iterLocatorsAndDocumentation = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, schemaDescriptionsByScm = None ):
        cmflocators = this.iterAllLikelyCmfLocators( this.getTemplatesRepositoryLocator() )
        R, messages, problems = this._getSchemaDescriptionsByScmForCmfLocatorsPlus(
            cmflocators,
            schemaDescriptionsByScm,
            isTemplate = True,
            )
        return R
    getSchemaDescriptionsOfTemplatesByScm = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa, schemaDescriptionsByScm = None ):
        cmflocators = this.iterAllLikelyCmfLocatorsForDsa( dsa )
        R, messages, problems = this._getSchemaDescriptionsByScmForCmfLocatorsPlus(
            cmflocators,
            schemaDescriptionsByScm,
            isTemplate = False,
            )
        return R
    getSchemaDescriptionsOfInstancesByScmForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa, scm, schemaDescriptionsByScm = None ):
        messages            = []
        problems            = []
        cmf                 = None
        schemaDescription   = None
        #---------------------------------------------------------------------------------------------------
        if schemaDescriptionsByScm is None:
            schemaDescriptionsByScm = this.getSchemaDescriptionsOfInstancesByScmForDsa( dsa )
        schemaDescriptions = schemaDescriptionsByScm.get( scm, None )
        #---------------------------------------------------------------------------------------------------
        if not schemaDescriptions:
            problems.append( ''
                +   "Unable to find a CMF instance XML file for DSA %s." % ( dsa, )
                )
            return cmf, schemaDescription, messages, problems
        schemaDescription = schemaDescriptions[ 0 ]
        #---------------------------------------------------------------------------------------------------
        cmflocator = schemaDescription.filelocator
        try:
            cmf = this.cmfForCmflocator( cmflocator )
        #---------------------------------------------------------------------------------------------------
        except Exception, e:
            problems.append( ''
                +   "Attempt to open or parse CMF XML file %s for DSA %s caused " % ( cmflocator, dsa, )
                +   "an exception to be raised: (%s) %s." % ( e.__class__, e, )
                )
        #---------------------------------------------------------------------------------------------------
        return cmf, schemaDescription, messages, problems
    getCmfInstanceAndSchemaDescriptionForDsaAndScmPlus__nomagictemplateinstantion__ = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filename, dsa, scm ):
        underscoreposition = filename.rfind( '_' )
        if underscoreposition > -1:
            R = '%s_%s.xml' % ( filename[ : underscoreposition ], dsa )
        else:
            R = 'cmf_%s_%s.xml' % ( scm, dsa, )
        return R
    _getCmfFilenameForDsaScm = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa, scm, scmfntrailer ):
        """

        Exceptions:
        ================================================================================================

        * **KeyError**
            if schema ``scm`` is not registered in naemspaceRegistry

        * **UnknownSchemaTemplateError**
            if no template can be retrieved for schema ``scm`` because none of the template CMFs
            declares the target namespace identified by ``scm``, or because none of the filenames of
            existing and matching template files ended in the string ``scmfntrailer`` (case-insensitive
            comparison; set ``scmfntrailer`` to empty string to avoid this).

        * **SchemaInstanceAlreadyExistsError**
            if schema ``scm`` points to an existing schema instance (cmf-file)
            of data source ``dsa``

        * **IOError**
            if the filelocator calculated for the givens points to an already existing file. This should
            never happen for valid, already existing CMFs; it may occur, however, in case the database
            configuration directory does include a file named like ``cmf_ABCD_1.20_PonTaurus.xml`` which
            is *not* a valid CMF (rationale: in this case, ``SchemaInstanceAlreadyExistsError`` could
            not have been justifiably raised).

        * **IOError**
            if anything goes wrong when attempting to copy the template file to its target
            location.

        """

        namespaceRegistry = g.namespaceRegistry
        try:
            scm = namespaceRegistry.normalize( scm ) # raises KeyError on scm unknown
        except KeyError:
            raise UnknownSchemaIdentifier( ''
                +   "Unknown Schema Identifier: '%s'." % ( scm, )
                )
        descriptionsOfSchemaTemplates = this.getSchemaDescriptionsOfTemplatesByScm()
        descriptionsOfSchemaInstances = this.getSchemaDescriptionsOfInstancesByScmForDsa( dsa )
        #print descriptionsOfSchemaTemplates.keys()
        #print descriptionsOfSchemaInstances.keys()
        if scm not in descriptionsOfSchemaTemplates:
            raise UnknownSchemaTemplateError( ''
                +   "Unable to find a template for Schema %s." % ( scm, )
                )
        if scm in descriptionsOfSchemaInstances:
            raise SchemaInstanceAlreadyExistsError( ''
                +   "Schema %s already instantiated for DSA %s." % ( scm, dsa, )
                )
        scmfntrailerLc = scmfntrailer.lower()
        try:
            for schemaDescription in descriptionsOfSchemaTemplates[ scm ]:
                filenameLc = schemaDescription.filename.lower()
                #print filenameLc.endswith( scmfntrailerLc ), `filenameLc`, `scmfntrailerLc`, schemaDescription
                if filenameLc.endswith( scmfntrailerLc ):
                    raise 'found'
        except 'found':
            pass
        else:
            raise UnknownSchemaTemplateError( ''
                +   "Unable to find a template for "
                +   "Schema %s and filename trailer %r." % ( scm, scmfntrailer, )
                )
        targetdirectorylocator  = this.getDatasourceConfigurationLocator( dsa )
        newcmffilename          = this._getCmfFilenameForDsaScm( schemaDescription.filename, dsa, scm )
        newcmffilelocator       = fsi.join( targetdirectorylocator, newcmffilename )
        if fsi.exists( newcmffilelocator ):
            raise IOError( ''
                +   "Unable to write CMF because "
                +   "file already exists: %s." % ( newcmffilelocator, )
                )
        import shutil
        try:
            shutil.copyfile( schemaDescription.filelocator, newcmffilelocator )
        except Exception, e:
            raise IOError( ''
                +   "Attempt to copy file %s to %s caused the following exception to be raised: \n"
                +   "(%s) %s." % ( e.__class__, e, )
                )
        return newcmffilelocator
    createCmfForDsaScmScmfn = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, scm = None ):
        R = {}
        #---------------------------------------------------------------------------------------------------
        if scm is not None:
            Dbs = g.configtool.utilities.topsy.dbs.Dbs
        for conceptLocator, listOfMappingObjects in cmf.path2mappings.iteritems():
            for mappingnr, mappingObject in enumerate( listOfMappingObjects ):
                #   biocase.wrapper.cmf_element.CMFMappingClass
                #   addItem filterObj getDBAttributes getItems getValues isSearchable
                #   items setItems
                for dbAttribute in mappingObject.getDBAttributes():
                    key     = ( dbAttribute.table, dbAttribute.attr )
                    target  = R.setdefault( key, [] )
                    if scm is not None:
                        conceptOntonym  = ':%s:%s' % ( scm, conceptLocator, )
                        conceptOntonym  = this._HACK_normalizeConceptlocatorToBracketless( conceptOntonym )
                        try:
                            termnr          = Dbs.getTermnrForOntonym( conceptOntonym )
                        except KeyError:
                            termnr          = None
                            conceptLocator  = '??? UNKNOWN LOCATOR ??? %s' % ( conceptLocator, )
                    else:
                        termnr          = None
                    value   = ( conceptLocator, termnr, mappingObject )
                    target.append( value )
        return R
    getMappingsByTablealiasesAndDsatsForCmf = classmethod( f ); del f



#           #---------------------------------------------------------------------------------------------------
#           psflocator = psfi.getPsfLocator( dsa )
#           schemaDescriptions = veryBasicSaxParser.getPsfSchemaDescriptionsForPsflocator( psflocator )
#           #---------------------------------------------------------------------------------------------------
#           for cmflocator in this.iterAllLikelyCmfLocatorsForDsa( dsa ):
#               problems, schemaDescription = \
#                   veryBasicSaxParser.getCmfSchemaDescriptionForCmflocatorPlus( cmflocator, isTemplate = False )
#               if schemaDescription is not None:
#                   target = R.setdefault( schemaDescription.namespacePrefix, [] )
#                   target.append( schemaDescription )
#               else:
#                   pass # print '# ????', cmflocator, problems

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsa ):
        R = this.getSchemaDescriptionsOfTemplatesByScm()
        R = this.getSchemaDescriptionsOfInstancesByScmForDsa( dsa, R )
        return R
    getAllSchemaDescriptionsByNamespaceForDsa = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, conceptlocator ):
        slashAtPosition = conceptlocator.find( '/@' )
        if slashAtPosition < 0: return conceptlocator
        R = '%s[%s]' % ( conceptlocator[ : slashAtPosition ], conceptlocator[ slashAtPosition + 1 : ] )
        return R
    _HACK_normalizeConceptlocatorToBracketed = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, conceptlocator ):
        slashAtPosition = conceptlocator.find( '[@' )
        if slashAtPosition < 0: return conceptlocator
        R = '%s/%s' % ( conceptlocator[ : slashAtPosition ], conceptlocator[ slashAtPosition + 1 : -1 ] )
        return R
    _HACK_normalizeConceptlocatorToBracketless = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, conceptlocator, dsatDescription ):
        #mappings = cmf.path2mappings.setdefault( conceptlocator, [] )
        #mappings = cmf.path2mappings.setdefault( normconceptlocator, [] )
        #mappings = this.getMappingsByConcept( cmf, normconceptlocator )
        #if mappings is None or len( mappings ) == 0:
        CMFMappingClass = g.biocase.wrapper.cmf_element.CMFMappingClass
        normconceptlocator  = this._HACK_normalizeConceptlocatorToBracketed( conceptlocator )
        mapping             = CMFMappingClass()
        dBAttributeObject   = dsatDescription.asDBAttributeObject()
        mapping.addItem( dBAttributeObject )
        cmf.addMappingToConcept( normconceptlocator, mapping )
    insertNewMappingObject = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, conceptlocator, dsatDescription ):
        #mappings = cmf.path2mappings.setdefault( conceptlocator, [] )
        #mappings = cmf.path2mappings.setdefault( normconceptlocator, [] )
        #mappings = this.getMappingsByConcept( cmf, normconceptlocator )
        #if mappings is None or len( mappings ) == 0:
        normconceptlocator  = this._HACK_normalizeConceptlocatorToBracketed( conceptlocator )
        cmf.getMappingsByConcept( normconceptlocator )
        cmf.delMappingOfConcept( normconceptlocator, indexOfMapping )
    deleteMapping = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, mapping, dsatDescription ):
        dBAttributeObject = dsatDescription.asDBAttributeObject()
        mapping.addItem( dBAttributeObject )
    addDsatdescriptionToMapping = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, mapping, text ):
        mapping.addItem( text )
    addLiteralToMapping = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, conceptlocator ):
        normconceptlocator = this._HACK_normalizeConceptlocatorToBracketed( conceptlocator )
        return cmf.getMappingsByConcept( normconceptlocator )
    getMappingsByConcept = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, conceptlocator, cardinality = None ):
        """Return an iterator that steps over all mappings in the ``cmf`` that contain exactly ``cardinality`` items
        (which maybe literals or data source attributes) together with the correct index as needed by
        ``cmf.delMappingOfConcept(normconceptlocator,indexOfMapping)``."""
        indexOfMapping = -1
        mappings = this.getMappingsByConcept( cmf, conceptlocator )
        for mapping in mappings:
            indexOfMapping += 1
            if cardinality is not None and len( mapping.items ) != cardinality: continue
            yield indexOfMapping, mapping
    iterIndicesAndMappings = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, conceptlocator, dsatDescription = None ):
        R = []
        normconceptlocator = this._HACK_normalizeConceptlocatorToBracketed( conceptlocator )
        while True:
            try:
                existingMappings = this.iterIndicesAndMappings( cmf, conceptlocator, cardinality = 1 )
                for indexOfMapping, existingMapping in existingMappings:
                    for dBAttributeObject in existingMapping.getDBAttributes():
                        if dsatDescription is not None:
                            if not dsatDescription.refersToSameAttributeAsDBAttributeObject(
                                dBAttributeObject ):
                                continue
                        #print
                        #print conceptlocator
                        #print '\t', indexOfMapping
                        #print '\t', dBAttributeObject.table, dBAttributeObject.attr
                        R.append( existingMapping )
                        cmf.delMappingOfConcept( normconceptlocator, indexOfMapping )
                        #   Having removed the mapping, we have to start over since now the list has
                        #   changed -- back to square one:
                        raise 'oncemore'
            except 'oncemore':
                continue
            break
        return R
    removeAllSingularMappingsToDsatAndConceptlocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, cmf, dsatDescription = None ):
        R = []
        for conceptlocator in cmf.path2mappings.iterkeys():
            removedMappings = \
                cmfi.removeAllSingularMappingsToDsatAndConceptlocator( cmf, conceptlocator, mydsatdescription0 )
            R.extend( removedMappings )
        return R
    removeAllSingularMappingsToDsat = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, dBAttributeObject0, dBAttributeObject1 ):
#           return (
#       _dBAttributeObjectsAreEqual = classmethod( f ); del f
#   DsatDescription.dBAttributeObjectsAreEqual


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    sep  = '#' * 108
    sep1 = '=' * 108
    sep2 = '-' * 108
    import sys; sys.setrecursionlimit(50)

    psfi = PsfIdioms
    cmfi = CmfIdioms

    #-------------------------------------------------------------------------------------------------------
    def test0():
        #---------------------------------------------------------------------------------------------------
        print sep
        for name, locator in psfi.getDsaliasLocatorPairs():
            print '%-50s%s' % ( name, locator, )
        #---------------------------------------------------------------------------------------------------
        print sep
        psf = psfi.psfForDsa( 'foo' )
        psfi.show( psf )
        print dir( psf )
        print psf.IP
        #---------------------------------------------------------------------------------------------------
        print psf.dbms
        #---------------------------------------------------------------------------------------------------
        print sep
        print psf.dbIP
        print psf.datasource
        print psf.user
        print psf.password
        print psf.encoding
        print psf.tablegraph
        #---------------------------------------------------------------------------------------------------
        dsDescription = psfi.getDsDescription( psf )
        for tableDescription in dsDescription:
            print tableDescription.name
            for columnDescription in tableDescription:
                print '\t%s' % ( columnDescription.name, )

    #-------------------------------------------------------------------------------------------------------
    def test1( dsa = 'pontaurus' ):
        #---------------------------------------------------------------------------------------------------
        method = cmfi.getAllSchemaDescriptionsByNamespaceForDsa
        #method = cmfi.getSchemaDescriptionsOfInstancesByScmForDsa
        cmfsByPrefix = method( dsa )
        print sep
        print "Available Schemas and Schema Templates for DSA %s:" % ( dsa, )
        for prefix, sds in cmfsByPrefix.iteritems():
            print sep1
            print prefix
            for sd in sds:
                print sep2
                sd.__printoverview__()

        print sep1
        print "Available mappings:"
        for prefix, sds in cmfsByPrefix.iteritems():
            for sd in sds:
                if sd.isTemplate: continue
                print prefix, sd.filelocator

    #test1()

#       class cmfiX( CmfIdioms ):
#

    dsa = 'foo'
    scm = 'spice12'
    #scm = 'abcd12'
    scmfntrailer = 'empty.xml'
    print cmfi.createCmfForDsaScmScmfn( dsa, scm, scmfntrailer )
