#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
from __future__ import                  division
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
U                                       = u.IOU.U
ReprMx                                  = u.IOU.ReprMx

############################################################################################################
#
#
#
#===========================================================================================================
rrBest          = +2
rrIndifference  = 0
rrWorst         = -2
#-----------------------------------------------------------------------------------------------------------
rrMin           = min( rrWorst, rrBest )
rrMax           = max( rrWorst, rrBest )
rrDelta         = abs( rrMax - rrMin )

############################################################################################################
#
#
#
#===========================================================================================================
def nratingFromRrating( rrating ):
    """Convert a raw rating into a normalized one. The present implementation simply divides by two,
    but that could well be different."""
    return rrating / 2

############################################################################################################
#
#
#
#===========================================================================================================
nrBest          = nratingFromRrating( rrBest )
nrWorst         = nratingFromRrating( rrWorst )
nrIndifference  = nratingFromRrating( rrIndifference )
#-----------------------------------------------------------------------------------------------------------
nrMin           = min( nrWorst, nrBest )
nrMax           = max( nrWorst, nrBest )
nrMinmax        = ( nrMin, nrMax )
nrDelta         = abs( nrMax - nrMin )
#-----------------------------------------------------------------------------------------------------------


############################################################################################################
#
#
#
#===========================================================================================================
class Rating( ReprMx ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, rrating, topic = None, focus = None ):
        self.rrating    = rrating
        self.topic      = topic
        self.focus      = focus

    #-------------------------------------------------------------------------------------------------------
    def f():
        def fget( self ):
            return nratingFromRrating( self.rrating )
        return locals()
    nrating = property( **f() ); del f

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        topic = U( self.topic )
        focus = U( self.focus )
        rr = self.rrating
        nr = self.nrating
        return '<rrating %(rr)s (%(nr).2f) topic=%(topic)s focus=%(focus)s>' % vars()


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit(50)
    print

    print
    for rr in range( rrMin, rrMax + 1 ):
        print '%+3d -- %.4f' % ( rr, nratingFromRrating( rr ), )

    print
    for rr in range( rrMin, rrMax + 1 ):
        r = Rating( rr )
        print
        print r
        print '%+3d -- %.4f' % ( rr, r.nrating, )

    print
    print nrIndifference
    print nrDelta





