#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   STANDARD IMPORTS
#
#===========================================================================================================
import cgi


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
h                           = g.hm.h
cfg                         = g.cfg
docrefs                     = g.docrefs
ServletABC                  = g.ServletABC
#-----------------------------------------------------------------------------------------------------------


############################################################################################################
#
#
#
#===========================================================================================================
class Servlet( ServletABC ):

    #=======================================================================================================
    def __init__( self ):
        self.new()
        self.cgiQuerydict   = None
        self.mission        = self.getMission()
        cfg.const.debug     = cfg.const.debug or ( self.query.getfirst( '__cgiinfo__', None ) is not None )
    #-------------------------------------------------------------------------------------------------------
    def new( self ):
        self.query          = None
        self.mission        = None
        self._lastUniqueId  = -1    # tracks unique element ids in the form 'id234'
    #=======================================================================================================
    def getMission( self ):
        if self.query is not None:
            for name in self.query.keys():
                if name.startswith( cfg.const.submitPrefix ):
                    return name[ len( cfg.const.submitPrefix ) : ]

    #=======================================================================================================
    def _debug( self, psTarget ):
        def title( label ):
            return cfg.tr( cfg.th( label, colspan = 2 ) )
        def entry( label, content ):
            return cfg.tr( cfg.td( cfg.b( label ) ), cfg.td( content ) )

        print cfg.br()
        t = cfg.table(
            title( 'Instance members' ),
            entry( 'mission',               self.mission ),
            entry( 'psTarget.filename',     psTarget.filename ),
            entry( 'g.pathbase',            g.pathbase ),
            clasz = 'debug',
            )
        names = self.query.keys()
        if names:
            t.append( title( 'Request parameters' ) )
            names_ci = [ ( name.lower(), name ) for name in names ]
            names_ci.sort()
            for name_ci, name in names_ci:
                t.append( entry( name, self.query.getvalue( name ) ) )
        else:
            t.append( title( 'The request did not contain any parameters.' ) )
        print t

    #=======================================================================================================
    def beginPage( self, title, relbiocasepath ):
        print 'Content-Type: text/html; charset=UTF-8\n'
        #print
        print docrefs.standardHtmlTemplate_start( title = title, relbiocasepath = relbiocasepath )

    #=======================================================================================================
    def endPage( self, relbiocasepath ):
        print docrefs.standardHtmlTemplate_end( relbiocasepath = relbiocasepath )

    #=======================================================================================================
    def getUniqueId( self ):
        self._lastUniqueId += 1
        return 'id%d' % self._lastUniqueId

