#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
import                                  sys
import                                  cgi
import                                  traceback
#   import                                  inspect
import                                  os.path
import                                  os
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
acquire                                 = u.pylon.acquire
Cookie                                  = u.EzCookie.EzCookie
Facet                                   = u.multilateralfacets.MultilateralFacet
FacetContainer                          = u.multilateralfacets.MultilateralFacetContainer
fsi                                     = u.filesystemIdioms
IOU                                     = u.IOU
S                                       = u.EzSet.S
typo                                    = u.typo
XmlMaker                                = u.XmlMaker.XmlMaker
GluerMx                                 = u.glue.GluerMx
#-----------------------------------------------------------------------------------------------------------

############################################################################################################
#
#
#
#===========================================================================================================
class getHttpHeader( object ):

    #-------------------------------------------------------------------------------------------------------
    def f( this, mimetype, encoding ):
        return 'Content-Type: %s; charset=%s' % ( mimetype, encoding, )
    contentType = classmethod( f ); del f


#   ############################################################################################################
#   #
#   #
#   #
#   #===========================================================================================================
#   class Response( object ):
#
#       #-------------------------------------------------------------------------------------------------------
#       class formats:
#           unknown         = 0
#           x               = 1
#           plaintext       = 2
#           rawhtmlfragment = 4
#
#       #-------------------------------------------------------------------------------------------------------
#       class states:
#           ok              = 0
#           errors          = 1
#           internalerror   = 2
#
#       #-------------------------------------------------------------------------------------------------------
#       def __init__( self, contents, format = formats.x, errors = None, status = states.ok ):
#           self.contents   = contents
#           self.format     = format
#           self.errors     = errors
#           self.status     = status
#
#   #===========================================================================================================
#   class PlaintextInternalErrorResponse( Response ):
#
#       #-------------------------------------------------------------------------------------------------------
#       def __init__( self, message ):
#           super( PlaintextInternalErrorResponse, self ).__init__(
#               contents    = message,
#               format      = Response.formats.plaintext,
#               errors      = True,
#               status      = Response.states.internalerror,
#               )


############################################################################################################
#
#
#
#===========================================================================================================
class Servlet3( object, GluerMx ):

    ########################################################################################################
    #   SERVLET BEHAVIOR PARAMETERS
    #-------------------------------------------------------------------------------------------------------
    title                       = 'Configtool Servlet2 Instance Page'
    titleTypename               = 'title'
    rootTypename                = 'html'    # obligatory
    rootIsRawstring             = False     # set to true and say self.root = '<b>foo</b>' to define page
    headTypename                = 'head'    # optional
    bodyTypename                = 'body'    # optional
    defaultNamespace            = XmlMaker._.namespaces.xhtml1.transitional
    doctype                     = XmlMaker._.doctypes.xhtml1.transitional
    bodyMimetype                = 'text/html'
    scriptMimetype              = 'text/javascript'
    styleMimetype               = 'text/css'
    encoding                    = 'utf-8'
    useMetatags                 = True
    useLinktags                 = True
    useScripttags               = True
    hrefPrevious                = None
    hrefNext                    = None
    resourceUrlBase             = 'URL_TO_RESOURCES'
    scriptUrlBase               = 'URL_TO_SCRIPTS'
    useCookies                  = True
    cookieMaxage                = 2 * Cookie.secondsPerWeek
    #-------------------------------------------------------------------------------------------------------
    facetDescriptions = dict(
        im = dict(
            name        = 'im',
            default     = 'default',
            controlled  = True,
            vocabulary  = dict(
                    default = 'default',
                    debug   = 'debug',
            )),
        )


    ########################################################################################################
    #   INITIALIZATION
    #-------------------------------------------------------------------------------------------------------
    def __init__( self ):
        #   self.new()
        self.here               = fsi.here( lambda:None )
        self.response           = None
        X = XmlMaker()
        #---------------------------------------------------------------------------------------------------
        self.FacetContainer     = FacetContainer()
        self.fc                 = self.FacetContainer
        self.fc.auxvars         = getattr( self, 'auxvars', None )
        for facetDescription in self.facetDescriptions.itervalues():
            self.fc.add( Facet( **facetDescription ) )
        self.fc.updateFromCgiEnvironment()
        #print '~~~~~~~~~~~', self.fc ###DEBUG###
        #---------------------------------------------------------------------------------------------------
        self.missionVocabulary  = self.fc.i.im.vocabulary
        self.mission            = self.missionVocabulary.nameForValue()
        for name, value in self.missionVocabulary.iteritems():
            setattr( self, 'mission_%s' % name, value )
        #---------------------------------------------------------------------------------------------------
        self.precontents        = X._.VirtualTag()
        self.postcontents       = X._.VirtualTag()
        self.preattributes      = X._.Attributes()
        self.root               = X._.t( self.rootTypename )
        #---------------------------------------------------------------------------------------------------
        if self.defaultNamespace:
            self.root.fillin( xmlns = self.defaultNamespace )
        #---------------------------------------------------------------------------------------------------
        if self.headTypename:
            self.head           = X._.t( self.headTypename )
            self.root.append( self.head )
        else:
            self.head           = None
        #---------------------------------------------------------------------------------------------------
        if self.bodyTypename:
            self.body           = ~self.root.X._.t( self.bodyTypename )
            self.contents       = self.body
        else:
            self.body           = None
            self.contents       = self.root
        #---------------------------------------------------------------------------------------------------
        if self.useMetatags:
            self.metatags       = ~self.head.X._.VirtualTag()
        else:
            self.metatags       = None
        #---------------------------------------------------------------------------------------------------
        if self.useLinktags:
            self.linktags       = ~self.head.X._.VirtualTag()
        else:
            self.linktags       = None
        #---------------------------------------------------------------------------------------------------
        if self.useScripttags:
            self.scripttags     = ~self.head.X._.VirtualTag()
            self.postscripttags = self.postcontents.X._.VirtualTag()
        else:
            self.scripttags     = None
            self.postscripttags = None
        #---------------------------------------------------------------------------------------------------
        self.cookie             = None
        self._loadCookie()
        self.session            = None
        #---------------------------------------------------------------------------------------------------
        self.messages           = []
        self.problems           = []
        #---------------------------------------------------------------------------------------------------
        self.X = XmlMaker( self.contents )
        self.X_                 = X._
        self.suppressPage       = False # set to True to only send headers
        #   HTTP Status keeps tracks of headers sent from the CGI to or through the server, such as
        #   client page caching inhibition and redirections:
        self.httpStatus         = []
        self.httpStatus_has_NoCache  = False
        self._respond()
        self.printAll()

    #-------------------------------------------------------------------------------------------------------
    def _loadCookie( self ):
        if not self.useCookies: return
        input = os.environ.get( 'HTTP_COOKIE', '' )
        self.cookie = Cookie()
        #self.cookie.guessPathAndDomain()
        self.cookie.maxage = self.cookieMaxage
        #self.cookie[ 'default' ] = 'dummy' # will print out that when page is sent
        #self.cookie[ 'default' ][ 'domain' ] = '127.0.0.1:8080' # will print out that when page is sent
        self.cookie.load( input )

    ########################################################################################################
    #   OUTPUT METHODS
    #-------------------------------------------------------------------------------------------------------
    def printAll( self ):
        self.printHttpHeaders()
        if not self.rootIsRawstring:
            if not self.suppressPage:
                self.printPage()
        #-------------------------------------------------------------------------------------------------------
        else:
            print self.root

    #-------------------------------------------------------------------------------------------------------
    def setRootRawstring( self, rawstring ):
        self.root = self.X._.Rawstring( rawstring )
        self.rootIsRawstring = True

    #-------------------------------------------------------------------------------------------------------
    def printHttpHeaders( self ):
        fs = "%s\r\n"
        write = sys.stdout.write
        write( fs % ( getHttpHeader.contentType( self.bodyMimetype, self.encoding ), ) )
        if self.httpStatus:
            #status = '\n' .join( [ '%s' % ( status, ) for status in self.httpStatus ] )
            #print status
            for status in self.httpStatus:
                write( fs % ( status, ) )
        if self.cookie is not None:
            #print '%s' % ( self.cookie, )
            write( fs % ( self.cookie, ) )
        #print 'hello'
        #print '%s' % ( getHttpHeader.contentType( self.bodyMimetype, self.encoding ), )
        write( fs % '' )

    #-------------------------------------------------------------------------------------------------------
    def setNoCachingHeaders( self ):
        if self.httpStatus_has_NoCache: return
        self.httpStatus.append( 'Cache-Control: no-cache, no-store' )
        self.httpStatus.append( 'Pragma: no-cache' )
        self.httpStatus.append( 'Expires: 01-Jan-2000 18:18:50 GMT' )
        self.httpStatus_has_NoCache = True

    #-------------------------------------------------------------------------------------------------------
    def redirect( self, location, suppressPage = True ):
        #self.httpStatus.append( 'Status: 303 See Other' )
        self.httpStatus.append( 'location: %s' % ( location, ) )
        self.httpStatus.append( 'Status: 302 Found' )
        #self.httpStatus.append( 'Status: 303 See other' )
        #self.httpStatus.append( 'Status: 307 Temporary Redirect' )
        self.suppressPage = False
        self.body.N = 'body'

    #-------------------------------------------------------------------------------------------------------
    def printPage( self ):
        print self.doctype
        if self.head is not None:
            self.head.append( self.X._.t( self.titleTypename, self.title ) )
            if self.useMetatags:
                ~self.metatags.X.meta(
                    http_equiv  = 'Content-Type',
                    content     = '%s; charset=%s' % ( self.bodyMimetype, self.encoding  ) )
                ~self.metatags.X.meta(
                    http_equiv  = 'Content-Style-Type',
                    content     = self.styleMimetype )
                ~self.metatags.X.meta(
                    http_equiv  = 'Content-Script-Type',
                    content     = self.scriptMimetype )
#           contents = []
#           contents.extend( self.precontents.P )
#           contents.append( self.contents )
#           contents.extend( self.postcontents.P )
#           contents.extend( self.postscripts.P )
        self.root.P.insert( 0, self.precontents )
        self.body |= self.postcontents
        self.body |= self.postscripttags
        self.root.fillin( self.preattributes )
        print self.root

    ########################################################################################################
    #   PAGE MODIFICATION METHODS
    #-------------------------------------------------------------------------------------------------------
    def setLink( self, rel, href ):
        assert self.useLinktags and self.linktags is not None
        ~self.linktags.X.link( rel = rel, href = href )

    #-------------------------------------------------------------------------------------------------------
    def setLinkToPrevious( self, href ):
        self.hrefPrevious = href
        self.setLink( rel = 'prev', href = href )

    #-------------------------------------------------------------------------------------------------------
    def setLinkToNext( self, href ):
        self.hrefNext = href
        self.setLink( rel = 'next', href = href )

    #-------------------------------------------------------------------------------------------------------
    def setLinkToCss( self, href ):
        self.setLink( rel = 'stylesheet', href = href )

    #-------------------------------------------------------------------------------------------------------
    def setLinkToIcon( self, href ):
        self.setLink( rel = 'SHORTCUT ICON', href = href )

    #-------------------------------------------------------------------------------------------------------
    def setLinkToScript( self, href ):
        assert self.useScripttags and self.scripttags is not None
        ~self.scripttags.X.script( src = href, type = self.scriptMimetype )

    #-------------------------------------------------------------------------------------------------------
    def includeScript( self, relativeFilepath, isPostscript = False, variables = None ):
        locator = os.path.abspath( os.path.join( self.here, relativeFilepath ) ).replace( '\\', '/' )
        source = ''
        try:
            try:
                sourcefile = file( locator, 'rb' )
                source = sourcefile.read()
            finally:
                try:
                    sourcefile.close()
                except:
                    pass
        except IOError, e:
            source = self.missingJsfile( locator, '%s' % ( e, ) ) #.splitlines()
        self.includeScriptSource( source, isPostscript, variables )

    #-------------------------------------------------------------------------------------------------------
    def includeScriptSource( self, source, isPostscript = False, variables = None ):
        assert self.useScripttags and self.scripttags is not None
        if isPostscript:
            scripttags = self.postscripttags
        else:
            scripttags = self.scripttags
        if variables:
            source %= variables
        scripttags |= self.X._.Script( self.X._.Rawstring( source ) )

    #-------------------------------------------------------------------------------------------------------
    def anchorToPrevious( self, *P, **Q ):
        if self.hrefPrevious:
            Q = acquire( Q, href = self.hrefPrevious )
            return self.X.a( *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def anchorToNext( self, *P, **Q ):
        if self.hrefNext:
            Q = acquire( Q, href = self.hrefNext )
            return self.X.a( *P, **Q )

    ########################################################################################################
    #   RESPONSE METHODS
    #-------------------------------------------------------------------------------------------------------
    def _respond( self ):
        self.respond()

    #-------------------------------------------------------------------------------------------------------
    def respond( self ):
        raise NotImplementedError

#       #-------------------------------------------------------------------------------------------------------
#       def getMissionNameAndResponseMethodFromIm( self, im ):
#           imFacet             = self.fc.i.im
#           missionName         = self.missionVocabulary.nameForValue( im )
#           if missionName is None: return None, None
#           responseMethodname  = 'respond_%s' % ( missionName, )
#           responseMethod      = getattr( self, responseMethodname, None )
#           if responseMethod is None: return None, None
#           return missionName, responseMethod

    #-------------------------------------------------------------------------------------------------------
    def divert( self, im, *P, **Q ):
        missionName, responseMethod = self.getMissionNameAndResponseMethodFromIm( im )
        if missionName is None:
            raise ValueError( 'Unable to divert to %r' % ( im, ) )
        self.mission = missionName
        self.fc.i.im.value = im
        self.fc.i.jm.value = ''
        return responseMethod( *P, **Q )

#       #-------------------------------------------------------------------------------------------------------
#       def act( self ):
#           responseMethod      = lambda:None
#           responseMethodname  = 'respond_%s' % ( self.mission, )
#           R                   = None
#           msg                 = None
#           try:
#               responseMethod = getattr( self, responseMethodname )
#           except AttributeError, e:
#               R = PlaintextInternalErrorResponse(
#                   'Unknown Mission Identifier: %r (%s).' % ( self.mission, e, ),
#                   )
#           else:
#               try:
#                   try:
#                       R = responseMethod()
#                   except:
#                       e   = sys.exc_info()[ 0 ]
#                       msg = ''.join( traceback.format_exception( *sys.exc_info() ) )
#                       if isinstance( e, basestring ):
#                           raise Exception()
#                       raise
#               except Exception, e:
#                   R = PlaintextInternalErrorResponse( msg )
#           if not isinstance( R, Response ):
#               rp = typo.clip( '%r' % ( R, ) )
#               cn = R.__class__.__name__
#               R = PlaintextInternalErrorResponse(
#                   message = ( ''
#                       + 'The response returned by method %(responseMethodname)s'
#                       + ' should be a Response instance, is %(rp)r (class %(cn)s).'
#                       ) % vars()
#                   )
#           self.response = R
#           return R

#       #-------------------------------------------------------------------------------------------------------
#       def Response( self, *P, **Q ):
#           return Response( *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def respond_debug( self ):
        self.title = 'Debugging Page'
        R = self.X.h1( self.title )
        return self.Response( R )

    #-------------------------------------------------------------------------------------------------------
    def respond_default( self ):
        self.title = 'Default Page (no mission specified)'
        R = self.X.h1( self.title )
        return self.Response( R )

    ########################################################################################################
    #   SUNDRY
    #-------------------------------------------------------------------------------------------------------
    def resourceUrl( self, resourceUrl ):
        return self._joinUrls( self.resourceUrlBase, resourceUrl )

    #-------------------------------------------------------------------------------------------------------
    def scriptUrl( self, scriptUrl ):
        return self._joinUrls( self.scriptUrlBase, scriptUrl )

    #-------------------------------------------------------------------------------------------------------
    def missingJsfile( self, locator, error ):
        msg = IOU.jsU( "This file is missing: %s.\n%s" % ( locator, error, ) )
        return """/* MISSING JS FILE */
        alert( %r ); """ % ( msg, )

    #-------------------------------------------------------------------------------------------------------
    def _joinUrls( self, baseUrl, resourceUrl = '' ):
        """Return URL that results from joining ``baseUrl`` and ``resourceUrl``. If the latter starts
        with a slash or a dot or if it contains a colon, the result is equal to ``resourceUrl``."""
        if baseUrl.endswith( '/' ):
            baseUrl = baseUrl[ : -1 ]
        if resourceUrl.startswith( '.' ) or resourceUrl.startswith( '/' ) or ':' in resourceUrl:
            return resourceUrl
        return '%s/%s' % ( baseUrl, resourceUrl, )

#       ########################################################################################################
#       #   MESSAGES AND PROBLEMS HANDLING
#
#           NOW DONE IN SELF.SESSION
#
#       #-------------------------------------------------------------------------------------------------------
#       def addProblemForSender( self, sender, msg ):
#           self.session.addProblem( sender, msg )
#
#       #-------------------------------------------------------------------------------------------------------
#       def popProblemsForSender( self, sender ):
#           self.session.getProblemForSender( sender, msg )
#
#       #-------------------------------------------------------------------------------------------------------
#       def addWarningForSender( self, sender, msg ):
#           self.session.addWarning( sender, msg )
#
#       #-------------------------------------------------------------------------------------------------------
#       def popWarningsForSender( self, sender ):
#           self.session.getWarningForSender( sender, msg )
#
#   #       def addProblem( self, *P ):
#   #           self.problems.append( self.X._.VirtualTag( *P ) )
#   #
#   #       #-------------------------------------------------------------------------------------------------------
#   #       def addMessage( self, *P ):
#   #           self.messages.append( self.X._.VirtualTag( *P ) )
#   #
#   #       #-------------------------------------------------------------------------------------------------------
#   #       def includeMessagesAndProblems( self ):
#   #           if self.messages:
#   #               c = self.X._.VirtualTag()
#   #               self.body.P.insert( 0, c )
#   #               for message in self.messages:
#   #                   c.append( self.X.div( message, clasz = 'message' ) )
#   #           if self.problems:
#   #               c = self.X._.VirtualTag()
#   #               self.body.P.insert( 0, c )
#   #               for problem in self.problems:
#   #                   c.append( self.X.div( problem, clasz = 'problem' ) )
#   #           if self.messages or self.problems:
#   #               self.body.P.insert( 0, self.X.div( self.X._.nbsp ) )
#   #               self.body.P.insert( 0, self.X.div( self.X._.nbsp ) )

    ########################################################################################################
    #   SUNDRY
    #-------------------------------------------------------------------------------------------------------
    def _extendClass( self, Q, *P ):
        classes = Q.setdefault( 'clasz', '' ).split()
        classes.extend( P )
        Q[ 'clasz' ] = ' '.join( classes )


############################################################################################################
#
#
#
#===========================================================================================================
class FramesetServlet( Servlet3 ):

    doctype                     = XmlMaker._.doctypes.xhtml1.frameset
    bodyTypename                = 'frameset'

    ########################################################################################################
    #   OUTPUT METHODS
    #-------------------------------------------------------------------------------------------------------
    def _start( self, title ):
        self.title = title
        #return self.body
        #self.setLinkToCss( '../media/boxer2.css' )

    #-------------------------------------------------------------------------------------------------------
    def _finish( self ):
        pass

    #-------------------------------------------------------------------------------------------------------
    def _respond( self ):
        try:
            self.respond()
        except Exception, e:
            self.body.N = 'body'
            raise

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    #=======================================================================================================
    class MyServlet( Servlet3 ):
        #---------------------------------------------------------------------------------------------------
        def respond( self ):
            ~self.X.p( 'Here is a paragraph, followed by a table:' )
            t = ~self.X.table()
            tr = ~t.X.tr()
            ~tr.X.td( 'table cell' )
            ~tr.X.td( 'mission: %r' % ( self.mission, ) )
            self.setLinkToScript( 'foo.js' )
            self.setLinkToCss( 'foo.css' )
            self.setLinkToNext( 'next.py' )
            self.setLinkToPrevious( 'previous.py' )

    import os
    os.environ[ 'QUERY_STRING' ] = 'x=42&im=UNREAL&im=db'
    #os.environ[ 'QUERY_STRING' ] = 'x=42'

    s = MyServlet()
    print s.mission
    print s.doctype

