#
# -*- coding: utf-8 -*-


#-----------------------------------------------------------------------------------------------------------
import                                      cgi
import                                      new
#-----------------------------------------------------------------------------------------------------------
u                                           = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
ReprMx                                      = u.IOU.ReprMx
U                                           = u.IOU.U
outputencodingname                          = u.IOU.outputencoding
SerializableMx                              = u.SerializableMx.SerializableMx
#-----------------------------------------------------------------------------------------------------------
#DEBUG                                       = True
DEBUG                                       = False
_EMPTY_STRING                               = ''
_NL                                         = '\n'
#-----------------------------------------------------------------------------------------------------------
class const:
    classHomonyms = ( 'class_', 'klass', 'clasz', 'clazz' )

#
#   To do
#   ========================================================================================================
#
#   *   regularize interface, make specials (virtual tags, entities etc.) more readily
#       accessible; remove split between document / tag / virtual tag / entity etc.
#
#   *   make it easier to produce empty tags -- e.g. output all tags with no contents as empty
#       tags
#
#   *   integrate most frequently experienced HTML/XML tasks in XmlMaker:
#
#       -   abstracted handling of name lists in ``class`` attribute
#
#       -   abstracted handling of css and ``style`` attributes
#
#       -   integration of variables across XML, CSS, JavaScript


############################################################################################################
#
#
#
#===========================================================================================================
class Helper( object ):

    #-------------------------------------------------------------------------------------------------------
    def f( this, Q, *P ):
        classes = Q.setdefault( 'clasz', '' ).split()
        classes.extend( P )
        Q[ 'clasz' ] = ' '.join( classes )
    extendClass = classmethod( f ); del f


############################################################################################################
#
#
#
#===========================================================================================================
class namespaces( object ):
    class xhtml1( object ):
        strict          = 'http://www.w3.org/1999/xhtml'
        transitional    = 'http://www.w3.org/1999/xhtml'
        generic         = 'http://www.w3.org/1999/xhtml'

#===========================================================================================================
class doctypes( object ):
    class xhtml1( object ):
        transitional = ( ''
            + '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"'
            + ' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' )
        frameset = ( ''
            + '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN"'
            + ' "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">' )

#   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
#   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
#   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN"     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">

class noescape: pass

############################################################################################################
#
#
#
#===========================================================================================================
def acquire( *P, **Q ):
    """Given any number of unnamed dictionaries (retrieved as ``P``) and any number of named arguments,
    return the dictionary that results from taking the named arguments as defaults, and all entries in
    ``P`` *in reversed order of appearance* as updates to those defaults. In other words, values with
    same names that come earlier *overwrite* values that come later."""
    for i in range( len( P ) - 1, -1, -1 ):
        Q.update( P[ i ] )
    return Q



############################################################################################################
#
#
#
#===========================================================================================================
def toEscapedUnicode( x ):
    return cgi.escape( U( x ) )


############################################################################################################
#
#
#
#===========================================================================================================
class mangle:
    #-------------------------------------------------------------------------------------------------------
    class rules( object ):
        #---------------------------------------------------------------------------------------------------
        def f( x ):
            return x.replace( '_', '-' )
        allUnderscoresToHyphens = staticmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( x ):
            return x.replace( '__', ':' )
        doubleUnderscoreToColon = staticmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( x ):
            if x.endswith( '_' ):
                return x[:-1]
            return x
        cancelTrailingUnderscore = staticmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    class attributeName( object ):
        def f( x ):
            if not x.startswith( '_' ):
                if x in const.classHomonyms:
                    x = 'class'
                x = mangle.rules.allUnderscoresToHyphens(
                    mangle.rules.doubleUnderscoreToColon( x ) )
                return x
        toText = staticmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    class className( object ):
        def f( x ):
            return mangle.rules.allUnderscoresToHyphens(
                mangle.rules.cancelTrailingUnderscore(
                    mangle.rules.doubleUnderscoreToColon( x ) ) )
        toText = staticmethod( f ); del f

class unmangle:
    #-------------------------------------------------------------------------------------------------------
    class rules( object ):
        #---------------------------------------------------------------------------------------------------
        def f( x ):
            return x.replace( '-', '_' )
        allHyphensToUnderscores = staticmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( x ):
            return x.replace( ':', '__' )
        ColonToDoubleUnderscore = staticmethod( f ); del f



############################################################################################################
#
#
#
#===========================================================================================================
class Contents( ReprMx, list, noescape, SerializableMx ):

    #-------------------------------------------------------------------------------------------------------
    replaceEmptyWithNbsp = False

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        R = []
        for element in self:
            if isinstance( element, noescape ):
                R.append( U( element ) )
            elif isinstance( element, Rawstring ):
                R.append( element )
            elif isinstance( element, _xperimental_RawOctetsString ):
                R.append( U( element ) )
            elif isinstance( element, basestring ):
                R.append( toEscapedUnicode( element ) )
            else:
                R.append( toEscapedUnicode( element ) ) # U() ???
        R = _EMPTY_STRING.join( R )
        if not R and self.replaceEmptyWithNbsp:
            R = '%s' % ( h.nbsp, )
        return R

#       #-------------------------------------------------------------------------------------------------------
#       def __unicode__( self ):
#           R = []
#           for element in self:
#               if isinstance( element, noescape ):
#                   R.append( U( element ) )
#               elif isinstance( element, Rawstring ):
#                   R.append( element )
#               elif isinstance( element, _xperimental_RawOctetsString ):
#                   R.append( Rawstring( U( element ) ) )
#               elif isinstance( element, basestring ):
#                   R.append( Rawstring( toEscapedUnicode( element ) ) )
#               else:
#                   R.append( Rawstring( toEscapedUnicode( element ) ) )# U() ???
#           R = _EMPTY_STRING.join( R )
#           if not R and self.replaceEmptyWithNbsp:
#               R = '%s' % ( h.nbsp, )
#           return R

    #-------------------------------------------------------------------------------------------------------
    def f( this, P ):
        R = []
        A = None
        for element in P:
            if   isinstance( element,  Rawstring ): A = element
            elif isinstance( element, basestring ): A = toEscapedUnicode( element )
            else:                                   A = U( element )
        if A is not None:
            R.append( A )
        R = _EMPTY_STRING.join( R )
        if ( not R ) and this.replaceEmptyWithNbsp:
            R = '%s' % ( X._.nbsp, )
        return R
    _toString = classmethod( f ); del f


#===========================================================================================================
class NbspGuardedContents( Contents ):

    #-------------------------------------------------------------------------------------------------------
    replaceEmptyWithNbsp = True


############################################################################################################
#
#
#
#===========================================================================================================
class Attributes( ReprMx, dict, noescape, SerializableMx ):

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        if len( self ):
            return ' '.join( [
                '%s="%s"' % (
                        mangle.attributeName.toText( U( name ) ),
                        toEscapedUnicode( value ) )
                    for name, value in self.items() ] )
        else:
            return _EMPTY_STRING


############################################################################################################
#
#
#
#===========================================================================================================
class AttributeWrapper( object ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, owner ):
        self.__dict__[ '_' ] = owner.Q

    #-------------------------------------------------------------------------------------------------------
    def __getitem__( self, name ):
        return self._[ name ]

    #-------------------------------------------------------------------------------------------------------
    def __setitem__( self, name, value ):
        self._[ name ] = value

    #-------------------------------------------------------------------------------------------------------
    def __getattr__( self, name ):
        return self[ name ]

    #-------------------------------------------------------------------------------------------------------
    def __setattr__( self, name, value ):
        if name.startswith( '__' ) and name.endswith( '__' ):
            setattr( self, name, value )
        self[ name ] = value

    #-------------------------------------------------------------------------------------------------------
    def __getstate__( self ):
        """Method to make instances ``pickle``\ able."""
        return {}

    #-------------------------------------------------------------------------------------------------------
    def __setstate__( self, getstate ):
        """Method to make instances ``pickle``\ able."""
        pass

############################################################################################################
#
#
#
#===========================================================================================================
class Tag( ReprMx, noescape, SerializableMx ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, __elementtypename__, *P, **Q ):
        self.N          = __elementtypename__
        self.P          = Contents( P )
        self.Q          = Attributes( Q )
        self.A          = AttributeWrapper( self )
        self.X          = XmlMaker( self )
        self.owner      = None
        self.newlines   = DEBUG
    #-------------------------------------------------------------------------------------------------------
    def __call__( self, *P, **Q ):
        """Perform ``~.extend(P)`` and ``~.update(Q)`` and return instance."""
        self.extend( P )
        self.update( Q )
        return self

    #-------------------------------------------------------------------------------------------------------
    def copy( self ):
        """Return a shallow copy of this instance with identical name, identical contents, and identical XML
        attributes."""
        return self.__class__( self.N, *self.P, **self.Q )

    #-------------------------------------------------------------------------------------------------------
    def emptycopy( self ):
        """Like ``~.copy()``, but without the contents."""
        return self.__class__( self.N, **self.Q )

    #-------------------------------------------------------------------------------------------------------
    def update( self, Q ):
        """Update XML attributes with the name/value pairs given in the single argument ``Q``, which should
        be a dictionary-like thingie."""
        self.Q.update( Q )

    #-------------------------------------------------------------------------------------------------------
    def fillin( self, *P, **Q ):
        """Set XML attributes where not already present; ``P`` and ``Q`` are handled by the module-level
        function ``acquire()``, which see for an explanantion."""
        self.acquire( self.Q, **acquire( *P, **Q ) )

    #-------------------------------------------------------------------------------------------------------
    def acquire( self, *P, **Q ):
        """Update XML attributes with the dictionary that results from applying the module-level function
        ``acquire(*P,**Q)`` to the arguments."""
        self.update( acquire( *P, **Q ) )

    #-------------------------------------------------------------------------------------------------------
    def append( self, *P ):
        """Append an arbitrary number of elements to the contents of the tag."""
        self.extend( P )

    #-------------------------------------------------------------------------------------------------------
    def __ior__( self, other ):
        """Applying the ``|`` operator: append right hand side to contents of this tag. OBS.: right hand
        side is not copied, so oring one tag to multiple others retains object identity (which may or may
        not be what you want)."""
        self.append( other )
        return self

    #-------------------------------------------------------------------------------------------------------
    def __or__( self, other ):
        R = self.copy()
        R.__ior__( other )
        return R
    __or__.__doc__ = __ior__.__doc__

    #-------------------------------------------------------------------------------------------------------
    def __iand__( self, other ):
        raise NotImplementedError
        #   R = self.copy()
        #   if not isinstance( self, VirtualTag ):
        #       R = VirtualTag( R )
        #   R.append( other )
        #   return R

    #-------------------------------------------------------------------------------------------------------
    def __and__( self, other ):
        """Applying the ``&`` operator means concatenation -- append right hand side after this tag. Left
        hand side is copied and, if it is not already an instance of ``VirtualTag``, put into a new virtual
        tag instance. OBS.: right hand side is not copied, so anding one tag to multiple others retains
        object identity (hich may or may not be what you want)."""
        R = self.copy()
        if not isinstance( self, VirtualTag ):
            R = VirtualTag( R )
        R.append( other )
        return R
    __and__.__doc__ = __iand__.__doc__

    #-------------------------------------------------------------------------------------------------------
    def __invert__( self ):
        if self.owner is None:
            raise TypeError( "You must set tag.owner to use this method." )
        self.owner._.root |= self
        return self

    #-------------------------------------------------------------------------------------------------------
    def extend( self, P ):
        self.P.extend( P )

    #-------------------------------------------------------------------------------------------------------
    def __getitem__( self, name ):
        return self.Q[ name ]

    #-------------------------------------------------------------------------------------------------------
    def __setitem__( self, name, value ):
        self.Q[ name ] = value

    #-------------------------------------------------------------------------------------------------------
    def set( self, **Q ):
        self.Q.update( Q )

    #-------------------------------------------------------------------------------------------------------
    def _getP( self ):
        """This method gives a hook to insert automatic content."""
        return self.P

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        return self.repr()

    #-------------------------------------------------------------------------------------------------------
    def repr( self, position = 'complete' ):
        #N, P, Q = map( toUnicode, [ self.N, self.P, self.Q, ] )
        N, P, Q = map( U, [ self.N, self._getP(), self.Q, ] )
        N = mangle.className.toText( U( N ) )
        if Q: Q = ' %s' % ( Q, )
        if self.newlines:
            nl = _NL
        else:
            nl = _EMPTY_STRING
        if position == 'complete':
            return '%(nl)s<%(N)s%(Q)s>%(P)s</%(N)s>' % vars()
        if position == 'start':
            return '%(nl)s<%(N)s%(Q)s>' % vars()
        if position == 'end':
            return '%(nl)s</%(N)s>' % vars()
        if position == 'content':
            return '%(nl)s%(P)s' % vars()
        if position == 'empty':
            return '%(nl)s<%(N)s%(Q)s/>' % vars()
        raise TypeError( "Unrecognized format option: %s" % ( position, ) )


############################################################################################################
#
#
#
#===========================================================================================================
class EmptyTag( Tag ):

    #-------------------------------------------------------------------------------------------------------
    def repr( self, position = 'empty' ):
        return super( EmptyTag, self ).repr( position )

############################################################################################################
#
#
#
#===========================================================================================================
class ProcessingInstruction( Tag ):

    #-------------------------------------------------------------------------------------------------------
    def repr( self, position = None ):
        #N, P, Q = map( toUnicode, [ self.N, self.P, self.Q, ] )
        P = self._getP()
        P = '\n'.join( map( U, P ) )
        if P: P = '\n%s\n' % ( P, )
        N, Q = map( U, [ self.N, self.Q, ] )
        if Q: Q = ' %s' % ( Q, )
        return '<?%(N)s%(Q)s%(P)s?>' % vars()

#   #-----------------------------------------------------------------------------------------------------------
#   PI = ProcessingInstruction

############################################################################################################
#
#
#
#===========================================================================================================
def XmlDeclaration( version = '1.0', encoding = outputencodingname, standalone = 'yes', **Q ):
    R = ProcessingInstruction( 'xml', version = version, encoding = encoding, standalone = standalone )
    R.update( Q )
    return R

############################################################################################################
#
#
#
#===========================================================================================================
def XmlCssDeclaration( href, type = 'text/css' ):
    """This is a partial implementation; see http://www.w3.org/TR/xml-stylesheet/ for details."""
    R = ProcessingInstruction( 'xml-stylesheet', href = href, type = type )
    return R

############################################################################################################
#
#
#
#===========================================================================================================
class VirtualTag( Tag ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, *P, **Q ):
        super( VirtualTag, self ).__init__( '(VirtualTag)', *P, **Q )

#       #-------------------------------------------------------------------------------------------------------
#       def repr( self, position = None ):
#           return '[%s]' % ( U( self._getP() ), )

#       #-------------------------------------------------------------------------------------------------------
#       def repr( self, position = None ):
#           return '%s' % ( self.P, )

    #-------------------------------------------------------------------------------------------------------
    def repr( self, position = 'complete' ):
        P = U( self._getP() )
        if self.newlines:
            nl = _NL
        else:
            nl = _EMPTY_STRING
        return '%(P)s' % vars()

    #-------------------------------------------------------------------------------------------------------
    def copy( self ):
        """Return a shallow copy of this instance with identical name, identical contents, and identical XML
        attributes."""
        return self.__class__( *self.P, **self.Q )

    #-------------------------------------------------------------------------------------------------------
    def emptycopy( self ):
        """Like ``~.copy()``, but without the contents."""
        return self.__class__( **self.Q )


############################################################################################################
#
#
#
#===========================================================================================================
class RawstringABC:
    pass

class Rawstring( RawstringABC, unicode ):
    pass

class _xperimental_RawOctetsString( RawstringABC, str ):
    pass


############################################################################################################
#
#
#
#===========================================================================================================
class CDATA( Tag ):

    #---------------------------------------------------------------------------------------------------
    opener = '<![CDATA['
    closer = ']]>'

    #---------------------------------------------------------------------------------------------------
    def __init__( self, *P, **Q ):
        super( CDATA, self ).__init__( '(CDATA)', *P, **Q )

    #---------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        R = []
        R.append( Rawstring( self.opener ) )
        R.extend( map( Rawstring, self.P ) )
        R.append( Rawstring( self.closer ) )
        return '\n'.join( R )
        #return Contents._toString( R )

#===========================================================================================================
class JsCDATA( CDATA ):

    #---------------------------------------------------------------------------------------------------
    opener = '//<![CDATA['
    closer = '//]]>'

############################################################################################################
#
#
#
#===========================================================================================================
class Script( Tag ):

    #---------------------------------------------------------------------------------------------------
    def __init__( self, *P, **Q ):
        super( Script, self ).__init__( 'script', *P, **Q )
        self.fillin( type = 'text/javascript' ) #, xmlns = 'http://www.w3.org/1999/xhtml' )

    #---------------------------------------------------------------------------------------------------
    def _getP( self ):
        """This method gives a hook to insert automatic content."""
        return '%s' % ( JsCDATA( *self.P, **self.Q ) )
#           R = []
#           R.append( Rawstring( '//<![CDATA[\n' ) )
#           R.extend( [ Rawstring( p ) for p in self.P ] )
#           R.append( Rawstring( '\n//]]>' ) )
#           return Contents( R )


############################################################################################################
#
#
#
#===========================================================================================================
class Entity( ReprMx, noescape, SerializableMx ):
    """Class for entities."""

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, name ):
        self.name = name

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        name = '%s' % ( self.name, )
        if name:
            if name[ 0 ].isdigit():
                name = '#%s' % name
            else:
                name = self.name
            return U( u'&%s;' % ( name, ) )
        return ''

#===========================================================================================================
nbsp = Entity( 'nbsp' )
amp  = Entity( 'amp' )
lt   = Entity( 'lt' )
gt   = Entity( 'gt' )
quot = Entity( 'quot' )
apos = Entity( 'apos' )

#===========================================================================================================
def tagFactory( __elementtypename__, *P, **Q ):
    def f( *P_, **Q_ ):
        P__ = list( P )
        P__.extend( P_ )
        Q__ = acquire( Q_, **Q )
        return Tag( __elementtypename__, *P__, **Q__ )
    return f

#===========================================================================================================
def htmlNsDeclaration( __attributename__ = 'xmlns:h', __ns__ = namespaces.xhtml1.transitional ):
    R = Attributes()
    R[ __attributename__ ] = __ns__
    return R


############################################################################################################
#
#
#
#===========================================================================================================
class Namespace( ReprMx, SerializableMx ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, prefix, url ):
        self.prefix = prefix
        self.url    = url

    #-------------------------------------------------------------------------------------------------------
    def __getattr__( self, name ):
        prefixedname = '%s:%s' % ( self.prefix, name, )
        R = Tag( prefixedname )
        return R

############################################################################################################
#
#
#
#===========================================================================================================
class Specials( object, SerializableMx ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, owner, root ):
        self.owner = owner
        self.root = root

    #-------------------------------------------------------------------------------------------------------
    Contents                            = Contents
    Attributes                          = Attributes
    namespaces                          = namespaces
    doctypes                            = doctypes
    tagFactory                          = tagFactory
    #Tag                     = tag       = Tag
    #VirtualTag              = v         = VirtualTag
    ProcessingInstruction   = pi        = ProcessingInstruction
    Rawstring               = raw       = Rawstring
    #   StringIO                =             StringIO
    #-------------------------------------------------------------------------------------------------------
    XmlDeclaration          = xmldec    = staticmethod( XmlDeclaration )
    XmlCssDeclaration       = cssdec    = staticmethod( XmlCssDeclaration )
    htmlNsDeclaration       = htmlns    = staticmethod( htmlNsDeclaration )
    Script                  = js        = Script
    Entity                  = en        = Entity
    #-------------------------------------------------------------------------------------------------------
    nbsp                                = nbsp
    amp                                 = amp
    lt                                  = lt
    gt                                  = gt
    quot                                = quot
    apos                                = apos

    #-------------------------------------------------------------------------------------------------------
    def VirtualTag( self, *P, **Q ):
        R = VirtualTag( *P, **Q )
        R.owner = self.owner
        return R

    #-------------------------------------------------------------------------------------------------------
    def v( self, *P, **Q ):
        return self.VirtualTag( *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def Tag( self, *P, **Q ):
        R = Tag( *P, **Q )
        R.owner = self.owner
        return R

    #-------------------------------------------------------------------------------------------------------
    def t( self, *P, **Q ):
        return self.Tag( *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def EmptyTag( self, *P, **Q ):
        R = EmptyTag( *P, **Q )
        R.owner = self.owner
        return R

    #-------------------------------------------------------------------------------------------------------
    def et( self, *P, **Q ):
        return self.EmptyTag( *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def Namespace( self, prefix, url ):
        R = Namespace( prefix, url )
        return R

    #-------------------------------------------------------------------------------------------------------
    def setNamespace( self, prefix, url ):
        R = self.Namespace( prefix, url )
        setattr( self.owner, prefix, R )
        return R

    #-------------------------------------------------------------------------------------------------------
    def setns( self, *P, **Q ):
        return self.setNamespace( *P, **Q )


############################################################################################################
#
#
#
#===========================================================================================================
class XmlMaker( ReprMx, noescape, SerializableMx ):

    #-------------------------------------------------------------------------------------------------------
    _ = Specials

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, root = None ):
        if root is None:
            root = VirtualTag()
        self._ = Specials( self, root )

    #-------------------------------------------------------------------------------------------------------
    def __getattr__( self, name ):
        R = Tag( name )
        R.owner = self
        return R

    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        """When asked to deliver a serialization, fall back to root element."""
        return self._.root.__unicode__()

#-----------------------------------------------------------------------------------------------------------
X = XmlMaker


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit( 50 )

    X = XmlMaker()
    sep = X.SEP( '#' * 150 )

    difficult =  u"""<€ & \u1000>""" ###DEBUG###
    t = X.oops( 'hello', difficult, d = difficult, width = '100px' )
#       t.acquire( dict( d = 'in-P0' ), dict( d = 'in-P1' ), d = 'in-Q', x = 'ekis' )
    defaults = dict( width = '150px', height = '150px' )
    #t.acquire( t.Q, **defaults )
    t.fillin( defaults )
    r = t.emptycopy()
    r.append( 'new' )
    r[ 'height' ] = '200px'
    print `t`
    print `r`

    print sep
    a = X.A( 'this is A' )
    b = X.B( 'this is B' )
    print a | b
    print a
    print b
    a |= b
    print a

    print sep
    a = X.A( 'this is A' )
    b = X.B( 'this is B' )
    print a & b
    print a
    print b
    a = a & b
    a = a & b
    print a
    b[ 'NEW' ] = '!!!NEW!!!'
    print a

    print sep
    print VirtualTag( 'contents', invisible = '???' )

    print X._.pi( 'xml', version="1.0", encoding="UTF-8", standalone="yes" )
    print X._.pi( 'php', '# first line', '# second line' )

    src = """
    function show() {
        alert( 'hello world!' );
        }

    function addLikeCrazyAllTheTime( id ) {
        ingredientE = document.getElementById( 'i1' );
        e = document.createElement( 'component' );
        textE = document.createTextNode( 'more!' );
        e.appendChild( textE );
        //setTextOfElement( e, text );
        ingredientE .appendChild( e );
        }"""
    print X._.js( src )
    print CDATA( '<<>>' )
    c = CDATA( 'abcd', 'efgh' )
    print c

    print X._.apos, X._.amp, X._.lt


#       def I( *P, **Q ):
#           return X( 'I', *P, **Q )

    I = tagFactory( 'i', 'prefixed', id = 'unknown' )
    print I( 'foo' )
    print I( 'bar & baz', id = 'well-known & ready', width = '100px' )
    print X._.xmldec()
    print X._.cssdec( 'http://unknown.com/xy.css' )


    #   h:form
    #       hierarchical-display
    #           *entry
    #               @id = 'e$termnr'
    #               header
    #                   indentation
    #                   title
    #                   selector
    #                       h:img
    #                       h:input
    #                           @name = @id = 'select$termnr'
    #                           @value = 'o' | 'x'
    #               extra
    #                   *detail
    #                       h:input
    #                           @name = @id = 'detail$termnr'                   ????? not unique
    #                           @value = 'associate:$that-gauge:$that-termrn'
    #                       detail-display
    #               pen
    #                   *entry ...

    #   h:form
    #       hierarchical-display
    #           *e
    #               @id = 'e$termnr'
    #               h
    #                   i
    #                   t
    #                   s
    #                       h:img
    #                       h:input
    #                           @name = @id = 'select$termnr'
    #                           @value = 'o' | 'x'
    #               x
    #                   *d
    #                       h:input
    #                           @name = @id = 'detail$termnr'                   ????? not unique
    #                           @value = 'associate:$that-gauge:$that-termrn'
    #                       dd
    #               p
    #                   *e ...


    HierarchicalDisplay = tagFactory( 'hierarchical-display' )
    Entry               = tagFactory( 'e', id = 'UNKNOWN' )
    Header              = tagFactory( 'h' )
    Indentation         = tagFactory( 'i' )
    Title               = tagFactory( 't' )
    Img                 = tagFactory( 'h:img', src = 'UNKNOWN' )
    Selector            = tagFactory( 's', Img() )
    Extra               = tagFactory( 'x' )
    Detail              = tagFactory( 'd' )
    Association         = tagFactory(
        'h:input', type = 'hidden', name = 'detail$termnr',
        id = 'detail$termnr', value = 'associate:$that-gauge:$that-termrn' )
    DD                  = tagFactory( 'dd' )
    Pen                 = tagFactory( 'p' )

    p = Pen()
    dd = '(unkown)'
    a = Association()
    d = Detail()
    x = Extra()
    s = Selector()
    t = Title()
    i = Indentation()
    h = Header()
    e = Entry()
    hd = HierarchicalDisplay( **acquire( X._.htmlns(), id = 'unknown' ) )

    its = i & t & s
    h |= its



    e |= h
    e |= x
    e |= p
    hd.append( e )
    print hd

    X._.setns( 'h', 'http://html' )
    print X.h
    print X.h.foo()

    print
    print sep
    X = XmlMaker( XmlMaker().myroot() )
    bar = X.bar( 'hello' ) # ; bar.parent = foo
    foo = X.foo( 'world' )
    ~foo
    ~bar
    foo.A.funny = 'that is rich! äöü'
    print X
    print EmptyTag( 'foo' )
#       t = ~X.foo( 'outer' ).X.foo( 'inner' )
#       print t


    X = XmlMaker()
    print X.oops( X.uml( u'ä' ) )
    print X.h__oops( X.uml( u'ä' ) )
