#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
from __future__ import division
#-----------------------------------------------------------------------------------------------------------
#   _feds                                   = g.configtool.utilities.feds
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_MkDatasource                           = u.feds.MkDatasource.MkDatasource
_Fact                                   = u.feds.MkDatasource.Fact
_FactHyper                              = u.feds.MkDatasource.FactHyper
_Table                                  = u.feds.MkDatasource.Table
_TableHyper                             = u.feds.MkDatasource.TableHyper
_ontonymAnalyzer                        = u.OntonymAnalyzer.OntonymAnalyzer()
_Misfit                                 = lambda:None
_E                                      = u.IOU.E
_EC                                     = u.IOU.EC
#-----------------------------------------------------------------------------------------------------------
_T                                      = _MkDatasource.underlyingDatatypes
D                                       = dict


############################################################################################################
#
#   VALUES
#
#===========================================================================================================
class facetclass:

    #=======================================================================================================
    class pickled:
        #---------------------------------------------------------------------------------------------------
        def f( this, name ):
            def R( self ):
                try:
                    return g.pickler.loads( getattr( (-self), name ) )
                except EOFError:
                    return None
            return R
        get = classmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( this, name ):
            def R( self, value ):
                setattr( (-self), name, g.pickler.dumps( value ) )
            return R
        set = classmethod( f ); del f


############################################################################################################
#
#   PROPERTIES
#
############################################################################################################
#   PROPERTY FACT
#===========================================================================================================
class PropertyFact( _Fact ):

    #-------------------------------------------------------------------------------------------------------
    def f():
        #---------------------------------------------------------------------------------------------------
        def fget( self ):
            return g.pickler.loads( getattr( -self, 'value' ) )
        #---------------------------------------------------------------------------------------------------
        def fset( self, value ):
            setattr( -self, 'value', g.pickler.dumps( value ) )
        #---------------------------------------------------------------------------------------------------
        return locals()
    value = property( **f() ); del f

    #-------------------------------------------------------------------------------------------------------
    def f():
        #---------------------------------------------------------------------------------------------------
        def fget( self ):
            return (-self).gauge
        #---------------------------------------------------------------------------------------------------
        def fset( self, value ):
            if ':' in value:
                value = value.replace( ':', '' )
            (-self).gauge = value
        #---------------------------------------------------------------------------------------------------
        return locals()
    gauge = property( **f() ); del f


############################################################################################################
#   PROPERTY TABLE HYPER
#===========================================================================================================
class PropertyTableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = PropertyFact
    typesByFacetname = D(
        gauge               = _T.string,
        locator             = _T.string,
        verb                = _T.string,
        value               = _T.string,    # pickled representations of Python objects
        )

    #-------------------------------------------------------------------------------------------------------
    class characterize( object ):
        #-------------------------------------------------------------------------------------------------------
        def f( this, ontonym, verb = None ):
            graphname, locator = _analyzeOntonym( ontonym, termnrsAsIntegers = False )
            if locator.isdigit():   R = this.forTermnr(  graphname, locator, verb )
            else:                   R = this.forLocator( graphname, locator, verb )
            return R
        forOntonym = classmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( this, graphname, termnr, verb = None ):
            d = D(
                gauge           = graphname,
                termnr          = termnr,
                )
            if verb is not None:
                d[ 'verb' ] = verb
            return D( property = d )
        forTermnr = classmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( this, graphname, locator, verb = None ):
            d = D(
                gauge           = graphname,
                locator         = locator,
                )
            if verb is not None:
                d[ 'verb' ] = verb
            return D( property = d )
        forLocator = classmethod( f ); del f

############################################################################################################
#   PROPERTY TABLE
#===========================================================================================================
class PropertyTable( _Table ):
    __hyperclass__      = PropertyTableHyper


############################################################################################################
#
#   RATINGS
#
############################################################################################################
#   RATING FACT
#===========================================================================================================
class RatingFact( _Fact ):

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):
        try:
            return g.pickler.loads( getattr( (-self), 'value' ) )
        except EOFError:
            return None
    #---------------------------------------------------------------------------------------------------
    def fset( self, value ):
        setattr( -self, 'value', g.pickler.dumps( value ) )
    #---------------------------------------------------------------------------------------------------
    value = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).topicGraphname
    def fset( self, value ):    (-self).topicGraphname = value.replace( ':', '' )
    topicGraphname = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).focusGraphname
    def fset( self, value ):    (-self).focusGraphname = value.replace( ':', '' )
    focusGraphname = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).topicTermnr
    def fset( self, value ):    (-self).topicTermnr = int( value )
    topicTermnr = property( fget, fset ); del fget, fset


############################################################################################################
#   RATING TABLE HYPER
#===========================================================================================================
class RatingTableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = RatingFact
    #-------------------------------------------------------------------------------------------------------
    typesByFacetname = D(
        topicGraphname      = _T.string,
        topicTermnr         = _T.integer,
        focusGraphname      = _T.string,
        value               = _T.string,    # pickled representation of a dictionary (sparse vector)
        )


############################################################################################################
#   RATING TABLE
#===========================================================================================================
class RatingTable( _Table ):
    __hyperclass__      = RatingTableHyper


############################################################################################################
#
#   DOCUMENTATIONS
#
############################################################################################################
#   DOCUMENTATION FACT
#===========================================================================================================
class DocumentationFact( _Fact ):

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).topicGraphname
    def fset( self, value ):    (-self).topicGraphname = value.replace( ':', '' )
    graphname = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).topicTermnr
    def fset( self, value ):    (-self).topicTermnr = int( value )
    termnr = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ): return ':%s:%s' % ( self.graphname, self.termnr, )
    ontonym = property( fget ); del fget

############################################################################################################
#   DOCUMENTATION TABLE HYPER
#===========================================================================================================
class DocumentationTableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = DocumentationFact
    #-------------------------------------------------------------------------------------------------------
    typesByFacetname = D(
        graphname           = _T.string,
        termnr              = _T.integer,
        short               = _T.string,
        long                = _T.string,
        )


############################################################################################################
#   DOCUMENTATION TABLE
#===========================================================================================================
class DocumentationTable( _Table ):
    __hyperclass__      = DocumentationTableHyper


############################################################################################################
#
#   RATINGTRACES
#
############################################################################################################
#   RATINGTRACE FACT
#===========================================================================================================
class RatingtraceFact( _Fact ):

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):
        try:
            return g.pickler.loads( getattr( (-self), 'value' ) )
        except EOFError:
            return []
    #---------------------------------------------------------------------------------------------------
    def fset( self, value ):
        setattr( -self, 'value', g.pickler.dumps( value ) )
    #---------------------------------------------------------------------------------------------------
    value = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).topicGraphname
    def fset( self, value ):    (-self).topicGraphname = value.replace( ':', '' )
    topicGraphname = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).focusGraphname
    def fset( self, value ):    (-self).focusGraphname = value.replace( ':', '' )
    focusGraphname = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).topicTermnr
    def fset( self, value ):    (-self).topicTermnr = int( value )
    topicTermnr = property( fget, fset ); del fget, fset

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):    return (-self).focusTermnr
    def fset( self, value ):    (-self).focusTermnr = int( value )
    focusTermnr = property( fget, fset ); del fget, fset


############################################################################################################
#   RATINGTRACE TABLE HYPER
#===========================================================================================================
class RatingtraceTableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = RatingtraceFact
    #-------------------------------------------------------------------------------------------------------
    typesByFacetname = D(
        topicGraphname      = _T.string,
        topicTermnr         = _T.integer,
        focusGraphname      = _T.string,
        focusTermnr         = _T.integer,
        value               = _T.string,    # pickled representation of a list
        )


############################################################################################################
#   RATINGTRACE TABLE
#===========================================================================================================
class RatingtraceTable( _Table ):
    __hyperclass__      = RatingtraceTableHyper

############################################################################################################
#
#   RATINGTRACES V2
#
############################################################################################################
#   RATINGTRACE2 FACT
#===========================================================================================================
class Ratingtrace2Fact( _Fact ):

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):
        try:
            return g.pickler.loads( getattr( (-self), 'sourceRating' ) )
        except EOFError:
            return []
    #---------------------------------------------------------------------------------------------------
    def fset( self, value ):
        setattr( -self, 'sourceRating', g.pickler.dumps( value ) )
    #---------------------------------------------------------------------------------------------------
    sourceRating = property( fget, fset ); del fget, fset


############################################################################################################
#   RATINGTRACE2 TABLE HYPER
#===========================================================================================================
class Ratingtrace2TableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = Ratingtrace2Fact
    #-------------------------------------------------------------------------------------------------------
    typesByFacetname = D(
        sourceOntonymA      = _T.string,
        sourceOntonymB      = _T.string,
        targetOntonymA      = _T.string,
        targetOntonymB      = _T.string,
        sourceRating        = _T.string,
        )


############################################################################################################
#   RATINGTRACE2 TABLE
#===========================================================================================================
class Ratingtrace2Table( _Table ):
    __hyperclass__      = Ratingtrace2TableHyper

############################################################################################################
#
#   GRAPHS
#
############################################################################################################
#   GRAPH FACT
#===========================================================================================================
class GraphFact( _Fact ):
    pass

############################################################################################################
#   GRAPH TABLE HYPER
#===========================================================================================================
class GraphTableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = GraphFact

    #-------------------------------------------------------------------------------------------------------
    typesByFacetname = D(
        familyname          = _T.string,    #   the name of the family of schemas (in pretty print)
        length              = _T.integer,   #   the number of nodes in the graph
        localgraphsource    = _T.string,    #   a local file providing the schema description
        name                = _T.string,    #   unique graph name
        namespaceurl        = _T.string,    #   the unique namespace URL
        version             = _T.string,    #   the version string of this schema
        )

        #   #---------------------------------------------------------------------------------------------------
        #   def f( this, name, length = -1 ):
        #       return D(
        #           name            = name,
        #           length          = length,
        #           )
        #   graph = classmethod( f ); del f


############################################################################################################
#   GRAPH TABLE
#===========================================================================================================
class GraphTable( _Table ):
    __hyperclass__      = GraphTableHyper

############################################################################################################
#
#   NODES
#
############################################################################################################
#   NODE FACT
#===========================================================================================================
class NodeFact( _Fact ):

    #-------------------------------------------------------------------------------------------------------
    def f():
        #---------------------------------------------------------------------------------------------------
        def fget( self ):
            return ':%s:%s' % ( self.gauge, self.locator, )
        #---------------------------------------------------------------------------------------------------
        return locals()
    ontonym = property( **f() ); del f

    #-------------------------------------------------------------------------------------------------------
    def f():
        #---------------------------------------------------------------------------------------------------
        def fget( self ):
            return self.name.startswith( '@' )
        #---------------------------------------------------------------------------------------------------
        return locals()
    isAttribute = property( **f() ); del f

    #-------------------------------------------------------------------------------------------------------
    def fget( self ):
        R = (-self).lastDescendantTermnr
        if R == -1: R = None
        return R
    #---------------------------------------------------------------------------------------------------
    def fset( self, value ):
        if value is None: value = -1
        assert value > -2
        (-self).lastDescendantTermnr = value
    #---------------------------------------------------------------------------------------------------
    lastDescendantTermnr = property( fget, fset ); del fget, fset


############################################################################################################
#   NODE TABLE HYPER
#===========================================================================================================
class NodeTableHyper( _TableHyper ):

    #-------------------------------------------------------------------------------------------------------
    factclass = NodeFact

    #-------------------------------------------------------------------------------------------------------
    typesByFacetname = D(
        gauge                   = _T.string,
        locator                 = _T.string,
        name                    = _T.string,
        level                   = _T.integer,
        termnr                  = _T.integer,
        parentTermnr            = _T.integer,   # -1 indicates root
        isLeaf                  = _T.integer,   # true if no descendants or all descendants are attributes
        lastDescendantTermnr    = _T.integer,   # excludes self; -1 indicates no descendants
        )

    #-------------------------------------------------------------------------------------------------------
    class characterize( object ):

        #---------------------------------------------------------------------------------------------------
        def f( this, ontonym ):
            graphname, locator = _ontonymAnalyzer.analyze( ontonym, termnrsAsIntegers = False )
            if locator.isdigit():   R = this.forTermnr(  graphname, locator )
            else:                   R = this.forLocator( graphname, locator )
            return R
        forOntonym = classmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( this, graphname, termnr ):
            termnr = int( termnr )
            return D( node = D(
                gauge           = graphname,
                termnr          = termnr,
                ))
        forTermnr = classmethod( f ); del f

        #---------------------------------------------------------------------------------------------------
        def f( this, graphname, locator ):
            return D( node = D(
                gauge           = graphname,
                locator         = locator,
                ))
        forLocator = classmethod( f ); del f

        #   #---------------------------------------------------------------------------------------------------
        #   def f(
        #       this,
        #       gauge,
        #       name,
        #       locator             = '',
        #       level               = -1,
        #       termnr              = -1,
        #       parentTermnr        = -1,
        #       isLeaf              = False,
        #       ):
        #       return D(
        #           gauge           = gauge,
        #           locator         = locator,
        #           name            = name,
        #           level           = level,
        #           termnr          = termnr,
        #           parentTermnr    = parentTermnr,
        #           isLeaf          = isLeaf,
        #           )
        #   node = classmethod( f ); del f

############################################################################################################
#   NODE TABLE
#===========================================================================================================
class NodeTable( _Table ):
    __hyperclass__      = NodeTableHyper



############################################################################################################
#
#
#
#===========================================================================================================
class Grove( _MkDatasource ):

    #-------------------------------------------------------------------------------------------------------
    _termrefByOntonymCache = None
    _namespacesByGraphnameCache = None
    _graphnamesByNamespaceCache = None

    #-------------------------------------------------------------------------------------------------------
#       characterize        = characterize
#       describe            = describe
    tableclassesByTablename  = D(
        property        = PropertyTable,
        graph           = GraphTable,
        node            = NodeTable,
        rating          = RatingTable,
        ratingtrace     = RatingtraceTable,
        ratingtrace2    = Ratingtrace2Table,
        documentation   = DocumentationTable,
        )

    #-------------------------------------------------------------------------------------------------------
    def addAllFactoids( self ):
        self.addFactoids(
            graph           =         GraphTableHyper.typesByFacetname,
            node            =          NodeTableHyper.typesByFacetname,
            property        =      PropertyTableHyper.typesByFacetname,
            rating          =        RatingTableHyper.typesByFacetname,
            ratingtrace     =   RatingtraceTableHyper.typesByFacetname,
            ratingtrace2    =  Ratingtrace2TableHyper.typesByFacetname,
            documentation   = DocumentationTableHyper.typesByFacetname,
            )

    #-------------------------------------------------------------------------------------------------------
    def addProperty( self, gauge, locator, verb, value ):
        self.addFacts(
            property = D(
                gauge   = gauge,
                locator = locator,
                verb    = verb,
                value   = value,
                )
            )

    #-------------------------------------------------------------------------------------------------------
    def addRating( self, topicGraphname, topicTermnr, focusGraphname, value ):
        self.addFacts(
            rating = D(
                topicGraphname  = topicGraphname,
                topicTermnr     = topicTermnr,
                focusGraphname  = focusGraphname,
                value           = value,
                )
            )

    #-------------------------------------------------------------------------------------------------------
    def addRatingtrace( self, topicGraphname, topicTermnr, focusGraphname, focusTermnr, value ):
        self.addFacts(
            ratingtrace = D(
                topicGraphname  = topicGraphname,
                topicTermnr     = topicTermnr,
                focusGraphname  = focusGraphname,
                focusTermnr     = focusTermnr,
                value           = value,
                )
            )

    #-------------------------------------------------------------------------------------------------------
    def addRatingtrace2( self,
        sourceOntonymA,
        sourceOntonymB,
        targetOntonymA,
        targetOntonymB,
        sourceRating,
        ):
        #---------------------------------------------------------------------------------------------------
        sourceOntonymA, sourceOntonymB = self._orderPairOfOntonyms( sourceOntonymA, sourceOntonymB )
        targetOntonymA, targetOntonymB = self._orderPairOfOntonyms( targetOntonymA, targetOntonymB )
        #---------------------------------------------------------------------------------------------------
        self.addFacts(
            ratingtrace2 = D(
                sourceOntonymA  = sourceOntonymA,
                sourceOntonymB  = sourceOntonymB,
                targetOntonymA  = targetOntonymA,
                targetOntonymB  = targetOntonymB,
                sourceRating    = sourceRating,
                )
            )

    #-------------------------------------------------------------------------------------------------------
    def getRatingtrace( self, topicGraphname, topicTermnr, focusGraphname, focusTermnr ):
        ratingtraceView = self.catchTable(
            ratingtrace = D(
                topicGraphname  = topicGraphname,
                topicTermnr     = topicTermnr,
                focusGraphname  = focusGraphname,
                focusTermnr     = focusTermnr,
                )
            )
        assert len( ratingtraceView ) == 1
        for ratingtraceFact in ratingtraceView: break
        return ratingtraceFact.value

    #-------------------------------------------------------------------------------------------------------
    def f( this, ontonymA, ontonymB ):
        if ontonymA > ontonymB:
            ontonymA, ontonymB = ontonymB, ontonymA
        return ontonymA, ontonymB
    _orderPairOfOntonyms = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def getRatingtrace2ForSource( self, sourceOntonymA, sourceOntonymB ):
        """Use this method to find out what target node pairs were affected by an rating made for a source
        node pair."""
        sourceOntonymA, sourceOntonymB = self._orderPairOfOntonyms( sourceOntonymA, sourceOntonymB )
        ratingtrace2View = self.catchTable(
            ratingtrace2 = D(
                sourceOntonymA  = sourceOntonymA,
                sourceOntonymB  = sourceOntonymB,
                )
            )
        return ratingtrace2View

    #-------------------------------------------------------------------------------------------------------
    def iterTripletsFromRatingtrace( self, topicGraphname, topicTermnr, focusGraphname, focusTermnr ):
        #---------------------------------------------------------------------------------------------------
        try:
            ratingtrace = self.getRatingtrace(
                topicGraphname, topicTermnr, focusGraphname, focusTermnr )
        except:
            return
        #---------------------------------------------------------------------------------------------------
        for tracetuple in ratingtrace:
            assert len( tracetuple ) == 3
            topicOriginOntonym, focusOriginOntonym, assessment = tracetuple
            topicOriginNodefact = self.nodefactForOntonym( topicOriginOntonym )
            focusOriginNodefact = self.nodefactForOntonym( focusOriginOntonym )
            yield topicOriginNodefact, focusOriginNodefact, assessment

    #-------------------------------------------------------------------------------------------------------
    def catchPropertyTable( self, ontonym = None, verb = None ):
        graphname, locator, termnr, R = self._catchPropertyTable( ontonym, verb )
        return R

    #-------------------------------------------------------------------------------------------------------
    def _catchPropertyTable( self, ontonym = None, verb = None ):
        graphname, locator, termnr  = self.tripletForOntonymOrNones( ontonym )
        resultsForLocator           = resultsForTermnr = None
        tableclass                  = self._getTableclassForTablename( 'property' )
        if bool( ontonym ) and graphname is None: return ( None, None, None, None, )
        #---------------------------------------------------------------------------------------------------
        Q = {}
        if graphname is not None:   Q[ 'gauge' ]    = graphname
        if locator is not None:     Q[ 'locator' ]  = locator
        if verb is not None:        Q[ 'verb' ]     = verb
        #---------------------------------------------------------------------------------------------------
        if Q:
            resultsForLocator       = self.catchTable( property = Q )
        #---------------------------------------------------------------------------------------------------
        if termnr is not None:      Q[ 'locator' ]  = termnr
        if Q:
            resultsForTermnr        = self.catchTable( property = Q )
        #---------------------------------------------------------------------------------------------------
        if ( resultsForLocator is not None ) and ( resultsForTermnr is not None ):
            mkViewObject            = ( -resultsForLocator ).union( -resultsForTermnr )
        elif resultsForLocator is not None:
            mkViewObject            = resultsForLocator
        elif resultsForTermnr  is not None:
            mkViewObject            = resultsForTermnr
        else:
            mkViewObject            = -( self.factoid( 'property' ) )
        #---------------------------------------------------------------------------------------------------
        R                           = tableclass( self, mkViewObject, 'property' )
        return graphname, locator, termnr, R

    #-------------------------------------------------------------------------------------------------------
    def iterRelatedNodefacts( self, ontonym = None, verb = None ):
        propertytable = self.catchPropertyTable( ontonym = ontonym, verb = verb )
        #print '++++++', ontonym, verb, propertytable
        if propertytable is None: return
        for propertyfact in propertytable:
            contextGauge = ':%s:' % ( propertyfact.gauge, )
            targetlocators = propertyfact.value
            if not targetlocators: continue
            for targetlocator in targetlocators:
                if isinstance( targetlocator, ( list, tuple, ) ):
                    assert len( targetlocator ) == 2
                    targetGraphname, targetLocator = targetlocator
                    targetGauge = ':%s:' % ( targetGraphname, )
                    targetOntonym = ( targetGauge, targetlocator, )
                else:
                    targetOntonym = ( contextGauge, targetlocator, )
                nodefact = self.nodefactForOntonymOrNone( targetOntonym )
                yield nodefact

    #-------------------------------------------------------------------------------------------------------
    def getGraphnameAndNamespace( self, graphnameOrNamespace, default = _Misfit ):
        graphnameOrNamespace, looksLikeNamespaceUrl = \
            self._unescapeGraphnameOrNamespace( graphnameOrNamespace )
        if looksLikeNamespaceUrl:
            namespace = graphnameOrNamespace
            graphname = self._getGraphnameForNamespace( namespace, default )
        else:
            graphname = graphnameOrNamespace
            namespace = self._getNamespaceForGraphname( graphname, default )
        return graphname, namespace

    #-------------------------------------------------------------------------------------------------------
    def getNamespaceForGraphname( self, graphname, default = _Misfit ):
        """Return the namespace that is registered for ``graphname``; otherwise, raise a ``ValueError``."""
        graphname, looksLikeNamespaceUrl = self._unescapeGraphnameOrNamespace( graphname )
        return self._getNamespaceForGraphname( graphname, default )

    #-------------------------------------------------------------------------------------------------------
    def getGraphnameForNamespace( self, namespace, default = _Misfit ):
        """Return the graphname that is registered for ``namespace``; otherwise, raise a ``ValueError``."""
        namespace, looksLikeNamespaceUrl = self._unescapeGraphnameOrNamespace( namespace )
        return self._getGraphnameForNamespace( namespace, default )

    #-------------------------------------------------------------------------------------------------------
    def _getNamespaceForGraphname( self, graphname, default = _Misfit ):
        self._prepareNamespaceAndGraphnameCaches()
        return self._getFromNsgnCache( graphname, self._namespacesByGraphnameCache, 'graphname', default )

    #-------------------------------------------------------------------------------------------------------
    def _getGraphnameForNamespace( self, namespace, default = _Misfit ):
        self._prepareNamespaceAndGraphnameCaches()
        return self._getFromNsgnCache( namespace, self._graphnamesByNamespaceCache, 'namespace', default )

    #-------------------------------------------------------------------------------------------------------
    def _getFromNsgnCache( self, key, cache, name, default = _Misfit ):
        R = cache.get( key, default )
        if R is _Misfit:
            raise ValueError( ''
                +   "Unknown %s: '%s'." % ( name, key, )
                )
        return R

    #-------------------------------------------------------------------------------------------------------
    def _unescapeGraphnameOrNamespace( self, text ):
        looksLikeNamespaceUrl = False
        if text.startswith( ':' ) and text.endswith( ':' ):
            text = text[ 1 : -1 ]
        if text.startswith( '{' ) and text.endswith( '}' ):
            text = text[ 1 : -1 ]
            looksLikeNamespaceUrl = True
        if '/' in text:
            looksLikeNamespaceUrl = True
        text = _E( text )
        return text, looksLikeNamespaceUrl

    #-------------------------------------------------------------------------------------------------------
    def _prepareNamespaceAndGraphnameCaches( self ):
        if self._namespacesByGraphnameCache is None or self._graphnamesByNamespaceCache is None:
            self._namespacesByGraphnameCache = {}
            self._graphnamesByNamespaceCache = {}
            for graphfact in self.getTable( 'graph' ):
                namespace = graphfact.namespaceurl
                graphname = graphfact.name
                self._namespacesByGraphnameCache[ graphname ] = namespace
                self._graphnamesByNamespaceCache[ namespace ] = graphname

    #-------------------------------------------------------------------------------------------------------
    def iterGauges( self ):
        for fact in self.catchTable( graph = None ):
            yield fact.name

    #-------------------------------------------------------------------------------------------------------
    def iterGraphnames( self ):
        return self.iterGauges()

    #-------------------------------------------------------------------------------------------------------
    def iterAllNodes( self ):
        return self.iterNodesForGauges()

    #-------------------------------------------------------------------------------------------------------
    def iterTermnrs( self, graphname ):
        graphlength = self.getGraphlength( graphname )
        for termnr in xrange( graphlength ):
            yield termnr

    #-------------------------------------------------------------------------------------------------------
    def iterNodesForGauges( self, *gauges ):
        if not gauges: gauges = self.iterGauges()
        for gauge in gauges:
            for fact in self.catchTable( node = D( gauge = gauge ) ):
                yield fact

    #-------------------------------------------------------------------------------------------------------
    def iterNodesForGraphnames( self, *graphnames ):
        return self.iterNodesForGauges( *graphnames )

    #-------------------------------------------------------------------------------------------------------
    def nodefactForOntonymOrNone( self, ontonym ):
        try:
            return self.nodefactForOntonym( ontonym )
        except KeyError:
            return None

    #-------------------------------------------------------------------------------------------------------
    def getRatingsvector( self, topicGraphname, topicTermnr, focusGraphname ):
        #---------------------------------------------------------------------------------------------------
        Vector  = u.neo.Vector
        #---------------------------------------------------------------------------------------------------
        topicTermnr = int( topicTermnr )
        ratingView = self.catchTable( rating = D(
            focusGraphname  = focusGraphname,
            topicGraphname  = topicGraphname,
            topicTermnr     = topicTermnr,
            ))
        assert len( ratingView ) < 2
        if len( ratingView ) == 0:
            ratingDict = {}
        else:
            for ratingFact in ratingView: break
            ratingDict = ratingFact.value
        #---------------------------------------------------------------------------------------------------
        focusGraphlength = self.getGraphlength( focusGraphname )
        R = Vector(
            iminmax = ( 0, focusGraphlength ),
            )
        R.updateSparse( ratingDict )
        return R

    #-------------------------------------------------------------------------------------------------------
    def _getNodefact( self, methodname, *P, **Q ):
        nodeTableHyperclass = self.tableclassesByTablename[ 'node' ].__hyperclass__
        method              = getattr( nodeTableHyperclass.characterize, methodname )
        characterization    = method( *P, **Q )
        table = self.catchTable( **characterization )
        facts = list( (+table).facts )
        if len( facts ) > 1:
            raise KeyError( ''
                +   "The description %s did not deliver a unique result." % ( characterization, )
                )
        if len( facts ) < 1:
            raise KeyError( ''
                +   "The description %s did not deliver any result." % ( characterization, )
                )
        return facts[ 0 ]

    #-------------------------------------------------------------------------------------------------------
    def nodefactForOntonym( self, ontonym ):
        return self._getNodefact( 'forOntonym', ontonym )

    #-------------------------------------------------------------------------------------------------------
    def nodefactForTermref( self, termref ):
        return self._getNodefact( 'forTermnr', *termref )

#           nodeTableHyperclass = self.tableclassesByTablename[ 'node' ].__hyperclass__
#           characterization    = nodeTableHyperclass.characterize.forOntonym( ontonym )
#           table = self.catchTable( **characterization )
#           facts = list( (+table).facts )
#           if len( facts ) > 1:
#               raise KeyError( ''
#                   +   "The description %s did not deliver a unique characterization." % ( ontonym, )
#                   )
#           if len( facts ) < 1:
#               raise KeyError( ''
#                   +   "The description %s did not deliver any result." % ( ontonym, )
#                   )
#           return facts[ 0 ]

    #-------------------------------------------------------------------------------------------------------
    def analyzeOntonym( self, ontonym, termnrsAsIntegers = False ):
        return _ontonymAnalyzer.analyze( ontonym, termnrsAsIntegers = termnrsAsIntegers )

    #-------------------------------------------------------------------------------------------------------
    def _buildTermrefByOntonymCache( self ):
        R = self._termrefByOntonymCache = {}
        for fact in dsGrove.factoid( 'node' ):
            R[ fact.ontonym ] = fact.gauge, fact.termnr

    #-------------------------------------------------------------------------------------------------------
    def _termrefForOntonymOrNonesFromCache( self, ontonym, termnrsAsIntegers = False ):
        if self._termrefByOntonymCache is None: self._buildTermrefByOntonymCache()
        try:
            graphname, termnr = self._termrefByOntonymCache[ ontonym ]
        except KeyError:
            return None, None
        if not termnrsAsIntegers:
            termnr = _ontonymAnalyzer.castNumericalTermnrToText( termnr )
        return graphname, termnr

    #-------------------------------------------------------------------------------------------------------
    def tripletForOntonymOrNones( self, ontonym, termnrsAsIntegers = False ):
        try:
            return self.tripletForOntonym( ontonym, termnrsAsIntegers = termnrsAsIntegers )
        except KeyError:
            return None, None, None

    #-------------------------------------------------------------------------------------------------------
    def tripletForOntonym( self, ontonym, termnrsAsIntegers = False ):
        nodefact = self.nodefactForOntonym( ontonym )
        termnr = nodefact.termnr
        if not termnrsAsIntegers:
            termnr = _ontonymAnalyzer.castNumericalTermnrToText( termnr )
        return nodefact.gauge, nodefact.locator, termnr

    #-------------------------------------------------------------------------------------------------------
    def getGraphlength( self, graphname ):
        facts = self.catchTable( graph = D( name = graphname ) )
        assert len( facts ) == 1
        for fact in facts:
            return fact.length

    #-------------------------------------------------------------------------------------------------------
    def iterTermnrs( self, graphname ):
        return xrange( self.getGraphlength( graphname ) )

    #-------------------------------------------------------------------------------------------------------
    def getDocumentationForTermref( self, termref ):
        graphname, termnr = termref
        documentationtable = self.catchTable(
            documentation = dict(
                graphname   = graphname,
                termnr      = termnr,
                )
            )
        documentationfact = None
        for documentationfact in documentationtable: break
        if documentationfact:
            return documentationfact.short, documentationfact.long
        return None, None

    #-------------------------------------------------------------------------------------------------------
    def getDescendants( self, ontonym ):
        graphname, locator, termnr, R = self._getDescendants( ontonym )
        return R

    #-------------------------------------------------------------------------------------------------------
    def _getDescendants( self, ontonym ):
        graphname, locator, termnr, propertyView = self._catchPropertyTable( ontonym, verb = 'descendants' )
        #print '???????????', graphname, locator, termnr, propertyView
        assert len( propertyView ) == 1
        for fact in propertyView:
            return graphname, locator, termnr, fact.value

    #-------------------------------------------------------------------------------------------------------
    def _iterNodefactsForOntonymAndVerb( self, ontonym, verb, includeSelf = True ):
        for termref in self._iterTermrefsForOntonymAndVerb( ontonym, verb, includeSelf ):
            nodefact = self.nodefactForTermref( termref )
            yield nodefact

    #-------------------------------------------------------------------------------------------------------
    def _iterTermrefsForOntonymAndVerb( self, ontonym, verb, includeSelf = True ):
        """This is the cheaper edition of a more perfect implementation meant to take into account that
        related terms can be from another graph, and, hence, be noted as ``(graphname,termnr)`` pairs --
        here, we simply assume that all entries are integer term numbers from the same graph."""
        graphname, locator, termnr, propertyView = self._catchPropertyTable( ontonym, verb = verb )
        assert len( propertyView ) == 1
        #print '$$$$$$$$', propertyView.__class__
        for fact in propertyView:
            break
        #fact = (-propertyView)[ 0 ]
        #print '$$$$$$$$', fact
        #print '$$$$$$$$', fact.value
        termnr = int( termnr )
        #---------------------------------------------------------------------------------------------------
        #   The relation may or may not include the present node -- to solve this, we simply first yield
        #   the node hinted at by ``ontonym``, if called for, and then step through the term numbers in the
        #   stored list while unconditionally omitting the present node:
        if includeSelf:
            yield graphname, termnr
        for relatedTermnr in fact.value:
            assert isinstance( relatedTermnr, int )
            if termnr == relatedTermnr: continue
            yield graphname, relatedTermnr

    #-------------------------------------------------------------------------------------------------------
    def iterDescendantTermrefs( self, ontonym, includeSelf = False ):
        return self._iterTermrefsForOntonymAndVerb( ontonym, 'descendants', includeSelf = includeSelf )
#           graphname, locator, termnr, descendants = self._getDescendants( ontonym )
#           if includeSelf:
#               yield graphname, termnr
#           for descendant in descendants:
#               assert isinstance( descendant, int )
#               yield graphname, descendant

    #-------------------------------------------------------------------------------------------------------
    def iterSubsequentTermrefs( self, ontonym, includeSelf = True ):
        return self._iterTermrefsForOntonymAndVerb( ontonym, 'subsequents', includeSelf )

    #-------------------------------------------------------------------------------------------------------
    def iterAncestorTermrefs( self, ontonym, includeSelf = False ):
        return self._iterTermrefsForOntonymAndVerb( ontonym, 'ancestors', includeSelf )

    #-------------------------------------------------------------------------------------------------------
    def iterAncestorNodefacts( self, ontonym, includeSelf = False ):
        return self._iterNodefactsForOntonymAndVerb( ontonym, 'ancestors', includeSelf )

    #-----------------------------------------------------------------------------------------------------------
    def _getPropertiesForAllNodes_hilevel( self, graphname, verb ):
        view = self.catchTable( property = D( gauge = graphname, verb = verb ) )
        R = {}
        for fact in view:
            R[ fact.locator ] = fact.value
        return R

    #-----------------------------------------------------------------------------------------------------------
    def getPropertiesForAllNodes( self, graphname, verb, termnrsAsStrings = True ):
        """This method is optimal whenever a sizeable portion of a graph's properties are needed (say, the
        lists of childnodes or ancestors for most of the nodes in a graph). A benchmark showes that where a
        naive approach with a select statement for every node from the 700-something nodes graph
        representing ABCD 1.2 takes almost 60 seconds on my machine for 1000 repetitions, whereas building a
        cache with ``~.getPropertiesForAllNodes()`` and getting the results from the dictionary only needs
        0.47 seconds for the same number of repetitions."""
        graphname, verb = map( _E, ( graphname, verb ) )
        mkViewObject = self.connection.view( 'property' )
        mkViewObject = mkViewObject.select( gauge = graphname, verb = verb )
        unpickle = g.pickler.loads
        R = {}
        if termnrsAsStrings:
            for mkRowrefObject in mkViewObject:
                R[ mkRowrefObject.locator ] = unpickle( mkRowrefObject.value )
        else:
            for mkRowrefObject in mkViewObject:
                R[ int( mkRowrefObject.locator ) ] = unpickle( mkRowrefObject.value )
        return R

    #-----------------------------------------------------------------------------------------------------------
    def getNodefactsByTermnrForGraphname( self, graphname ):
        """(See documentation for ``~.getPropertiesForAllNodes()``.)"""
        view = self.catchTable( node = D( gauge = graphname ) )
        R = {}
        for nodefact in view:
            R[ nodefact.termnr ] = nodefact
        return R

    #-----------------------------------------------------------------------------------------------------------
    def getNodefactsByTermnrstrForGraphname( self, graphname ):
        """(See documentation for ``~.getPropertiesForAllNodes()``.)"""
        view = self.catchTable( node = D( gauge = graphname ) )
        R = {}
        for nodefact in view:
            R[ str( nodefact.termnr ) ] = nodefact
        return R

    #-----------------------------------------------------------------------------------------------------------
    def getNodefactsByLocatorForGraphname( self, graphname ):
        """(See documentation for ``~.getPropertiesForAllNodes()``.)"""
        view = self.catchTable( node = D( gauge = graphname ) )
        R = {}
        for nodefact in view:
            R[ nodefact.locator ] = nodefact
        return R

    #-----------------------------------------------------------------------------------------------------------
    def getDocumentationfactsByTermnrForGraphname( self, graphname ):
        """(See documentation for ``~.getPropertiesForAllNodes()``.)"""
        view = self.catchTable( documentation = D( graphname = graphname ) )
        R = {}
        for fact in view:
            R[ fact.termnr ] = fact
        return R

    #-----------------------------------------------------------------------------------------------------------
    def getDocumentationfactsByTermnrstrForGraphname( self, graphname ):
        """(See documentation for ``~.getPropertiesForAllNodes()``.)"""
        return map( str, self.getDocumentationfactsByTermnrForGraphname( graphname ) )







