#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
#   from time import time as                _time
#   from time import strftime as            _strftime
#   from time import localtime as           _localtime
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
feds                                    = u.feds
#-----------------------------------------------------------------------------------------------------------
_xsdbDatasource                         = feds.xsdbDatasource.xsdbDatasource
_NoSuchOID                              = feds.xsdbDatasource._NoSuchOID


#   class Xlist( list ): pass
#   setattr( Xlist, _xsdbDatasource.autoaddoidname, None )

#       def __init__( self, *P, **Q ):
#           super( Xlist, self, *P, **Q )
#           setattr( self, _xsdbDatasource.autoaddoidname, None )

############################################################################################################
#
#
#
#===========================================================================================================
class Sessiondata( _xsdbDatasource ):

    #-------------------------------------------------------------------------------------------------------
    def _sessionFilter( self, session ):
        """Return a dictionary that, when made part of a description, uniquely identifies ``session`` -- we
        use this to make sure only data pertaining to a given session is made accessible and no other."""
        return self._sessionFilterForSid( session.sid )

    #-------------------------------------------------------------------------------------------------------
    def _sessionFilterForSid( self, sid ):
        return dict( sid = sid )

    #-------------------------------------------------------------------------------------------------------
    def getData( self, session, *P, **Q ):
        sessionFilter = self._sessionFilter( session )
        return self.catch( sessionFilter, *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def popData( self, session, *P, **Q ):
        sessionFilter = self._sessionFilter( session )
        R = []
        for oid in self.catchOids( sessionFilter, *P, **Q ):
            R.append( self.get( oid ) )
            self.remove( oid )
        return R

    #-------------------------------------------------------------------------------------------------------
    def addData( self, session, data, *P, **Q ):
        sessionFilter = self._sessionFilter( session )
        return self.add( data, sessionFilter, *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def replaceData( self, session, data, *P, **Q ):
        sessionFilter = self._sessionFilter( session )
        for oid in self.catchOids( sessionFilter, *P, **Q ):
            self.remove( oid )
        self.addData( session, data, *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def removeDataForSidIfPossible( self, sid ):
        """Given an ``sid``, try to remove the associated session data if possible. In case no objects are
        associated with the ``sid``, ignore silently. Return whether any objects were deleted or not."""
        R = False
        sessionFilter = self._sessionFilterForSid( sid )
        for oid in self.catchOids( sessionFilter ):
            try:
                self.remove( oid )
                R = R or True
            except _NoSuchOID:
                pass
        return R

    #-------------------------------------------------------------------------------------------------------
    def addProblemForSender( self, session, sender, message ):
        Q = dict( category = 'problem', sender = sender )
        messageLists = list( self.getData( session, **Q ) )
        #print '++++++++++++++++', messageLists  ###DEBUG###
        if messageLists:
            messageList = messageLists[ 0 ]
            messageList.append( message )
            #print '~~~~~~~~~~~~~', messageList.oid
            self.replaceData( session, messageList, **Q )
        else:
            #messageList = Xlist( [ message, ] )
            messageList = [ message, ]
            self.addData( session, messageList, **Q )

    #-------------------------------------------------------------------------------------------------------
    def popProblemsForSender( self, session, sender ):
        raise NotImplementedError()

    #-------------------------------------------------------------------------------------------------------
    def addWarningForSender( self, session, sender, message ):
        raise NotImplementedError()

    #-------------------------------------------------------------------------------------------------------
    def popWarningsForSender( self, session, sender ):
        raise NotImplementedError()


