#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
from __future__ import division
#-----------------------------------------------------------------------------------------------------------
from time import time as                _time
from time import strftime as            _strftime
from time import localtime as           _localtime
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
feds                                    = u.feds
#-----------------------------------------------------------------------------------------------------------
_NoSuchOID                              = feds.xsdbDatasource._NoSuchOID
_xsdbDatasource                         = feds.xsdbDatasource.xsdbDatasource
_seconds                                = u.EzTime.seconds
_MySerializableMx                       = u.pylon.MySerializableMx
_Misfit                                 = u.Misfit.Misfit
#-------------------------------------------------------------------------------------------------------
def _now():
    return int( _time() )


#   ###########################################################################################################
#   #
#   #
#   #
#   #===========================================================================================================
#   class Message( _MySerializableMx, object ):
#
#   #       #-------------------------------------------------------------------------------------------------------
#   #       __dontpickle__ = ( '_dsSessions', )
#
#       #-------------------------------------------------------------------------------------------------------
#       def __init__( self, category, sender, message ):
#           self.category   = category
#           self.sender     = sender
#           self.message    = message


#   ###########################################################################################################
#   #
#   #
#   #
#   #===========================================================================================================
#   class Messages( _MySerializableMx, object ):
#
#       #-------------------------------------------------------------------------------------------------------
#       __dontpickle__ = ( '_dsSessions', )
#
#       #-------------------------------------------------------------------------------------------------------
#       def __init__( self, dsinstance ):
#           self._dsSessions = dsinstance
#
#       def
#
#
#

###########################################################################################################
#
#
#
#===========================================================================================================
class Session( _MySerializableMx, object ):

    #-------------------------------------------------------------------------------------------------------
    __dontpickle__ = ( '_dsSessions' )

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, sid ):
        self.oid            = sid
        self.active         = True
        now                 = _now()
        self.created        = now
        self.lastused       = None
        self._dsSessions    = None      #   used to make updates of description when touched
        self.touch( now )
        self.data           = {} # _EzNamespace()
        self.touched        = 1         #   this attribute introduced by xsdb

    #-------------------------------------------------------------------------------------------------------
    def get( self, name ):
        return self.data[ name ]

    #-------------------------------------------------------------------------------------------------------
    def set( self, name, value ):
        self.data[ name ] = value
        self.touch()

    #-------------------------------------------------------------------------------------------------------
    def __getitem__( self, name ):
        return self.get( name )

    #-------------------------------------------------------------------------------------------------------
    def __setitem__( self, name, value ):
        return self.set( name, value )

    #-------------------------------------------------------------------------------------------------------
    def store( self ):
        return self._dsSessions.store( self )

    #-------------------------------------------------------------------------------------------------------
    def getSid( self ):
        return self.oid
    sid = property( getSid )

    #-------------------------------------------------------------------------------------------------------
    def touch( self, now = None ):
        if now is None: now = _now()
        self.lastused   = now
        self.touched    = 1
        if self._dsSessions is not None:
            self._dsSessions._redescribeSession( self )

    #-------------------------------------------------------------------------------------------------------
    def getAge( self ):
        return _now() - self.lastused
    age = property( getAge )

    #-------------------------------------------------------------------------------------------------------
    def getTooOld( self ):
        return self._dsSessions.sessionTooOld( self )
    tooOld = property( getTooOld )

    #-------------------------------------------------------------------------------------------------------
    def deactivate( self ):
        self.active = False

#       #-------------------------------------------------------------------------------------------------------
#       def getSessionDataObject( self, *P, **Q ):
#           return self._dsSessions.getSessionDataObject( self, *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def __repr__( self ):
        fs = '%Y-%m-%d/%H:%M:%S'
        created     = _strftime( fs, _localtime( self.created ) )
        lastused    = _strftime( fs, _localtime( self.lastused ) )
        age         = self.age
        if self.active:
            active = ''
        else:
            active = 'Inactive '
        #   data = '%s' % ( self.data, )
        data = self.data
        names = data.keys()
        names.sort()
        data = ' '.join( [ "%s=%r" % ( name, data[ name ], ) for name in names ] )
        return "[%sSession '%s' c%s u%s a%s {%s}]" % ( active, self.oid, created, lastused, age, data )

    #-------------------------------------------------------------------------------------------------------
    #   PROBLEMS AND WARNINGS
    #-------------------------------------------------------------------------------------------------------
    def addProblemForSender( self, sender, message ):
        return self._dsSessions._dsData.addProblemForSender( self, sender, message )

    #-------------------------------------------------------------------------------------------------------
    def popProblemsForSender( self, sender ):
        return self._dsSessions._dsData.popProblemsForSender( self, sender )

    #-------------------------------------------------------------------------------------------------------
    def addWarningForSender( self, sender, message ):
        return self._dsSessions._dsData.addWarningForSender( self, sender, message )

    #-------------------------------------------------------------------------------------------------------
    def popWarningsForSender( self, sender ):
        return self._dsSessions._dsData.popWarningsForSender( self, sender, message )


############################################################################################################
#
#
#
#===========================================================================================================
class Sessions( _xsdbDatasource ):

    #-------------------------------------------------------------------------------------------------------
    #autoaddoidname      = 'oid'
    autoaddoiddescriptionname   = 'sid'
    sessionmaxage               = 14 * _seconds.perDay
    approximatesidlength        = 9
    CATEGORY_SESSION            =  'session'
    CATEGORY_DATA               =  'data'
    seconds                     = _seconds

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, dsn = None, readonly = None ):
        super( Sessions, self ).__init__( dsn = dsn, readonly = readonly )
        self._dsData = None

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        ds = this( readonly = False )
        ds.recreateDatasource()
        #ds.declareIndex( ds.Description( category = 'sid' ), [ 'value' ], 'sidvalueindex' )
        ds.close()
    recreate = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def get( self, *P, **Q ):
        R = super( Sessions, self ).get( *P, **Q )
        if isinstance( R, Session ):
            R._dsSessions = self
        return R

    #-------------------------------------------------------------------------------------------------------
    def setDsData( self, dsData ):
        self._dsData = dsData

    #-------------------------------------------------------------------------------------------------------
    def getSids( self ):
        return self.oids
    sids = property( getSids )

    #-------------------------------------------------------------------------------------------------------
    def getSidsForActive( self, active = True ):
        return self.catchOids( **self._getMinimalDescriptionForActive( active = True ) )

    #-------------------------------------------------------------------------------------------------------
    def getNewOid( self, x = None ):
        """Return a new random object id that lends itself for being used as a session id. The
        implementation is not concurrency-proof and you cannot retrieve a bunch of new oids and later add a
        bunch of objects with those ids -- this has to be done one-by-one."""
        from random import randint
        oids    = self.oids
        sidl2   = max( 2, self.approximatesidlength // 2 )
        number  = '%d' % ( self.cumulativeObjectcount + 1 )
        while True:
            leftlength  = randint( 1, sidl2 )
            rightlength = randint( 1, sidl2 )
            base0 = ''.join( [ chr( randint( 97, 122 ) ) for i in range( leftlength  ) ] )
            base1 = ''.join( [ chr( randint( 97, 122 ) ) for i in range( rightlength ) ] )
            R = '%s%s%s' % ( base0, number, base1 )
            if R not in oids: break
        return R

    #-------------------------------------------------------------------------------------------------------
    def getNewSid( self, x = None ):
        """Equivalent to ``~.getNewOid()``."""
        return self.getNewOid( x )

    #-------------------------------------------------------------------------------------------------------
    def getNewSession( self ):
        sid = self.getNewSid()
        R = Session( sid )
        self.addWithOid( R, sid, **self._getFullDescriptionForSession( R ) )
        return R

    #-------------------------------------------------------------------------------------------------------
    def _getFullDescriptionForSession( self, session ):
        return dict(
            category    = self.CATEGORY_SESSION,
            sid         = session.oid,
            created     = session.created,
            lastused    = session.lastused,
            active      = session.active,
            )

    #-------------------------------------------------------------------------------------------------------
    def _getMinimalDescriptionForSession( self, session ):
        return self._getMinimalDescriptionForSid( session.sid )

    #-------------------------------------------------------------------------------------------------------
    def _getMinimalDescriptionForSid( self, sid ):
        return dict(
            category    = self.CATEGORY_SESSION,
            sid         = sid,
            )

    #-------------------------------------------------------------------------------------------------------
    def _getMinimalDescriptionForActive( self, active = True ):
        return dict(
            category    = self.CATEGORY_SESSION,
            active      = active,
            )

    #-------------------------------------------------------------------------------------------------------
    def _getMinimalDescriptionOfSession( self ):
        return dict(
            category    = self.CATEGORY_SESSION,
            )

    #-------------------------------------------------------------------------------------------------------
    def _redescribeSession( self, session ):
        #self.store( session )
        oldDescription = self._getMinimalDescriptionForSession( session )
        newDescription = self._getFullDescriptionForSession( session )
        self.removeDescriptions( session.oid, **oldDescription )
        self.describeOid( session.oid, **newDescription )

    #-------------------------------------------------------------------------------------------------------
    def touch( self, session ):
        session.touch()
        #self.store( session )
        #self._redescribeSession( session )

    #-------------------------------------------------------------------------------------------------------
    def deactivateSession( self, session ):
        session.deactivate()
        self.store( session )
        self._redescribeSession( session )

    #-------------------------------------------------------------------------------------------------------
    def removeSessionForSidIfPossible( self, sid ):
        """Given an ``sid``, try to remove the associated session object if possible. In case no session is
        associated with the ``sid``, ignore silently. Return whether an object was deleted or not."""
        description = self._getMinimalDescriptionForSid( sid )
        try:
            self.remove( sid )
        except _NoSuchOID:
            return False
        return True

    #-------------------------------------------------------------------------------------------------------
    def sessionTooOld( self, session ):
        return session.age > self.sessionmaxage

    #-------------------------------------------------------------------------------------------------------
    def getSessionForSid( self, sid ):
        #return self.get( sid )
        R = list( self.catch( **self._getMinimalDescriptionForSid( sid ) ) )
        if not R:
            raise KeyError( ''
                "Unable to retrieve session for sid '%s'." % ( sid, )
                )
        assert len( R ) == 1
        return R[ 0 ]

    #-------------------------------------------------------------------------------------------------------
    def getOldOrNewSidAndSessionForSid( self, sid ):
        try:
            R = self.getSessionForSid( sid )
        except KeyError:
            R = None
        else:
            if not R.active or self.sessionTooOld( R ):
                self.deactivateSession( R )
                R = None
        if R is None:
            R = self.getNewSession()
        return R.sid, R

    #-------------------------------------------------------------------------------------------------------
    def getSessions( self ):
        return self.catch( **self._getMinimalDescriptionOfSession() )
    sessions = property( getSessions )

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        pass
    sample_query = classmethod( f ); del f



