#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
#   import                                  sys
#   import                                  imp
import os.path as                       _p
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_feds                                   = u.feds
#-----------------------------------------------------------------------------------------------------------
_cfg                                    = _feds.configuration.configuration
_Lock                                   = u.Lock.Lock

############################################################################################################
#
#   ABSTRACT BASE CLASS FOR FEDERATORS
#
#===========================================================================================================
class FederatorAbc( object ):

    locksHomelocator                    = _p.join(
        _cfg.persistenceHomepath, _cfg.datastoreHomename, _cfg.datasourceFederatorLocksHomename, )

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, metatopic, readonly, *datasources ):
        self.metatopic      = metatopic
        self.readonly       = readonly
        self.datasources    = []
        self.datasources.extend( datasources )
        self._lockAcquireTimeWaited = None
        self._lockReleaseTimeWaited = None
        self._lock          = None
        self._acquireLock()

    #-------------------------------------------------------------------------------------------------------
    def getWrite( self ):
        return not self.readonly
    write = property( getWrite )

    #-------------------------------------------------------------------------------------------------------
    def f( this, metatopic, readonly = True ):
        return ( metatopic, readonly, )
    _getFederatorCacheindex = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def close( self ):
        #print '+++++++++++ %s.close()' % self.__class__.__name__
        for datasource in self.datasources:
            datasource.close()
        self._releaseLock()

    #-------------------------------------------------------------------------------------------------------
    def getLockname( self ):
        return self.__class__.__name__
    lockname = property( getLockname )

    #-------------------------------------------------------------------------------------------------------
    def _acquireLock( self, write = None ):
        if write is None: write = self.write
        locklocator = _p.join( FederatorAbc.locksHomelocator, self.lockname, )
        self._lock  = _Lock( locklocator, write = write )
        self._lockAcquireTimeWaited = self._lock.timeWaited

    #-------------------------------------------------------------------------------------------------------
    def _releaseLock( self ):
        if self._lock is None: return
        self._lock.release()
        self._lockReleaseTimeWaited = self._lock.timeWaited
        self._lock = None

