#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
import sys as                           _sys
import imp as                           _imp
import os.path as                       _ospath
#-----------------------------------------------------------------------------------------------------------
_feds                                   = g.configtool.utilities.feds
#-----------------------------------------------------------------------------------------------------------
UnknownMetatopicError                   = _feds.exceptions.UnknownMetatopicError
_c                                      = _feds.configuration.configuration
#-----------------------------------------------------------------------------------------------------------
_DatasourceFederatorsPackage            = getattr( _feds, _c.federatorsHomename )
_DatasourceClassesPackage               = getattr( _feds, _c.datasourceClassesHomename )

############################################################################################################
#
#   CONFIGURATION
#
#===========================================================================================================
class c( _c ):
    DATASOURCEMODULEINTERNALNAMEFORMAT  = 'feds-DatasourceClassModule-%d'


############################################################################################################
#
#   CLASS TO BUILD UNIQUELY IDENTIFIABLE STRINGS
#
#===========================================================================================================
class _ThrowawayUnicodeClass( unicode ):
    pass


############################################################################################################
#
#   CLASS TO RETRIEVE AND CACHE FEDERATORS, DATA SOURCE CLASSES, AND DATA SOURCE INSTANCES
#
#===========================================================================================================
class MetaFederator( object ):

    #-------------------------------------------------------------------------------------------------------
    datasourceClassCache            = {}
    datasourceCache                 = {}
    federatorCache                  = {}
    datasourceClassesHomeLocator    = _ospath.abspath( _ospath.join( c.here, c.datasourceClassesHomename ) )

    #-------------------------------------------------------------------------------------------------------
    def __init__( self ):
        raise NotImplementedError( ''
            +   "This class cannot be instantiated: '%s'." % ( self.__class__.__name__ )
            )

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsn, *P, **Q ):
        #print '******* dsn', dsn
        datasourceClass = this.getDatasourceClassForDsn( dsn )
        datasourceIndex = datasourceClass._getDsCacheindex( dsn, *P, **Q )
        R  = None # this.datasourceCache.get( datasourceIndex, None )
        if R is None:
            R = datasourceClass( dsn, *P, **Q )
            this.cacheDatasource( R ) # this.datasourceCache[ id( R ) ] = R
        else:
            R.reopen( *P, **Q )
        return R
    getDatasource = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsn ):
        R = this.datasourceClassCache.get( dsn, None )
        if R is None:
            R = this._importAndCacheDsClass( dsn )
        return R
    getDatasourceClassForDsn = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, dsn ):
#           #---------------------------------------------------------------------------------------------------
#           #   Find out name of class and module and its location:
#           scriptDirectory             = this.datasourceClassesHomeLocator
#           dsClassname                 = dsn
#           dsClassModuleFilebasename   = dsClassname
#           dsClassNumber               = len( this.datasourceClassCache )
#           dsClassModuleinternalname   = c.DATASOURCEMODULEINTERNALNAMEFORMAT % ( dsClassNumber )
#           #---------------------------------------------------------------------------------------------------
#           #   Locate the module:
#           #print '*****', dsClassModuleFilebasename, [ scriptDirectory ]
#           #print '*****', scriptFile, scriptFilename, scriptDescription
#           scriptFile,                 \
#           scriptFilename,             \
#           scriptDescription           = _imp.find_module( dsClassModuleFilebasename, [ scriptDirectory ] )
#           #---------------------------------------------------------------------------------------------------
#           #   Import the module:
#           #   Build a uniquely identifiable object that acts as a string. The rationale is that someone
#           #   else may have put the same entry into ``sys.path`` and counts on it remaining there; on the
#           #   other hand, importing the script may result in some ``sys.path`` modification, so we can not
#           #   count on our entry to remain in position zero. So we need something that acts like a string
#           #   but has object identity beyond the characters in the string (in CPython, if ``a,b`` are
#           #   strings or numbers and ``a==b``, ``=>`` ``id(a)==id(b)``).
#           _scriptDirectory = _ThrowawayUnicodeClass( scriptDirectory )
#           #   Put it into sys.path -- this ensures that the module being import can use import
#           #   statements as usual.
#           _sys.path.insert( 0, _scriptDirectory )
#           _imp.load_module( dsClassModuleinternalname, scriptFile, scriptFilename, scriptDescription )
#           #   Now go looking for that entry in ``sys.path`` again, and remove it. This implies that
#           #   runtime imports for the imported module will *not* work as advertised, but I can not
#           #   see how to guarantee that point (given that anyone may manipulate ``sys.path``).
#           for i, entry in enumerate( _sys.path ):
#               if entry is _scriptDirectory:
#                   del _sys.path[ i ]
#                   break
#           del _scriptDirectory
#           #---------------------------------------------------------------------------------------------------
#           #   Retrieve class from module:
#           scriptModule                = _sys.modules[ dsClassModuleinternalname ]
#           R                           = getattr( scriptModule, dsClassname )
#           #---------------------------------------------------------------------------------------------------
#           #   Store it in cache:
#           this.datasourceClassCache[ dsn ]    = R
#           #---------------------------------------------------------------------------------------------------
#           return R
#       _importAndCacheDsClass = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsn ):
        #---------------------------------------------------------------------------------------------------
        #   Find out name of class and module and its location:
        scriptDirectory             = this.datasourceClassesHomeLocator
        dsClassModuleFilebasename   = dsn
        dsClassname                 = dsn
        #---------------------------------------------------------------------------------------------------
        #   Retrieve class from module:
        dsClassModule               = getattr( _DatasourceClassesPackage, dsClassModuleFilebasename )
        R                           = getattr( dsClassModule, dsClassname )
        #---------------------------------------------------------------------------------------------------
        #   Store it in cache:
        this.datasourceClassCache[ dsn ] = R
        #---------------------------------------------------------------------------------------------------
        return R
    _importAndCacheDsClass = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, federatorCacheindex ):
#           R = this.federatorCache.get( federatorCacheindex, None )
#           return R
#       getCachedFederator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, datasource ):
        this.datasourceCache[ id( datasource ) ] = datasource
    cacheDatasource = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, federator ):
        this.federatorCache[ id( federator ) ] = federator
    cacheFederator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, metatopic ):
        return c.federatorsNameformat % ( metatopic, )
    federatorModuleFilebasenameForMetatopic = classmethod( f )

    #-------------------------------------------------------------------------------------------------------
    def f( this, metatopic, *P, **Q ):
        """Return a data source federator object for a given ``metatopic`` and an appropriate number of
        further arguments (the semantics of which are determined by the selected federator class's
        ``__init__()`` method)."""
        federatorModuleFilebasename = this.federatorModuleFilebasenameForMetatopic( metatopic )
        federatorClassname          = federatorModuleFilebasename
        try:
            federatorModule     = getattr( _DatasourceFederatorsPackage, federatorModuleFilebasename )
            federatorClass      = getattr( federatorModule, federatorClassname )
        except AttributeError:
            raise UnknownMetatopicError( ''
                +   "Unknown metatopic: '%s'" % ( metatopic, )
                )
        #federatorCacheindex = federatorClass._getFederatorCacheindex( metatopic, *P, **Q )
        #federator           = this.getCachedFederator( federatorCacheindex )
        federator = None
        if federator is None:
            federator = federatorClass( metatopic, *P, **Q )
            this.cacheFederator( federator )
        return federator
    resolve = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, metatopic ):
#           datasourceCache = this.datasourceCache
#           for key in datasourceCache.keys():
#               if metatopic in key:
#                   del datasourceCache[ key ]
#       clearDatasourceCacheForMetatopic = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, metatopic, *P, **Q ):
        return this.resolve( metatopic, readonly = True )
    getReadonly = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, metatopic, *P, **Q ):
        return this.resolve( metatopic, readonly = False )
    getWritable = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this ):
        """Close all cached federators and datasources."""
        #print '############### Metafederator.close'
        for cache in this.federatorCache, this.datasourceCache:
            for instance in cache.itervalues():
                instance.close()
    close = classmethod( f ); del f


############################################################################################################
#
#   REGISTER METAFEDERATOR'S CLOSE METHOD AS A FINALIZER
#
#===========================================================================================================
g.configtool.utilities.finalizer.register( MetaFederator.close )


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys
    sys.setrecursionlimit(50)

    sep0                                    = '#' * 108
    sep1                                    = '=' * 108
    sep2                                    = '-' * 108

#       print MetaFederator._importAndCacheDsClass( 'countries' )
#       print MetaFederator._importAndCacheDsClass( 'vectors' )
#
#       print MetaFederator.getDatasourceClassForDsn( 'countries' )
#       print MetaFederator.datasourceClassCache
    #ds = MetaFederator.getDatasource( 'Countries', readonly = True )
    #print ds
    #ds.sample_query()


    geography = MetaFederator.resolve( 'Geography' )
    print geography.dsCountries
    print list( geography.catchCountries() )
    print list( geography.catchCountries( 'Asia' ) )
    print list( geography.catchCapitals() )
    print list( geography.catchCapitals( 'Germany' ) )
    print list( geography.catch( category = 'lake' ) )


    sessions = MetaFederator.resolve( 'Sessions' )








