#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
from time import time as                _time
import inspect as                       _inspect
import os as                            _os
import os.path as                       _p
from weakref import WeakValueDictionary as      _WeakValueDictionary
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
#   _Lock                                   = u.Lock.Lock
_acquire                                = u.pylon.acquire
_AttributeAccessingMedium               = u.hyper.AttributeAccessingMedium
#   _setproperty                            = u.hyper._setproperty
_DictHyper                              = u.hyper.DictHyper
_E                                      = u.IOU.E
_EC                                     = u.IOU.EC
_feds                                   = u.feds
_fillin                                 = u.pylon.fillin
_hyper                                  = u.hyper.hyper
_HyperAbc                               = u.hyper.HyperAbc
_hypo                                   = u.hyper.hypo
_Misfit                                 = u.Misfit.Misfit
_S                                      = u.EzSet.S
_U                                      = u.IOU.U
_UC                                     = u.IOU.UC
#-----------------------------------------------------------------------------------------------------------
_cfg                                    = _feds.configuration.configuration
_hexid                                  = lambda x: hex( id( x ) )
#-----------------------------------------------------------------------------------------------------------
_mk                                     = u.metakit.metakitplus
#   import metakitplus as                   _mk


#   (1)
#
#   should have factoids as classes that define names, property getters and setters, and database
#   types:
#
#
#   class PropertyFact( Fact ):
#
#   __mktypes__ = D(
#   gauge = T.string,
#   locator = T.string,
#   verb...
#   value...
#   )
#   def f( self ):
#   ...
#   value = g.pickler.loads( value )
#   ...


############################################################################################################
#
#   EXCEPTIONS
#
#===========================================================================================================
class MkDatasourceError( Exception ): pass
class SelectionError( MkDatasourceError, KeyError, IndexError ): pass


############################################################################################################
#
#   WRAPPER CLASSES: ROWS
#
#===========================================================================================================
class FactHyper( _HyperAbc ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, medium, tableHyper ):
        super( FactHyper, self ).__init__( medium )
        self.tableHyper = tableHyper
        #   self.cache      = {}

    #-------------------------------------------------------------------------------------------------------
    def getNames( self ):
        return self.tableHyper.names
    names = property( getNames )

    #-------------------------------------------------------------------------------------------------------
    def getDatasource( self ):
        return self.tableHyper.datasource
    datasource = property( getDatasource )

    #-------------------------------------------------------------------------------------------------------
    def dict( self ):
        R = {}
        medium = self.medium
        for name in self.names:
            R[ name ] = medium[ name ]
        return R

    #-------------------------------------------------------------------------------------------------------
    def update( self, Q ):
        medium = self.medium
        for name, value in Q.iteritems():
            medium[ name ] = value

    #   #-------------------------------------------------------------------------------------------------------
    #   def getWriteToCache( self ):
    #       return self.hypo.__writetocache__
    #   def setWriteToCache( self, value ):
    #       self.hypo.__writetocache__ = value
    #       self.tableHyper._registerCachedFact( self.hypo, value )
    #   writeToCache = property( getWriteToCache, setWriteToCache )

#===========================================================================================================
class Fact( _AttributeAccessingMedium ):

    #-------------------------------------------------------------------------------------------------------
    #   Data provider class (not used here):
    __hypoclass__       = None
    #-------------------------------------------------------------------------------------------------------
    #   Functionalities provider class:
    __hyperclass__      = FactHyper
    #   #-------------------------------------------------------------------------------------------------------
    #   #   If set to true, setting items and attributes will not change the underlying data source file,
    #   #   but rather update cache tables in (+~).tableHyper
    #   __writetocache__    = False

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, tableHyper, mkRowObject ):
        self.__dict__[ self.__hypername__ ] = self.__hyperclass__( self, tableHyper )
        self.__dict__[ self.__hyponame__  ] = mkRowObject

#       #-------------------------------------------------------------------------------------------------------
#       def __getitem__( self, name ):          return getattr( _hypo( self ), name )
#       def __setitem__( self, name, value ):   setattr( _hypo( self ), name, value )

    #-------------------------------------------------------------------------------------------------------
    def __eq__( self, other ):
        if isinstance( other, Fact ):
            other = (+other).dict()
        if isinstance( other, dict ):
            return (+self).dict() == other
        raise TypeError( ''
            +   "Bad types for equality comparison: %s object and %s object." % (
                    self.__class__, other.__class__, )
            )

    #   #-------------------------------------------------------------------------------------------------------
    #   def __getattr__( self, name ):
    #       if self.__writetocache__:
    #           raise NotImplementedError( ''
    #               +   "Reading from cached fact not implemented. Use uncached fact instead."
    #               )
    #       return getattr( hypo( self ), name )
    #
    #   #-------------------------------------------------------------------------------------------------------
    #   def __setattr__( self, name, value ):
    #       if self.__writetocache__:
    #           (+self).
    #       else:
    #           _setproperty( self, name, value ) or setattr( hypo( self ), name, value )

############################################################################################################
#
#   WRAPPER CLASSES: FACTOIDS
#
#===========================================================================================================
class TableHyper( _HyperAbc ):

    #-------------------------------------------------------------------------------------------------------
    idname                  = 'id'
    _factsBySytemIdCache    = _WeakValueDictionary()
    factclass               = Fact

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, medium, mkDatasource, name = None ):
        super( TableHyper, self ).__init__( medium )
        self._mkDatasource      = mkDatasource
        self.name               = name
        self._factsByIdCache    = {}
        #   self._cachedFactsById   = {}

    #   #-------------------------------------------------------------------------------------------------------
    #   def _registerCachedFact( self, factHypo, doRegister = True ):
    #       key = id ( factHypo )
    #       if doRegister:
    #           self._cachedFactsById.setdefault( key, factHypo )
    #       else:
    #           self._cachedFactsById.pop( key, None )

    #-------------------------------------------------------------------------------------------------------
    def getNames( self ):
        structure = self.hypo.structure()
        #print '**********', structure  ###DEBUG###
        return [ property.name for property in structure ]
    names = property( getNames )

    #-------------------------------------------------------------------------------------------------------
    def getDatasource( self ):
        return self._mkDatasource
    datasource = property( getDatasource )

    #-------------------------------------------------------------------------------------------------------
    def project( self, *names ):
        hypo = self.hypo
        properties = [ getattr( hypo, name ) for name in names ]
        mkViewObject = hypo.project( *properties )
        R = Table( self._mkDatasource, mkViewObject )
        return R

    #-------------------------------------------------------------------------------------------------------
    def select( self, **Q ):
        mkViewObject    = self.hypo.select( **Q )
        tableclass      = self._mkDatasource._getTableclassForTablename( self.name )
        R               = tableclass( self._mkDatasource, mkViewObject )
        return R

    #-------------------------------------------------------------------------------------------------------
    def filter( self, filter ):
        """
        Implementation Notes
        ====================

        One of the weak points of Metakit is that some commands like ``filter()`` do not return views with
        the affected rows, but rather views that contain rows with indices. This is most often not what we
        want. One possible workaround is to modify the table by adding a temporary column with a boolean
        value (which will not be persisted) and fill that column with a boolean indicating inclusion of the
        row in the result set; we can then return the result of an ordinary ``select()``."""
        #---------------------------------------------------------------------------------------------------
        mkViewObject = self.hypo
        from random import randrange
        randomName = '_temp_%d' % randrange( 0, 1e6 )
        #   skipping test whether column name already exists
        mkViewObject.addproperty( _mk.property( 'I', randomName ) )
        for fact in self.facts:
            mkRowObject = _hypo( fact )
            setattr( mkRowObject, randomName, bool( filter( fact ) ) )
        condition = { randomName: 1 }
        mkViewObject = _hypo( self ).select( **condition )
        R = Table( self._mkDatasource, mkViewObject, self.name )
        return R

    #-------------------------------------------------------------------------------------------------------
    def getIds( self ):
        idname = self.idname
        hypo = self.hypo
        mkViewObject = hypo.project( getattr( hypo, idname ) )
        for mkRowObject in mkViewObject:
            yield getattr( mkRowObject, idname )
    ids = property( getIds )

    #-------------------------------------------------------------------------------------------------------
    def getFacts( self ):
        for mkRowObject in self.hypo:
            mkRowObjectSystemId = _hexid( mkRowObject )
            R = self._factsBySytemIdCache.get( mkRowObjectSystemId, None )
            if R is None:
                #print '........', self.factclass
                R = self.factclass( self, mkRowObject )
                self._factsBySytemIdCache[ mkRowObjectSystemId ] = R
            yield R
    facts = property( getFacts )

    #-------------------------------------------------------------------------------------------------------
    def factForId( self, id ):
        R = self._factsByIdCache.get( id, None )
        if R is None:
            selection = self.hypo.select( id = id )
            #-----------------------------------------------------------------------------------------------
            if not selection:
                raise SelectionError( ''
                    +   "Table %s: Unable to find fact for id %r." % ( self.name, id, )
                    )
            #-----------------------------------------------------------------------------------------------
            if len( selection ) > 1:
                raise InconsistencyError( ''
                    +   "Table %s: Found more than one fact for id %r." % ( self.name, id, )
                    )
            #-----------------------------------------------------------------------------------------------
            for mkRowObject in selection: break
            print '+++++++', self.factclass
            R = self._factsByIdCache[ id ] = self.factclass( self, mkRowObject )
        return R

    #-------------------------------------------------------------------------------------------------------
    def append( self, **Q ):
        mkViewObject    = self.hypo
        rowindex        = mkViewObject.append()
        mkRowObject     = mkViewObject[ rowindex ]
        factclass       = self.factclass
        fact            = factclass( tableHyper = self, mkRowObject = mkRowObject )
        (+fact).update( Q )

    #-------------------------------------------------------------------------------------------------------
    def length( self ):
        return len( self.hypo )

    #-------------------------------------------------------------------------------------------------------
    def copy( self ):
        #   Remember self.hypo is the underlying view (two tiers below), but _hypo( self ) is the
        #   hyper.Medium object (one tier below). This could also be written as::
        #
        #       return (-self).__class__( self.mkDatasource, --self )
        #
        return _hypo( self ).__class__( self._mkDatasource, self.hypo )


#===========================================================================================================
class Table( _AttributeAccessingMedium ):

    #-------------------------------------------------------------------------------------------------------
    #   Data provider class (not used here):
    __hypoclass__       = None
    #-------------------------------------------------------------------------------------------------------
    #   Functionalities provider class:
    __hyperclass__      = TableHyper

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, mkDatasource, mkViewObject, name = None ):
        self.__dict__[ self.__hypername__ ] = self.__hyperclass__( self, mkDatasource, name )
        self.__dict__[ self.__hyponame__  ] = mkViewObject

#       #-------------------------------------------------------------------------------------------------------
#       def __getitem__( self, name ):          return getattr( _hypo( self ), name )
#       def __setitem__( self, name, value ):   setattr( _hypo( self ), name, value )

    #-------------------------------------------------------------------------------------------------------
    def __iter__( self ):
        return _hyper( self ).facts

    #-------------------------------------------------------------------------------------------------------
    def __len__( self ):
        return len( _hypo( self ) )

    #-------------------------------------------------------------------------------------------------------
    #   REPRESENTATION
    #-------------------------------------------------------------------------------------------------------
    def __unicode__( self ):
        names = _hyper( self ).names
        return '<%s %s>' % ( self.__class__.__name__, ', '.join(
            [ '%s:%s' % ( name, self[ name ].type, )
                for name in names ]
            ) )

############################################################################################################
#
#   UNICODE HANDLING
#
#===========================================================================================================
def _ecdict( Q ):
    R = {}
    for name, value in Q.iteritems():
        R[ _E( name ) ] = _EC( value )
    return R

#-----------------------------------------------------------------------------------------------------------
def _eclist( P ):
    return map( _EC, P )

#-----------------------------------------------------------------------------------------------------------
def _ucdict( Q ):
    R = {}
    for name, value in Q.iteritems():
        R[ _U( name ) ] = _U( value )
    return R

#-----------------------------------------------------------------------------------------------------------
def _uclist( P ):
    return map( _UC, P )


############################################################################################################
#
#   CONFIGURATION
#
#===========================================================================================================
class cfg( _cfg ):
    mkDataFilenameSuffix                = 'mkdb'
    #-------------------------------------------------------------------------------------------------------
    #   The suffixes of all filetypes we need for the chosen hierarchy implementation:
    filenameSuffixes                   = ( mkDataFilenameSuffix, )
#           _cfg.xsdbDataFilenameSuffix, _cfg.xsdbLinkFilenameSuffix, _cfg.xsdbLogFilenameSuffix, )
    #-------------------------------------------------------------------------------------------------------
    #   These are the suffixes of files that should minimally be present in a directory that is to
    #   be considered a tentatively valid connection directory:
    minimalFilenameSuffixes            = ( mkDataFilenameSuffix, )
#           _cfg.xsdbDataFilenameSuffix, _cfg.xsdbLinkFilenameSuffix, )
#       #-------------------------------------------------------------------------------------------------------
#       #   If useBlobs is set to True, only strings will be pickled -- reviving the original objects will
#       #   have to be done by the application.
#       useBlobs                           = False

############################################################################################################
#
#
#
#===========================================================================================================
class getMkViewDescription( object ):

    #-------------------------------------------------------------------------------------------------------
    defaultUnderlyingDatatype = 'S'

    #-------------------------------------------------------------------------------------------------------
    class underlyingDatatypes:
        integer = 'I' # adaptive integer (becomes Python int)
        string  = 'S' # C null terminated string (becomes Python string)
        binary  = 'B' # C array of bytes (becomes Python string)
        long    = 'L' # 64-bit integer (becomes Python long)
        float   = 'F' # C float (becomes Python float)
        double  = 'D' # C double (is a Python float)

    #-------------------------------------------------------------------------------------------------------
    def f( this, __name__, *P, **Q ):
        for name in P:
            Q[ name ] = this.defaultUnderlyingDatatype
        names = Q.keys()
        names = [ ( name.lower(), name ) for name in names ]
        names.sort()
        names = [ name[ 1 ] for name in names ]
        fields = ','.join( [ '%s:%s' % ( name, Q[ name ], ) for name in names ] )
        R = '%s[%s]' % ( __name__, fields, )
        return R
    fromNames = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, datasource, name ):
        if isinstance( datasource, MkDatasource ):
            datasource = datasource.connection
        fields = datasource.description( name )
        R = '%s[%s]' % ( name, fields, )
        return R
    fromDatasource = classmethod( f ); del f


############################################################################################################
#
#
#
#===========================================================================================================
class MkDatasourceMetadescription( object ):
    dsn                                 = 'default'
    homelocator                         = cfg.persistenceHomepath
    storehomename                       = cfg.datastoreHomename
    datafilenamesuffix                  = cfg.mkDataFilenameSuffix
    filenamesuffixes                    = cfg.filenameSuffixes
    minimalfilenamesuffixes             = cfg.minimalFilenameSuffixes
    autoopen                            = True
    #   autostarttransaction                = True
    autocommit                          = True
#       autoaddoid                          = True # if True, add(obj) => setattr( obj, autoaddoidname, oid )
#       autoaddoidname                      = 'oid'
#       useblobs                            = cfg.useBlobs
#       metadataoid                         = None # this unique value cannot be used for regular oids
#       autoaddoiddescription               = True
#       autoaddoiddescriptionname           = '__oid__'

############################################################################################################
#
#
#
#===========================================================================================================
class MkDatasource( MkDatasourceMetadescription ):

    #-------------------------------------------------------------------------------------------------------
    readonly                            = True
    verbosity                           = cfg.verbosity
    #dependencies                        = []

    #-------------------------------------------------------------------------------------------------------
    underlyingDatatypes                 = getMkViewDescription.underlyingDatatypes
    defaultUnderlyingDatatype           = getMkViewDescription.defaultUnderlyingDatatype
    tableclassesByTablename                  = {}
    defaultTableclass                   = Table

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, dsn = None, readonly = None ):
        #---------------------------------------------------------------------------------------------------
        if readonly                     is not None: self.readonly = readonly
        if dsn                          is     None: dsn = self.__class__.__name__
        #---------------------------------------------------------------------------------------------------
        self.dsn                        = dsn
        self.connection                 = None
        self._metadata                  = None
        #---------------------------------------------------------------------------------------------------
        self.prepareDs()
        if self.autoopen:
            self.open()
        self._descriptionsByNameCache       = _WeakValueDictionary()

    ########################################################################################################
    #   OPENING AND CLOSING
    #-------------------------------------------------------------------------------------------------------
    def __del__( self ):
        close = getattr( self, 'close', None )
        if close is None: return
        close()

    #-------------------------------------------------------------------------------------------------------
    def open( self, readonly = None ):
        V = self.verbosity
        if readonly is None:    readonly = self.readonly
        else:                   self.readonly = readonly
        dsfilelocator       = self.dsfilelocator
        startup             = not self._dsAppearsToExist()
        clear               = True # see http://xsdb.sourceforge.net/api.html "Existing Databases"
        #---------------------------------------------------------------------------------------------------
        if readonly:
            mode = 0
        else:
            mode = 1
        #---------------------------------------------------------------------------------------------------
        if V: print "Trying to connect to data source '%s' in '%s'." % ( self.dsn, self.dshomelocator, )
        #print '+++++++++++', mode, dsfilelocator ###DEBUG###
        self.connection = _mk.storage( dsfilelocator, mode )
        if V: print "Connected to data source '%s' in '%s'." % ( self.dsn, self.dshomelocator, )
#           #---------------------------------------------------------------------------------------------------
#           if self.autocommit:
#               self.connection.autocommit()
        #---------------------------------------------------------------------------------------------------
        return self

    #-------------------------------------------------------------------------------------------------------
    def close( self ):
        V = self.verbosity
        if V > 2: print "Trying to close transaction and connection for data source '%s'." % ( self.dsn, )
        #self.releaseLock()
        if ( not self.readonly ) and self.autocommit:
            try:                    self._commit()
            except AttributeError:  pass
            if V > 2: print "Committed data for data source '%s'." % ( self.dsn, )
        if self.connection is not None:
            self.connection = None
            if V > 2: print "Closed connection for data source '%s'." % ( self.dsn, )

    #-------------------------------------------------------------------------------------------------------
    def abort( self ):
        V = self.verbosity
        if self.transaction is not None:
            self.transaction.abort()
        self.transaction = None
        self.connection  = None
#           self.releaseLock()

    #-------------------------------------------------------------------------------------------------------
    def _commit( self ):
        V = self.verbosity
        if V > 2: print "Committing transaction for data source '%s'." % ( self.dsn, )
        assert not self.readonly
        self.connection.commit()

    #-------------------------------------------------------------------------------------------------------
    def f( this, dsn, readonly = True ):
        return dsn
    _getDsCacheindex = classmethod( f ); del f

    ########################################################################################################
    #   OBJECT HANDLING
#       #-------------------------------------------------------------------------------------------------------
#       def declareIndex( self, description, facetnames, indexname ):
#           t0 = _time()
#           assert not self.readonly
#           V = self.verbosity
#           if V: print "Building index %s, %s, %s." % ( description, facetnames, indexname, )
#           self.transaction.index( description, facetnames, indexname )
#           self.addedindextime += _time() - t0

    #-------------------------------------------------------------------------------------------------------
    def add( self, x, *P, **Q ):
        oid = self.getNewOid( x )
        return self.addWithOid( x, oid, *P, **Q )

    #-------------------------------------------------------------------------------------------------------
    def addFactoids( self, **Q ):
        R = []
        for name, namespace in Q.iteritems():
            viewdescription = getMkViewDescription.fromNames( name, **namespace )
            R.append( self.connection.getas( viewdescription ) )
        return R

    #-------------------------------------------------------------------------------------------------------
    def addFacts( self, **QQ ):
        for tablename, factdescription in QQ.iteritems():
            factdescription = _ecdict( factdescription )
            table           = self.factoid( tablename )
            #print '%%%%%%%%%%%%%', table.__class__
            (+table).append( **factdescription )

    #-------------------------------------------------------------------------------------------------------
    def tableExists( self, tablename ):
        try:
            self.connection.description( tablename )
            return True
        except KeyError:
            return False

    #-------------------------------------------------------------------------------------------------------
    def removeFactoid( self, nameOrTable ):
        if isinstance( nameOrTable, Table ):
            name = Table.name
        else:
            name = nameOrTable
        if name is None:
            raise ValueError( ''
                +   "Unable to remove an anonymous description."
                )
        view = self._getMkViewObject( name )
        del view[:]
        self.connection.getas( name )
        self._descriptionsByNameCache.pop( name, None )

    #-------------------------------------------------------------------------------------------------------
    def removeFactoids( self, *namesOrFactoids ):
        if not namesOrFactoids: namesOrFactoids = self.factoidNames
        for nameOrTable in namesOrFactoids:
            self.removeFactoid( nameOrTable )

    #-------------------------------------------------------------------------------------------------------
    def clearTable( self, nameOrTable ):
        if isinstance( nameOrTable, Table ):
            name = Table.name
        else:
            name = nameOrTable
        if name is None:
            raise ValueError( ''
                +   "Unable to remove an anonymous description."
                )
        view = self._getMkViewObject( name )
        del view[:]

    #-------------------------------------------------------------------------------------------------------
    def clearTables( self, *namesOrTables ):
        if not namesOrTables: namesOrTables = self.factoidNames
        for nameOrTable in namesOrTables:
            self.clearTable( nameOrTable )

    #-------------------------------------------------------------------------------------------------------
    def addFact__old__( self, __name__, *P, **Q ):
        view = self._getMkViewObject( __name__ )
        Q = _ecdict( Q )
        view.append( **Q )

    #-------------------------------------------------------------------------------------------------------
    def removeFact( self, __name__, *P, **Q ):
        raise NotImplementedError
        # view.delete(index): Row at index removed from Table

    #-------------------------------------------------------------------------------------------------------
    def insertFact( self, __name__, *P, **Q ):
        raise NotImplementedError
        # view.insert(index, obj): Coerce object to a Row and insert at index in Table

    #-------------------------------------------------------------------------------------------------------
    def _getTableclassForTablename( self, name ):
        return self.tableclassesByTablename.get( name, self.defaultTableclass )

    #-------------------------------------------------------------------------------------------------------
    def catchTable( self, **Q ):
        if not len( Q ) == 1:
            raise TypeError( ''
                +   "Method only accepts a single name/namespace pair."
                )
        name, namespace = Q.popitem()
        R = self.factoid( name )
        if namespace:
            namespace       = _ecdict( namespace )
            mkViewObject    = _hypo( R ).select( **namespace )
            tableclass      = self._getTableclassForTablename( name )
            R               = tableclass( self, mkViewObject, name )
        else:
            R               = _hyper( R ).copy()
        return R

    ########################################################################################################
    #   META DATA
    #-------------------------------------------------------------------------------------------------------
    def getFactoidNames( self ):
        """N.B.: does *not* handle views in views, does *not* handle blocked views."""
        descriptionString = self.connection.description()
        tables = descriptionString.split( '],' )
        R = [ table.split( '[' )[ 0 ] for table in tables ]
        return R
    factoidNames = property( getFactoidNames )

    #-------------------------------------------------------------------------------------------------------
    def getFactoids( self ):
        return [ self.factoid( name ) for name in self.factoidNames ]
    factoids = property( getFactoids )

    #-------------------------------------------------------------------------------------------------------
    def factoid( self, tablename ):
        R = self._descriptionsByNameCache.get( tablename, None )
        if R is None:
            mkViewObject = self.connection.view( tablename )
            tableclass = self._getTableclassForTablename( tablename )
            #print '&&&&&&&&&&&&&&&&', tablename, tableclass
            R = self._descriptionsByNameCache[ tablename ] = tableclass( self, mkViewObject )
        return R

    #-------------------------------------------------------------------------------------------------------
    def getTable( self, tablename ):
        return self.factoid( tablename )

    #-------------------------------------------------------------------------------------------------------
    def _getMkViewObject( self, name ):
        return _hypo( self.factoid( name ) )

    #-------------------------------------------------------------------------------------------------------
    def _dumpDescription( self, nameOrTable ):
        if isinstance( nameOrTable, basestring ):
            view = self._getMkViewObject( nameOrTable )
        elif isinstance( nameOrTable, Table ):
            view = _hypo( nameOrTable )
        else:
            view = nameOrTable
        _mk.dump( view )

    ########################################################################################################
    #   FILE SYSTEM HANDLING
    #-------------------------------------------------------------------------------------------------------
    def prepareDs( self, purge = False ):
        R = self.prepareStorehome()
        R = self.prepareDshome() or R
        return R

    #-------------------------------------------------------------------------------------------------------
    def getStorehomelocator( self ):
        return _p.join( self.homelocator, self.storehomename )
    storehomelocator = property( getStorehomelocator )

    #-------------------------------------------------------------------------------------------------------
    def getDsdirectoryname( self ):
        return self.dsn
    dsdirectoryname = property( getDsdirectoryname )

    #-------------------------------------------------------------------------------------------------------
    def getDsfilename( self, filenamesuffix = None ):
        if filenamesuffix is None: filenamesuffix = self.datafilenamesuffix
        return '%s.%s' % ( self.dsn, filenamesuffix )
    dsfilename = property( getDsfilename )

    #-------------------------------------------------------------------------------------------------------
    def getDshomelocator( self ):
        return _p.join( self.storehomelocator, self.dsdirectoryname )
    dshomelocator = property( getDshomelocator )

    #-------------------------------------------------------------------------------------------------------
    def getDsfilelocator( self, filenamesuffix = None ):
        dsfilename = self.getDsfilename( filenamesuffix )
        return _p.join( self.dshomelocator, dsfilename )
    dsfilelocator = property( getDsfilelocator )

    #-------------------------------------------------------------------------------------------------------
    def recreateDatasource( self ):
        assert not self.readonly
        wasopen = False
        if self.connection is not None:
            wasopen = True
            self.abort()
        self._purgeDsdirectory()
        if wasopen:
            self.open()

    #-------------------------------------------------------------------------------------------------------
    def _dsAppearsToExist( self ):
        """Return true iff all files ndeemed necessary for operation appear to exist."""
        for filenamesuffix in self.minimalfilenamesuffixes:
            filelocator = self.getDsfilelocator( filenamesuffix )
            if not _p.exists( filelocator ): return False
            if not _p.isfile( filelocator ): return False
        return True

    #-------------------------------------------------------------------------------------------------------
    def _purgeDsdirectory( self ):
        """Remove all xsdb-specific files (i.e. such with extensions as listed in ``~.filenamesuffixes``)
        from the data source home directory identified by ``~.dshomelocator``. Do not remove any other
        files. Raise ``IOError`` if an object exists under the name of ``~.dshomelocator`` which is not a
        directory, or if any of the filenames match objects that are not files."""
        #---------------------------------------------------------------------------------------------------
        dshomelocator = self.dshomelocator
        V = self.verbosity
        if V: print "Trying to purge data source home directory '%s'." % ( dshomelocator, )
        if _p.exists( dshomelocator ):
            if V: print "Exists: '%s'." % ( dshomelocator )
            if not _p.isdir( dshomelocator ):
                if V: print "Not a directory: '%s'." % ( dshomelocator )
                raise IOError(
                    "Database name must match directory or nothing: '%s'." % ( directoryname, ) )
            if V: print "Is a directory: '%s'." % ( dshomelocator )
        for filenamesuffix in self.filenamesuffixes:
            filelocator = self.getDsfilelocator( filenamesuffix )
            #print '+++++++++', filenamesuffix, filelocator
            if _p.exists( filelocator ):
                if V: print "Exists: '%s'." % ( filelocator )
                if not _p.isfile( filelocator ):
                    if V: print "Not a file: '%s'." % ( filelocator )
                    raise IOError( ''
                        +   "Filename must match file or nothing: '%s'." % ( filelocator, )
                        )
                _os.remove( filelocator )
                if V: print "Removed file: '%s'." % ( filelocator )
            else:
                if V: print "Does not exist: '%s'." % ( filelocator )
        if V: print "Directory cleaned: '%s'." % ( dshomelocator )

    #-------------------------------------------------------------------------------------------------------
    def prepareDshome( self ):
        """In case ``databasepath`` ``=`` *directoryname* ``+ '/' +`` *databasename* exists and is a
        directory, clean it using ``~.cleanDirectory()``, q.v. Successful completion of
        ``~.cleanDirectory()`` means that ``databasepath`` is indeed a directory, if it exists; if not,
        create it. Return value indicates whether directory was created."""
        R                   = True
        V                   = self.verbosity
        dshomelocator       = self.dshomelocator
        if _os.path.exists( dshomelocator ):
            if V: print "Exists: '%s'." % ( dshomelocator )
        else:
            if V: print "Does not exist: '%s'." % ( dshomelocator )
            _os.mkdir( dshomelocator )
            R = True
            if V: print "Directory created '%s'." % ( dshomelocator )
        if V: print "Directory prepared: '%s'." % ( dshomelocator )
#           if self.reconnect:
#               dsfilelocator = self.dsfilelocator
#               if _p.exists( dsfilelocator ):
#                   if V: print "Exists: '%s'." % ( dsfilelocator, )
#                   if _p.isfile( dsfilelocator ):
#                       if V: print "Is a file: '%s'." % ( dsfilelocator, )
#                   else:
#                       if V: print "Not a file: '%s'." % ( dsfilelocator, )
#                       raise IOError( ''
#                           +   "File system object by the name of the datafile exists, "
#                           +   "but is not a file: '%s'." % ( dsfilelocator, )
#                           )
#               else:
#                   if V: print "Does not exist: '%s'." % ( dsfilelocator, )
#                   self.reconnect = False
#                   if V: print "Property ~.reconnect set to False."
#           if not self.reconnect:
#               self._purgeDsdirectory()
        return R

    #-------------------------------------------------------------------------------------------------------
    def prepareStorehome( self ):
        """Return value indicates whether directory was created."""
        R                   = True
        V                   = self.verbosity
        storehomelocator    = self.storehomelocator
        if not _p.exists( storehomelocator ):
            if V: print "Does not exist: '%s'." % ( storehomelocator )
            _os.mkdir( storehomelocator )
            R = True
            if V: print "Directory created '%s'." % ( storehomelocator )
        if V: print "Directory prepared: '%s'." % ( storehomelocator )
        return R


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit( 50 )
    sep0 = '#' * 108
    sep1 = '=' * 108
    sep2 = '-' * 108
