#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import                  division
#-----------------------------------------------------------------------------------------------------------
import re as                            _re
#-----------------------------------------------------------------------------------------------------------
_D = dict

############################################################################################################
#
#
#
#===========================================================================================================
def _commandsAndSymbolsByLength( flowConventions ):
    commands = {}
    byLength = []
    for name, d in flowConventions.iteritems():
        symbol              = d[ 'symbol' ]
        argumentPattern     = d[ 'argumentPattern' ]
        commandName         = d[ 'commandName' ]
        if argumentPattern: argumentRe = _re.compile( argumentPattern )
        else:               argumentRe = None
        commands[ symbol ] = dict(
            attributeName   = name,
            argumentRe      = argumentRe,
            commandName     = commandName,
            )
        byLength.append( ( - len( symbol ), symbol ) )
    byLength.sort()
    byLength = [ e[ 1 ] for e in byLength ]
    return commands, byLength


#-----------------------------------------------------------------------------------------------------------
flowConventions = _D(

    #=======================================================================================================
    graphname = _D(
        addToCluster        = False,
        argumentPattern     = '[^:]+',
        commandName         = 'graphname',
        counterpartname     = False,
        symbol              = ':',
        ),

    #=======================================================================================================
    parent = _D(
        addToCluster        = True,
        argumentPattern     = False,
        commandName         = 'parent',
        counterpartname     = 'childnodes',
        symbol              = '<',
        ),

    #-------------------------------------------------------------------------------------------------------
    child = _D(
        addToCluster        = True,
        argumentPattern     = False,
        commandName         = 'child',
        counterpartname     = 'parent',
        symbol              = '>'
        ),

    #=======================================================================================================
    subnode = _D(
        addToCluster        = True,
        argumentPattern     = False,
        commandName         = 'subnode',
        counterpartname     = 'supernodes',
        symbol              = '=>',
        ),

    #-------------------------------------------------------------------------------------------------------
    supernode = _D(
        addToCluster        = True,
        argumentPattern     = False,
        commandName         = 'supernode',
        counterpartname     = 'subnodes',
        symbol              = '<=',
        ),

    #-------------------------------------------------------------------------------------------------------
    equivalent = _D(
        addToCluster        = False,
        argumentPattern     = False,
        commandName         = 'equivalent',
        counterpartname     = False,
        symbol              = '<=>',
        ),

#       #-------------------------------------------------------------------------------------------------------
#       superiors = _D(
#           addToCluster        = False,
#           argumentPattern     = False,
#           commandName         = 'superior',
#           counterpartname     = False,
#           symbol              = '<<-',
#           ),
#
#       #-------------------------------------------------------------------------------------------------------
#        supernodes = _D(
#           addToCluster        = False,
#           argumentPattern     = False,
#           commandName         = False,
#           counterpartname     = False,
#           symbol              = '<-',
#           ),
#
#       #-------------------------------------------------------------------------------------------------------
#       facts = _D(
#           addToCluster        = False,
#           argumentPattern     = False,
#           commandName         = 'fact',
#           counterpartname     = False,
#           symbol              = '%',
#           ),
#
#       #-------------------------------------------------------------------------------------------------------
#       subnodes = _D(
#           addToCluster        = False,
#           argumentPattern     = False,
#           commandName         = False,
#           counterpartname     = False,
#           symbol              = '->',
#           ),
#
#       #-------------------------------------------------------------------------------------------------------
#       inferiors = _D(
#           addToCluster        = False,
#           argumentPattern     = False,
#           commandName         = 'inferior',
#           counterpartname     = False,
#           symbol              = '->>',
#           ),

    )



#-----------------------------------------------------------------------------------------------------------
commands, commandsymbolsByLength = _commandsAndSymbolsByLength( flowConventions )







#   ############################################################################################################
#   #
#   #   YELLOW PAGES
#   #
#   #===========================================================================================================
#   #   from __future__ import                  division
#   #-----------------------------------------------------------------------------------------------------------
#   #   #from sets import                        Set
#   #   #from StringIO import                    StringIO
#   #   import csvIdioms as                     csvi
#   #   #import tabulardata as                   tab
#   #   #-----------------------------------------------------------------------------------------------------------
#   #   from IOU import                         ReprMx
#   #   from infra import                       RepromSetABC
#   #   import                                  infra
#   #   from EzSet import                       S
#   #   from Fact import                        Fact
#   #   from Fact import                        Facet
#   #   from Fact import                        FactsetDict
#   #   #-----------------------------------------------------------------------------------------------------------
#   #   L2CACHEVALID_NAME                       = '_L2CacheIsValid'
#   #   XPATH_NAMESEP                           = '/'
#   #   EMPTYSET                                = S()
#   #   PREFIXES_IF_IN_SOURCE                   = ( '', '.' )
#   #   PREFIXES_IF_ONLY_IN_CLUSTER             = ( '', '~' )
#   #   PREFIXES_IF_PRIVATE_FACT                = ( '', '#' )
#   #   PREFIXES_IF_LOCAL_FACT                  = ( '', '^' )
#
#   #-----------------------------------------------------------------------------------------------------------
#   csvi                                    = g.configtool.utilities.reprom.csvIdioms
#
#
#   reader = csvi.getCsv.fromText( r"""
#       name            symbol      addToCluster    counterpartname     argumentPattern commandName
#       antecedents     <=          +               subsequents         #               antecedent
#       subsequents     =>          +               antecedents         #               subsequent
#       parents         <           +               children            #               parent
#       children        >           +               parents             #               child
#       superiors       <<-         -               #                   #               superior
#       inferiors       ->>         -               #                   #               inferior
#       subnodes        ->          -               #                   #
#       supernodes      <-          -               #                   #
#       equivalents     <=>         -               #                   #               equivalent
#       graphname       :           #               #                   [^:]+           graphname
#       facts           %           #               #                   #               fact
#       """,
#       optionset = 'whitespace', escapechar = None )
#
#
#   NODE_AND_LOCATOR_DETAILS = {}
#   for facts in reader:
#       name = facts.pop( 'name' )
#       if name:
#           NODE_AND_LOCATOR_DETAILS[ name ] = facts
#           for facetname, facetvalue in facts.items():
#               if facetvalue == '+':
#                   facts[ facetname ] = True
#               elif not facetvalue or facetvalue == '-' or facetvalue.startswith( '#' ):
#                   facts[ facetname ] = False
#
#
#   if __name__ == '__main__':
#
#       for symbol, d in NODE_AND_LOCATOR_DETAILS.items():
#           print symbol, d
#
#       print NODE_AND_LOCATOR_DETAILS
#
