#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   import                                  sys
#   import                                  cgi
#   import                                  traceback
#   #   import                                  inspect
#   import                                  os.path
#   import                                  os
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
typeIdioms                              = u.typeIdioms.typeIdioms


############################################################################################################
#
#
#
#===========================================================================================================
class Glue:

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, owner ):
        self.__dict__[ '__owner__' ] = owner

    #-------------------------------------------------------------------------------------------------------
    def __getattr__( self, name ):
        return getattr( self.__dict__[ '__owner__' ], name )

    #-------------------------------------------------------------------------------------------------------
    def __setattr__( self, name, value ):
        if not name in vars( self ):
            setattr( self.__dict__[ '__owner__' ], name, value )

############################################################################################################
#
#
#
#===========================================================================================================
class GluerMx:

    #-------------------------------------------------------------------------------------------------------
    def glueMethod( self, name, method ):
        """Glue a given ``method`` to the servlet class and execute it like an ordinary instance method.
        This makes it possible to use code from remote files like it had been defined right within the class
        definition here."""
        #---------------------------------------------------------------------------------------------------
        #   In case ``method`` is a free function, we're almost ready.
        if not typeIdioms.isFunction( method ):
            #-----------------------------------------------------------------------------------------------
            #   If not, we expect it to be the method of an instance or, better, of a class.
            assert typeIdioms.isMethod( method )
            #-----------------------------------------------------------------------------------------------
            #   Retrieve class where method is defined:
            methodClass = method.im_class
            #-----------------------------------------------------------------------------------------------
            #   This class must be derived from ``Glue`` -- if this should not be true, make it come true:
            if not issubclass( methodClass, Glue ):
                class methodClass( Glue, methodClass ): pass
            #-----------------------------------------------------------------------------------------------
            #   Under ``_gluedInstance``, we keep an instance of the glued class. That instance itself has
            #   a magic attribute ``__owner__`` that refers back to ``self`` for method resolution:
            _gluedInstance = self._gluedInstance = methodClass( self )
            #-----------------------------------------------------------------------------------------------
            #   We change the interpretation of ``method`` to whatever the glued instance has under the
            #   name that the original method was defined under (this is just a fancy way of saying that
            #   a class and instance attributes are unified to instance attributes):
            method = getattr( _gluedInstance, method.__name__ )
            #method = lambda self, *P, **Q: instanceMethod( *P, **Q )
        #---------------------------------------------------------------------------------------------------
        #   Make ``method`` available to ``self`` under ``name`` by grafting it into ``self``'s class:
        setattr( self.__class__, name, method )


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    #-------------------------------------------------------------------------------------------------------
    import sys; sys.setrecursionlimit( 50 )
    sep = '=' * 108

    class A( GluerMx ):

        def foo( self, x = 42 ):
            return x * 2


    class B( Glue ):

        def engage( self, x = 84 ):
            return self.oops( x )

        def oops( self, x ):
            return x * 3 + self.foo( x )

    #   a = A()
    #   b = B( a )
    #   A.engage = b.engage
    #   print a.engage( 2 )


    a = A()
    a.glueMethod( 'something', B( a ).engage )
    print a.something( 2 )





