#
# -*- coding: utf-8 -*-

#   http://www.xml.com/pub/a/2003/10/15/py-xml.html

#-----------------------------------------------------------------------------------------------------------
import                                      cgi
import                                      new
pylon                                       = g.pylon
#import                                                                              urllib
#   urllib.quote
#   urllib.quote_plus
#   urllib.unquote
#   urllib.unquote_plus

#-----------------------------------------------------------------------------------------------------------
#   toUnicode                                   = g.IO.toUnicode
#   StringPresenter                             = g.IO.Unicode.StringPresenter
toUnicode                                   = g.configtool.utilities.IOU.U
StringPresenter                             = g.configtool.utilities.IOU.ReprMx


############################################################################################################
#
#
#
#===========================================================================================================
EMPTY_STRING = ''
class const:
    classHomonyms = ( 'class_', 'klass', 'clasz', 'clazz' )
    binaryTags = """a abbr acronym address applet area b base basefont bdo big blockquote body button
        caption center cite code col colgroup dd del dir dfn div dl dt em fieldset font form frame frameset
        h1 h2 h3 h4 h5 h6 head html i iframe img ins isindex kbd label legend li link map menu meta nobr
        noframes noscript object ol optgroup option p param pre q s samp script select small span strike
        strong style sub sup table tbody td textarea tfoot th thead title tr tt u ul var xmp""".split()
    unaryTags = """br hr input""".split()

############################################################################################################
#
#
#
#===========================================================================================================
def toEscapedUnicode( x ):
    return cgi.escape( toUnicode( x ) )

#   #===========================================================================================================
#   def toEscapedOctets( x ):
#       """This is supposed to make sure all text is HTML-escaped UTF-8. However, for some unknown reason,
#       entities are escaped twice before being printed; hence, this function has temporarily been reduced to
#       produce simple UTF-8 output. Use ``__toEscapedOctets__()`` instead where needed."""
#       return g.IO.toOctets( x ) # postponed: cgi.escape( toOctets( x ) )

############################################################################################################
#
#
#
#===========================================================================================================
class mangle:
    class rules:
        def allUnderscoresToHyphens( x ):
            return x.replace( '_', '-' )
        allUnderscoresToHyphens = staticmethod( allUnderscoresToHyphens )

        def cancelTrailungUnderscore( x ):
            if x.endswith( '_' ):
                return x[:-1]
            return x
        cancelTrailungUnderscore = staticmethod( cancelTrailungUnderscore )

    class attributeName:
        def toText( x ):
            if not x.startswith( '_' ):
                if x in const.classHomonyms:
                    x = 'class'
                x = mangle.rules.allUnderscoresToHyphens( x )
                return x
        toText = staticmethod( toText )

    class className:
        def toText( x ):
            return mangle.rules.allUnderscoresToHyphens(
                mangle.rules.cancelTrailungUnderscore( x ) )
        toText = staticmethod( toText )

############################################################################################################
#
#
#
#===========================================================================================================
class Attributes( StringPresenter, dict ):

    def __unicode__( self ):
        if len( self ):
            return ' '.join( [
                '%s="%s"' % (
                        mangle.attributeName.toText( toUnicode( name ) ),
                        toEscapedUnicode( value ) )
                    for name, value in self.items() ] )
        else:
            return EMPTY_STRING

############################################################################################################
#
#
#
#===========================================================================================================
class Contents( StringPresenter, list ):

    nonEmpty = False

    def __unicode__( self ):
        R = []
        for element in self:
            if isinstance( element, Rawstring ):
                R.append( element )
            elif isinstance( element, basestring ):
                R.append( toEscapedUnicode( element ) )
            else:
                R.append( toUnicode( element ) )
        R = EMPTY_STRING.join( R )
        if not R and self.nonEmpty:
            R = '%s' % ( h.nbsp, )
        return R

class NeContents( Contents ):

    nonEmpty = True


############################################################################################################
#
#
#
#===========================================================================================================
def _getNameAsClassname( self ):
        #return 'XXX'###################################
        name = getattr( self, 'xmlelementtypename', None )
        if name is None:
            name = self.__class__.__name__
        return mangle.className.toText( name )

#===========================================================================================================
class TagABC( StringPresenter, object ):

    def __unicode__( self ):
        return self.repr( 'complete' )

    N = property( _getNameAsClassname )

    def append( self, value ):
        self.P.append( value )

    def extend( self, values ):
        for value in values:
            self.append( value )

    def __getitem__( self, name ):
        return self.Q[ name ]

    def __setitem__( self, name, value ):
        self.Q[ name ] = value

    def set( self, **Q ):
        self.Q.update( Q )

#===========================================================================================================
class UnaryTagABC( TagABC ):

    def __init__( self, **Q ):
        self.Q = Attributes( Q )

    def repr( self, position = 'complete' ):
        #N, Q = map( toUnicode, [ self.N, self.Q, ] )
        N, Q = map( toUnicode, [ self.N, self.Q, ] )
        if Q: Q = ' %s' % ( Q, )
        if position == 'complete':
            return '<%(N)s%(Q)s/>' % vars()
        if position == 'start':
            return '<%(N)s%(Q)s>' % vars()
        if position == 'end':
            return '</%(N)s>' % vars()
        if position == 'content':
            return ''
        raise TypeError( "Unrecognized format option: %s" % ( position, ) )

#===========================================================================================================
class BinaryTagABC( TagABC ):

    def __init__( self, *P, **Q ):
        self.P = Contents( P )
        self.Q = Attributes( Q )

    def _getP( self ):
        """This method gives a hook to insert automatic content."""
        return self.P

    def repr( self, position = 'complete' ):
        #N, P, Q = map( toUnicode, [ self.N, self.P, self.Q, ] )
        N, P, Q = map( toUnicode, [ self.N, self._getP(), self.Q, ] )
        if Q: Q = ' %s' % ( Q, )
        if position == 'complete':
            return '<%(N)s%(Q)s>%(P)s</%(N)s>' % vars()
        if position == 'start':
            return '<%(N)s%(Q)s>' % vars()
        if position == 'end':
            return '</%(N)s>' % vars()
        if position == 'content':
            return '%(P)s' % vars()
        if position == 'empty':
            return '<%(N)s%(Q)s/>' % vars()
        raise TypeError( "Unrecognized format option: %s" % ( position, ) )


############################################################################################################
#
#
#
#===========================================================================================================
def UnaryTagMC( name, baseClasses, classDictionary ):
    if UnaryTagABC not in baseClasses:
        baseClasses = tuple( [ UnaryTagABC ] + list( baseClasses ) )
    R = new.classobj( name, baseClasses, classDictionary )
    return R

#===========================================================================================================
def BinaryTagMC( name, baseClasses, classDictionary ):
    if BinaryTagABC not in baseClasses:
        baseClasses = tuple( [ BinaryTagABC ] + list( baseClasses ) )
    R = new.classobj( name, baseClasses, classDictionary )
    return R

############################################################################################################
#
#
#
class h:
    pass
#===========================================================================================================
def getClassStatement( metaclassName, className ):
    return """
class __XXX__:
    class %(className)s:
        __metaclass__ = %(metaclassName)s
h.%(className)s = __XXX__.%(className)s
""" % vars()

#===========================================================================================================
for metaclassName, branch in [
    ( 'BinaryTagMC', const.binaryTags ),
    ( 'UnaryTagMC',  const.unaryTags  ), ]:
    for className in branch:
        statement = getClassStatement( metaclassName, className )
        try:
            exec statement
        except SyntaxError:
            className = '%s_' % ( className, )
            statement = getClassStatement( metaclassName, className )
            exec statement
del __XXX__

#===========================================================================================================
class en( StringPresenter, object ):
    """Class for entities."""
    def __init__( self, name ):
        self.name = name
    def __unicode__( self ):
        return self.repr()
    def repr( self ):
        name = '%s' % ( self.name, )
        if name:
            if name[ 0 ].isdigit():
                name = '#%s' % name
            else:
                name = self.name
            return toUnicode( u'&%s;' % ( name, ) )
        return ''

#===========================================================================================================
h.en = en
h.nbsp = en( 'nbsp' )

#   #===========================================================================================================
#   def f( *P, **Q ):
#       Q = pylon.acquire( Q, type = 'text/javascript' ) # language = 'javascript1.2'
#       return h.script( *P, **Q )
#   h.javascript = staticmethod( f ); del f

############################################################################################################
#
#
#
#===========================================================================================================
class Rawstring( unicode ): pass
h.Rawstring = Rawstring

############################################################################################################
#
#
#
#===========================================================================================================
class javascript( h.script ):

    #---------------------------------------------------------------------------------------------------
    xmlelementtypename = 'script'

    #---------------------------------------------------------------------------------------------------
    def __init__( self, *P, **Q ):
        Q = pylon.acquire( Q, type = 'text/javascript' )
        super( javascript, self ).__init__( *P, **Q )
        #self.shapeup()

    def _getP( self ):
        """This method gives a hook to insert automatic content."""
        R = []
        R.append( Rawstring( '//<![CDATA[\n' ) )
        R.extend( [ Rawstring( p ) for p in self.P ] )
        R.append( Rawstring( '\n//]]>' ) )
        return Contents( R )

h.javascript = javascript

#===========================================================================================================
def E( *P ):
    """Factory function for invisible elements."""
    return Contents( P )
h.E = staticmethod( E )

#===========================================================================================================
def NE( *P ):
    return NeContents( P )
h.NE = staticmethod( NE )


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    g.IO.installStdOutEncoder()
    c = Contents( [ '<', 'ä', '>' ] )
    print c
    print `c`
    print `str( c )`
    print `unicode( c )`

    a = Attributes( a = 'ä', b = 'ö' )
    a[ 'ü' ] = '<ü>'
    print a

    d = h.td( 'hello world! & everyone <ä>' )
    d[ 'ü' ] = '<ü>'
    print d
    print h.p( 'Tom', en( 'nbsp' ), '&', en( 'nbsp' ), 'Jerry' )

    print Contents( ( h.p( 'x' ), h.p( 'y' ), ) )

    print
    print h.javascript( 'function f() { alert( "<hello>" ) }' )

