#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   for __future__ import                  division
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
U                                       = u.IOU.U
ReprMx                                  = u.IOU.ReprMx
Rating                                  = u.Rating.Rating
S                                       = u.EzSet.S
#-----------------------------------------------------------------------------------------------------------
fsi                                     = u.filesystemIdioms
#-----------------------------------------------------------------------------------------------------------
DENT_B                                  = '    '
DENT_T                                  = '\t'
#-----------------------------------------------------------------------------------------------------------
defaultDirectorylocator                 = g.cfg.assessmentsHomelocator
#   #-----------------------------------------------------------------------------------------------------------
#   if DEBUG:
#       print '### DEBUGGING SET TO TRUE, LIST OF ASSESSMENT INPUT FILES INCOMPLETE ###'
#       filter = lambda locator: locator.endswith( '_debugAssessments.flow' )
#       #filter = lambda locator: locator.endswith( '.flow' )
#   else:
#       filter = lambda locator: locator.endswith( '.flow' )


############################################################################################################
#
#
#
#===========================================================================================================
class iterRatings( object ):

    #-------------------------------------------------------------------------------------------------------
    def f( this, filenamefilter = None, directorylocator = None ):
        #---------------------------------------------------------------------------------------------------
        if filenamefilter is None:
            filenamefilter = lambda name: name.endswith( '.flow' )
        #---------------------------------------------------------------------------------------------------
        if directorylocator is None:
            directorylocator = defaultDirectorylocator
        #---------------------------------------------------------------------------------------------------
        filenames = fsi.iterateNames( directorylocator, filter = filenamefilter )
        #print directorylocator
        #print '*************', list( filenames )
        for filename in filenames:
            filelocator = fsi.join( directorylocator, filename )
            for x in this.forFilelocator( filelocator ):
                yield x
    forFilenamefilter = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocatorfilter, directorylocator = None ):
        #---------------------------------------------------------------------------------------------------
        if directorylocator is None:
            directorylocator = defaultDirectorylocator
        #---------------------------------------------------------------------------------------------------
        filelocators = fsi.iterateLocators( directorylocator, filter = filelocatorfilter )
        for filelocator in filelocators:
            for x in this.forFilelocator( filelocator ):
                yield x
    forFilelocatorfilter = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filelocator ):
        fso     = file( filelocator, 'rb' )
        text    = U( fso.read() )
        del fso
        #print 'reading assessments from %s' % ( filelocator, )
        for x in this.forText( text ):
            yield x
    forFilelocator = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, text ):
        lines = text.splitlines()
        for x in this.forLines( lines ):
            yield x
    forText = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, lines ):
        topic = None
        linenr = -1
        for line in lines:
            linenr += 1
            line = line.rstrip()
            if not line: continue
            if line.lstrip().startswith( '#' ): continue
            if line.startswith( DENT_B ) or line.startswith( DENT_T ):
                assert topic is not None
                assert '#' in line
                focus, rrating  = line.split( '#' )
                focus           = focus.strip()
                rrating         = rrating.strip()
                rrating         = float( rrating )
                rating          = Rating( rrating = rrating, topic = topic, focus = focus )
                #print '\t%s' % ( rating, )
                yield rating
                #print '\t%s' % ( rating, )
            else:
                try:
                    if not line.startswith( ':' ): raise ValueError
                    topic = line
                    #print `topic`
                except ValueError:
                    print "Error: Line should start with ':' (line %s)" % ( linenr, )
                    print `line`
                    raise
    forLines = classmethod( f ); del f


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit(50)


    def filenamefilter( filename ):
        #print '+++++++++', filename
        return filename.endswith( '.flow' ) and '_debug' in filename

    for rating in iterRatings.forFilenamefilter( filenamefilter = None ):
        print rating
        #print rating.focus



