#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
import cgi as                           _cgi
import os.path as                       _p
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_feds                                   = u.feds
_S                                      = u.EzSet.S
_XmlMaker                               = u.XmlMaker.XmlMaker
#-----------------------------------------------------------------------------------------------------------
_cmfi                                   = u.PsfCmfIdioms.CmfIdioms
_fsi                                    = u.filesystemIdioms
_inter                                  = u.kpyInterpol.inter
#-----------------------------------------------------------------------------------------------------------
sep0                                    = '#' * 108
sep1                                    = '=' * 108
sep2                                    = '-' * 108


#-----------------------------------------------------------------------------------------------------------
def prepareDocumentationTables( dsGrove ):
    if dsGrove.tableExists( 'documentation' ):
        dsGrove.clearTable( 'documentation' )
        dsGrove._commit()
    DocumentationTableHyper = _feds.DatasourceClasses.Grove.DocumentationTableHyper
    dsGrove.addFactoids(
        documentation   = DocumentationTableHyper.typesByFacetname,
        )
    dsGrove._commit()

#-----------------------------------------------------------------------------------------------------------
def make( verbose = False ):
    #-------------------------------------------------------------------------------------------------------
    groveFed            = _feds.resolve( 'Grove', readonly = False )
    dsGrove             = groveFed.dsGrove
    prepareDocumentationTables( dsGrove )
    #-------------------------------------------------------------------------------------------------------
    table               = dsGrove.factoid( 'documentation' )
    mkViewObject        = (-table)
    #-------------------------------------------------------------------------------------------------------
    del mkViewObject[:]
    #for graphname, cmflocator, namespace in _cmfi.iterPrefixLocatorAndNamespacesForAllSchemas():
    for graphfact in dsGrove.factoid( 'graph' ):
        graphname   = graphfact.name
        cmflocator  = graphfact.localgraphsource
        namespace   = graphfact.namespaceurl
        cmfilename    = _p.split( cmflocator )[ 1 ]
        if verbose: print "Adding documentation for %s" % ( graphname, )
        if not cmfilename.startswith( 'cmf_' ): continue # we don't have docs for :bion: yet
        #---------------------------------------------------------------------------------------------------
        nodefactsByLocator  = dsGrove.getNodefactsByLocatorForGraphname( graphname )
        if not nodefactsByLocator:
            if verbose: print "Skipping unknown graph :%(graphname)s:" % vars()
            continue
        dcount = ncount = -1
        for locator, short, long in _cmfi.iterLocatorsAndDocumentation( cmflocator ):
            ncount += 1
            nodefact    = nodefactsByLocator.get( locator, None )
            if nodefact is None:
                if verbose: print "Skipping unknown node :%(graphname)s:%(locator)s" % vars()
                continue
            termnr      = nodefact.termnr
            if verbose: print locator
            if short:
                dcount += 1
                if verbose: print '   ', short
            if long:
                dcount += 1
                if verbose: print '   ', long
            if short or long:
                mkViewObject.append(
                    graphname   = graphname,
                    termnr      = termnr,
                    short       = short,
                    long        = long,
                    )
        if verbose:
            v = vars()
            print ( ''
                +   "Persisted %(dcount)d documentation strings " % v
                +   "for %(ncount)d nodes in :%(graphname)s:" % v
                )
    dsGrove._commit()
    groveFed.close()

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':


    make()

    groveFed            = _feds.resolve( 'Grove', readonly = False )
    dsGrove             = groveFed.dsGrove

    print sep0
    for graphname in dsGrove.iterGauges():
        doccount = len( dsGrove.catchTable( documentation = dict( graphname = graphname ) ) )
        print "Documentation coverage for %(graphname)s: %(doccount)d terms documented." % vars()


