#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
import                                  os
D                                       = dict
import os.path as                       _p
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_feds                                   = u.feds
#-----------------------------------------------------------------------------------------------------------
_cmfi                                   = u.PsfCmfIdioms.CmfIdioms
_flowGraphReader                        = u.flowGraphReaderForEzGraph
_fsi                                    = u.filesystemIdioms
_getMkViewDescription                   = u.feds.MkDatasource.getMkViewDescription
_Graph                                  = u.EzGraph.Graph
_Grove                                  = u.EzGraph.Grove
_makeMkRatings                          = u.makeDatabases.makeRatings
_makeLexicalIndices                     = u.makeDatabases.makeLexicalIndices
_buildAllLexicalIndices                 = u.makeDatabases.makeLexicalIndices.buildAllIndices
_MkDatasource                           = u.feds.MkDatasource.MkDatasource
_Node                                   = u.EzGraph.Node
_addDocumentation                       = u.makeDatabases.makeDocumentation.make
#-----------------------------------------------------------------------------------------------------------
here                                    = _fsi.here( lambda:None )
sep0 = '#' * 108
sep1 = '=' * 108
sep2 = '-' * 108
#-----------------------------------------------------------------------------------------------------------
T                                       = _MkDatasource.underlyingDatatypes
stopwatch                               = u.EzTime.Stopwatch( 'makeGrove' )
#-----------------------------------------------------------------------------------------------------------
GRAPHNAMES_USED_FOR_TESTING             = """
    abcd12
    bion
    """.split()

#-----------------------------------------------------------------------------------------------------------
TESTING                                 = False
POPULATE                                = False
ADDRATINGS                              = False
SHOWPROPERTIES                          = False
SHOWRATINGS                             = False
SHOWSOMEGROVEFACTS                      = False
PERSISTTRACES                           = False
ADDDOCUMENTATION                        = False
BUILDLEXICALINDICES                     = False
VERBOSE                                 = False
#   #-----------------------------------------------------------------------------------------------------------
#   TESTING                                 = True
POPULATE                                = True
ADDRATINGS                              = True
#   SHOWPROPERTIES                          = True
#   SHOWRATINGS                             = True
#   SHOWSOMEGROVEFACTS                      = True
PERSISTTRACES                           = True
ADDDOCUMENTATION                        = True
BUILDLEXICALINDICES                     = True
#   VERBOSE                                 = True
#-----------------------------------------------------------------------------------------------------------


#-----------------------------------------------------------------------------------------------------------
def make( verbose = False ):
    swMake = stopwatch.start( 'make()' )
    if POPULATE:            _populate( verbose = verbose )
    if ADDRATINGS:          _addRatings( verbose = verbose )
    if SHOWPROPERTIES:      showSomeNodeRelations()
    if SHOWRATINGS:         showRatings()
    if ADDDOCUMENTATION:
        stopwatch.start( 'ADDING DOCUMENTATION TO DATASOURCE' )
        _addDocumentation( verbose = verbose )
        stopwatch.stop()
    if BUILDLEXICALINDICES: _buildLexicalIndices( verbose = verbose )
    stopwatch.stop( swMake )
    stopwatch.finish()
    print stopwatch

#-------------------------------------------------------------------------------------------------------
def _purge():
    groveFed = _feds.resolve( 'Grove', readonly = False )
    groveFed.dsGrove.removeFactoids()
    #groveFed.dsGrove._commit()
    groveFed.close()

#-------------------------------------------------------------------------------------------------------
def _populate( verbose = False ):
    _purge()
    groveFed = _feds.resolve( 'Grove', readonly = False )
    dsGrove = groveFed.dsGrove
    dsGrove.addAllFactoids()
    populate( dsGrove, verbose )
    groveFed.close()

#-------------------------------------------------------------------------------------------------------
def _addRatings( verbose = False ):
    groveFed = _feds.resolve( 'Grove', readonly = False )
    dsGrove = groveFed.dsGrove
    dsGrove.clearTable( 'rating' )
    dsGrove.clearTable( 'ratingtrace' )
    dsGrove.clearTable( 'ratingtrace2' )
    _makeMkRatings.TESTING          = TESTING
    _makeMkRatings.PERSISTTRACES    = PERSISTTRACES
    _makeMkRatings.makeForFilenamefilter( dsGrove, verbose = verbose )

    tracesByTermrefpair = _makeMkRatings.traces
    termrefpairs        = tracesByTermrefpair.keys()
    termrefpairs.sort()
    for termrefpair in termrefpairs:
        traces = tracesByTermrefpair[ termrefpair ]
        #print '$', termrefpair, traces ###DEBUG###
    groveFed.close()

#-------------------------------------------------------------------------------------------------------
def _buildLexicalIndices( verbose = False ):
    _makeLexicalIndices.VERBOSE = verbose
    _buildAllLexicalIndices()

############################################################################################################
#
#
#
#===========================================================================================================
def addNodes( ds, graph ):
    #-------------------------------------------------------------------------------------------------------
    termnr          = -1
    #-------------------------------------------------------------------------------------------------------
    for node in graph:
        #---------------------------------------------------------------------------------------------------
        if node.parent is None: parentTermnr = -1
        else:                   parentTermnr = node.parent.termnr
        #---------------------------------------------------------------------------------------------------
        nodefact = D(
            gauge                   = graph.name,
            locator                 = node.locator,
            name                    = node.name,
            level                   = node.level,
            termnr                  = node.termnr,
            isLeaf                  = node.isLeaf,
            parentTermnr            = parentTermnr,
            lastDescendantTermnr    = node.lastDescendantTermnr,
            )
        ds.addFacts( node = nodefact, )
    #-------------------------------------------------------------------------------------------------------
    length      = termnr + 1
    #-------------------------------------------------------------------------------------------------------
    return length

############################################################################################################
#
#
#
#===========================================================================================================
def addProperties( ds, grove ):
    for graph in grove:
        graphname = graph.name
        for node in graph:
            #-----------------------------------------------------------------------------------------------
            locator = '%s' % node.termnr
            #-----------------------------------------------------------------------------------------------
            ds.addProperty( graphname, locator, 'subsequents',  node.subsequentTermnrs  )
            ds.addProperty( graphname, locator, 'childnodes',   node.childnodeTermnrs   )
            ds.addProperty( graphname, locator, 'descendants',  tuple( node.iterDescendantTermnrs() ) )
            ds.addProperty( graphname, locator, 'ancestors',    node.ancestorTermnrs    )

############################################################################################################
#
#
#
#===========================================================================================================
def populate( ds, verbose = False ):
    grove = _Grove()
    parseAllSources = stopwatch.start( 'PARSING' )
    namespacesAndFilelocatorsByGraphname = {}
    iterate = _cmfi.iterPrefixLocatorAndNamespacesForAllSchemas
    #-------------------------------------------------------------------------------------------------------
    #   Iterate over likely schemas, using the ``CmfIdioms`` method named above. The method will
    #   yield triplets ``(graphname, filelocator, namespace)`` for valid schemas, but an
    #   exception in case a parse error for an illegal CMF was encountered; this exception is
    #   here documented with a message but otherwise ignored. Schemas with missing namespaces
    #   will be silently ignored; however, schemas with namespaces that are not associated
    #   with a prefix in ``{../../../biocase/configuration/.configuration}.namespacesByPrefix``
    #   will be assigned a prefix à la ``http_www.biocase.org_schemas_metaprofile_1.2``.
    for whatever in iterate(
        yieldExceptions         = True,
        useDefaultPrefixes      = True,
        useDefaultNamespaces    = False,
        ):
        if isinstance( whatever, Exception ):
            print
            print '-' * 108
            print '!!! %s' % ( whatever, )
            print '-' * 108
            print
            continue
        graphname, filelocator, namespace = whatever
        filename = _p.split( filelocator )[ 1 ]
        namespacesAndFilelocatorsByGraphname[ graphname ] = ( filelocator, namespace, )
        if TESTING and graphname not in GRAPHNAMES_USED_FOR_TESTING: continue
        #---------------------------------------------------------------------------------------------------
        stopwatch.start( 'parsing %s' % graphname )
        if filename.endswith( '.flow' ):
            amr         = graphname == 'test' # exp.: allow multiple rootnodes
            text        = _fsi.read( here, filelocator )
            graph       = _flowGraphReader.parse( text, allowMultipleRootnodes = amr, verbose = verbose )
        #---------------------------------------------------------------------------------------------------
        else:
            #cmflocator  = _p.abspath( _fsi.join( g.cfg.rawCmfTemplateLocator, filename ) )
            graph       = _cmfi.getGraphForGaugeAndCmflocator( graphname, filelocator )
        stopwatch.stop()
        stopwatch.start( 'adding  %s' % graphname )
        grove.add( graph )
        stopwatch.stop()
    stopwatch.stop( parseAllSources )
    #-------------------------------------------------------------------------------------------------------
    stopwatch.start( 'ASSIGNING TERMNRS' )
    grove.close()
    stopwatch.stop()
    stopwatch.start( 'RESOLVING COMMANDS' )
    _flowGraphReader.resolveCommands( grove, verbose = verbose )
    stopwatch.stop()
    #-------------------------------------------------------------------------------------------------------
    addingNodesAndGraphs = stopwatch.start( 'ADDING NODES TO DATASOURCE' )
    for graph in grove:
        graphname = graph.name
        filelocator, namespace = namespacesAndFilelocatorsByGraphname.get( graphname, ( '', '', ) )
        stopwatch.start( 'adding %s (%d nodes)' % ( graphname, len( graph ) ) )
        addNodes( ds, graph )
        #---------------------------------------------------------------------------------------------------
        graphfact = D(
            name                = graphname,
            length              = len( graph ),
            localgraphsource    = filelocator,
            namespaceurl        = namespace,
            )
        ds.addFacts( graph = graphfact )
        stopwatch.stop()
    stopwatch.stop( addingNodesAndGraphs )
    #-------------------------------------------------------------------------------------------------------
    stopwatch.start( 'ADDING PROPERTIES TO DATASOURCE' )
    addProperties( ds, grove )
    stopwatch.stop()
    if SHOWSOMEGROVEFACTS: showSomeGroveFacts( grove )
    del grove


#===========================================================================================================
def showRelations( ds ):
    for fact in ds.catchTable( property = None ):
        print fact

#===========================================================================================================
def showTables( ds ):
    print sep0
    print "Tables defined in %s:" % ( groveFed.dsGrove.dsfilelocator, )
    print ds.factoidNames

#===========================================================================================================
def showTabledefinitions( ds ):
    print sep0
    for factoidName in ds.factoidNames:
        print _getMkViewDescription.fromDatasource( ds, factoidName )

#===========================================================================================================
def showAllFacts( ds ):
    print sep0
    for factoidName in ds.factoidNames:
        for fact in ds.factoid( factoidName ):
            print fact

#===========================================================================================================
def showRatings():
    groveFed = _feds.resolve( 'Grove', readonly = True )
    dsGrove = groveFed.dsGrove
    ratingtable = dsGrove.factoid( 'rating' )
    count = -1
    #_blanks = ' ' * 108
    #-------------------------------------------------------------------------------------------------------
    for ratingfact in ratingtable:
        #---------------------------------------------------------------------------------------------------
        count += 1
        if count > 50: break
        #---------------------------------------------------------------------------------------------------
        ratingsvector   = ratingfact.value
        if not ratingsvector: continue
        #---------------------------------------------------------------------------------------------------
        print sep0
        #---------------------------------------------------------------------------------------------------
        focusGraphname  = ratingfact.focusGraphname
        focusGauge      = ':%s:' % focusGraphname
        topicGraphname  = ratingfact.topicGraphname
        topicGauge      = ':%s:' % topicGraphname
        topicTermnr     = ratingfact.topicTermnr
        topicNodefact   = dsGrove.nodefactForOntonym( ( topicGauge, topicTermnr ) )
        topicOntonym    = topicNodefact.ontonym
        #---------------------------------------------------------------------------------------------------
        print "Ratings for %s:" % ( topicOntonym, )
        focusTermnrs    = ratingsvector.keys()
        focusTermnrs.sort()
        #---------------------------------------------------------------------------------------------------
        for focusTermnr in focusTermnrs:
            print sep1
            rawrating       = ratingsvector[ focusTermnr ]
            focusNodefact   = dsGrove.nodefactForOntonym( ( focusGauge, focusTermnr ) )
            #focusOntonym    = ( _blanks + focusNodefact.ontonym )[ -100 : ]
            focusOntonym    = focusNodefact.ontonym
            print '\t%+2d %s' % ( rawrating, focusOntonym )
            iterator = dsGrove.iterTripletsFromRatingtrace(
                    topicGraphname, topicTermnr, focusGraphname, focusTermnr )
            print sep1
            print '\tTraces:'
            for topicOriginNodefact, focusOriginNodefact, assessment in iterator:
                print sep2
                print '\t\t%s' % topicOriginNodefact.locator
                print '\t\t%s' % focusOriginNodefact.locator
                print '\t\t%s' % assessment
    #-------------------------------------------------------------------------------------------------------
    groveFed.close()
    del groveFed
    del dsGrove

#===========================================================================================================
def showSomeGroveFacts( grove ):
    print '=' * 108
    graph = grove[ 'bion' ]
    node  = graph[ '/bion' ]
    print node
    #---------------------------------------------------------------------------------
    print '-' * 108
    print 'childnodes', node.childnodes
    print 'childnodeTermnrs', node.childnodeTermnrs
    print 'lastChildnode', node.lastChildnode
    print 'lastChildnode.termnr', node.lastChildnode.termnr
    print 'lastDescendantTermnr', node.lastDescendantTermnr
    print 'lastDescendant', node.lastDescendant
    print 'descendants.name', [ subnode.name for subnode in node.descendants ]
    print 'tuple(iterDescendantTermnrs())', tuple( node.iterDescendantTermnrs() )
    #---------------------------------------------------------------------------------
    print '-' * 108
    print 'Childnodes'
    for subnode in node.childnodes:
        print '   ', subnode
    #---------------------------------------------------------------------------------
    print '-' * 108
    print 'Descendants'
    for subnodeTermnr in node.iterDescendantTermnrs( includeSelf = True ):
        print '   ', graph.getNodeForTermnr( subnodeTermnr ).locator
    #---------------------------------------------------------------------------------
    print '-' * 108
    #print node._getAncestorList()
    print 'Ancestors'
    for subnode in node.ancestors:
        print '   ', subnode
    #---------------------------------------------------------------------------------
    print '-' * 108
    locator = '/bion/collection/unit-type/physical-union'
    node = graph[ locator ]
    print 'AncestorsOrSelf of %s' % locator
    for subnode in node.getAncestors( includeSelf = True ):
        print '   ', subnode.locator
    #---------------------------------------------------------------------------------
    print '-' * 108
    locator = '/bion/collection/organism-group/plants'
    node = graph[ locator ]
    print 'Subsequents of %s' % locator
    print node.subsequentTermnrs
    print 'descendants',    [ subnode.termnr for subnode in node.descendants ]
    print 'ownSubnodes',    [ subnode.termnr for subnode in node.ownSubnodes ]
    print 'otherSubnodes',  [ subnode.termnr for subnode in node.otherSubnodes ]
    for subnodeTermnr in node.subsequents:
        print '   ', subnodeTermnr.locator
    #---------------------------------------------------------------------------------
    print '-' * 108
    locator = '/bion/collection/organism-group/animals'
    node = graph[ locator ]
    print 'Subsequents of %s' % locator
    print node.subsequentTermnrs
    print 'descendants',    [ subnode.termnr for subnode in node.descendants ]
    print 'ownSubnodes',    [ subnode.termnr for subnode in node.ownSubnodes ]
    print 'otherSubnodes',  [ subnode.termnr for subnode in node.otherSubnodes ]
    for subnodeTermnr in node.subsequents:
        print '   ', subnodeTermnr.locator
    #---------------------------------------------------------------------------------
    print '-' * 108
    locator = '/bion/collection/organism-group'
    node = graph[ locator ]
    print 'Subsequents of %s' % locator
    print node.subsequentTermnrs
    print 'descendants',    [ subnode.termnr for subnode in node.descendants ]
    print 'ownSubnodes',    [ subnode.termnr for subnode in node.ownSubnodes ]
    print 'otherSubnodes',  [ subnode.termnr for subnode in node.otherSubnodes ]
    for subnodeTermnr in node.subsequents:
        print '   ', subnodeTermnr.locator
    #---------------------------------------------------------------------------------
    print '#' * 108
    print

#===========================================================================================================
def showSomeNodeRelations():
    groveFed = _feds.resolve( 'Grove', readonly = True )
    dsGrove = groveFed.dsGrove
    ontonyms = [
        ':bion:/bion/collection/organism-group',
        ':bion:/bion/collection/organism-group/plants',
        ':bion:/bion/collection/organism-group/animals',
        ':bion:/bion/collection/organism-group/fungi',
        ( ':abcd12:',   '/DataSets/DataSet/Units/Unit/UnitDigitalImages/UnitDigitalImage/ImageIPR' ),
        ( ':bion:',     '/bion/collection' ),
#           ':test:/root',
#           ':test:/root/re2',
#           ':test:/unknown',
#           ':bion:/bion/collection/collection-type/herbarium',
#           ( ':abcd12:',   '/DataSets' ),
#           ( ':abcd12:',   '/DataSets/DataSet/Units/Unit' ),
        ]
    verbs = 'childnodes', 'descendants', 'subnodes', 'subsequents'
    print sep0
    for ontonym in ontonyms:
        print sep1
        print ontonym
        for verb in verbs:
            nodefacts = tuple( dsGrove.iterRelatedNodefacts( ontonym, verb ) )
            if not nodefacts: continue
            print
            print verb
            for nodefact in nodefacts:
                print '    :%s:%s' % ( nodefact.gauge, nodefact.locator, )
    groveFed.close()
    del groveFed
    del dsGrove

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit( 50 )
    sep0 = '#' * 108
    sep1 = '=' * 108
    sep2 = '-' * 108

    make( verbose = VERBOSE )
    #showSomeNodeRelations()

#       groveFed = _feds.resolve( 'Grove', readonly = True )
#       dsGrove = groveFed.dsGrove
#       for fact in dsGrove.factoid( 'ratingtrace2' ):
#           print fact
    #print '$$$$$$$$$$'; import sys; sys.exit()




