#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
import os as                            _o
import sys
import time
import os.path as                       _p
import operator as                      _operator
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_inter                                  = u.kpyInterpol.inter
_fsi                                    = u.filesystemIdioms
_indexhomename                          = 'lupyindex'
_feds                                   = u.feds
#-----------------------------------------------------------------------------------------------------------
_AbcdPathTokenizer                      = u.nlnormalizer.AbcdTokenizers.AbcdPathTokenizer
_AbcdTextTokenizer                      = u.nlnormalizer.AbcdTokenizers.AbcdTextTokenizer
#-----------------------------------------------------------------------------------------------------------
_indexhomelocator                       = _fsi.join( g.cfg.persistenceLocator, _indexhomename )
#-----------------------------------------------------------------------------------------------------------
_lupy                                   = u.lupywrapper.lupy
_fsi.includeThisDirectoryInPath( u.lupywrapper )
#-----------------------------------------------------------------------------------------------------------
_Index                                  = _lupy.indexer.Index
#   _IndexSearcher                          = _lupy.search.indexsearcher.IndexSearcher
#   _TermQuery                              = _lupy.search.term.TermQuery
#   _PhraseQuery                            = _lupy.search.phrase.PhraseQuery
#   _BooleanQuery                           = _lupy.search.boolean.BooleanQuery
#   _Term                                   = _lupy.index.term.Term
#-----------------------------------------------------------------------------------------------------------
VERBOSE                                 = False
#-----------------------------------------------------------------------------------------------------------
VERBOSE                                 = True


############################################################################################################
#
#
#
#===========================================================================================================
def getIndexlocatorForGraphname( graphname ):
    return _fsi.join( _indexhomelocator, graphname )

############################################################################################################
#
#
#
#===========================================================================================================
def buildAllIndices( optimize = True ):
    #-------------------------------------------------------------------------------------------------------
    #for graphname in ( 'abcd149', ):
    groveFed = _feds.resolve( 'Grove', readonly = False )
    dsGrove = groveFed.dsGrove
    for graphname in dsGrove.iterGauges():
        if VERBOSE: print "Building Index for graph :%s:" % ( graphname, )
        buildIndex( dsGrove, graphname, optimize )

############################################################################################################
#
#
#
#===========================================================================================================
def buildIndex( dsGrove, graphname, optimize = True ):
    #-------------------------------------------------------------------------------------------------------
    indexlocator = getIndexlocatorForGraphname( graphname )

    #-------------------------------------------------------------------------------------------------------
    #   Remove results of previous runs:
    if _p.exists( indexlocator ):
        for f in _o.listdir( indexlocator ):
            file = _p.join( indexlocator, f )
            if _p.isfile( file ):
                _o.remove( file )
        try:
            _o.rmdir( indexlocator )
        except:
            print "The lupy schema dir %s couldnt be removed. Probably there are some non lupy files left."%indexlocator

    #-------------------------------------------------------------------------------------------------------
    # Create a new Index
    index = _Index( indexlocator, create = True )
    index.setMergeFactor( 20 )

    if VERBOSE: print '\t...gathering statistics',
    #-------------------------------------------------------------------------------------------------------
    for title, text in iterDocumentationItems(
        dsGrove, graphname, includeLocators = True, includeAncestors = True ):
        # the next line creates a Document with 2 fields
        # one field is named text and the other is named
        # filename. The latter is created as Keyword since
        # the name is preceded by '_'. Naughty but expdient.
        index.index( text = text, __title = title, )
    if VERBOSE: print 'ok'

    if optimize:
        if VERBOSE: print '\t...optimizing index',
        index.optimize()
        if VERBOSE: print 'ok'


############################################################################################################
#
#
#
#===========================================================================================================
def iterDocumentationItems( dsGrove, graphname, includeLocators = True, includeAncestors = True ):
    #-------------------------------------------------------------------------------------------------------
    pathTokenizer       = _AbcdPathTokenizer()
    textTokenizer       = _AbcdTextTokenizer()
    graphlength         = dsGrove.getGraphlength( graphname )
    #-------------------------------------------------------------------------------------------------------
    _normaltextByTermnrCache = {}
    documentationView   = dsGrove.catchTable( documentation = dict( graphname = graphname ) )
    for documentationFact in documentationView:
        normaltext = ' '.join(
            textTokenizer.tokenize(
                '%s %s' % ( documentationFact.short, documentationFact.long, ) ) )
        _normaltextByTermnrCache[ documentationFact.termnr ] = normaltext
    del documentationView
    if includeAncestors:
        ancestorTermnrsByTermnrCache = dsGrove.getPropertiesForAllNodes(
            graphname, 'ancestors', termnrsAsStrings = False )
        #print ancestorTermnrsByTermnrCache
        #print _normaltextByTermnrCache
        #YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY
        normaltextByTermnrCache = {}
        ancestortermnrs         = None
        collector               = None
        ancestordocu            = None
        for termnr in range( graphlength ):
            collector = [ _normaltextByTermnrCache.get( termnr, '' ) ]
            ancestortermnrs = ancestorTermnrsByTermnrCache.get( termnr, () )
            if ancestortermnrs:
                ancestordocu = normaltextByTermnrCache.get( termnr, None )
                if ancestordocu:
                    collector.append( ancestordocu )
                else:
                    for ancestortermnr in ancestortermnrs:
                        collector.append( _normaltextByTermnrCache.get( ancestortermnr, '' ) )
            normaltextByTermnrCache[ termnr ] = ' '.join( collector )
        del ancestordocu
        del ancestortermnrs
        del collector
        del ancestorTermnrsByTermnrCache
    else:
        normaltextByTermnrCache = _normaltextByTermnrCache
    del _normaltextByTermnrCache
    #-------------------------------------------------------------------------------------------------------
    if includeLocators:
        nodefactsByTermnrCache = dsGrove.getNodefactsByTermnrForGraphname( graphname )
    #-------------------------------------------------------------------------------------------------------
    #fs = ':%s:%%d' % ( graphname, )
    for termnr in range( 0, graphlength ):
        if includeLocators:
            normallocator   = ' '.join(
                pathTokenizer.tokenize(
                    nodefactsByTermnrCache[ termnr ].locator ) )
        #---------------------------------------------------------------------------------------------------
        normaltext = normaltextByTermnrCache.get( termnr, '' )
        if includeLocators:
            normaltext = '%s %s' % ( normallocator, normaltext, )
        #---------------------------------------------------------------------------------------------------
        title = str( termnr ) # fs % ( termnr, )
        yield title, normaltext


############################################################################################################
#
#
#
#===========================================================================================================
def make( verbose = False ):
    global VERBOSE
    VERBOSE = verbose
    buildAllIndices( _dsGrove, optimize = True )

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit( 50 )
    sep0 = '#' * 108
    sep1 = '=' * 108
    sep2 = '-' * 108

    make( verbose = VERBOSE )

