#
# -*- coding: utf-8 -*-

############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   import                                  warnings
#   from sets import                        Set
import                                  os
import                                  inspect
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
AssessmentsMatrix                       = u.AssessmentsMatrix.AssessmentsMatrix
iterRatings                             = u.iterRatings.iterRatings
_feds                                   = u.feds
#-----------------------------------------------------------------------------------------------------------
assessmentsMatricesCache                = {}
ratingsDbCache                          = {}
traces                                  = {}
D                                       = dict
#-----------------------------------------------------------------------------------------------------------
TESTING                                 = False
PERSISTTRACES                           = False
#-----------------------------------------------------------------------------------------------------------
#   TESTING                                 = True
PERSISTTRACES                           = True

#-----------------------------------------------------------------------------------------------------------
def make( verbose = False ):
    groveFed = _feds.resolve( 'Grove', readonly = False )
    dsGrove = groveFed.dsGrove
    dsGrove.clearTable( 'rating' )
    makeForFilenamefilter( dsGrove, verbose = verbose )
    groveFed.close()

############################################################################################################
#   CONFIGURATION
#===========================================================================================================
class cfg:
    here            = os.path.dirname( inspect.getsourcefile( lambda:None ) )
    dbname          = 'ratings'

#   ############################################################################################################
#   #   CREATION
#   #===========================================================================================================
#   def createDatabase():
#       ratingsXsdb = Xsdb( cfg.here, cfg.dbname, startup = True, verbose = True )
#       ratingsXsdb.prepareDirectory()
#       connection = ratingsXsdb.getConnection()
#       ratingsXsdbTa = xsdbi.getTransaction( connection )
#       return ratingsXsdb, ratingsXsdbTa




#   #-----------------------------------------------------------------------------------------------------------
#   def __interim__getAllKnownRatings():
#       return g.resources.interimAssessmentsInput.ratings

#-----------------------------------------------------------------------------------------------------------
def getAssessmentsMatrixForGaugepair( dsGrove, gaugepair ):
    R = assessmentsMatricesCache.get( gaugepair, None )
    if R is None:
        topicGauge, focusGauge = gaugepair
        R = AssessmentsMatrix( dsGrove, topicGauge, focusGauge )
        assessmentsMatricesCache[ gaugepair ] = R
    return R

#-----------------------------------------------------------------------------------------------------------
def getRatingsDbForGaugepair( gaugepair ):
    R = ratingsDbCache.get( gaugepair, None )
    if R is None:
        topicGauge, focusGauge = gaugepair
        R = RatingsVectorsByTopicTermnrDb( topicGauge, focusGauge )
        ratingsDbCache[ gaugepair ] = R
        R.delete()
        R.openForWriting()
    return R

#-----------------------------------------------------------------------------------------------------------
def makeForFilenamefilter(
    dsGrove,
    filenamefilter      = None,
    directorylocator    = None,
    verbose             = False,
    ):
    #-------------------------------------------------------------------------------------------------------
    #read_assessments_mdb_xls.writeFlow()
    rratings = iterRatings.forFilenamefilter( filenamefilter, directorylocator )
    makeForRatings( dsGrove, rratings, verbose )

#-------------------------------------------------------------------------------------------------------
def _termrefForOntonym( dsGrove, ontonym ):
    gauge, locator, termnr = dsGrove.tripletForOntonymOrNones( ontonym )
    try:
        assert gauge    is not None
        assert termnr   is not None
        return gauge, termnr
    except AssertionError:
        raise KeyError( ''
            +   "Unable to resolve ontonym: %r" % ( ontonym, )
            )

#-----------------------------------------------------------------------------------------------------------
def makeForRatings( dsGrove, rratings, verbose = False ):
    #-------------------------------------------------------------------------------------------------------
    debug_count = -1
    V = verbose
    for rrating in rratings:
        #print '~~~~~~~~~', rrating; continue
        debug_count += 1
        if TESTING and debug_count > 5: break
        #   print rrating.focus
        #   print dir( rrating ); break
        #-------------------------------------------------------------------------------------------------------
        #rating                  = rrating.nrating
        rating                  = rrating.rrating
        #-------------------------------------------------------------------------------------------------------
        topicOntonym            = rrating.topic
        focusOntonym            = rrating.focus
        #-------------------------------------------------------------------------------------------------------
        topicTermref            = _termrefForOntonym( dsGrove, topicOntonym )
        focusTermref            = _termrefForOntonym( dsGrove, focusOntonym )
        #-------------------------------------------------------------------------------------------------------
        topicGauge, topicTermnr = topicTermref
        focusGauge, focusTermnr = focusTermref
        #-------------------------------------------------------------------------------------------------------
        gaugepair               = ( topicGauge, focusGauge )
        assessmentsMatrix       = getAssessmentsMatrixForGaugepair( dsGrove, gaugepair )
        #-------------------------------------------------------------------------------------------------------
        if V:
            print '%-15s %5s = %s' % ( topicGauge, topicTermnr, topicOntonym )
            print '%-15s %5s = %s' % ( focusGauge, focusTermnr, focusOntonym )
            print 'Rating: %s' % ( rating, )
            print
        assessmentsMatrix.addAssessmentForTermrefs( dsGrove, topicTermref, focusTermref, rating )
#           print '\t added:'
#           print '\t\t%s' % topicOntonym
#           print '\t\t%s' % focusOntonym
#           print '\t\t%s' % rating

    collectTracesFromAllAssessmentsMatrices()

    #-------------------------------------------------------------------------------------------------------
    if V: "Persisting %d assessments." % len( assessmentsMatricesCache )
    for gaugepair, assessments in assessmentsMatricesCache.iteritems():
        topicGraphname, focusGraphname = gaugepair
        common = D(
            topicGraphname  = topicGraphname,
            focusGraphname  = focusGraphname,
            )
        for topicTermnr in dsGrove.iterTermnrs( topicGraphname ):
            ratingsVector = dict( assessments.ratingsVectorWithTermnrsForTopicTermnr( topicTermnr ) )
            fact = D(
                topicTermnr = topicTermnr,
                value       = ratingsVector,
                )
            fact.update( common )
            dsGrove.addRating( **fact )

    if not PERSISTTRACES: return
    #-------------------------------------------------------------------------------------------------------
    if V: "Persisting %d traces." % len( traces )
    for termrefPair, traceslist in traces.iteritems():
        topicTermref,   focusTermref    = termrefPair
        topicGraphname, topicTermnr     = topicTermref
        focusGraphname, focusTermnr     = focusTermref
        targetOntonymA = ':%s:%s' % ( topicGraphname, topicTermnr, )
        targetOntonymB = ':%s:%s' % ( focusGraphname, focusTermnr, )
        #print '%%%%%%%%%%% adding trace:', ( topicGraphname, topicTermnr, focusGraphname, focusTermnr, traceslist )
        dsGrove.addRatingtrace( topicGraphname, topicTermnr, focusGraphname, focusTermnr, traceslist )
        for sourceOntonymA, sourceOntonymB, assessment in traceslist:
            dsGrove.addRatingtrace2(
                sourceOntonymA,
                sourceOntonymB,
                targetOntonymA,
                targetOntonymB,
                assessment,
                )


#===========================================================================================================
def collectTracesFromAllAssessmentsMatrices():
    for assessmentsMatrix in assessmentsMatricesCache.itervalues():
        tracesByTermrefPair = assessmentsMatrix.traces
        for termrefPair, traceslist in tracesByTermrefPair.iteritems():
            trascestarget = traces.setdefault( termrefPair, [] )
            trascestarget.extend( traceslist )


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import sys; sys.setrecursionlimit(50)
    sep0 = '#' * 108
    sep1 = '=' * 108
    sep2 = '-' * 108


#       for x in iterRatings.forFilenamefilter( filenamefilter = None ):
#           print x
#       YYYYYYYYYY


    make( verbose = True )

#       for key, value in traces.iteritems():
#           print key, value

    # ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
    #assessmentTracesDb = g.utilities.persistence.storedefs.AssessmentTracesDb()
    #assessmentTracesDb.delete()
    #assessmentTracesDb.openForWriting()
    #assessmentTracesDb[ 'traces' ] = traces
    #assessmentTracesDb.close()
#       print 'persisted %d traces.' % len( traces )

#       topicGauge = 'bion'
#       focusGauge = 'abcd12'
#
#       topicLocators = [ x.strip() for x in """
#           /topic/science/biology/field-by-object/botany
#   #           /topic/collection/botanical-garden
#   #           /topic/collection/zoological-garden
#   #           /topic/collection/herbarium
#   #           /topic/collection/seedbank
#   #           /topic/collection/genebank
#   #           /topic/collection/core-samples
#   #           /topic/collection/culture/bacteria
#   #           /topic/collection/culture/algae
#   #           /topic/science/biology/field-by-object/botany
#   #           /topic/science/biology/field-by-object/mycology
#   #           /topic/science/biology/field-by-object/phycology
#           """.splitlines() if not '#' in x ]
#
#       ratingsDb = RatingsVectorsByTopicTermnrDb( topicGauge, focusGauge )
#       print ratingsDb.storeLocator
#       print ratingsDb.keys()
#       for topicLocator in topicLocators:
#           if not topicLocator: continue
#           print sep0
#           print topicLocator
#           _dummy, topicTermnr = AssessmentsMatrix._termrefForGaugeAndLocator( topicGauge, topicLocator )
#           ratingsVector = ratingsDb[ topicTermnr ]
#           ratingsAndNodes = AssessmentsMatrix.iterRatingsVectorWithNodesForGaugeAndRatingsVectorWithTermnrs(
#               gauge           = focusGauge,
#               ratingsVector   = ratingsVector,
#               maxcount        = None,
#               minrating       = None,
#               )
#           for rating, node in ratingsAndNodes:
#               if rating == 0: continue
#               print '\t%7.2f %s' % ( rating, node.ontonym, )



#       count = 0
#       for line in iterShowRatingLines():
#           count +=1
#           if count > 50: print '...'; break
#           print line
#
#       for key in ratingsDb.keys():
#           print key
#           break


