#
# -*- coding: utf-8 -*-

"""This module defines a single function, ``publish()``, which makes objects globally available without
necessitating any imports."""


import __builtin__
_Misfit = lambda:None

#===========================================================================================================
def publish( name, value, overwrite = True ):
    """Publish ``value`` under ``name`` in dictionary ``__builtin__.__dict__``, which makes the name visible
    in all ensuing code without further imports."""
    builtinsdict    = __builtin__.__dict__
    definedvalue    = builtinsdict.get( name, _Misfit )
    if not overwrite and definedvalue is not _Misfit and definedvalue is not value:
        raise NameError( "Name %r already defined in __builtin__." % ( name, ) )
    builtinsdict[ name ] = value








