#
# -*- coding: utf-8 -*-

"""

CVS::

    $Revision: 3 $
    $Author: markus $
    $Date: 2005-07-01 17:15:59 +0200 (Fri, 01 Jul 2005) $

"""


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
from __future__ import division
import string
#-----------------------------------------------------------------------------------------------------------
import cgi as                           _cgi
#-----------------------------------------------------------------------------------------------------------
u                                       = g.configtool.utilities
#-----------------------------------------------------------------------------------------------------------
_feds                                   = u.feds
_D                                       = dict
_Ratingscalculator                      = u.tempratingsweb.Ratingscalculator.Ratingscalculator
_S                                      = u.EzSet.S
_XmlMaker                               = u.XmlMaker.XmlMaker
_wraplines                              = u.typo.wraplines
_lexicalsearch                          = u.lupywrapper.search
#-----------------------------------------------------------------------------------------------------------
fsi                                     = u.filesystemIdioms
Servlet                                 = u.Servlet3.Servlet3
#-----------------------------------------------------------------------------------------------------------
here                                    = fsi.here( lambda:None )
#-----------------------------------------------------------------------------------------------------------
USETOOLTIPS                             = False
#-----------------------------------------------------------------------------------------------------------
USETOOLTIPS                             = True


#===========================================================================================================
def engage():
    MyServlet()
    return

inlinehelp  = _XmlMaker._.Rawstring( fsi.read( fsi.join( here, 'ratingsweb.help.fragment.html'  ) ) )
localscript =                        fsi.read( fsi.join( here, 'ratingsweb.js'                    ) )


############################################################################################################
#
#
#
#===========================================================================================================
class MyServletBase( Servlet ):

    ########################################################################################################
    #   SERVLET BEHAVIOR PARAMETERS
    #-------------------------------------------------------------------------------------------------------
    htmlNamespace               = _XmlMaker._.namespaces.xhtml1.transitional
    doctype                     = _XmlMaker._.doctypes.xhtml1.transitional
    #-------------------------------------------------------------------------------------------------------

    ########################################################################################################
    #   OUTPUT METHODS
    #-------------------------------------------------------------------------------------------------------
    def _start( self, title ):
        self.title = title
        #return self.body
        self.setLinkToCss( './ratingsweb.css' )
        self.setLinkToCss( '../../resources/css/biocase.css' )
        #self.setLinkToCss( './tooltips.css' )


    #-------------------------------------------------------------------------------------------------------
    def _finish( self ):
        pass

    #-------------------------------------------------------------------------------------------------------
    def _getGroveFed( self ):
        R = getattr( self, 'groveFed', None )
        if R is None:
            R = _feds.resolve( 'Grove', readonly = True )
        return R

#       #-------------------------------------------------------------------------------------------------------
#       def getRatings( self, query ):
#           dsGrove         = self._getGroveFed().dsGrove
#           topicGraphname  = self.topicGraphname  = 'bion'
#           focusGraphname  = self.focusGraphname  = 'abcd12'
#           linenr          = 0
#           #rc              = self.ratingscalculator #= _Ratingscalculator(
#                                                    #                   query, topicGraphname, focusGraphname )
#           ratings         = self.ratingscalculator.getRatings()
#           getNodefact     = dsGrove.nodefactForOntonym
#           focusGauge      = ':%s:' % ( focusGraphname, )
#           #---------------------------------------------------------------------------------------------------
#           R = [
#               ( rating, getNodefact( ( focusGauge, focusTermnr ) ) )
#                   for rating, focusTermnr in ratings ]
#           return R

    #-------------------------------------------------------------------------------------------------------
    def iterRatinggroups( self, ratingsAndTermnrs ):
        #~self.body.X.div( '***************** %s' % ( len( ratingsAndTermnrs ), ) )
        previousrating = None
        for rating, node in ratingsAndTermnrs:
            #yield rating, [ node ]
            if previousrating is None:
                nodes = [ node ]
                previousrating = rating
                continue
            if rating == previousrating:
                nodes.append( node )
                continue
            yield previousrating, nodes
            previousrating = rating
            nodes = [ node ]
        try:
            yield rating, nodes
        except NameError:
            pass

############################################################################################################
#
#
#
#===========================================================================================================
class MyServlet( MyServletBase ):


    #-------------------------------------------------------------------------------------------------------
    #   QUERY STRING ARGUMENTS
    #-------------------------------------------------------------------------------------------------------
    facetDescriptions = _D(

        #---------------------------------------------------------------------------------------------------
        #   MISSION
        #---------------------------------------------------------------------------------------------------
        #   Specifies purpose of calling this module.
        #
        im = _D(
            name        = 'im',
            default     = 'df',
            controlled  = True,
            vocabulary  = _D(
                    default = 'df',
            )),

        #---------------------------------------------------------------------------------------------------
        #   QUERY
        #---------------------------------------------------------------------------------------------------
        #   Ex.: q = zoo* or botanical-garden
        #
        #   Specifies query in terms of the topic schema.
        #
        q = _D(
            name        = 'q',
            default     = '',
            ),

        #---------------------------------------------------------------------------------------------------
        #   TOPIC SCHEMA
        #---------------------------------------------------------------------------------------------------
        #   Ex.: ts = bion
        #
        #   Specifies topic schema (from where the search terms come).
        #
        ts = _D(
            name        = 'ts',
            default     = 'bion',
            ),

        #---------------------------------------------------------------------------------------------------
        #   FOCUS SCHEMA
        #---------------------------------------------------------------------------------------------------
        #   Ex.: fs = abcd12
        #
        #   Specifies focus schema (from where the results are gathered).
        #
        fs = _D(
            name        = 'fs',
            default     = 'abcd12',
            ),

        #---------------------------------------------------------------------------------------------------
        #   TARGET ELEMENT
        #---------------------------------------------------------------------------------------------------
        #   Ex.: te = myjsfunction
        #
        #   Name of a JavaScript function in the opening windowes that accepts exactly two arguments;
        #   this function will be called when the user selects an element in the result set by
        #   clicking on it.
        #
        #   If ``te`` is set to a non-empty value, results will be formatted
        #   with click-to-send-back links.
        te = _D(
            name        = 'te',
            default     = '',
            ),

        #---------------------------------------------------------------------------------------------------
        #   DISPLAY LOCATORS
        #---------------------------------------------------------------------------------------------------
        #
        #   Whether or not to display concept locators.
        #
        dl = _D(
            name        = 'dl',
            default     = 'n',
            controlled  = True,
            vocabulary  = _D(
                n       = 'n',
                y       = 'y',
            )),

        #---------------------------------------------------------------------------------------------------
        #   DISPLAY DOCUMENTATION
        #---------------------------------------------------------------------------------------------------
        #
        #   Whether or not to display what documentation.
        #
        dd = _D(
            name        = 'dd',
            default     = 'n',
            controlled  = True,
            vocabulary  = _D(
                n       = 'n',
                y       = 'y',
                x       = 'x',
            )),

        #---------------------------------------------------------------------------------------------------
        #   SEARCH TYPE
        #---------------------------------------------------------------------------------------------------
        #
        #   Whether to use lexical or topical searching.
        #
        st = _D(
            name        = 'st',
            default     = 't',
            controlled  = True,
            vocabulary  = _D(
                t       = 't',
                l       = 'l',
            )),

        #---------------------------------------------------------------------------------------------------
        #   RESULT FORMAT
        #---------------------------------------------------------------------------------------------------
        #
        #   Whether to return graphnames ('g') or namespace URLs ('n'). Default is 'g'.
        #
        rf = _D(
            name        = 'rf',
            default     = 'g',
            controlled  = True,
            vocabulary  = _D(
                g       = 'g',
                n       = 'n',
            )),

        #---------------------------------------------------------------------------------------------------
        )

    #-------------------------------------------------------------------------------------------------------
    def respond( self ):
        #---------------------------------------------------------------------------------------------------
        #   Always inhibit client page caching:
        self.setNoCachingHeaders()
        self.respond_default()

    #-------------------------------------------------------------------------------------------------------
    def _extendClass( self, Q, *P ):
        classes = Q.setdefault( 'clasz', '' ).split()
        classes.extend( P )
        Q[ 'clasz' ] = ' '.join( classes )

    #-------------------------------------------------------------------------------------------------------
    def indentation( self, level ):
        X       = self.body.X
        dent    = "<span class='rw_dent'>&nbsp;</span>"
        level   = max( level - 1, 0 )
        return X.span( X._.Rawstring( dent * level ), clasz = 'rw_indentation' )

    ########################################################################################################
    #   RESPONSE
    #-------------------------------------------------------------------------------------------------------
    def respond_default( self, checkApw = True ):
        global localscript
        #---------------------------------------------------------------------------------------------------
        self.searchType     = st = self.fc.i.st.value
        targetElementId     = self.targetElementId = self.fc.i.te.value
        targetElementId_    = targetElementId
        if not targetElementId_: targetElementId_ = 'UNKNOWN'
        localscript         %= vars()
        self.includeScriptSource( localscript )
        self.groveFed       = self._getGroveFed()
        dsGrove             = self.groveFed.dsGrove
        query               =   self.query              = self.fc.i.q.value
        returnNamespace     =   self.returnNamespace    = self.fc.i.rf.value == 'n'
        displayLocators     =   self.displayLocators    = self.fc.i.dl.value == 'y'
        displayDocs         =   self.displayDocs        = self.fc.i.dd.value
        linkResults         =   bool( targetElementId )
        topicOrFocusIdentificationInvalid = False
        topicGraphname = topicNamespace = focusGraphname = focusNamespace = None
        #---------------------------------------------------------------------------------------------------
        try:
            topicGraphname,         topicNamespace      = dsGrove.getGraphnameAndNamespace( self.fc.i.ts.value )
            focusGraphname,         focusNamespace      = dsGrove.getGraphnameAndNamespace( self.fc.i.fs.value )
        except ValueError:
            topicOrFocusIdentificationInvalid = True
        self.topicGraphname,    self.topicNamespace = topicGraphname, topicNamespace
        self.focusGraphname,    self.focusNamespace = focusGraphname, focusNamespace
        #---------------------------------------------------------------------------------------------------
        if st == 't':
            if topicOrFocusIdentificationInvalid:
                ratingscalculator = None
            else:
                ratingscalculator = self.ratingscalculator = _Ratingscalculator(
                    query, topicGraphname, focusGraphname )
        #---------------------------------------------------------------------------------------------------
        self._start( 'RatingsWeb' )
        X = self.body.X
        #---------------------------------------------------------------------------------------------------
        header  = ~X.div( 'Concept Retrieval Interface', id = 'Header' )
        #---------------------------------------------------------------------------------------------------
        content = ~X.div( id = 'Content' )

        #---------------------------------------------------------------------------------------------------
        footer  = ~X.div(
            X.a(
                X.img(
                    src     = "../../resources/images/biocase_powered.gif",
                    width   = "112",
                    height  = "34",
                    ),
                href    = "http://www.biocase.org",
                ),
            id = 'Footer',
            )
        #---------------------------------------------------------------------------------------------------
        X = content.X
        _ = nbsp = X._.nbsp
        content |= inlinehelp
        if not topicOrFocusIdentificationInvalid:
            ~X.div( "Searching for results from concept schema ", X.b( focusGraphname, ), ".", )
        self.body.Q[ 'onload' ] = self.body.Q.get( 'onload', '' ) + 'ratingsweb_initialize();'
        form = ~X.form( method = 'get', action = './index.cgi' )
        ~form.X.input( type = 'hidden', name = 'fs', value = focusGraphname )
        ~form.X.input( type = 'hidden', name = 'im', value = self.fc.i.im.value )
        ~form.X.input( type = 'hidden', name = 'te', value = targetElementId )
        ~form.X.input( type = 'hidden', name = 'ts', value = topicGraphname )
        table = ~form.X.table( border = 1, style = 'width:100%;vertical-align:bottom;border:1px solid white;', cellspacing = 0, cellpadding = 0 )
        #~table.X.tr( X.td( X.textarea( query, style = 'width:100%;', rows = 5, name = 'q' ) ) )
        ~table.X.tr(
            X.td( self.textarea( query ), colspan = 15, clasz = 'rw_td' ),
            )
        def xtd( width, *P, **Q ):
            return X.td( nowrap = 'nowrap', width = '%d%%' % width, clasz = 'rw_td', *P, **Q )
        def xi( type, name, value, checkvalue = None, *P, **Q ):
            if checkvalue == value: Q[ 'checked' ] = 'checked'
            return X.input( type = type, name = name, value = value, *P, **Q )
        dl = self.fc.i.dl.value
        dd = self.fc.i.dd.value
        #---------------------------------------------------------------------------------------------------
        sub = xtd( 10, xi( 'submit',  'rw_kw', 'query'        ), rowspan = 2, )
        #---------------------------------------------------------------------------------------------------
        stl = xtd(  1, xi( 'radio',   'st',    'l',       st  ), )
        stt = xtd(  1, xi( 'radio',   'st',    't',       st  ), )
        #---------------------------------------------------------------------------------------------------
        dln = xtd(  1, xi( 'radio',   'dl',    'n',       dl  ), )
        dly = xtd(  1, xi( 'radio',   'dl',    'y',       dl  ), )
        ddn = xtd(  1, xi( 'radio',   'dd',    'n',       dd  ), )
        ddy = xtd(  1, xi( 'radio',   'dd',    'y',       dd  ), )
        ddx = xtd(  1, xi( 'radio',   'dd',    'x',       dd  ), )
        #---------------------------------------------------------------------------------------------------
        st_ = xtd(  1, _, _, "Search method:",              _, _ )
        stL = xtd(  1,       "lexical",                     _, _ )
        stT = xtd(  1,       "topical",                     _, _ )
        #---------------------------------------------------------------------------------------------------
        dl_ = xtd(  1, _, _, "Show locators:",              _, _ )
        dlN = xtd(  1,       "no",                          _, _ )
        dlY = xtd(  1,       "yes",                         _, _ )
        xx0 = xtd( 90, _, ' ', _, ' ', _, ' ', _, ' ',      _, _ )
        dd_ = xtd( 90, _, _, "Show documentation:",         _, _ )
        ddN = xtd(  1,       "no",                          _, _ )
        ddY = xtd(  1,       "short",                       _, _ )
        ddX = xtd(  1,       "extended",                    _, _ )
        xxx = xtd( 90, _, ' ', _, ' ', _, ' ', _, ' ',      _, _ )
        emp = xtd( 90,                                      _, _, colspan = 9, )
        #---------------------------------------------------------------------------------------------------
        ~table.X.tr(
            sub,
            dl_, dln, dlN, dly, dlY, xx0, dd_, ddn, ddN, ddy, ddY, ddx, ddX, xxx,
            )
        ~table.X.tr(
            st_, stl, stL, stt, stT, emp,
            )
        #---------------------------------------------------------------------------------------------------

        #===================================================================================================
        #if not query: return self._finish()
        #===================================================================================================
        #   self.groveFed               = self._getGroveFed()
        #   dsGrove                     = self.groveFed.dsGrove
        getNodefact                 = dsGrove.nodefactForOntonym
        newFocusGraphname           = focusGraphname
        #---------------------------------------------------------------------------------------------------
        if query: ~X.div( X.b( "Query: " ), query )
        #---------------------------------------------------------------------------------------------------
        ratingsAndTermnrs = None
        try:
            if topicOrFocusIdentificationInvalid:
                if topicGraphname is None:
                    _parametervalue = self.fc.i.ts.value
                    _parametername  = 'topic'
                else:
                    _parametervalue = self.fc.i.fs.value
                    _parametername  = 'focus'
                raise ValueError( ''
                    +   "The %s identification '%s' is invalid." % ( _parametername, _parametervalue )
                    )
            try:
                if st == 't':
                    ratingsAndTermnrs = self.ratingscalculator.getRatings()
                else:
                    normphrase, newFocusGraphname, ratingsAndTermnrs = \
                        _lexicalsearch.searchOnSingleGraphForScoresAndTermnrs( query, focusGraphname )
                    #return self._finish()

            finally:
                if st == 't':
                    if self.ratingscalculator.report:
                        ~X.div( X.b( "Expansion" ), " (in reverse Polish notation):" )
                        ~X.pre( self.ratingscalculator.report )
                else:
                    ~X.div( X.b( "Normalized Query: " ), normphrase )
        except Exception, e:
            ~X.div(
                X.div( "When trying to evaluate your query, the following problem was encountered:" ),
                X.div( '%s' % ( e, ), ),
                clasz = 'rw_error',
                )
            return self._finish()
        #---------------------------------------------------------------------------------------------------
        if newFocusGraphname != focusGraphname:
            ~X.div( "Focus graph temporarily switched to ", X.b( newFocusGraphname ) )
        focusGraphname,         focusNamespace      = dsGrove.getGraphnameAndNamespace( newFocusGraphname )
        self.focusGraphname,    self.focusNamespace = focusGraphname, focusNamespace
        #---------------------------------------------------------------------------------------------------
        focusGauge                  = ':%s:' % ( self.focusGraphname, )
        ancestorTermnrCache         = dsGrove.getPropertiesForAllNodes( focusGraphname, 'ancestors' )
        nodefactsByTermnrstrCache   = dsGrove.getNodefactsByTermnrstrForGraphname( focusGraphname )
        if dd in 'yx':
            self.docfactsByTermnrCache = dsGrove.getDocumentationfactsByTermnrForGraphname( focusGraphname )
        if st == 'l':
            _ratingsAndTermnrs = []
            for rating, termnr in ratingsAndTermnrs:
                nodefact = nodefactsByTermnrstrCache[ str( termnr ) ]
                #if nodefact.name.startswith( '@' ): continue
                if not nodefact.isLeaf: continue
                _ratingsAndTermnrs.append( ( rating, termnr, ) )
            del ratingsAndTermnrs[:]
            for rating, termnr in _ratingsAndTermnrs:
                nodefact = nodefactsByTermnrstrCache[ str( termnr ) ]
                ratingsAndTermnrs.append( ( rating, termnr, ) )
                #for attributeTermnr in range( termnr, nodefact.lastDescendantTermnr ):
                #    ratingsAndTermnrs.append( ( rating, attributeTermnr, ) )
        #---------------------------------------------------------------------------------------------------
        ~X.div( X.b( "Results:" ), )
#           rtable = ~X.table( border = 1, style = 'width:100%;', cellspacing = 0, cellpadding = 0 )
#           ~rtable.X.tr(
#               X.td( "Group nr." ),
#               X.td( "Rating" ),
#               X.td( "Result Concepts" ),
#               clasz = 'rw_tableheader',
#               )
        linenr = 0
        #---------------------------------------------------------------------------------------------------
        for rating, termnrs in self.iterRatinggroups( ratingsAndTermnrs ):
            linenr += 1
            ~X.div( X._.nbsp, clasz = 'rw_hr' )
            if query: ~X.div( X.b( "Group %d, Rating: %+0.4f" % ( linenr, rating, ) ) )
            ontonymscell = ~X.div( clasz = 'ontonym' )
#               ~rtable.X.tr(
#                   X.td( linenr,       clasz = 'rw_linenumber',  ),
#                   X.td( ratingstring, clasz = 'rw_rating', nowrap = 'nowrap' ),
#                   ontonymscell,
#                   )
            selectedTermnrs = _S( *termnrs )
            nodefactsByParentTermnr = self.nodefactsByParentTermnr = {}
            #-----------------------------------------------------------------------------------------------
            for termnr in termnrs:
                termnrstr           = str( termnr )
                nodefact            = nodefactsByTermnrstrCache[ termnrstr ]
                #ontonymForDisplay   = '/ '.join( nodefact.ontonym.split( '/' ) )
                ancestorTermnrs     = ancestorTermnrCache[ str( nodefact.termnr ) ]
                parentTermnr        = nodefact.parentTermnr
                target = nodefactsByParentTermnr.setdefault( parentTermnr, [ [], [], ] )
                subindex = not nodefact.isAttribute
                target[ subindex ].append( nodefact )
                for ancestorTermnr in ancestorTermnrs:
                    nodefactsByParentTermnr.setdefault( ancestorTermnr, [ [], [], ] )
                #-------------------------------------------------------------------------------------------
            parentTermnrs = nodefactsByParentTermnr.keys()
            parentTermnrs.sort()
            #-----------------------------------------------------------------------------------------------
            for parentTermnr in parentTermnrs:
                if parentTermnr < 0: continue
                headnodefact        = nodefactsByTermnrstrCache[ str( parentTermnr ) ]
                if not headnodefact.isLeaf:
                    headname            = headnodefact.name
                    headtermnr          = headnodefact.termnr
                    headlevel           = headnodefact.level
                    ~ontonymscell.X.div(
                        self.indentation( headlevel ),
                        #X.span( `headtermnr`, ' ', clasz = 'rw_headtermnr' ),
                        X.span( headname, clasz = 'rw_headname' ),
                        clasz = 'rw_header'
                        )
                    attributefacts = nodefactsByParentTermnr.get( headtermnr, (None,None) )[ 0 ]
                    if attributefacts:
                        self.showMembers( ontonymscell, attributefacts, linkResults, areAttributes = True )
                #-------------------------------------------------------------------------------------------
                membernodefacts     = nodefactsByParentTermnr[ parentTermnr ][ 1 ]
                self.showMembers( ontonymscell, membernodefacts, linkResults )
                #~ontonymscell.X.div( X._.nbsp, )
        #---------------------------------------------------------------------------------------------------
        return self._finish()

    #-------------------------------------------------------------------------------------------------------
    def showMembers( self, targetcell, membernodefacts, linkResults, areAttributes = False ):
        X                           = self.body.X
        focusGraphname              = self.focusGraphname
        if self.returnNamespace:
            focusGraphId = self.focusNamespace
        else:
            focusGraphId = focusGraphname
        nodefactsByParentTermnr     = self.nodefactsByParentTermnr
        divclasses                  = ( 'rw_membername', 'rw_membername rw_attr' )
        divclass                    = divclasses[ areAttributes ]
        membernodefacts             = [ ( fact.termnr, fact ) for fact in membernodefacts ]
        membernodefacts.sort()
        #indentation = self.
        #-----------------------------------------------------------------------------------------------
        for membertermnr, membernodefact in membernodefacts:
            level               = membernodefact.level - areAttributes
            indentationSpan     = self.indentation( level )
            if areAttributes:
                postindentationSpan = X.span( X._.nbsp, clasz = 'rw_postdent' )
            else:
                postindentationSpan = ''
        #-----------------------------------------------------------------------------------------------
        for membertermnr, membernodefact in membernodefacts:
            if not membernodefact.isLeaf: continue
            membername          = membernodefact.name
            memberlevel         = membernodefact.level
            #indentationSpan     = self.indentation( memberlevel )
            membertermnrSpan    = X.span( `membertermnr`, clasz = 'rw_membertermnr'    )
            membernameSpan      = X.span( membername,     clasz = divclass             )
            if linkResults:
            #if USETOOLTIPS:
                href = "javascript:sendTermref('%s',%s)" % ( focusGraphId, membertermnr )
                ~targetcell.X.div(
                    indentationSpan,
                    membertermnrSpan,
                    ' ',
                    postindentationSpan,
                    X.a(
                        membernameSpan,
                        #X.span( membernodefact.locator ),
                        href   = href,
                        clasz  = 'rw_a',
                        ),
                    clasz = 'rw_entry',
                    )
            else:
                ~targetcell.X.div(
                    indentationSpan,
                    membertermnrSpan,
                    postindentationSpan,
                    membernameSpan,
                    )
            attributefacts = nodefactsByParentTermnr.get( membertermnr, (None,None) )[ 0 ]
            if self.displayLocators or ( self.displayDocs in 'yx' ):
                hiddentermnrSpan = X.span( `membertermnr`, clasz = 'rw_membertermnr rw_hide' )
                if self.displayLocators:
                    # ___HACK___ start
                    # to recreate parent[@attribute] form of attribute xpaths
                    path = membernodefact.ontonym
                    if path.find('/@') > 0:
                        path = string.replace(path, '/@', '[@')
                        path += ']'
                    # ___HACK___ end
                    pathSpan = X.span( path, clasz = 'rw_path' )
                    ~targetcell.X.div(
                        indentationSpan,
                        hiddentermnrSpan,
                        postindentationSpan,
                        pathSpan,
                        )
            if self.displayDocs in 'yx':
                docfact = self.docfactsByTermnrCache.get( membertermnr, None )
                if docfact is not None:
                    short = docfact.short
                    if short:
                        for line in _wraplines( short ):
                            shortdocSpan = X.span( line, clasz = 'rw_shortdoc' )
                            ~targetcell.X.div(
                                indentationSpan,
                                hiddentermnrSpan,
                                postindentationSpan,
                                shortdocSpan,
                                )
                    if self.displayDocs == 'x':
                        long = docfact.long
                        if long:
                            for line in _wraplines( long ):
                                longdocSpan = X.span( line, clasz = 'rw_longdoc' )
                                ~targetcell.X.div(
                                    indentationSpan,
                                    hiddentermnrSpan,
                                    postindentationSpan,
                                    longdocSpan,
                                    )
            if attributefacts:
                self.showMembers( targetcell, attributefacts, linkResults, areAttributes = True )
    #-------------------------------------------------------------------------------------------------------
    def textarea( self, query = '' ):
        #---------------------------------------------------------------------------------------------------
        X = self.body.X
        R = X.textarea(
            query,
            style   = ( ''
                +   'width:98%;'
                ),
            rows    = 5,
            name    = 'q',
            onkeyup = "javascript:handletextarea(this);",
            )
        return R

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    import os
    os.environ[ 'QUERY_STRING' ] = 'im=df'
    __cgimain__()
