#
# -*- coding: utf-8 -*-


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
import                                  types


############################################################################################################
#
#
#
#===========================================================================================================
class typeIdioms( object ):

    #-------------------------------------------------------------------------------------------------------
    classTypes = ( types.ClassType, types.TypeType, )

    #-------------------------------------------------------------------------------------------------------
    def f( this, x ):
        return type( x ) in this.classTypes
    isClass = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, x ):
        return type( x ) == types.MethodType
    isMethod = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, x ):
        return type( x ) == types.FunctionType
    isFunction = classmethod( f ); del f


############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':

    #-------------------------------------------------------------------------------------------------------
    import sys as anymodule
    sep = '=' * 108

    #-------------------------------------------------------------------------------------------------------
    print dir( types )

    #-------------------------------------------------------------------------------------------------------
    class Cclass:
        def f( self ): pass

    #-------------------------------------------------------------------------------------------------------
    class Nclass( object ):
        def f( self ): pass

    #-------------------------------------------------------------------------------------------------------
    def test( title, x ):
        lines = """
#           bool( getattr( x, '__bases__' ) )
#           callable( x )
#           isinstance( x, object )
#           isinstance( x, type )
#           issubclass( x, object )
#           issubclass( x, type )
#           type( x )
#           type( x ) == types.ClassType
#           type( x ) == types.FunctionType
#           type( x ) == types.InstanceType
#           type( x ) == types.MethodType
#           type( x ) == types.ModuleType
#           type( x ) == types.TypeType
#           type( x ) == x.__class__
        typeIdioms.isClass( x )
        typeIdioms.isMethod( x )
        typeIdioms.isFunction( x )
        """.splitlines()
        print sep
        print title
        for line in lines:
            line = line.strip()
            if not line: continue
            if line.startswith( '#' ): continue
            try:
                result = eval( line )
            except Exception, e:
                result = '(%s) %s' % ( e.__class__, e, )
            print '%-50s: %s' % ( line, result, )


    #-------------------------------------------------------------------------------------------------------
    test( 'Cclass', Cclass )
    test( 'Nclass', Nclass )
    test( 'Cclass()', Cclass() )
    test( 'Nclass()', Nclass() )
    test( 'Cclass.f', Cclass.f )
    test( 'Nclass.f', Nclass.f )
    test( 'Cclass().f', Cclass().f )
    test( 'Nclass().f', Nclass().f )
    test( 'anymodule', anymodule )


