#
# -*- coding: utf-8 -*-

#   from http://www.aminus.org/rbre/python/xray.py
#
#   """Load modules, classes, functions, and attributes by dotted package names.
#
#   This work, including the source code, documentation
#   and related data, is placed into the public domain.
#
#   The orginal author is Robert Brewer, Amor Ministries.
#
#   THIS SOFTWARE IS PROVIDED AS-IS, WITHOUT WARRANTY
#   OF ANY KIND, NOT EVEN THE IMPLIED WARRANTY OF
#   MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE
#   ASSUMES _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE
#   RESULTING FROM THE USE, MODIFICATION, OR
#   REDISTRIBUTION OF THIS SOFTWARE.
#
#   Usage:
#
#       desiredClass = xray.classes("myapp.stringtools.alwayslowercase", str)
#       newInstance = desiredClass()
#
#   or
#
#       for f in startup_function_names:
#           func_object = xray.functions(f)
#           func_object()
#
#
#   Rationale:
#
#   I try to create systems that are configurable by deployers; mostly becase I
#   hate it when an application forces me to use the database, filesystem,
#   communication protocol, algorithm, or operating system du jour. Abstracting
#   these basic components of an application is its own study (look up the Gang
#   of Four "Strategy" pattern for a start); this is often accomplished with
#   classes which share signatures, often via subclassing. However, the deployer
#   then needs to specify the class they wish to use. This module gives them
#   the ability to specify that with a single string (for example, in a text
#   configuration file).
#
#   """
#
#   import sys
#
#   def modules(modulePath):
#       """Load a module and retrieve a reference to that module."""
#       try:
#           aMod = sys.modules[modulePath]
#           if aMod is None:
#               raise KeyError
#       except KeyError:
#           # The last [''] is important.
#           aMod = __import__(modulePath, globals(), locals(), [''])
#       return aMod
#
#   def attributes(fullAttributeName):
#       """Load a module and retrieve an attribute of that module."""
#
#       # Parse out the path, module, and attribute
#       lastDot = fullAttributeName.rfind(u".")
#       attrName = fullAttributeName[lastDot + 1:]
#       modPath = fullAttributeName[:lastDot]
#
#       aMod = modules(modPath)
#       # Let an AttributeError propagate outward.
#       try:
#           anAttr = getattr(aMod, attrName)
#       except AttributeError:
#           raise AttributeError("'%s' object has no attribute '%s'"
#                                % (modPath, attrName))
#
#       # Return a reference to the attribute.
#       return anAttr
#
#   def functions(fullFuncName):
#       """Load a module and retrieve a function object."""
#
#       aFunc = attributes(fullFuncName)
#
#       # Assert that the function is a *callable* attribute.
#       if not callable(aFunc):
#           raise TypeError(u"'%s' is not callable." % fullFuncName)
#
#       # Return a reference to the function itself,
#       # not the results of the function.
#       return aFunc
#
#   def classes(fullClassName, parentClass=None):
#       """Load a module and retrieve a class (NOT an instance).
#
#       If the parentClass is supplied, className must be of parentClass
#       or a subclass of parentClass (or None is returned).
#       """
#       aClass = functions(fullClassName)
#
#       # Assert that the class is a subclass of parentClass.
#       if parentClass is not None:
#           if not issubclass(aClass, parentClass):
#               raise TypeError(u"'%s' is not a subclass of %s" %
#                               (fullClassName, parentClass.__name__))
#
#       # Return a reference to the class itself, not an instantiated object.
#       return aClass
#


############################################################################################################
#
#   YELLOW PAGES
#
#===========================================================================================================
#   from __future__ import division
#-----------------------------------------------------------------------------------------------------------
import                                  sys
import imp as                           _imp
import os.path as                       _ospath
from new import module as               _StandardModuleClass
import                                  __builtin__
import  traceback as                    _traceback
#-----------------------------------------------------------------------------------------------------------
try:                import cPickle as   _pickler
except ImportError: import pickle as    _pickler
#-----------------------------------------------------------------------------------------------------------
_Misfit                                 = lambda:None
GLOBALNAMEBASE_NAME                     = 'g'
#   PUBLISH_D_AS_DICT                       = True
#-----------------------------------------------------------------------------------------------------------
VERBOSE                                 = False
#   VERBOSE                                 = True



############################################################################################################
#
#
#
#===========================================================================================================
class ImpModule( _StandardModuleClass ):

    #-------------------------------------------------------------------------------------------------------
    __gnb_verbose__ = VERBOSE

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, module, dotpath ):
        super( ImpModule, self ).__init__( module.__name__ )
        self.__dict__.update( module.__dict__ )
        self.__gnb_dotpath__ = dotpath

    #-------------------------------------------------------------------------------------------------------
    def __getattr__( self, name ):
        #---------------------------------------------------------------------------------------------------
        dotpath             = self.__dict__[ '__gnb_dotpath__' ]
        if dotpath: dotpath = '.'.join( ( dotpath, name, ) )
        else:       dotpath = name
        #---------------------------------------------------------------------------------------------------
        R = self.__gnb_objectForName__( name, dotpath )
        setattr( self, name, R )
        return R

    #-------------------------------------------------------------------------------------------------------
    def f( this, name, dotpath ):
        #---------------------------------------------------------------------------------------------------
        namespace = {}
        statement = 'import %(dotpath)s as %(name)s' % vars()
        #---------------------------------------------------------------------------------------------------
        try:
            if this.__gnb_verbose__:
                print 'ImpModule.__gnb_objectForName__(): %r' % ( statement, )
            exec statement in globals(), namespace
        #---------------------------------------------------------------------------------------------------
        except Exception, e:
            raise
#               raise e.__class__( ''
#                   +   "\nWhen trying to execute %r, the following error occured:" % ( statement, )
#                   +   _getTracebackReport( e )
#                   +   "(%s) %s" % ( e.__class__, e, )
#                   +   "\n-- sys.path: \n%s" % ( ', \n'.join( sys.path ), )
#                   )
        #---------------------------------------------------------------------------------------------------
        return this.__gnb_wrapModule__( namespace[ name ], dotpath )
    __gnb_objectForName__ = classmethod( f ); del f

#       #-------------------------------------------------------------------------------------------------------
#       def f( this, name, dotpath ):
#           #   moduleName = 'pylon'
#           #   path = [ 'c:/biocase/private/configtool/utilities' ]
#           moduleName = 'utilities'
#           path = [ self.__gnb_homelocator__ ]
#           path.extend( sys.path )
#           scriptFile,                 \
#           scriptFilename,             \
#           scriptDescription           = _imp.find_module( moduleName, path )
#           scriptFilename = normalize( scriptFilename )
#           _imp.load_module( scriptFilename, scriptFile, scriptFilename, scriptDescription )
#           #---------------------------------------------------------------------------------------------------
#           R = this.__gnb_wrapModule__( namespace[ name ], dotpath )
#           R.__gnb_homelocator__ =
#           return R
#       __gnb_objectForName__ = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, filename ):
        R = filename
        R = '/'.join( R.split( '\\' ) )
        R = '/'.join( R.split( '::' ) )
        if R.endswith( '.pyc' ) or R.endswith( '.pyo' ) or R.endswith( '.pyw' ): R = R[ : -1 ]
        return R
    __gnb_normalizeFilename__ = classmethod( f ); del f

    #-------------------------------------------------------------------------------------------------------
    def f( this, obj, dotpath ):
        """In case ``obj`` is an instance of the standard module class, wrap it up and return a congruent
        ``ImpModule`` instance. Otherwise, return ``obj`` as-is."""
        #   Note: must not use ``this`` here to avoid confusion with derivaed class GlobalNamebase
        if isinstance( obj, _StandardModuleClass ): return ImpModule( obj, dotpath )
        return obj
    __gnb_wrapModule__ = classmethod( f ); del f


############################################################################################################
#
#   CREATE AND PUBLISH GLOBAL NAMEBASE
#
#===========================================================================================================
class GlobalNamebase( ImpModule ):

    #-------------------------------------------------------------------------------------------------------
    def __init__( self, name = GLOBALNAMEBASE_NAME ):
        super( GlobalNamebase, self ).__init__( _StandardModuleClass( GLOBALNAMEBASE_NAME ), '' )
        self.publish( name, self )
        #   if PUBLISH_D_AS_DICT:
        #       self.publish( 'D', dict )

    #-------------------------------------------------------------------------------------------------------
    def publish( self, name, value, overwrite = True ):
        """Publish ``value`` under ``name`` in dictionary ``__builtin__.__dict__``, which makes the name
        visible in all ensuing code without further imports."""
        builtinsdict    = __builtin__.__dict__
        definedvalue    = builtinsdict.get( name, _Misfit )
        if not overwrite and definedvalue is not _Misfit and definedvalue is not value:
            raise NameError( "Name %r already defined in __builtin__." % ( name, ) )
        builtinsdict[ name ] = value

#-----------------------------------------------------------------------------------------------------------
g = GlobalNamebase()

#   This addition is debatable, but practical and only done for reasons of backward compatibility:
g.pickler = _pickler

############################################################################################################
#
#
#
#===========================================================================================================
if __name__ == '__main__':


    #import sys; sys.setrecursionlimit(50)
    sys.setrecursionlimit(50)
    sep0 = '#' * 108
    sep1 = '=' * 108
    sep2 = '-' * 108

    print sys.modules.keys()

    #   class G( object ):
    #
    #       def __getattr__( self, name ):
    #           print name

    sys.path.insert( 0, 'c:/biocase/private' )
    sys.path.insert( 0, 'c:/biocase/private/configtool' )

    print sys.path
    #print g.configtool
    print sep1
    print g.configtool.utilities.pylon.acquire
    print sep1
    print g.configtool.utilities.pylon.acquire
    print sep1
    print g.configtool.utilities.typo.wrap
    print g.XXXXXXXXXXXXXXXXXXXXXXXX
    print __builtin__.__dict__[ 'g' ]


