#
# -*- coding: utf-8 -*-

'''A simple debugging class used in web apps like querytool or configtool.
'''

############################################################################################################
#
#   IMPORTS
#
#===========================================================================================================

import string
from types import TupleType, DictType, UnicodeType
from biocase.tools.htmltools  import escapeHtml, escapeBackslash


############################################################################################################
#
#   CLASSES
#
#===========================================================================================================
class DebugClass:
    def __init__(self):
        self.logs    = []
        self.display = False
        self.escapeHtml      = True
        self.escapeBackslash = True
        self.debuglevel = 1
        
    def __add__(self, x):
        if type(x) == TupleType:
            self.logs.append(x[1])
        elif type(x) ==DictType and x.has_key('msg'):
            self.logs.append(x['msg'])
        else:
            self.logs.append(x)
    def __getitem__(self, x):
        return self.logs[x]
    
    def __repr__(self):
        return self.__unicode__().encode('utf-8')
  
    def __unicode__(self):
        logs = []
        for log in self.logs:
            # change to unicode string
            if type(log) is not UnicodeType:
                try:
                    log = unicode(log, errors='replace')
                except:
                    try:
                        log = unicode( str(log) )
                    except:
                        log = u'COULDNT TRANSFORM LOG ENTRY INTO UNICODE STRING'
            # escape html?
            if self.escapeHtml:
                log = escapeHtml(log)
            if self.escapeBackslash:
                log = escapeBackslash(log)
            logs.append(log)
        return string.join(logs, "\n")
  
    def logPassedTime(self, msg):
        pass
    def setSourcename(self, dsa):
        pass

############################################################################################################
#
#   GENERAL FUNCTIONS
#
#===========================================================================================================
    
    