#
# -*- coding: utf-8 -*-

'''Reusable libxml2 toos. 
'''

############################################################################################################
#
#   IMPORTS
#
#===========================================================================================================

import libxml2, libxslt
import logging
log = logging.getLogger("biocase.tools")

############################################################################################################
#
#   GENERAL FUNCTIONS
#
#===========================================================================================================

def transformXML(docDOM, xslLoc, paras={}):
    stylesheetResult = 'XSLT NOT WORKING !!!'
    # apply stylesheet
    log.info("PARSE STYLESHEET %s"%xslLoc)
    try:
        styledoc = libxml2.parseFile( xslLoc )
        style = libxslt.parseStylesheetDoc(styledoc)
    except:
        log.exception("ERROR: Stylesheet could not be parsed")
        stylesheetResult = 'XSLT NOT WORKING !!! Stylesheet could not be parsed.'
        return stylesheetResult
        
    log.info("APPLY STYLESHEET")
    xsltParas = {}
    for p,val in paras.items():
        xsltParas[p] = "'%s'"%str(val)
    log.info("STYLESHEET PARAMETERS: %s" % (unicode(xsltParas)))
    # Hack, for some reason this does not work
    try:
        result = style.applyStylesheet(docDOM, xsltParas)
        stylesheetResult = style.saveResultToString(result)
        log.info("  OK")
        result.freeDoc()
    except:
        log.exception("ERROR when applying the stylesheet")
        stylesheetResult = 'XSLT NOT WORKING !!! Error when applying the stylesheet.'
    
    styledoc.freeDoc()
    return stylesheetResult
    

    
