# -*- coding: utf8 -*-
'''
DB MODULE - Firebird
*******************************
***  DB MODULE - Firebird
*******************************
$RCSfile: dbmod_firebird.py,v $
$Revision: 354 $
$Author: markus $
$Date: 2005-10-12 14:54:21 +0200 (Wed, 12 Oct 2005) $

The biocase.wrapper database module to access Firebird/Interbase databases.
You will need the kinterbasdb python module to run this dbmodule.
'''


import os
from string                                import join
from types								import *
from biocase.wrapper.errorclasses         import *
from biocase.wrapper.dbmod.base_dbmod   import DBBasemodule
from biocase.wrapper.sql.base			import sqlBase

from mx.DateTime import now, ISO
_DateTime = now()

# no alias tag
sqlBase.templates['alias'] = '#1  #2'

# limit is like this: ROWS $offset TO $last
sqlBase.templates['select-limit'] = 'SELECT FIRST #3 DISTINCT #1 FROM #2'
#sqlBase.templates['select-limit'] = None

# ---------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------
class DBmodule(DBBasemodule):
    __version__ = '0.21 using kinterbasedb ?'
    __dbmod__    = u'Firebird module'
    
    # _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
    def __init__(self, psfObj, logObj):
        # init the inherited class 
        # setting the logObj and psfObj references to self.logObj and self.psfObj
        # call createDBconnection method
        DBBasemodule.__init__(self, psfObj, logObj)

        # read DB 8bit encoding
        self.logObj+(2,"8bit DB Encoding: %s"%(psfObj.encoding))
        self.conn.encoding = psfObj.encoding

    # _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
    def createDBconnection(self):
        try:
            import kinterbasdb
        except:
            raise DbModuleMissingError('kinterbasdb', log=self.logObj)
        self.__class__.__version__ = self.__class__.__version__[:-1]+ join([str(x) for x in kinterbasdb.__version__], ".")
        #
        # connect
        #
        try:
            if len(self.psfObj.password) > 0:
            	return kinterbasdb.connect(host=str(self.psfObj.dbIP), user=str(self.psfObj.user), database=str(self.psfObj.datasource), password=str(self.psfObj.password) )
            else:
            	return kinterbasdb.connect(host=str(self.psfObj.dbIP), user=str(self.psfObj.user), database=str(self.psfObj.datasource) )
        except:
            self.logObj + "Connection parameters used: Host=%s (type=%s), DB=%s (type=%s), User=%s (type=%s), Passwd=%s (type=%s)" % (self.psfObj.dbIP, str(type(self.psfObj.dbIP)), self.psfObj.datasource, str(type(self.psfObj.datasource)), self.psfObj.user, str(type(self.psfObj.user)) ,self.psfObj.password, str(type(self.psfObj.password)) )
            raise ConnectionError()

    
    def execSQL(self, sql, paras=None):
    	if paras is not None:
    		# only allow strings as parameters
    		p_tmp = []
    		for p in paras:
    			if type(p)==UnicodeType:
    				p = p.encode(self.conn.encoding)
	    		p_tmp.append( p )
   			paras=p_tmp
  		# call base method
    	return DBBasemodule.execSQL(self, sql, paras)
    
