# -*- coding: utf8 -*-
'''DB MODULE - PSYCO-POSTGRESQL
*******************************
***  DB MODULE - PSYCO-POSTGRESQL
*******************************
$RCSfile: dbmod_psycopg.py,v $
$Revision: 354 $
$Author: markus $
$Date: 2005-10-12 14:54:21 +0200 (Wed, 12 Oct 2005) $

The biocase.wrapper database module to access PostgreSQL databases.
You will need the psycopg module to connect to a PostgreSQL DB.
'''

from string								import join
from biocase.wrapper.errorclasses 		import *
from biocase.wrapper.sql.base 			import sqlBase
from biocase.wrapper.dbmod.base_dbmod   import DBBasemodule



#############################################
#
# CUSTOMIZATION for PostgreSQL
#
# OVERLOAD BASE CLASSES AND OTHER METHODS
#
#############################################

# uses inherited ANSI SQL apart from the following.
sqlBase.templates['attribute'] = '"#1"."#2"'
sqlBase.templates['table'] = '"#1"'
sqlBase.binaryCOP['like'] = "ILIKE"
		

# ---------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------
class DBmodule(DBBasemodule):
	__version__ = '0.31 using psycopg ?'
	__dbmod__	= u'Psyco-PostgreSQL DB module'
	
	# _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
	def __init__(self, psfObj, logObj):
		# init the inherited class 
		# setting the logObj and psfObj references to self.logObj and self.psfObj
		# call createDBconnection method
		DBBasemodule.__init__(self, psfObj, logObj)
		# dont use parameters but integrate all parameters into SQL strings:
		self.trans.integrateParametersInSQLString()
		# set unicode encoding to true
		#c = self.conn.cursor()
		#c.execute("set client_encoding to %s" %(self.psfObj.encoding))
		#c = None


	# _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
	def createDBconnection(self):
		try:
			import psycopg
		except:
			raise DbModuleMissingError('psycopg', log=self.logObj)
		self.__class__.__version__ = self.__class__.__version__[:-1]+psycopg.__version__
		try:
			if len(self.psfObj.password) > 0:
				loginParas = "host=%s user=%s password=%s dbname=%s" % (self.psfObj.dbIP, self.psfObj.user, self.psfObj.password, self.psfObj.datasource )
				return psycopg.connect(loginParas)
			else:
				loginParas = "host=%s user=%s dbname=%s" % (self.psfObj.dbIP, self.psfObj.user, self.psfObj.datasource )
				return psycopg.connect(loginParas)
		except:
			raise ConnectionError()
			

	
