# -*- coding: utf8 -*-
'''
DIAGNOSTICS
**********************
***  DIAGNOSTICS
**********************
$RCSfile: diagnostics.py,v $
$Revision: 9 $
$Author: markus $
$Date: 2005-07-04 11:47:00 +0200 (Mon, 04 Jul 2005) $

Standardized infor and wrning messages
'''

#
# to pass parameters use the %s placeholder for strings or %i for integers
#

#
# EXAMPLE OF USAING IT IN THE CODE

# OLD CODE
# self.logObj + (2, "ERROR in %s transforming DBVal2XML of record %s"%(self.xpath, str(record)), 1)
# NEW CODE
# raiseDiagnostic(self.logObj, 'RSP_DATA_TRANSFORMATION_DB2XML_FAILED', (self.xpath, str(record)) )



# WARNING MESSAGES
# type= 0->debug,  1->info,  2->warn,  3->error,  4-> fatal
diagnostics = {
	# PARAMETERS used: 1=attribute name,  2=element name
	'RSP_ELEM_DROP':{'type':2, 'level':1, 'msg':'The mandatory attribute %s could not be created. The element %s was also dropped.' }

	# PARAMETERS used: 1=attribute name,  2=element name
	, 'RSP_DATA_TRANSFORMATION_DB2XML_FAILED':{'type':1, 'level':2, 'msg':"ERROR in %s transforming DBVal2XML of record %s" }
	
}



# ------------------------------------------------------------------------
def raiseDiagnostic(logObj, code, paras=()):
	paras = tuple(paras)
	if diagnostics.has_key(code):
		diagnostic = diagnostics[code]
		logObj + {'type':diagnostic['type'], 'level':diagnostic['level'], 'code':code, 'msg':diagnostic['msg']%paras }
	else:
		logObj + (1, "Unknown warning raised with CODE=%s, parameters=%s"%(code, str(paras)) )
	pass
		