# -*- coding: utf8 -*-
'''
SAX HANDLERS for PSF
######################
# SAX HANDLERS 
# for PSF
######################
$RCSfile: metadata_handler.py,v $
$Revision: 9 $
$Author: markus $
$Date: 2005-07-04 11:47:00 +0200 (Mon, 04 Jul 2005) $
'''


import os
import xml.sax.handler
from os.path							import join as pathjoin
from biocase.wrapper.errorclasses 		import *
from biocase.tools.various_functions 	import isTrue



		
		
# ------------------------------------------------------------------------------------
class DsaMetadataConfigHandler(xml.sax.handler.ContentHandler):
	'''parses the wrapper configuration file and fills a psf object with its data.'''

	# _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
	def __init__(self, debug, metadataObj):
		self.debug   = debug
		self.metaObj = metadataObj
		self._value  = ''
		xml.sax.handler.ContentHandler.__init__(self)
	
	# _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
	def startElement(self, name, attrs):
		self._value = ''
		if name == 'Logging':
			state = self.psfObj.logObj.__class__.loggingStates.get(attrs.get('state',None), None)
			if state <> None:
				self.psfObj.logObj.logstate = state
			rate = self.psfObj.logObj.__class__.loggingRates.get(attrs.get('rate',None), None)
			if rate <> None:
				self.psfObj.logObj.lograte = rate
			customLogdir = attrs.get('dir',None)
			if customLogdir <> None:
				self.psfObj.logObj.logdir  = customLogdir
				
				
	# _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
	def endElement(self, name):
		self._value = self._value.strip()
		if name == 'DebugLevel':
			try:
				newDebugLevel = int(self._value)
				self.psfObj.logObj.debuglevel = newDebugLevel 
			except:
				pass
		elif name == 'Webserver_IP':
			if self._value <> None and len(self._value) > 2:
				self.metaObj.IP = self._value
		elif name == 'RecordResultLimit':
			try:
				self.psfObj.recLimit = int(self._value)
				if self.psfObj.recLimit <= 0:
					self.psfObj.recLimit = 0
			except:
				pass
		elif name == 'PickleCMF':
			try:
				self.psfObj.pickleCMF = isTrue(self._value)
			except:
				pass
		self._value = ''
				
	# _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
	def characters(self, ch):
		self._value += ch


