# -*- coding: utf8 -*-
'''
R E Q U E S T - C L A S S
**********************************************
*	   R E Q U E S T - C L A S S
*	   base class for request parsers
**********************************************
$RCSfile: sp2k_response.py,v $
$Revision: 43 $
$Author: markus $
$Date: 2005-07-05 18:30:48 +0200 (Tue, 05 Jul 2005) $

Base class to generate a request object with the help of
a protocol specific request parser.
'''

import types
from xml.sax							import parse, parseString
from biocase.wrapper.protocol.base_request     import RequestBaseClass
from biocase.wrapper.protocol.base_response     import ResponseBaseClass
import xml.dom.minidom
import xml.dom.ext
from cgi								 import FieldStorage
from os.path							 import isfile
from os								 import environ
from biocase.wrapper.errorclasses		 import *
from biocase.wrapper.protocol.base_request	 import RequestBaseClass
from biocase.wrapper.sql.operators		import compressOperator
import biocase.wrapper
from biocase.wrapper.operations       import getOperationsObjectForDBMod
from biocase.wrapper.typeconverter    import DBtransformerClass
from biocase.wrapper.operations   import recordStatus
from mx.DateTime import now

    
    
# ------------------------------------------------------------------------------------
class ResponseClass(ResponseBaseClass):
    '''Response class implementing the species2000 protocol for responses.'''
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    def __init__(self, logObj):
        ResponseBaseClass.__init__(self, logObj)
        # status about paging, record count etc.
        # self.recordStatus = recordStatus()
		
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    def init(self):
        '''No doc to init.'''
        pass

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    def setSearchContent(self, xml, recStatus=None):
        self.type = "search"
        if xml is not None:
            self.content = xml
        elif self.requestObj.rtype == '1':
            self.content = self.doc.createElementNS(None, 'XMLRESPONSE')
            #<TYPE1RESULT NUMBER="0" />
            type1resultElem = self.doc.createElementNS(None, 'TYPE1RESULT')
            type1resultElem.setAttribute('NUMBER', '0')
            self.content.appendChild( type1resultElem )
        else:
            self.content = self.doc.createElementNS(None, 'XMLRESPONSE')
            self.logObj + "No content provided by search."
        self.recordStatus = recStatus

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    def getProtocolDocument(self, dbmod=None):
        # add metadata comments to output
        # add DBmod used:
        if dbmod is not None:
			comment = self.doc.createComment("Using pywrapper database module %s."%dbmod)
			self.doc.appendChild(comment)
        # add timestamp (2001-09-11T09:30:47-05:00)
        comment = self.doc.createComment("Send time: %s."% str(now()) )
        self.doc.appendChild(comment)
        # add processing duration
        comment = self.doc.createComment("Process time: %s."% str(self.logObj.getProcessingTime()) )
        self.doc.appendChild(comment)
        # add content
        if isinstance(self.content, xml.dom.minidom.Node):
            self.doc.appendChild(self.content)
        else:
            self.logObj + "No content provided by search."
        # add logging as HTML comments
        if self.logObj.debuglevel <> 0:
            comment = self.doc.createComment(" DEBUGGING for level %i :"%self.logObj.debuglevel)
            self.doc.appendChild(comment)
            logs = self.logObj.returnLogList()[1:]
            for (log_type, code, log) in logs:
                if log_type is not None:
                    comment = "TYPE=%s"%log_type
                if code is not None:
                    comment += " CODE=%s"%code
                if len(comment) > 0:
                    comment = "%s: "%comment
                comment = self.doc.createComment( " %s%s "%(comment, log ) )
                self.doc.appendChild(comment)
        else:
            comment = self.doc.createComment( " DEBUGGING turned off" )
            self.doc.appendChild(comment)
		#
		# return protocol document as DOM
		#
        return ResponseBaseClass.getProtocolDocument(self)
		
		

	
	




    