<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:xs="http://www.w3.org/2001/XMLSchema" 
xmlns:fn="http://www.w3.org/2004/07/xpath-functions" 
xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" 
xmlns:n1="http://www.biocase.org/schemas/protocol/1.3" 
exclude-result-prefixes="xsl xs fn xdt n1">
	<xsl:output version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes" media-type="text/html"/>
	<xsl:template match="/">
		<html>
			<link href="../resources/css/biocase.css" rel="stylesheet" type="text/css"></link>
			<body>
				<h3>Wrapper messages: </h3>
				<xsl:choose>
					<xsl:when test="count(n1:response/n1:diagnostics/n1:diagnostic[@severity='error'])">
						<h4>Errors: </h4>
						<h2><font color="red">There are errors</font></h2>
						<ul>
						<xsl:for-each select="n1:response/n1:diagnostics/n1:diagnostic">
							<xsl:choose>
								<xsl:when test="@severity ='error'">
									<li>
										<xsl:value-of select="."/>
									</li>
									<li>
										<xsl:value-of select="../n1:diagnostic[position()=last()]"/><br></br><br></br>
									</li>
								</xsl:when>
								<xsl:otherwise>
									<xsl:if test="@code">
										<ul><li><xsl:value-of select="."/></li></ul>
									</xsl:if>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						</ul>
					</xsl:when>
					<xsl:otherwise><h1><font color="green">No errors found!</font></h1></xsl:otherwise>
				</xsl:choose>
				<h4>Diagnostics:</h4>
				<ul>
					<xsl:for-each select="n1:response/n1:diagnostics/n1:diagnostic">
						<xsl:if test="@severity != 'error' and not(@code) ">
							<li>
								<xsl:value-of select="."/>
							</li>
						</xsl:if>
					</xsl:for-each>
				</ul>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>