<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:n1="http://www.tdwg.org/schemas/newprotocol/1.0/datasource" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2004/07/xpath-functions" xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes">
	<xsl:output version="1.0" encoding="UTF-8" indent="no" omit-xml-declaration="yes" media-type="text/html"/>
	<xsl:template match="/">
		<html>
			<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
			<head>
				<title/>
				<link href="resources/css/biocase.css" rel="stylesheet" type="text/css"/>
				<link rel="SHORTCUT ICON" href="resources/images/favicon.ico"/>
			</head>
			<body>
				<div id="header"> Datasource: <i>
					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<xsl:for-each select="n1:label">
								<xsl:apply-templates/>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
				
				<xsl:value-of select="$dsa"/>
				</i></div>
				<div id="NavBar">
					<a href="index.cgi">Start</a>
					<span class="breadcrumbSeparator"> &#187; </span>
					<strong>Datasource <i><xsl:value-of select="$dsa"/></i></strong>
				</div>
				<div id="content">
					<br/>
					<h3 class="background">Access point:</h3>
					<p>This is the wrapper URL needed to access your datasource service from outside.</p>
					<ul>
						<li><xsl:value-of select="$wrapper_url"/> </li>
					</ul>

					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<xsl:for-each select="n1:abstract">
								<xsl:apply-templates/>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<br/>
					<br/>
					<xsl:if test="n1:response/n1:metadata/n1:keywords">
					<span class="label">Keywords: </span>
					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<xsl:for-each select="n1:keywords">
								<xsl:apply-templates/>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<br/>
					<br/>
					</xsl:if>
					<xsl:if test="n1:response/n1:metadata/n1:citation">
					<span class="label">Citation: </span>
					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<xsl:for-each select="n1:citation">
								<xsl:apply-templates/>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<br/>
					<br/>
					</xsl:if>
					<xsl:if test="n1:response/n1:metadata/n1:right">
					<span class="label">Rights: </span>
					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<xsl:for-each select="n1:rights">
								<xsl:apply-templates/>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<br/>
					<br/>
					</xsl:if>
					<xsl:if test="n1:response/n1:metadata/n1:conceptualSchema">
					<span class="label">Conceptual schemas supported:</span>
					<br/>
					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<table>
								<tr>
									<th>Namespace</th>
									<th>Date last updated</th>
									<th>Number of records</th>
								</tr>
								<xsl:for-each select="n1:conceptualSchema">
									<tr>
										<td>
											<xsl:for-each select="@namespace">
												<xsl:value-of select="."/>
											</xsl:for-each>
										</td>
										<td>
											<xsl:for-each select="@dateLastUpdated">
												<xsl:value-of select="."/>
											</xsl:for-each>
										</td>
										<td>
											<xsl:for-each select="@numberOfRecords">
												<xsl:value-of select="."/>
											</xsl:for-each>
										</td>
									</tr>
								</xsl:for-each>
							</table>
						</xsl:for-each>
					</xsl:for-each>
					</xsl:if>
					<xsl:if test="n1:response/n1:metadata/n1:relatedEntities">
					<h3 class="background">Related entities:</h3>
					<xsl:for-each select="n1:response">
						<xsl:for-each select="n1:metadata">
							<xsl:for-each select="n1:relatedEntities">
								<xsl:for-each select="n1:entity">
									<xsl:for-each select="n1:logoURL">
										<img border="0" align="right">
											<xsl:attribute name="src"><xsl:value-of select="."/></xsl:attribute>
										</img>
									</xsl:for-each>
									<h3>
										<xsl:for-each select="n1:name">
											<xsl:apply-templates/>
										</xsl:for-each> (<xsl:for-each select="n1:acronym">
											<xsl:apply-templates/>
										</xsl:for-each>)
										</h3>
									<span class="label">Role: </span>
									<xsl:for-each select="n1:role">
										<xsl:apply-templates/>, 
                                        </xsl:for-each>
									<br/>
									<br/>
									<span class="label">Contacts:</span>
									<br/>
									<table>
										<tr>
											<th>Type</th>
											<th>Name</th>
											<th>Title</th>
											<th>email</th>
											<th>Phone</th>
										</tr>
										<xsl:for-each select="n1:contact">
											<tr>
												<td>
													<xsl:for-each select="@type">
														<xsl:value-of select="."/>
													</xsl:for-each>
												</td>
												<td>
													<xsl:for-each select="n1:name">
														<xsl:apply-templates/>
													</xsl:for-each>
												</td>
												<td>
													<xsl:for-each select="n1:title">
														<xsl:apply-templates/>
													</xsl:for-each>
												</td>
												<td>
													<xsl:for-each select="n1:email">
														<xsl:apply-templates/>
													</xsl:for-each>
												</td>
												<td>
													<xsl:for-each select="n1:phone">
														<xsl:apply-templates/>
													</xsl:for-each>
												</td>
											</tr>
										</xsl:for-each>
									</table>
									<br/>
									<span class="label">Description:</span>
									<br/>
									<xsl:for-each select="n1:description">
										<xsl:apply-templates/>
									</xsl:for-each>
									<hr size="1"/>
								</xsl:for-each>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					</xsl:if>
					<h3 class="background">Useful links:</h3>
					<ul>
						<li>
							<a>
								<xsl:attribute name="href">querytool/main.cgi?dsa=<xsl:value-of select="$dsa"/></xsl:attribute>QUERY 
							</a>
								this datasource with the QueryTool
						</li>
						<li>
							<a>
								<xsl:attribute name="href">configtool/datasource.cgi?dsa=<xsl:value-of select="$dsa"/></xsl:attribute>CONFIGURE 
							</a>
								this datasource with the graphical configtool
						</li>
						<li>
							<a>
								<xsl:attribute name="href">testingtool/index.cgi?dsa=<xsl:value-of select="$dsa"/></xsl:attribute>TEST
							</a>
								this datasource using the TestingService
						</li>
						<li>
							<a>
								<xsl:attribute name="href">utilities/queryforms/qf_manual.cgi?url=<xsl:value-of select="$wrapper_url"/></xsl:attribute>DEBUG
							</a>
								 this datasource using the manual query forms
						</li>
					</ul>
				</div>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
