-- DBTools Manager DBPGSQL - PostgreSQL Database Dump
--
CREATE DATABASE "biocase_training";
--\connect biocase_training

-- Dumping Schemas Information


-- Dumping User Type Information


-- Dumping Domains Information

CREATE DOMAIN "information_schema"."cardinal_number" integer;
CREATE DOMAIN "information_schema"."sql_identifier" varchar(0);
CREATE DOMAIN "information_schema"."character_data" varchar(0);
;

-- Dumping Sequences


-- Dumping Functions


--

-- Dumping Table: abcdmetadata
--
CREATE TABLE "public"."abcdmetadata" 
(
	"MetadataID" int8 NOT NULL DEFAULT 0,
	"DatasetGUID" varchar(50),
	"TechnicalContactName" varchar(50) NOT NULL,
	"TechnicalContactEmail" varchar(50),
	"TechnicalContactPhone" varchar(50) NOT NULL,
	"TechnicalContactAddress" varchar(255),
	"ContentContactName" varchar(50) NOT NULL,
	"ContentContactEmail" varchar(50),
	"ContentContactPhone" varchar(50),
	"ContentContactAddress" varchar(255),
	"OtherProviderUDDI" varchar(50),
	"DatasetTitle" varchar(50),
	"DatasetDetails" text,
	"DatasetCoverage" text,
	"DatasetURI" varchar(50),
	"DatasetIconURI" varchar(50),
	"DatasetVersionMajor" integer DEFAULT 0,
	"DatasetVersionMinor" integer DEFAULT 0,
	"DatasetCreators" text,
	"DatasetContributors" text,
	"DateCreated" timestamp,
	"DateModified" timestamp NOT NULL,
	"OwnerOrganizationName" varchar(255),
	"OwnerOrganizationAbbrev" varchar(50),
	"OwnerContactPerson" varchar(255) NOT NULL,
	"OwnerContactRole" varchar(50),
	"OwnerAddress" varchar(255),
	"OwnerTelephone" varchar(50),
	"OwnerEmail" varchar(50),
	"OwnerURI" varchar(50),
	"OwnerLogoURI" varchar(255),
	"IPRText" varchar(255),
	"IPRDetails" text,
	"IPRURI" varchar(255),
	"CopyrightText" varchar(255),
	"CopyrightDetails" text,
	"CopyrightURI" varchar(255),
	"TermsOfUseText" varchar(255),
	"TermsOfUseDetails" text,
	"TermsOfUseURI" varchar(255),
	"DisclaimersText" varchar(255),
	"DisclaimersDetails" text,
	"DisclaimersURI" varchar(255),
	"LicenseText" varchar(255),
	"LicensesDetails" text,
	"LicenseURI" varchar(255),
	"AcknowledgementsText" varchar(255),
	"AcknowledgementsDetails" text,
	"AcknowledgementsURI" varchar(255),
	"CitationsText" varchar(255),
	"CitationsDetails" text,
	"CitationsURI" varchar(255),
	"SourceInstitutionID" varchar(50) NOT NULL,
	"SourceID" varchar(50) NOT NULL,
	"RecordBasis" varchar(50),
	"KindOfUnit" varchar(50),
	"HigherTaxonRank" varchar(50),
	CONSTRAINT "IX_abcdmetadata_pkey" PRIMARY KEY ("MetadataID")
);
CREATE INDEX "DatasetGUID" ON abcdmetadata USING btree ("DatasetGUID");
CREATE INDEX "MetadataID" ON abcdmetadata USING btree ("MetadataID");
CREATE INDEX "SourceID" ON abcdmetadata USING btree ("SourceID");
CREATE INDEX "SourceInstitutionID" ON abcdmetadata USING btree ("SourceInstitutionID");

-- Dumping Data
INSERT INTO "public"."abcdmetadata" ("MetadataID", "DatasetGUID", "TechnicalContactName", "TechnicalContactEmail", "TechnicalContactPhone", "TechnicalContactAddress", "ContentContactName", "ContentContactEmail", "ContentContactPhone", "ContentContactAddress", "OtherProviderUDDI", "DatasetTitle", "DatasetDetails", "DatasetCoverage", "DatasetURI", "DatasetIconURI", "DatasetVersionMajor", "DatasetVersionMinor", "DatasetCreators", "DatasetContributors", "DateCreated", "DateModified", "OwnerOrganizationName", "OwnerOrganizationAbbrev", "OwnerContactPerson", "OwnerContactRole", "OwnerAddress", "OwnerTelephone", "OwnerEmail", "OwnerURI", "OwnerLogoURI", "IPRText", "IPRDetails", "IPRURI", "CopyrightText", "CopyrightDetails", "CopyrightURI", "TermsOfUseText", "TermsOfUseDetails", "TermsOfUseURI", "DisclaimersText", "DisclaimersDetails", "DisclaimersURI", "LicenseText", "LicensesDetails", "LicenseURI", "AcknowledgementsText", "AcknowledgementsDetails", "AcknowledgementsURI", "CitationsText", "CitationsDetails", "CitationsURI", "SourceInstitutionID", "SourceID", "RecordBasis", "KindOfUnit", "HigherTaxonRank") VALUES(1, NULL, 'Tomas A Edison', 't.edison@edison.org', '+ 55 555 555 555', 'Botanic Garden & Botanical Museum Berlin-Dahlem, Knigin-Luise-Str.6-8, 14191 Berlin, Germany', 'Charles Robert Darwin', 'c.darwin@darwin.org', '+ 55 555 555 555', 'Botanic Garden & Botanical Museum Berlin-Dahlem, Knigin-Luise-Str.6-8, 14191 Berlin, Germany', NULL, 'Training Algae Database for BPS2', 'This database is only a demonstrating database for learning to use the BioCASe Provider Software. Please do not use this data for anything.', 'This database is testing data and does not cover anything.', 'http://www.biocase.org', 'http://www.biocase.org/images/bdi_logo.gif', 2, 0, 'Javier de la Torre, Markus Dring', 'CedocBiv BCN', '2005-03-17 00:00:00', '2005-03-17 00:00:00', 'BioCASE', 'BIOCASE', 'Charles Robert Darwin', 'Director', 'Botanic Garden & Botanical Museum Berlin-Dahlem, Knigin-Luise-Str.6-8, 14191 Berlin, Germany', '+ 55 555 555 555', 'c.darwin@darwin.org', 'http://www.darwin.org', 'http://www.biocase.org/images/bdi_logo.gif', 'IPR Text to be completed', NULL, 'http://www.bgbm.org/disclaim_e.htm', 'Copyright text', NULL, NULL, 'This is a testing database anythign can be done', NULL, NULL, 'Do not use this data for anything. Is only testing data for demosntration purpose only', NULL, NULL, 'General Public License', NULL, 'http://www.gnu.org/copyleft/gpl.html', 'Our families and friends for their support :D', NULL, NULL, 'BioCASE database', NULL, NULL, 'BIOCASE', 'BioCASE training Facilities', 'PreservedSpecimen', 'wholeorganisms', 'familia');
-- Dumping COLUMNS COMMENT



-- Dumping Table Triggers


--

-- Dumping Table: collectors
--
CREATE TABLE "public"."collectors" 
(
	"ID" int8 NOT NULL,
	"UnitID" int8,
	"AgentText" varchar(255),
	"PrimaryCollectorFlag" int8,
	CONSTRAINT "IX_collectors_pkey" PRIMARY KEY ("ID"),
	CONSTRAINT "FK_biocase_training_herbariumsheets_collectors" FOREIGN KEY ("UnitID") REFERENCES "collectors" ("UnitID")
);
CREATE INDEX "HerbariumSheetsCollectors" ON collectors USING btree ("UnitID");
CREATE INDEX "ID" ON collectors USING btree ("ID");
CREATE INDEX "UnitID" ON collectors USING btree ("UnitID");

-- Dumping Data
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174105, 39, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174106, 368, 'Vivant, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174107, 395, 'Follmann-Schrag, I.-A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174108, 395, 'Follmann, G.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174109, 421, 'Follmann-Schrag, I.-A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174110, 421, 'Follmann, G.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174111, 425, 'Follmann-Schrag, I.-A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174112, 425, 'Follmann, G.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174113, 435, 'Follmann, G.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174114, 447, 'Follmann', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174115, 607, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174116, 610, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174117, 611, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174118, 612, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174119, 620, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174120, 620, 'Morales, C.G.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174121, 621, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174122, 621, 'Morales, C.G.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174123, 879, 'Zollinger, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174124, 1025, 'Hosseus, C.C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174125, 1298, 'Coppins, B.J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174126, 1298, 'Sheard, J.W.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174127, 1352, 'Hale, M.E.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174128, 1379, 'Skytte Christiansen, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174129, 1433, 'Sojk, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174130, 1436, 'Lambinon, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174131, 1447, 'Vezda, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174132, 1449, 'Degener, O.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174133, 1449, 'Degener, I.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174134, 1454, 'Poelt, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174135, 1454, 'Vezda, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174136, 1478, 'James, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174137, 1478, 'Coppins, B.J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174138, 1508, 'Degener, O.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174139, 1508, 'Degener, I.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174140, 1509, 'Degener, O.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174141, 1509, 'Degener, I.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174142, 1516, 'Culberson, W. L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174143, 1516, 'Culberson, C. F.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174144, 1594, 'Poelt, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174145, 1594, 'Scheidegger, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174146, 1644, 'Vezda, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174147, 1692, 'Degener, O.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174148, 1692, 'Degener, I.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174149, 1723, 'Rundel, P.W.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174150, 1749, 'Mahu, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174151, 1762, 'Follmann, G.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174152, 1776, 'Follmann, G.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174153, 1776, 'Snchez-Pinto, L.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174154, 1982, 'Muhr, L.-E.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174155, 1982, 'Coppins, B.J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174156, 1993, 'Kalb, K.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174157, 1993, 'Poelt, J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174158, 2005, 'Tnsberg, T.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174159, 2006, 'Poelt, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174160, 2006, 'Vezda, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174161, 2037, 'Crespo, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174162, 2037, 'Vezda, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174163, 2152, 'Vezda, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174164, 2230, 'Farkas, E.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174165, 2340, 'Hladun, N.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174166, 2422, 'Tibell, L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174167, 2424, 'Tibell, L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174168, 2445, 'Tibell, L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174169, 2454, 'Hafellner, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174170, 2454, 'Merotsy, P,', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174171, 2454, 'Rogers, R.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174172, 2819, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174173, 3200, 'Hedberg, Olov', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174174, 3200, 'Knox, D.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174175, 3707, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174176, 3963, 'Hladun, N.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174177, 3963, 'Llimona, X.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174178, 3963, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174179, 3965, 'Hladun, N.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174180, 3965, 'Llimona, X.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174181, 3965, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174182, 3966, 'Hladun, N.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174183, 3966, 'Llimona, X.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174184, 3966, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174185, 4063, 'Culberson, William L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174186, 4063, 'Culberson, Chicita F.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174187, 4067, 'Farkas, E.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174188, 4067, 'Lks, L.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174189, 4120, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174190, 4331, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174191, 4332, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174192, 4427, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174193, 4427, 'Gmez, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174194, 4427, 'Navarro, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174195, 4488, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174196, 4616, 'Nimis, P.L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174197, 4616, 'Tretiach, M.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174198, 4616, 'Poelt, J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174199, 4616, 'Vezda, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174200, 4655, 'Kalb, K.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174201, 4657, 'Kalb, K.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174202, 4657, 'Poelt, J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174203, 4657, 'Sipman, H.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174204, 4658, 'Hafellner, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174205, 4658, 'Rogers, R.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174206, 4658, 'Merrotsy, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174207, 4659, 'Farkas, E.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174208, 4659, 'Pcs, T.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174209, 4664, 'Codogno, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174210, 4664, 'Tretiach, M.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174211, 4664, 'Poelt, J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174212, 4664, 'Vezda, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174213, 5039, 'Thor, G.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174214, 5041, 'Osorio, H.S.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174215, 5053, 'Nimis, P.L.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174216, 5053, 'Poelt, J.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174217, 5121, 'Vezda, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174218, 5224, 'Boqueras, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174219, 5224, 'Hladun, N.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174220, 5224, 'Diederich, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174221, 5224, 'Prez, J. M.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174222, 5224, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174223, 5224, 'Pereira, I.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174224, 5224, 'Rico, V.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174225, 5224, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174226, 5264, 'Kantvilas, G.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174227, 5264, 'Mayrhofer, H.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174228, 5264, 'Vezda, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174229, 5287, 'Trk, R.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174230, 5287, 'Wunder, H.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174231, 5326, 'Farkas, E.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174232, 5328, 'Kalb, K.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174233, 5329, 'Poelt, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174234, 5329, 'Pittoni, H.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174235, 5561, 'Barbero, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174236, 5704, 'Hladun, N.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174237, 5704, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174238, 5705, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174239, 5705, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174240, 5705, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174241, 5707, 'Gmez-Bolea, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174242, 5707, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174243, 5740, 'Etayo, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174244, 5741, 'Obermayer, W.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174245, 8200, 'Hladun, N.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174246, 8200, 'Llimona, X.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174247, 8200, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174248, 8284, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174249, 8284, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174250, 8284, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174251, 8381, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174252, 8381, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174253, 8382, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174254, 8382, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174255, 8383, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174256, 8383, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174257, 8384, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174258, 8384, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174259, 8385, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174260, 8385, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174261, 8391, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174262, 8394, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174263, 8398, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174264, 8399, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174265, 8399, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174266, 8962, 'Etayo, J.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174267, 9032, 'Boom, P. v. d.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174268, 9309, 'Llimona, X.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174269, 9309, 'Hladun, N.L.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174270, 9309, 'Ballesteros, E.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174271, 9736, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174272, 9736, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174273, 9736, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174274, 10385, 'Boom, P. v. d.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174275, 10768, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174276, 10768, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174277, 10768, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174278, 13209, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174279, 13210, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174280, 13211, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174281, 13213, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174282, 13215, 'Boqueras, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174283, 13215, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174284, 13215, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174285, 13217, 'Clauzade, G.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174286, 13217, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174287, 13217, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174288, 13217, 'et al.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174289, 13219, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174290, 13219, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174291, 13219, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174292, 13236, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174293, 13236, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174294, 13237, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174295, 13237, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174296, 13238, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174297, 13238, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174298, 13239, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174299, 13239, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174300, 13239, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174301, 13240, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174302, 13240, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174303, 13240, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174304, 13262, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174305, 13262, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174306, 13263, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174307, 13263, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174308, 13264, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174309, 13264, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174310, 13265, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174311, 13265, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174312, 13266, 'Roux, C.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174313, 13266, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174314, 13374, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174315, 13374, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174316, 13374, 'Giralt, M.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174317, 13375, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174318, 13375, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174319, 13375, 'Giralt, M.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174320, 13384, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174321, 13384, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174322, 13386, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174323, 13386, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174324, 13387, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174325, 13387, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174326, 13388, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174327, 13388, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174328, 13389, 'Navarro-Rosins, P.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174329, 13389, 'Roux, C.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174330, 13421, 'Giralt, M.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174331, 13421, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174332, 13421, 'Navarro-Rosins, P.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174333, 13747, 'Longn, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174334, 13747, 'Gmez-Bolea, A.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174335, 14133, 'Crespo, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174336, 14133, 'Divakar, P.K.', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174337, 14202, 'Vezda, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174338, 14203, 'Vezda, A.', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174339, 14204, 'A.Gntsch', 1);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174340, 14204, 'J.Torre', 0);
INSERT INTO "public"."collectors" ("ID", "UnitID", "AgentText", "PrimaryCollectorFlag") VALUES(174341, 14204, 'M.Dring', 0);
-- Dumping COLUMNS COMMENT



-- Dumping Table Triggers


--

-- Dumping Table: herbariumsheets
--
CREATE TABLE "public"."herbariumsheets" 
(
	"UnitID" int8 NOT NULL,
	"TypeStatus" varchar(30),
	"ProjectTitle" varchar(150),
	"BiotopeText" varchar(255),
	"DateText" varchar(50),
	"ISODateTimeBegin" timestamp,
	"LocalityText" varchar(255),
	"CountryName" varchar(255),
	"Notes" varchar(255),
	"AltitudeLowerValue" int8 DEFAULT 0,
	"AltitudeUpperValue" int8 DEFAULT 0,
	"LongitudeDecimal" int8 DEFAULT 0,
	"LatitudeDecimal" int8 DEFAULT 0,
	"MetadataID" int8,
	CONSTRAINT "IX_herbariumsheets_pkey" PRIMARY KEY ("UnitID"),
	CONSTRAINT "FK_biocase_training_abcdmetadata_herbariumsheets" FOREIGN KEY ("MetadataID") REFERENCES "herbariumsheets" ("MetadataID")
);
CREATE INDEX "ABCDmetadataHerbariumSheets" ON herbariumsheets USING btree ("MetadataID");
CREATE INDEX source_id ON herbariumsheets USING btree ("MetadataID");

-- Dumping Data
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(39, 'holotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad gypsum compactm locis septentr. vel occident. spectantibus, 30 - 60 inclinatis', NULL, '2005-03-17 17:02:17', 'HISPANIA. Las Bardenas.Caparroso', 'Spain', NULL, 400, NULL, 1, 1, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(368, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem Fraxini excelsioris', NULL, '2005-03-17 17:02:17', 'GALLIA. Montes Pyrenaei occident. St-Just-Ibarre, in valle fluvii Bidouze', 'Spain', NULL, 700, NULL, 2, 2, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(395, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'gesellig auf Erosionsrippen (Granodiorittuff) , auch  ber Kakteenresten im Ramalinetum inanis. S-W, pH 6.9', NULL, '2005-03-17 17:02:17', 'Nordchile, Prov. Antofagasta: Nebeloase Cerro Moreno bei Antofagasta', 'Spain', NULL, 600, NULL, 3, 3, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(421, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'zerteut im Dornenwerk von Sulenkakteen im Tornabenietum intricate. NW-SW, pH 6,6.', NULL, '2005-03-17 17:02:17', 'Nordchile, Prov Antofagasta: Stammsukkuletengrtel des Nebeloase Cerro Moreno auf der Halbinsel Mejillones bei Antofagasta', 'Spain', NULL, 450, NULL, 4, 4, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(425, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'zerstreut im Dornenwerk von Sulenkakteen im Tornabenietum intricatae,  SW, pH 6.5', NULL, '2005-03-17 17:02:17', 'Nordchile, prov. Antofagasta: Stammsukulentengrtel der Nebeloase Cerro Moreno auf der Halbinsel Mejillones bei Antofagasta', 'Spain', NULL, 500, NULL, 5, 5, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(435, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'Kolonienbildend an Stirnflchen und berhngen von Diorithckern im Roccelletum portentosae. SW, pH 6,5.', NULL, '2005-03-17 17:02:17', 'Nordchile, Prov. Antofagasta: Nebelzone am Cerro Moreno, Halbinsel Mejillones unweit Antofagasta', 'Spain', NULL, 500, NULL, 6, 6, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(447, 'isotipus', 'Museum Botanicum Berolinense - Lichenes Chilenses', NULL, NULL, '2005-03-17 17:02:17', 'Cerro Moreno, Eulychnia (  Prov Antofagasta)', 'Spain', NULL, 600, NULL, 7, 7, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(607, 'holotipus', NULL, 'Sobre sol margs ms o menys guixs i sal, poc inslinat al N, molt solellat. Abundant', NULL, '2005-03-17 17:02:17', 'Pechina ( Almeria). Rera campament', 'Spain', NULL, NULL, NULL, 8, 8, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(610, 'holotipus', NULL, 'parasit de Diploschistes steppicus, sobre crosta guixosa solellada', NULL, '2005-03-17 17:02:17', 'Barbastro, a l\' Oest de El Pueyo', 'Spain', NULL, 400, NULL, 9, 9, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(611, 'holotipus', NULL, 'crosta guixosa. Acar. placod-reag. teloschistetosum.', NULL, '2005-03-17 17:02:17', 'Venta de os Yesos ( Almeria)', 'Spain', NULL, NULL, NULL, 10, 10, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(612, 'holotipus', NULL, 'Crosta guixosa solellada', NULL, '2005-03-17 17:02:17', 'Venta de los Yesos ( Almeria)', 'Spain', NULL, NULL, NULL, 11, 11, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(620, 'isotipus', NULL, 'Sobre lava asolellada, abundant, en poblaci gairab monoespecfica', NULL, '2005-03-17 17:02:17', 'Cam de  Vela Blanca. Sierra de Gata.', 'Spain', NULL, 60, NULL, 12, 12, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(621, 'isotipus', NULL, 'Sobre lava solellada, abundant, en poblaci gairab monoespecfica.', NULL, '2005-03-17 17:02:17', 'Cam de Vela Blanca. Sierra de Gata', 'Spain', NULL, 60, NULL, 13, 13, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(879, 'isotipus', 'Lichenotheca parva - Edita a Sect. Bot. Mus. Hist.-nat. Hung. 1969', 'ad arbores', NULL, '2005-03-17 17:02:17', 'Java -  Mt. Rantie', 'Spain', NULL, 650, NULL, 14, 14, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1025, 'sintipus', 'Lichenes exsiccati - Editi a Sect. Bot. Mus. Hist.-nat. Hung. 1969', 'ad saxa', NULL, '2005-03-17 17:02:17', 'Argentina -  Sierra Chica de Cordoba.', 'Spain', NULL, 1280, NULL, 15, 15, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1298, 'topotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Saxicola', NULL, '2005-03-17 17:02:17', 'MAGNA BRITANIA. Caledonia: Edinburgum, Braid Hills', 'Spain', NULL, 150, NULL, 16, 16, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1352, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad saxa in vicinitate fluminis', NULL, '2005-03-17 17:02:17', 'INDIA. Tmail Nadu: Silver Cascade, Kodaikanal, Plani Hills', 'INDIA.', NULL, 1800, NULL, 17, 17, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1379, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'in apothecis Lecanorae conizaeoides', NULL, '2005-03-17 17:02:17', 'DANIA. Sjaellandia: Herstedvester.', 'Spain', NULL, NULL, NULL, 18, 18, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1433, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad lapides calcareos locis apricis', NULL, '2005-03-17 17:02:17', 'PERSIA australis. Bandar Lengeh, in collibus ad septentriones-orientem versus ab urbe Bandar Lengeh.', 'PERSIA', NULL, NULL, NULL, 19, 19, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1436, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem et lignum truncorum vetustorum Senecionis johnstonii ssp refractisquamati', NULL, '2005-03-17 17:02:17', 'ZAIRE. Prov. Kivu, Birunga montes, in planitie Rukumi montis ignivomi Karisimbi', 'ZAIRE', NULL, 3500, NULL, 20, 20, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1447, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad scopulos andesiticos\r\nAd scopulos andesiticos', NULL, '2005-03-17 17:02:17', 'BULGARIA. Distr. Burgas, in litore Euxini Ponti 5 km ad meridiem versus ab oppido Solopol', 'BULGARIA', NULL, 3, 10, 21, 21, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1449, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem Leucaenae sp. ( cult)', NULL, '2005-03-17 17:02:17', 'HAWAII INSULAE. Oahu. Keawaula Vally, in litore', 'U.S.A.', NULL, NULL, NULL, 22, 22, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1454, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'In thallo Physciae sciastrae parasitice vigens, in rupibus conglomeraticis', NULL, '2005-03-17 17:02:17', 'BOHEMOSLOVACIA. Moravia austro-occidentalis, in valle fluminis Rokytn supra urbem Moravsk Krumlov', 'Spain', NULL, 280, NULL, 23, 23, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1478, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'in thallo Pertusariae leucoplacae vigens, ad corticem Coryli', NULL, '2005-03-17 17:02:17', 'MAGNA BRITANIA. Caledonia. Mid-Perthshire, Aberfeldy, Glen Lyon, prope Woodend', 'ENGLAND', NULL, NULL, NULL, 24, 24, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1508, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad coticem arboria ( Ficus sp. cult.)', NULL, '2005-03-17 17:02:17', 'HAWAII INSULAE. Insula Oahu, Kuakonahua Gulch prope territorium Universitatis', 'U.S.A.', NULL, 210, NULL, 25, 25, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1509, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad coticem arboria ( Semanea seman cult.)', NULL, '2005-03-17 17:02:17', 'HAWAII INSULAE. Kilea, Kau', 'U.S.A.', NULL, 110, NULL, 26, 26, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1516, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'ad saxa in silva', NULL, '2005-03-17 17:02:17', 'U.S.A. Arkansas. Polk County: 5 km ad septentriones vesrus a Mena, in loco dicto Blue Haze Vista prope viam dictam Talimena Skyline Drive.', 'U.S.A.', NULL, NULL, NULL, 27, 27, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1594, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad lignum putridum et supra muscos.', NULL, '2005-03-17 17:02:17', 'AUSTRIA: Salisburgia, Lungau in alpibus \"Schladminger Tauern\" dictis, in valle dicta Weisspriachtal, inter Khbarnhtte et Khbarnalm.', 'AUSTRIA', NULL, 1450, NULL, 28, 28, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1644, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad folia Buxi Colchicae', NULL, '2005-03-17 17:02:17', 'U.R.R.S. Rossia merd., Colchis ( Transcaucasia occid.), distr. Lazarevskoje: in faucibus rivi Dagomys Zapadnyi, supra vicum Tretja Rota', 'U.R.R.S.', NULL, 250, NULL, 29, 29, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1692, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'klienflchig auf verhltnismssig glatten Borkenschollen der mittleren Stammpartien einzelner Laubbume ( Samanea saman) , in einer artenarmen Kleinkrustengesellschaft der Arthonietalia radiatae, SO, pH 6,6', NULL, '2005-03-17 17:02:17', 'Hawaii-inseln, Hawaii: trockene Felsenheide( Kau Desert) am Sdabfall des Kilauea an der sdstlichen Inselabdachung', 'Spain', NULL, 110, NULL, 30, 30, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1723, 'topotipus', NULL, 'tuffbildend auf lichtoffenen, seewindbestrichenen luftfeuchten Birmskiesschtten un Lavarippen verschidenen,  Neigungsgrades im Desmazierietum josecuervoi. NW-SW, pH 7,2', NULL, '2005-03-17 17:02:17', 'Westmexiko, Niederkalifornien: Westhang der Colina del Sudoeste in der Baha de San Quintn', 'Spain', NULL, 30, 90, 31, 31, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1749, 'topotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'kolonienbildend an halbschttigen luftoffenen Borkenpartien des Mittelstammteils lterer Blaufieberbume im Graphidetum immersae. 50 m, SO-SW', NULL, '2005-03-17 17:02:17', 'Mittelchile, Prov Valparaso: lychter Eukalyptushain auf den Kstenhhen ber dem Balneario El Quisco', 'Spain', NULL, 50, NULL, 32, 32, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1762, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'flchenfllend an seewindbestrichenen halbschattigen Borkenschollen der mittleren Stammpartien lterer Nadelbume im Graphidetum immersae, pH 6,1', NULL, '2005-03-17 17:02:17', 'Mittelchile, Prov Aconcagua: Kiefernplanzung im Windschatten der Isla Seca in der Bucht von Zapallar', 'Spain', NULL, 20, NULL, 33, 33, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1776, 'isotipus', 'G. Follmann: Lichenes Exsiccati Selecti a Museo Botanico Berolinensi editi', 'vogelnestartig im halbschattigen Unterkronenteil solitrer Nadelbume auf jungen Lavastrmen im Ramalinetum subgeniculatae. NO-NW,  pH 6.5', NULL, '2005-03-17 17:02:17', 'Kanarische Inseln, Tenerife: Kiefernkampzone im unterem Nebelgrtel bei San Jun del Reparo am nordwestlichen Inselabfall', 'Spain', NULL, 800, NULL, 34, 34, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1982, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Loco aperto ad truncum decorticatum supra rivum', NULL, '2005-03-17 17:02:17', 'SUECIA. Vermlandia, par. Lungsund, Punbcken', 'SUECIA', NULL, 170, NULL, 35, 35, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(1993, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad terram et pantas destructas in fossis viae in silva montana', NULL, '2005-03-17 17:02:17', 'BRASILIA.So Paulo, Ihla de So Sebastio, 130 km ad oriemtem versus So paulo, ad latera orientalia montis Morro das Tacas', 'BRASIL', NULL, 500, NULL, 36, 36, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2005, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad basin abscisam arboris ( Picea abies)', NULL, '2005-03-17 17:02:17', 'NORVEGIA . Sor-Trondelag, Melhus, inter montem Loasen et rivulum Loa, 300-400 m ad septentriones et orientem versus lacu Benna', 'NORVEGIA', 'TLC: barbatic acid and 4-0-demethylbarbati acid', 185, 200, 37, 37, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2006, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad saxa sxhistosa, in thallo Lecanorae rupicolae, coll. parasitice vigens', NULL, '2005-03-17 17:02:17', 'HISPANIA. Catalonia, montes Montseny, Matagalls', 'Spain', NULL, 1500, NULL, 38, 38, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2037, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem Juniperi thuriferae, in Junipereto thuriferae soluto', NULL, '2005-03-17 17:02:17', 'HISPANIA. Prov. Soria, prope vicum Judes, Paramera', 'Spain', NULL, 1250, NULL, 39, 39, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2152, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad saxa quartzictica', NULL, '2005-03-17 17:02:17', 'JUGOSLAVIA.Montenegro. Sinus Kotor dictus, supra pagum Morin', 'JUGOSLAVIA', NULL, 50, NULL, 40, 40, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2230, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Foliicola in pluviisilva', NULL, '2005-03-17 17:02:17', 'TANZANIA. Tanga regio. Usambara Orientalis, reservatum naturae Kihuhwi Forest dictum, secus trametem inter Kihuhwi et Kwamkoro', 'TANZANIA', NULL, 220, 320, 41, 41, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2340, 'tipus', NULL, 'en la umbra sobre paredes verticales de roca metamorfica, orientada al N  y protegida de la lluvvia', NULL, '2005-03-17 17:02:17', 'Puig de Sa Carbassa', 'Spain', NULL, 1600, NULL, 42, 42, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2422, 'isotipus', 'L. Tibell: Caliciales Exsiccatae', 'on decorticates , dead but still standing trunk of Eucaliptus sp', NULL, '2005-03-17 17:02:17', 'AUSTRALIA. Tasmania: Ben Lomond National Park, 32 km E of Evensdale, along Ben Lomond Road, 1 KMNW of Carr Villa', 'AUSTRALIA', NULL, 1080, NULL, 147, 41, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2424, 'isotipus', 'L. Tibell: Caliciales Exsiccatae', 'On Bark of roadside fence-post.', NULL, '2005-03-17 17:02:17', 'COSTA RICA. Puntarenas: on old Camino Real, 3,5 km SE of Paso Real', 'Spain', NULL, 200, NULL, 83, 9, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2445, 'isotipus', 'L. Tibell: Caliciales Exsiccatae', 'On trunk of Cocos nucifera at the sea-shore', NULL, '2005-03-17 17:02:17', 'COSTA RICA. Limon: 1 km NW of Pto. Limn', 'COSTA RICA', NULL, 5, NULL, 83, 10, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2454, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Foliicola in pluviisilva', NULL, '2005-03-17 17:02:17', 'AUSTRALIA. New South Wales: Border Ranges National Park, Wiangaree, Brindle Creek', 'AUSTRALIA', NULL, 850, NULL, 2, 4, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(2819, 'tipus', NULL, 'Sl calcari ms o menys guixs, poc inclinat N solellat', NULL, '2005-03-17 17:02:17', 'ESPANYA, Almeria: Pechina', 'Spain', NULL, NULL, NULL, 2, 5, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(3200, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad terram glacie destructam, in regione alpina', NULL, '2005-03-17 17:02:17', 'KENYA. Regio montis Kenya, in parte superiore vallis Teleki', 'KENYA', NULL, 4200, NULL, 3, 6, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(3707, 'tipus', NULL, 'sobre Quercus ilex', NULL, '2005-03-17 17:02:17', 'ESPANYA , Catlunya, Tarragons, Mas d\'en Casico', 'Spain', NULL, 40, NULL, 4, 7, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(3963, 'holotipus', NULL, 'roques carbonatades del litoral, orient N, parsita de Caloplaca marina', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Tarragons, Vilaseca i Salou, Punta del Rac ( Cap de Salou)', 'Spain', NULL, 3, 10, 5, 8, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(3965, 'isotipus', NULL, 'roques carbonatades del litoral, orient N, parsita de Caloplaca marina', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Tarragons, Vilaseca i Salou, Punta del Rac ( Cap de Salou)', 'Spain', NULL, 3, 10, 6, 9, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(3966, 'isotipus', NULL, 'roques carbonatades del litoral, orient N, parsita de Caloplaca marina', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Tarragons, Vilaseca i Salou, Punta del Rac ( Cap de Salou)', 'Spain', NULL, 3, 10, 7, 10, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4063, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem truncorum Aceris rubri', NULL, '2005-03-17 17:02:17', 'U.S.A. Carolina Borealis. Orange County: Prope oppidum Hillsborough, in sylva dicta Duke Forest, prope lapidicinas.', 'U.S.A', NULL, 165, NULL, 8, 11, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4067, 'topotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad saxa andesitica', NULL, '2005-03-17 17:02:17', 'HUNGARIA. Distr.Veszprm, Doba, in monte Soml', 'HUNGARIA', NULL, 300, 350, 9, 12, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4120, NULL, NULL, 'Pi blanc', NULL, '2005-03-17 17:02:17', 'ESPANYA, CATALUNYA, TARRAGONA, Alt Camp: Masarborns: Torrent Seguera.', 'Spain', NULL, 200, NULL, 10, 13, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4331, 'holotipus', NULL, 'sobre roques calcries compactes, 110 incl.', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Girona, Ripolls, Queralbs, Vall de Nria, Forat de l\' Embut, sota el Pla dels  Eugassers', 'Spain', NULL, 2300, 2400, 11, 14, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4332, 'isotipus', NULL, 'sobre roques calcries compactes, 110 incl.', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Girona, Ripolls, Queralbs, Vall de Nria, Forat de l\' Embut, sota el Pla dels  Eugassers', 'Spain', NULL, 2300, 2400, 12, 15, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4427, 'tipus', NULL, 'Corticolous', NULL, '2005-03-17 17:02:17', 'SPAIN, CATALONIA, Tarragona: Esblada ( Alt Camp)', 'Spain', NULL, 650, NULL, 13, 16, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4488, 'holotipus', NULL, 'Roques calcries del llit d\'un t orrent', NULL, '2005-03-17 17:02:17', 'ESPANYA -  CATALUNYA, prov. Barcelona, Anoia, Castellol.', 'Spain', NULL, 400, 500, 14, 17, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4616, 'topotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'as saxa basaltica', NULL, '2005-03-17 17:02:17', 'ITALIA. SARDINIA. Prov. Cagliari : Giara die Gesturi, supra pagum Gesturi', 'ITALIA', NULL, 550, NULL, 15, 18, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4655, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Foliicola in pluviisilva.', NULL, '2005-03-17 17:02:17', 'BRASILIA. Amazonas. Manaus, in ripa fluminis Rio Negro 100-200 km supra Manaus', 'BRASIL', NULL, 40, NULL, 16, 19, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4657, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Foliicola in pluviisilva.', NULL, '2005-03-17 17:02:17', 'BRASILIA. So Paulo. Ilha de So  Sebastiao, 130 km ad oriemtem a So Paulo, in declivibus occidentalibus montium Morro das Tacas', 'BRASIL', NULL, 200, NULL, 17, 20, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4658, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad truncum Nothofagi moreii', NULL, '2005-03-17 17:02:17', 'AUSTRALIA. New South Wales , reservatum naturae Border Rnages National Park dictum, ad septentriones et orientem a Wiangaree, brindle Creek', 'AUSTRALIA', NULL, 850, NULL, 18, 21, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4659, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Foliicola', NULL, '2005-03-17 17:02:17', 'TANZANIA. Tanga regio. Usambara Orientalis, reservatum naturae Marvera Forest, dictum 6 km ad septentriones et orientem ab Amani.', 'Spain', NULL, 1000, 1180, 19, 22, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(4664, 'topotipus', NULL, 'Ad saxa schistosa rivi aestate sicci', NULL, '2005-03-17 17:02:17', 'ITALIA. SARDINIA. Prov. Nuoro: Catena del Marghine, infra punta Palai', 'ITALIA', NULL, 920, NULL, 20, 23, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5039, 'holotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad. corticem arboris in pluviisilva', NULL, '2005-03-17 17:02:17', 'AUSTRALIA. Queensland, circa 15 km ad occidentem et septentriones a Tully prope litorem Mission, secus Stony Creek', 'Spain', NULL, 20, NULL, 21, 24, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5041, 'holotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad. corticem Cupressi loco umbroso', NULL, '2005-03-17 17:02:17', 'URUGUAY. Montevideo, Parque Rivera', 'URUGUAY', NULL, NULL, NULL, 22, 25, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5053, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem Fagi', NULL, '2005-03-17 17:02:17', 'ITALIA. Calabria, Serra del Prete, loco Massiccio del Pollino dicto', 'ITALIA', NULL, 1680, NULL, 23, 26, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5121, 'topotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'ad ramulos emortuos Juniperi', NULL, '2005-03-17 17:02:17', 'ITALIA. SARDINIA. Prov. Sassari. Nurra, scopulum Punta ( Capo) Falcone dictum', 'ITALIA', NULL, 150, NULL, 24, 27, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5224, 'tipus', NULL, 'Corylus avellana', NULL, '2005-03-17 17:02:17', 'Espanya, CATALUNYA, Montsians, La Snia, Barrabanc del Retaule ( serra dels Ports)', 'Spain', NULL, 1000, 1100, 25, 28, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5264, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad saxa andesitica sub arcem', NULL, '2005-03-17 17:02:17', 'AUSTRIA. Stiria, distr. Feldbach, Riegersburg', 'AUSTRIA', NULL, 400, NULL, 26, 29, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5287, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad truncum Aceris pseudoplatani', NULL, '2005-03-17 17:02:17', 'GERMANIA. Bavaria: Berchtesgadener Land, Unterschnau, Astenreirweg-  Zulehenweg', 'GERMANY', NULL, 620, NULL, 27, 30, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5326, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'In pluviisilva montana', NULL, '2005-03-17 17:02:17', 'TANZANIA. Regio Morogoro: montes Nguru, in valle \"Dikurura\", 3 km ad orientem a \" Mhonda Mission\".', 'TANZANIA', NULL, 900, NULL, 28, 31, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5328, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Foliicola in pluviisilva', '14-18-10-1980', '2005-03-17 17:02:17', 'BRASILIA. Amazonas: Manaus, 100 km ad septentiones et occidenten a Manaus', 'BRASIL', NULL, 40, NULL, 29, 32, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5329, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad corticem trunci Betulae', NULL, '2005-03-17 17:02:17', 'AUSTRIA. Styria: in collibus\" Oststeierisches Hgeland\", distr. Feldbach, Lamberg in pago Petersdorf II', 'AUSTRIA', NULL, 420, NULL, 30, 33, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5561, 'holotipus', NULL, 'on soft meteorized granitic blocks', NULL, '2005-03-17 17:02:17', 'Spain, Catalonia, prov. Barcelona, El Maresme, Dosrius, Parque Natural del Corredor, along the way to the farm named Can Miloca', 'Spain', NULL, 500, NULL, 31, 34, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5704, 'holotipus', NULL, 'roca calcria( bloc)', NULL, '2005-03-17 17:02:17', 'ESPANYA, CATALUNYA, prov. de TARRAGONA, TERRA ALTA, l\'Horta de St Joan, Riu de l\' Estret  ( Serra dels Ports)', 'Spain', NULL, 500, 600, 32, 35, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5705, 'holotipus', NULL, 'roca calcria ( pedres del sl)', NULL, '2005-03-17 17:02:17', 'ESPANYA, CATALUNYA, prov. de TARRAGONA, ALT CAMP, Querol, a prop d\'Esblada', 'Spain', NULL, 700, 750, 33, 36, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5707, 'holotipus', NULL, 'roca calcria ( bloc)', NULL, '2005-03-17 17:02:17', 'ESPANYA, CATALUNYA, prov. de TARRAGONA, MONTSIANES, la Snia, Fageda del Retaule ( Serra dels Ports)', 'Spain', NULL, 1100, NULL, 34, 37, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5740, 'isotipus', NULL, 'on Juniperus thurifera', NULL, '2005-03-17 17:02:17', 'Spain, Palencia: La Cruz, Velilla del Rio Carrin', 'Spain', NULL, 1200, NULL, 35, 38, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(5741, 'isotipus', 'Herbarium Walter Obermayer', 'auf Salix alba', NULL, '2005-03-17 17:02:17', 'STEREICH, Steiermark, Seetaler Alpen-N-Abhang, 6 km E von Unzmarkt, Murknie zwischen Wll und Edling', 'AUSTRIA', NULL, 720, NULL, 36, 39, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8200, 'holotipus', NULL, 'roca calcria ( bloc). Orient. N.', NULL, '2005-03-17 17:02:17', 'ESPANYA, CATALUNYA, prov. de Tarragona, TARRAGONES, Vila-seca i Salou, Punta del Rac ( Cap de Salou)', 'Spain', NULL, 3, 10, 37, 40, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8284, 'isotipus', NULL, 'roca margosa calcria( pedres del sl).', NULL, '2005-03-17 17:02:17', 'ESPANYA, CATALUNYA, prov. de TARRAGONA, ALT CAMP, Querol a prop d\'Esblada', 'Spain', NULL, 700, 750, 38, 41, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8381, 'isotipus', NULL, 'sur sol argileux dcalcifi', NULL, '2005-03-17 17:02:17', 'France, Provence, Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 39, 42, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8382, 'isotipus', NULL, 'sur sol argileux dcalcifi', NULL, '2005-03-17 17:02:17', 'France, Provence, Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 40, 43, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8383, 'isotipus', NULL, 'sur sol argileux dcalcifi', NULL, '2005-03-17 17:02:17', 'France, Provence, Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 41, 44, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8384, 'isotipus', NULL, 'sur sol argileux dcalcifi', NULL, '2005-03-17 17:02:17', 'France, Provence, Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 42, 45, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8385, 'isotipus', NULL, 'sur sol argileux dcalcifi', NULL, '2005-03-17 17:02:17', 'France, Provence, Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 43, 46, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8391, 'isotipus', 'Herbario C. Roux', '8 m sub la lumturo, supre de klifo , apudmara etago. krutajo, kalkopetro marna, ofte grandparte senkalkita, prepice ce la suprajo.Orientigo: generala: U; loka: U. Deklivo : 80', NULL, '2005-03-17 17:02:17', 'Portugalio, Algarve, kabo S. Vicente', 'PORTUGAL', NULL, 80, NULL, 44, 47, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8394, 'isotipus', 'Herbario C. Roux', 'apude k U de la televid-cenro, adlitora etago, sur krutajeto el korala kalkopetro malfajne grejsa, je 25 m de la maro, elmetita al la marrsprucoj. Orientigo: generala: SSU; loka: N. Deklivo: 80', NULL, '2005-03-17 17:02:17', 'Cipro, Larnaca, kabo Greco', 'Spain', NULL, 15, NULL, 45, 48, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8398, 'holotipus', NULL, 'sobre piedras margosas del suelo', NULL, '2005-03-17 17:02:17', 'Espaa, Catalunya, prov. Tarragona: Alt Camp, Querol, cerca del pueblo de Esblada', 'Spain', NULL, 700, NULL, 46, 49, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8399, 'holotipus', NULL, 'on calcareus rocks exposed to the W', NULL, '2005-03-17 17:02:17', 'Espaa, Catalunya: Prov. Tarragona, Ribera d\' Ebre. Mra d\'Ebre, els Xarcums', 'Spain', NULL, 300, NULL, 47, 50, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(8962, 'holotipus', NULL, 'sobre suelo gipsicola', NULL, '2005-03-17 17:02:17', 'ESP, Navarra, prov. de, Rada, la Bardena Blanca', 'Spain', NULL, 300, 400, 48, 51, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(9032, 'isotipus', 'Coll.: P. v. d. Boom', 'E exp. rock on slope', NULL, '2005-03-17 17:02:17', 'PORTUGAL. Algarve. N of Portimo, 6 1/2 km WNW of Silves, 1 km N of road  \'124\', along river Odelouca, small valley ( W_E) with E exposed outcrops, Ceratonia and Olea', 'PORTUGAL', NULL, 20, NULL, 49, 52, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(9309, 'holotipus', NULL, 'sobre roca calcarea, orient. N, incli. 90', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Girona, Baix Empord, Torruella de Montgr, Illes Medes, Meda Gran', 'Spain', NULL, 50, NULL, 50, 53, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(9736, 'holotipus', NULL, 'roca calcria. Parasita Fulgensia fulgens', NULL, '2005-03-17 17:02:17', 'ESP, illes Balears, prov. de Menorca, Ciutadella, prop de Cala\'n Bast', 'Spain', 'preparacions microscpiques', 6, 10, 51, 54, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(10385, 'isotipus', 'Coll.: P. v. d. Boom', NULL, NULL, '2005-03-17 17:02:17', 'PORTUGAL. Algarve. NV of Sagres, S of road toCabo de So vicente, haflway, coastal plain with exposed outcrops and shrubs', 'PORTUGAL', NULL, 50, NULL, 52, 55, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(10768, 'holotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Garrofer', NULL, '2005-03-17 17:02:17', 'SPAIN: Catalunya, Baix Ebre, L\'Atmella de Mar, Mas Rabosenc', 'Spain', NULL, 100, NULL, 53, 56, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13209, 'isotipus', NULL, 'sobre sls guixencs.  Parasita Fulgensia desertorum', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Lleida, Noguera, Vilanova de l\'Aguda, prop de pble de Ribelles', 'Spain', NULL, 400, NULL, 54, 57, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13210, 'isotipus', NULL, 'sobre sls guixencs. Parasita Fulgensia desertorum', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Lleida, Noguera, Vilanova de l\'Aguda, prop de pble de Ribelles', 'Spain', NULL, 400, NULL, 55, 58, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13211, 'holotipus', NULL, 'sobre s`ls guixencs. Parasita Fulgensia desertorum', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Lleida, Noguera, Vilanova de l\'Aguda, prop de pble de Ribelles', 'Spain', NULL, NULL, NULL, 56, 59, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13213, 'holotipus', NULL, 'sobre pedres calcries del sl. Parasita Caloplaca marmorata', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Lleida, Segarra, Cervera, sobre les Fonts de Orobins, al costat de la carretera de Granyellana', 'Spain', NULL, 500, NULL, 57, 60, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13215, 'holotipus', NULL, 'sobre  Epifits de Acer opalus subsp granatense. Parasita lecidella elaeochroma', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Montsians, La Snia, Barranc del Retaule ( Serra dels Ports)', 'Spain', NULL, 1100, NULL, 58, 61, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13217, 'holotipus', NULL, 'sobre Gres carbonat.Parasita Caloplaca gr. variabilis', NULL, '2005-03-17 17:02:17', 'FRA, Provena, prov. de Vaucluse, Gordes , Col de Gordes', 'France', NULL, 350, NULL, 59, 62, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13219, 'isotipus', NULL, 'sobre roca cabonatada', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de  Tarragona,  Alt Camp, Querol, prop d\' Esblada', 'Spain', NULL, 700, 750, 60, 63, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13236, 'isotipus', NULL, 'sobre roca carbonatada, parasita de Aspicilia coronata', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Priorat, La Torre de Fontaubella, Collet de la Plana d\'en Cervera', 'Spain', NULL, 500, 550, 61, 64, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13237, 'isotipus', NULL, 'sobre roca carbonatada, parasita de Aspicilia coronata , prop de Caloplaca alociza', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Priorat, La Torre de Fontaubella, Collet de la Plana d\'en Cervera', 'Spain', NULL, 500, 550, 62, 65, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13238, 'holotipus', NULL, 'sobre roca carbonatada, parasita de Aspicilia coronata', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Priorat, La Torre de Fontaubella, Collet de la Plana d\'en Cervera', 'Spain', NULL, 500, 550, 63, 66, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13239, 'holotipus', NULL, 'sobre roca carbonatada, parasita de Caloplaca erythocarpa', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Ribera d\'Ebre, Tivissa, Barranc de Montalt, prop de Serra d\' Alms', 'Spain', NULL, 300, 400, 64, 67, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13240, 'isotipus', NULL, 'sobre roca carbonatada, parasita de Caloplaca erythocarpa', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Ribera d\'Ebre, Tivissa, Barranc de Montalt, prop de Serra d\' Alms', 'Spain', NULL, 300, 400, 65, 68, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13262, 'isotipus', NULL, 'sur sol argileux decalcifi, parasite de Squamarina lentigera', NULL, '2005-03-17 17:02:17', 'FRA, Provena, prov. de  Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 66, 69, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13263, 'isotipus', NULL, 'sur sol argileux decalcifi, parasita de Squamarina lentigera', NULL, '2005-03-17 17:02:17', 'FRA, Provena, prov. de  Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 67, 70, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13264, 'isotipus', NULL, 'sur sol argileux decalcifi, parasite de Squamarina lentigera', NULL, '2005-03-17 17:02:17', 'FRA, Provena, prov. de  Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 68, 71, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13265, 'isotipus', NULL, 'sur sol argileux decalcifi, parasite de Squamarina lentigera', NULL, '2005-03-17 17:02:17', 'FRA, Provena, prov. de  Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 69, 72, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13266, 'isotipus', NULL, 'sur sol argileux decalcifi, parasita de Squamarina lentigera', NULL, '2005-03-17 17:02:17', 'FRA, Provena, prov. de  Bouches-du-Rhne, Martigues-Caronte, prs du vallon de Bonnieux', 'France', NULL, 2, 3, 70, 73, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13374, 'isotipus', NULL, 'roca cabonatada, marga, pedres del sol', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov de Tarragona, Alt Camp, Querol, prop d\'Esblada', 'Spain', NULL, 700, 750, 71, 74, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13375, 'isotipus', NULL, 'roca cabonatada, marga, pedres del sol', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov de Tarragona, Alt Camp, Querol, prop d\'Esblada', 'Spain', NULL, 700, 750, 72, 75, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13384, 'isotipus', NULL, 'parts superiors exposades de blocs de calcaria compacta', NULL, '2005-03-17 17:02:17', 'FRA, Llenguadoc-Rosell prov. de Pirineus Orientals, Tautavel ( Taltaull) , cami entre el fort i la torre, prop de la pedrera', 'France', NULL, 400, 500, 73, 76, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13386, 'isotipus', NULL, 'Parts superiors exposades de blocs de calcaria compacta', NULL, '2005-03-17 17:02:17', 'FRA, Llenguadoc- Rosell, prov de Pirineus Orientals, Tautavel ( Taltaull), cami entre el fort i la torre, prop de la pedrera', 'France', NULL, 400, 500, 74, 77, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13387, 'isotipus', NULL, 'parts superiors exposades de blocs de calcaria compacta', NULL, '2005-03-17 17:02:17', 'FRA, Llenguadoc- Rosell, prov de Pirineus Orientals, Tautavel ( Taltaull), cami entre el fort i la torre, prop de la pedrera', 'France', NULL, 400, 500, 75, 78, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13388, 'isotipus', NULL, 'parts superiors exposades de blocs de calcaria compacta', NULL, '2005-03-17 17:02:17', 'FRA, Llenguadoc- Rosell, prov de Pirineus Orientals, Tautavel ( Taltaull), cami entre el fort i la torre, prop de la pedrera', 'France', NULL, 400, 500, 76, 79, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13389, 'isotipus', NULL, 'parts superiors exposades de blocs de calcaria compacta', NULL, '2005-03-17 17:02:17', 'FRA, Llenguadoc- Rosell, prov de Pirineus Orientals, Tautavel ( Taltaull), cami entre el fort i la torre, prop de la pedrera', 'France', NULL, 400, 500, 77, 80, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13421, 'holotipus', NULL, 'sobre roca carbonatada, parasita de Aspicilia calcarea', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Tarragona, Ribera d\'Ebre, Tivissa, Barranc de Montalt, prop de Serra d\' Alms', 'Spain', NULL, 300, 400, 78, 81, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(13747, 'tipus', NULL, 'sobre Quercus ilex', NULL, '2005-03-17 17:02:17', 'ESP, Catalunya, prov. de Barcelona, Valls Occidental, Matadepera, serra de Sant Lloren del Munt, Canal Freda', 'Spain', NULL, 700, NULL, 79, 82, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(14133, 'isotipus', NULL, 'On Quercus pyrenaica trunk', NULL, '2005-03-17 17:02:17', 'Espaa: Madrid, Cercedilla', 'Spain', NULL, 1300, NULL, 80, 83, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(14202, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad folia Buxi colchicae', NULL, '2005-03-17 17:02:17', 'URSS. Rossia merid., Colchis (Transcaucasia occid.), distr. Adler: in valle angusta rivi Kudepsta, 5 km ab ostio in mare.', 'URSS', NULL, 20, 30, 81, 84, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(14203, 'isotipus', 'A. Vezda: Lichenes Selecti Exsiccati', 'Ad folia Buxi colchicae', NULL, '2005-03-17 17:02:17', 'URSS. Rossia merid., Colchis (Transcaucasia occid.), distr. Lazarevskoje: in faucibus rivi Dagomys Zapadnyi, supra vicum Tretja Rota', 'URSS', NULL, 250, NULL, 82, 85, 1);
INSERT INTO "public"."herbariumsheets" ("UnitID", "TypeStatus", "ProjectTitle", "BiotopeText", "DateText", "ISODateTimeBegin", "LocalityText", "CountryName", "Notes", "AltitudeLowerValue", "AltitudeUpperValue", "LongitudeDecimal", "LatitudeDecimal", "MetadataID") VALUES(14204, 'isotipus', 'HerbariumImages BGBM', 'Text describing the Biotope', '1998-06-06', '1998-06-06 00:00:00', 'Allgaeuer Alpen', 'Germany', 'This is a totally wrong record just for example', 1500, 1500, 10, 47, 1);
-- Dumping COLUMNS COMMENT



-- Dumping Table Triggers


--

-- Dumping Table: identifications
--
CREATE TABLE "public"."identifications" 
(
	"ID" int8 NOT NULL,
	"UnitID" int8,
	"PreferedFlag" int8,
	"DateText" timestamp,
	"NameAuthorYearString" varchar(255),
	"Genus" varchar(20),
	"FirstEpithet" varchar(90),
	"SecondEpithet" varchar(90),
	"Rank" varchar(255),
	"Author" varchar(255),
	"IdentificationAuthor" varchar(255),
	"HigherTaxon" varchar(40),
	"IdentificationRef" varchar(255),
	CONSTRAINT "IX_identifications_pkey" PRIMARY KEY ("ID"),
	CONSTRAINT "FK_biocase_training_herbariumsheets_identifications" FOREIGN KEY ("UnitID") REFERENCES "identifications" ("UnitID")
);
CREATE INDEX "HerbariumSheetsIdentifications" ON identifications USING btree ("UnitID");
CREATE INDEX "IdentificationRef" ON identifications USING btree ("IdentificationRef");
CREATE INDEX "NameAuthorYearString" ON identifications USING btree ("NameAuthorYearString");
CREATE INDEX "UnitId" ON identifications USING btree ("UnitID");

-- Dumping Data
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111395, 368, 0, NULL, 'Belonia caudata (Vezda & Vivant) P.M. Jrg. & Vezda,', 'Belonia', 'caudata', NULL, 'sp.', '(Vezda & Vivant) P.M. Jrg. & Vezda,', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111396, 620, 0, NULL, 'Caloplaca gloriae Llimona & Werner', 'Caloplaca', 'gloriae', NULL, 'sp.', 'Llimona & Werner', 'Llimona, X.', 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111399, 621, 0, NULL, 'Caloplaca gloriae Llimona & Werner', 'Caloplaca', 'gloriae', NULL, 'sp.', 'Llimona & Werner', 'Werner', 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111400, 1692, 0, '1980-01-02 00:00:00', 'Dimerella frederici Kalb', 'Dimerella', 'frederici', NULL, 'sp.', 'Kalb', 'Kalb, K.', 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111401, 5224, 0, NULL, 'Karsteniomyces llimonae Boqueras & Diederich', 'Karsteniomyces', 'llimonae', NULL, 'sp.', 'Boqueras & Diederich', 'Boqueras, M.', 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111402, 8284, 0, NULL, 'Koerberiella pruinosa Nav.-Ros. & Hafellner', 'Koerberiella', 'pruinosa', NULL, 'sp.', 'Nav.-Ros. & Hafellner', NULL, 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111404, 1749, 0, '1977-01-09 00:00:00', 'Lecanactis acicularis C.W. Dodge', 'Lecanactis', 'acicularis', NULL, 'sp.', 'C.W. Dodge', 'Follmann, G.', 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111406, 1762, 0, '1976-01-09 00:00:00', 'Lecanactis subdryophila Follmann & Vezda', 'Lecanactis', 'subdryophila', NULL, 'sp.', 'Follmann & Vezda', 'Vezda, A.', 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111408, 10385, 0, NULL, 'Lecania poeltii Van den Boom, Alonso & Egea', 'Lecania', 'poeltii', NULL, 'sp.', 'Van den Boom, Alonso & Egea', 'Poelt, J.', 'Bacidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111409, 5561, 0, NULL, 'Neofuscelia halei Essl., M. Barbero & Llimona', 'Neofuscelia', 'halei', NULL, 'sp.', 'Essl., M. Barbero & Llimona', NULL, 'Parmeliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111411, 421, 0, '1966-01-12 00:00:00', 'Ramalina cactacearum Follmann', 'Ramalina', 'cactacearum', NULL, 'sp.', 'Follmann', 'Follmann, G.', 'Ramalinaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111412, 395, 0, '1966-01-06 00:00:00', 'Ramalina tigrina Follmann', 'Ramalina', 'tigrina', NULL, 'sp.', 'Follmann', 'Follmann, G.', 'Ramalinaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111413, 610, 0, '1987-06-05 00:00:00', 'Rhizocarpon malenconianum (Llimona & Werner) Hafellner & Mayrhofer{?}', 'Rhizocarpon', 'malenconianum', NULL, 'sp.', '(Llimona & Werner) Hafellner & Mayrhofer{?}', 'Giralt, M.', 'Rhizocarpaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111414, 9032, 0, '1994-01-01 00:00:00', 'Rinodina algarvensis Giralt, M. Barbero & Van den Boom', 'Rinodina', 'algarvensis', NULL, 'sp.', 'Giralt, M. Barbero & Van den Boom', 'Mayrhofer, H.', 'Physciaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111415, 4427, 0, NULL, 'Rinodina boleana Giralt & H. Mayrhofer', 'Rinodina', 'boleana', NULL, 'sp.', 'Giralt & H. Mayrhofer', 'Mayrhofer, H.', 'Physciaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111416, 435, 0, '1966-01-12 00:00:00', 'Roccellina luteola Follmann', 'Roccellina', 'luteola', NULL, 'sp.', 'Follmann', 'Follmann, G.', NULL, NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111417, 425, 0, '1966-01-12 00:00:00', 'Usnea eulychinae Follmann', 'Usnea', 'eulychinae', NULL, 'sp.', 'Follmann', 'Follmann, G.', 'Parmeliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111418, 879, 0, NULL, 'Usnea grandis Motyka', 'Usnea', 'grandis', NULL, 'sp.', 'Motyka', 'Motyka, J.', 'Parmeliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111419, 1025, 0, NULL, 'Usnea pinnata Rsnen', 'Usnea', 'pinnata', NULL, 'sp.', 'Rsnen', 'Rsnen, V.', 'Parmeliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111421, 5287, 0, NULL, 'Xanthoria fulva (Hoffm.) Poelt & Petut.', 'Xanthoria', 'fulva', NULL, 'sp.', '(Hoffm.) Poelt & Petut.', 'Poelt, J.', 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111422, 1594, 1, NULL, 'Anzina carneonivea (Anzi) Scheid.', 'Anzina', 'carneonivea', NULL, 'sp.', '(Anzi) Scheid.', NULL, 'Agyriaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111423, 10768, 1, NULL, 'Arthothelium taediosoides Giralt & Grube', 'Arthothelium', 'taediosoides', NULL, 'sp.', 'Giralt & Grube', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111424, 4664, 1, NULL, 'Aspicilia hydrocharis Poelt & Nimis', 'Aspicilia', 'hydrocharis', NULL, 'sp.', 'Poelt & Nimis', NULL, 'Hymeneliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111425, 14202, 1, NULL, 'Bacidia vasakii Vezda', 'Bacidia', 'vasakii', NULL, 'sp.', 'Vezda', NULL, 'Bacidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111426, 368, 1, NULL, 'Belonia caudata (Vezda & Vivant) P.M. Jrg. & Vezda,', 'Belonia', 'caudata', NULL, 'sp.', '(Vezda & Vivant) P.M. Jrg. & Vezda,', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111427, 9309, 1, NULL, 'Belonia mediterranea Nav.-Ros. & Llimona', 'Belonia', 'mediterranea', NULL, 'sp.', 'Nav.-Ros. & Llimona', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111428, 1449, 1, NULL, 'Buellia multispora Kalb & Vezda', 'Buellia', 'multispora', NULL, 'sp.', 'Kalb & Vezda', NULL, 'Physciaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111429, 1454, 1, NULL, 'Buelliella physciicola Poelt & Hafellner', 'Buelliella', 'physciicola', NULL, 'sp.', 'Poelt & Hafellner', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111430, 5328, 1, NULL, 'Byssoloma amazonicum Kalb & Vezda', 'Byssoloma', 'amazonicum', NULL, 'sp.', 'Kalb & Vezda', NULL, 'Pilocarpaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111431, 13747, 1, NULL, 'Byssoloma llimonae Srus., Gmez-Bolea, Longn & Lcking', 'Byssoloma', 'llimonae', NULL, 'sp.', 'Srus., Gmez-Bolea, Longn & Lcking', NULL, 'Pilocarpaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111432, 2422, 1, NULL, 'Calicium adspersum Pers. subsp. australe Tibell', 'Calicium', 'adspersum', 'australe', 'subsp.', 'Tibell', NULL, 'Caliciaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111433, 2424, 1, NULL, 'Calicium constrictum Tibell', 'Calicium', 'constrictum', NULL, 'sp.', 'Tibell', NULL, 'Caliciaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111434, 13384, 1, NULL, 'Caloplaca calcitrapa Nav.-Ros., Gaya & Cl. Roux', 'Caloplaca', 'calcitrapa', NULL, 'sp.', 'Nav.-Ros., Gaya & Cl. Roux', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111435, 13386, 1, NULL, 'Caloplaca calcitrapa Nav.-Ros., Gaya & Cl. Roux', 'Caloplaca', 'calcitrapa', NULL, 'sp.', 'Nav.-Ros., Gaya & Cl. Roux', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111436, 13387, 1, NULL, 'Caloplaca calcitrapa Nav.-Ros., Gaya & Cl. Roux', 'Caloplaca', 'calcitrapa', NULL, 'sp.', 'Nav.-Ros., Gaya & Cl. Roux', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111437, 13388, 1, NULL, 'Caloplaca calcitrapa Nav.-Ros., Gaya & Cl. Roux', 'Caloplaca', 'calcitrapa', NULL, 'sp.', 'Nav.-Ros., Gaya & Cl. Roux', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111438, 13389, 1, NULL, 'Caloplaca calcitrapa Nav.-Ros., Gaya & Cl. Roux', 'Caloplaca', 'calcitrapa', NULL, 'sp.', 'Nav.-Ros., Gaya & Cl. Roux', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111439, 5264, 1, NULL, 'Caloplaca citrina (Hoffm.) Th. Fr. var. arcis Poelt et Vezda', 'Caloplaca', 'citrina', NULL, 'sp.', '(Hoffm.) Th. Fr.', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111440, 8391, 1, NULL, 'Caloplaca egeana Cl. Roux & Nav.-Ros.', 'Caloplaca', 'egeana', NULL, 'sp.', 'Cl. Roux & Nav.-Ros.', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111442, 620, 1, NULL, 'Caloplaca gloriae Llimona & Werner', 'Caloplaca', 'gloriae', NULL, 'sp.', 'Llimona & Werner', 'Werner', 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111443, 621, 1, NULL, 'Caloplaca gloriae Llimona & Werner', 'Caloplaca', 'gloriae', NULL, 'sp.', 'Llimona & Werner', 'Llimona', 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111445, 8200, 1, NULL, 'Caloplaca tavaresiana Nav.-Ros. & Cl. Roux', 'Caloplaca', 'tavaresiana', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111446, 8394, 1, NULL, 'Caloplaca veneris Cl. Roux & Nav.-Ros.', 'Caloplaca', 'veneris', NULL, 'sp.', 'Cl. Roux & Nav.-Ros.', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111447, 5053, 1, NULL, 'Candelariella faginea Nimis, Poelt & Puntillo', 'Candelariella', 'faginea', NULL, 'sp.', 'Nimis, Poelt & Puntillo', NULL, 'Candelariaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111448, 8962, 1, NULL, 'Catapyrenium llimonae Etayo, Nav.-Ros. & Breuss', 'Catapyrenium', 'llimonae', NULL, 'sp.', 'Etayo, Nav.-Ros. & Breuss', NULL, 'Verrucariaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111449, 4331, 1, NULL, 'Catapyrenium nuriense Nav.-Ros. & Breuss', 'Catapyrenium', 'nuriense', NULL, 'sp.', 'Nav.-Ros. & Breuss', NULL, 'Verrucariaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111450, 4332, 1, NULL, 'Catapyrenium nuriense Nav.-Ros. & Breuss', 'Catapyrenium', 'nuriense', NULL, 'sp.', 'Nav.-Ros. & Breuss', NULL, 'Verrucariaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111451, 5329, 1, NULL, 'Cheiromycina petri D. Hawksw. & Poelt', 'Cheiromycina', 'petri', NULL, 'sp.', 'D. Hawksw. & Poelt', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111452, 447, 1, NULL, 'Chiodecton klementii Follmann', 'Chiodecton', 'klementii', NULL, 'sp.', 'Follmann', NULL, 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111453, 2005, 1, NULL, 'Cladonia norvegica Tnsberg & Holien', 'Cladonia', 'norvegica', NULL, 'sp.', 'Tnsberg & Holien', NULL, 'Cladoniaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111454, 1723, 1, NULL, 'Desmazieria josecuervoi Rundel & Bowler', 'Desmazieria', 'josecuervoi', NULL, 'sp.', 'Rundel & Bowler', NULL, 'Ramalinaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111455, 1508, 1, NULL, 'Dimerella degeneri Kalb & Vezda', 'Dimerella', 'degeneri', NULL, 'sp.', 'Kalb & Vezda', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111456, 1509, 1, NULL, 'Dimerella frederici Kalb', 'Dimerella', 'frederici', NULL, 'sp.', 'Kalb', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111457, 1692, 1, '1980-01-02 00:00:00', 'Dimerella frederici Kalb', 'Dimerella', 'frederici', NULL, 'sp.', 'Kalb', 'Kalb, K.', 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111458, 5041, 1, NULL, 'Dimerella isidiigera Vezda & Osorio', 'Dimerella', 'isidiigera', NULL, 'sp.', 'Vezda & Osorio', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111459, 2230, 1, NULL, 'Dimerella pocsii Vezda & Farkas', 'Dimerella', 'pocsii', NULL, 'sp.', 'Vezda & Farkas', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111460, 5039, 1, NULL, 'Dimerella subdentata Vezda & G. Thor', 'Dimerella', 'subdentata', NULL, 'sp.', 'Vezda & G. Thor', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111461, 5326, 1, NULL, 'Dimerella subfallaciosa Vezda & Farkas', 'Dimerella', 'subfallaciosa', NULL, 'sp.', 'Vezda & Farkas', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111462, 4659, 1, NULL, 'Dimerella usambarensis Vezda & Farkas', 'Dimerella', 'usambarensis', NULL, 'sp.', 'Vezda & Farkas', NULL, 'Gyalectaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111463, 4120, 1, NULL, 'Diplolaeviopsis ranula Giralt & D. Hawksw.', 'Diplolaeviopsis', 'ranula', NULL, 'sp.', 'Giralt & D. Hawksw.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111464, 2454, 1, NULL, 'Fellhanera endopurpurea Hafellner & Vezda', 'Fellhanera', 'endopurpurea', NULL, 'sp.', 'Hafellner & Vezda', NULL, 'Pilocarpaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111465, 611, 1, NULL, 'Fulgensia desertorum (Tomin) Poelt fma macrospora Llimona', 'Fulgensia', 'desertorum', NULL, 'sp.', '(Tomin) Poelt', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111466, 612, 1, NULL, 'Fulgensia fulgida (Nyl.) Szatala var. calcinata Llimona', 'Fulgensia', 'fulgida', NULL, 'sp.', '(Nyl.) Szatala', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111467, 607, 1, NULL, 'Fulgensia poeltii Llimona', 'Fulgensia', 'poeltii', NULL, 'sp.', 'Llimona', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111468, 2819, 1, NULL, 'Fulgensia poeltii Llimona', 'Fulgensia', 'poeltii', NULL, 'sp.', 'Llimona', NULL, 'Teloschistaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111469, 1644, 1, NULL, 'Gyalectidium colchicum Vezda', 'Gyalectidium', 'colchicum', NULL, 'sp.', 'Vezda', NULL, 'Gomphillaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111470, 14203, 1, NULL, 'Gyalectidium colchicum Vezda', 'Gyalectidium', 'colchicum', NULL, 'sp.', 'Vezda', NULL, 'Gomphillaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111471, 1993, 1, NULL, 'Gyalideopsis kalbii Vezda', 'Gyalideopsis', 'kalbii', NULL, 'sp.', 'Vezda', NULL, 'Gomphillaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111472, 4063, 1, NULL, 'Haematomma pustulatum Brodo & W.L. Culb.', 'Haematomma', 'pustulatum', NULL, 'sp.', 'Brodo & W.L. Culb.', NULL, 'Haematommataceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111473, 2152, 1, NULL, 'Huilia circumnigrata Vezda', 'Huilia', 'circumnigrata', NULL, 'sp.', 'Vezda', NULL, 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111474, 5224, 1, NULL, 'Karsteniomyces llimonae Boqueras & Diederich', 'Karsteniomyces', 'llimonae', NULL, 'sp.', 'Boqueras & Diederich', 'Boqueras, M.', 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111476, 8284, 1, NULL, 'Koerberiella pruinosa Nav.-Ros. & Hafellner', 'Koerberiella', 'pruinosa', NULL, 'sp.', 'Nav.-Ros. & Hafellner', 'Navarro-Rosins, P.', 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111477, 8398, 1, NULL, 'Koerberiella pruinosa Nav.-Ros. & Hafellner', 'Koerberiella', 'pruinosa', NULL, 'sp.', 'Nav.-Ros. & Hafellner', NULL, 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111478, 13219, 1, NULL, 'Koerberiella pruinosa Nav.-Ros. & Hafellner', 'Koerberiella', 'pruinosa', NULL, 'sp.', 'Nav.-Ros. & Hafellner', NULL, 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111479, 13374, 1, NULL, 'Koerberiella pruinosa Nav.-Ros. & Hafellner', 'Koerberiella', 'pruinosa', NULL, 'sp.', 'Nav.-Ros. & Hafellner', NULL, 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111480, 13375, 1, NULL, 'Koerberiella pruinosa Nav.-Ros. & Hafellner', 'Koerberiella', 'pruinosa', NULL, 'sp.', 'Nav.-Ros. & Hafellner', NULL, 'Porpidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111481, 1749, 1, '1977-01-09 00:00:00', 'Lecanactis acicularis C.W. Dodge', 'Lecanactis', 'acicularis', NULL, 'sp.', 'C.W. Dodge', 'Follmann, G.', 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111483, 1762, 1, '1976-01-09 00:00:00', 'Lecanactis subdryophila Follmann & Vezda', 'Lecanactis', 'subdryophila', NULL, 'sp.', 'Follmann & Vezda', 'Vezda, A.', 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111485, 10385, 1, NULL, 'Lecania poeltii Van den Boom, Alonso & Egea', 'Lecania', 'poeltii', NULL, 'sp.', 'Van den Boom, Alonso & Egea', 'Poelt, J.', 'Bacidiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111486, 1298, 1, NULL, 'Lecanora andrewii de Lesd.', 'Lecanora', 'andrewii', NULL, 'sp.', 'de Lesd.', NULL, 'Lecanoraceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111487, 3707, 1, NULL, 'Lecanora strobilinoides Giralt & Gmez-Bolea', 'Lecanora', 'strobilinoides', NULL, 'sp.', 'Giralt & Gmez-Bolea', NULL, 'Lecanoraceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111488, 2340, 1, NULL, 'Lecanora subradiosa Nyl. var. effigurata Hladun', 'Lecanora', 'subradiosa', NULL, 'sp.', 'Nyl.', NULL, 'Lecanoraceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111489, 39, 1, NULL, 'Lecidea gypsicola Llimona', 'Lecidea', 'gypsicola', NULL, 'sp.', 'Llimona', NULL, 'Lecideaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111490, 5121, 1, NULL, 'Lecidella achristotera (Nyl.) Hertel & Leuckert var. juniperina Poelt & Nimis', 'Lecidella', 'achristotera', NULL, 'sp.', '(Nyl.) Hertel & Leuckert', NULL, 'Lecanoraceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111491, 4616, 1, NULL, 'Lecidella vorax Leuckert & Poelt', 'Lecidella', 'vorax', NULL, 'sp.', 'Leuckert & Poelt', NULL, 'Lecanoraceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111492, 8381, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111493, 8382, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111494, 8383, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111495, 8384, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111496, 8385, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111497, 13262, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111498, 13263, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111499, 13264, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111500, 13265, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111501, 13266, 1, NULL, 'Lichenochora clauzadei Nav.-Ros.', 'Lichenochora', 'clauzadei', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111502, 13209, 1, NULL, 'Lichenochora epidesertorum Nav.-Ros.', 'Lichenochora', 'epidesertorum', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111503, 13210, 1, NULL, 'Lichenochora epidesertorum Nav.-Ros.', 'Lichenochora', 'epidesertorum', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111504, 13211, 1, NULL, 'Lichenochora epidesertorum Nav.-Ros.', 'Lichenochora', 'epidesertorum', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111505, 9736, 1, NULL, 'Lichenochora epifulgens Nav.-Ros. & Cl. Roux', 'Lichenochora', 'epifulgens', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111506, 13213, 1, NULL, 'Lichenochora epimarmorata Nav.-Ros.', 'Lichenochora', 'epimarmorata', NULL, 'sp.', 'Nav.-Ros.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111507, 13215, 1, NULL, 'Lichenochora lecidellae Boqueras & Nav.-Ros.', 'Lichenochora', 'lecidellae', NULL, 'sp.', 'Boqueras & Nav.-Ros.', NULL, 'Incertae sedis', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111508, 13217, 1, NULL, 'Lichenochora pyrenodesmiae Nav.-Ros. & Cl. Roux', 'Lichenochora', 'pyrenodesmiae', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111509, 1379, 1, NULL, 'Lichenoconium parasiticum D. Hawksw.', 'Lichenoconium', 'parasiticum', NULL, 'sp.', 'D. Hawksw.', NULL, 'Incertae sedis', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111510, 8399, 1, NULL, 'Lichenostigma elongata Nav.-Ros. & Hafellner', 'Lichenostigma', 'elongata', NULL, 'sp.', 'Nav.-Ros. & Hafellner', NULL, 'Lichenotheliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111511, 4655, 1, NULL, 'Mazosia pilosa Kalb & Vezda', 'Mazosia', 'pilosa', NULL, 'sp.', 'Kalb & Vezda', NULL, 'Roccellaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111512, 4657, 1, NULL, 'Mazosia pseudobambusae Kalb & Vezda', 'Mazosia', 'pseudobambusae', NULL, 'sp.', 'Kalb & Vezda', NULL, 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111513, 1982, 1, NULL, 'Micarea muhrii Coppins', 'Micarea', 'muhrii', NULL, 'sp.', 'Coppins', NULL, 'Micareaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111515, 5561, 1, NULL, 'Neofuscelia halei Essl., M. Barbero & Llimona', 'Neofuscelia', 'halei', NULL, 'sp.', 'Essl., M. Barbero & Llimona', 'Esslinger, Theodore L.', 'Parmeliaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111516, 1478, 1, NULL, 'Opegrapha pertusariicola Coppins & P. James', 'Opegrapha', 'pertusariicola', NULL, 'sp.', 'Coppins & P. James', NULL, 'Roccellaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111517, 1516, 1, NULL, 'Parmelia semansiana W.L. Culb. & C.F. Culb.', 'Parmelia', 'semansiana', NULL, 'sp.', 'W.L. Culb. & C.F. Culb.', NULL, 'Parmeliaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111518, 14133, 1, NULL, 'Parmelia semansiana W.L. Culb. & C.F. Culb.', 'Parmelia', 'semansiana', NULL, 'sp.', 'W.L. Culb. & C.F. Culb.', NULL, 'Parmeliaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111519, 1352, 1, NULL, 'Parmotrema indicum Hale', 'Parmotrema', 'indicum', NULL, 'sp.', 'Hale', NULL, 'Parmeliaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111520, 2037, 1, NULL, 'Pertusaria paramerae A. Crespo & Vezda', 'Pertusaria', 'paramerae', NULL, 'sp.', 'A. Crespo & Vezda', NULL, 'Pertusariaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111521, 1433, 1, NULL, 'Pyrenopsis sojakii Vezda', 'Pyrenopsis', 'sojakii', NULL, 'sp.', 'Vezda', NULL, 'Lichinaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111522, 421, 1, NULL, 'Ramalina cactacearum Follmann', 'Ramalina', 'cactacearum', NULL, 'sp.', 'Follmann', 'Follmann, G.', 'Ramalinaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111523, 1447, 1, NULL, 'Ramalina euxini Vezda', 'Ramalina', 'euxini', NULL, 'sp.', 'Vezda', NULL, 'Ramalinaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111524, 1776, 1, NULL, 'Ramalina superfraxinea Follmann & Snchez-Pinto', 'Ramalina', 'superfraxinea', NULL, 'sp.', 'Follmann & Snchez-Pinto', NULL, 'Ramalinaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111525, 395, 1, NULL, 'Ramalina tigrina Follmann', 'Ramalina', 'tigrina', NULL, 'sp.', 'Follmann', 'Follmann, G.', 'Ramalinaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111526, 5705, 1, NULL, 'Rhagadostoma boleae Nav.-Ros. & Hladn', 'Rhagadostoma', 'boleae', NULL, 'sp.', 'Nav.-Ros. & Hladn', NULL, 'Nitschkiaceae', 'SANTESSON, R. 1993. The lichens and lichenicolous fungi of Sweden and Norway. STB-forlaget, Lund, Sweden.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111527, 5704, 1, NULL, 'Rhagadostoma rugosum Nav.-Ros. & Hladn', 'Rhagadostoma', 'rugosum', NULL, 'sp.', 'Nav.-Ros. & Hladn', NULL, 'Nitschkiaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111528, 5707, 1, NULL, 'Rhagadostoma verrucariarum Nav.-Ros. & Hladn', 'Rhagadostoma', 'verrucariarum', NULL, 'sp.', 'Nav.-Ros. & Hladn', NULL, 'Nitschkiaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111529, 2006, 1, NULL, 'Rhizocarpon inimicum Poelt & Vezda', 'Rhizocarpon', 'inimicum', NULL, 'sp.', 'Poelt & Vezda', NULL, 'Rhizocarpaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111530, 610, 1, '1987-06-05 00:00:00', 'Rhizocarpon malenconianum (Llimona & Werner) Hafellner & Mayrhofer{?}', 'Rhizocarpon', 'malenconianum', NULL, 'sp.', '(Llimona & Werner) Hafellner & Mayrhofer{?}', 'Giralt, M.', 'Rhizocarpaceae', NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111531, 9032, 1, '1994-01-01 00:00:00', 'Rinodina algarvensis Giralt, M. Barbero & Van den Boom', 'Rinodina', 'algarvensis', NULL, 'sp.', 'Giralt, M. Barbero & Van den Boom', 'Mayrhofer, H.', 'Physciaceae', 'SANTESSON, R. 1993. The lichens and lichenicolous fungi of Sweden and Norway. STB-forlaget, Lund, Sweden.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111532, 4427, 1, NULL, 'Rinodina boleana Giralt & H. Mayrhofer', 'Rinodina', 'boleana', NULL, 'sp.', 'Giralt & H. Mayrhofer', 'Mayrhofer, H.', 'Physciaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111533, 5740, 1, NULL, 'Rinodina llimonae Giralt & Etayo', 'Rinodina', 'llimonae', NULL, 'sp.', 'Giralt & Etayo', NULL, 'Physciaceae', 'LAMB, I. M. 1963. Index Nominum Lichenum. Ronald, New York.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111534, 5741, 1, NULL, 'Rinodina poeltiana Giralt & W. Oberm.', 'Rinodina', 'poeltiana', NULL, 'sp.', 'Giralt & W. Oberm.', NULL, 'Physciaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111535, 435, 1, '1966-01-12 00:00:00', 'Roccellina luteola Follmann', 'Roccellina', 'luteola', NULL, 'sp.', 'Follmann', 'Follmann, G.', NULL, NULL);
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111536, 4658, 1, NULL, 'Sagenidiopsis merrotsii R.W. Rogers & Hafellner', 'Sagenidiopsis', 'merrotsii', NULL, 'sp.', 'R.W. Rogers & Hafellner', NULL, 'Arthoniaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111537, 4488, 1, NULL, 'Sarcopyrenia bacillospora Nav.-Ros. & Hladun', 'Sarcopyrenia', 'bacillospora', NULL, 'sp.', 'Nav.-Ros. & Hladun', NULL, 'Incertae sedis', 'LAMB, I. M. 1963. Index Nominum Lichenum. Ronald, New York.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111538, 2445, 1, NULL, 'Schistophoron variabile Tibell', 'Schistophoron', 'variabile', NULL, 'sp.', 'Tibell', NULL, 'Incertae sedis', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111539, 1436, 1, NULL, 'Strangospora senecionis Lambinon & Vezda', 'Strangospora', 'senecionis', NULL, 'sp.', 'Lambinon & Vezda', NULL, 'Acarosporaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111540, 425, 1, NULL, 'Usnea eulychinae Follmann', 'Usnea', 'eulychinae', NULL, 'sp.', 'Follmann', 'Follmann, G.', 'Parmeliaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111541, 879, 1, NULL, 'Usnea grandis Motyka', 'Usnea', 'grandis', NULL, 'sp.', 'Motyka', 'Motyka, J.', 'Parmeliaceae', 'LAMB, I. M. 1963. Index Nominum Lichenum. Ronald, New York.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111542, 1025, 1, NULL, 'Usnea pinnata Rsnen', 'Usnea', 'pinnata', NULL, 'sp.', 'Rsnen', 'Rsnen, V.', 'Parmeliaceae', 'LAMB, I. M. 1963. Index Nominum Lichenum. Ronald, New York.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111543, 3963, 1, NULL, 'Verrucaria hladuniana Nav.-Ros. & Cl. Roux', 'Verrucaria', 'hladuniana', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Verrucariaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111544, 3965, 1, NULL, 'Verrucaria hladuniana Nav.-Ros. & Cl. Roux', 'Verrucaria', 'hladuniana', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Verrucariaceae', 'SANTESSON, R. 1993. The lichens and lichenicolous fungi of Sweden and Norway. STB-forlaget, Lund, Sweden.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111545, 3966, 1, NULL, 'Verrucaria hladuniana Nav.-Ros. & Cl. Roux', 'Verrucaria', 'hladuniana', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Verrucariaceae', 'SANTESSON, R. 1993. The lichens and lichenicolous fungi of Sweden and Norway. STB-forlaget, Lund, Sweden.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111546, 13239, 1, NULL, 'Weddellomyces erythrocarpae Nav.-Ros. & Cl. Roux', 'Weddellomyces', 'erythrocarpae', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Dacampiaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111547, 13240, 1, NULL, 'Weddellomyces erythrocarpae Nav.-Ros. & Cl. Roux', 'Weddellomyces', 'erythrocarpae', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Dacampiaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111548, 13421, 1, NULL, 'Weddellomyces heterochrous Nav.-Ros. & Cl. Roux', 'Weddellomyces', 'heterochrous', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Dacampiaceae', 'LAMB, I. M. 1963. Index Nominum Lichenum. Ronald, New York.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111549, 13236, 1, NULL, 'Weddellomyces pachyosporicola Nav.-Ros. & Cl. Roux', 'Weddellomyces', 'pachyosporicola', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Dacampiaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111550, 13237, 1, NULL, 'Weddellomyces pachyosporicola Nav.-Ros. & Cl. Roux', 'Weddellomyces', 'pachyosporicola', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Dacampiaceae', 'LAMB, I. M. 1963. Index Nominum Lichenum. Ronald, New York.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111551, 13238, 1, NULL, 'Weddellomyces pachyosporicola Nav.-Ros. & Cl. Roux', 'Weddellomyces', 'pachyosporicola', NULL, 'sp.', 'Nav.-Ros. & Cl. Roux', NULL, 'Dacampiaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111552, 3200, 1, NULL, 'Xanthoparmelia cylindriloba M.D.E. Knox', 'Xanthoparmelia', 'cylindriloba', NULL, 'sp.', 'M.D.E. Knox', NULL, 'Parmeliaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111553, 4067, 1, NULL, 'Xanthoparmelia somlonsis (Gyeln.) Hale', 'Xanthoparmelia', 'somlonsis', NULL, 'sp.', '(Gyeln.) Hale', NULL, 'Parmeliaceae', 'SANTESSON, R. 1993. The lichens and lichenicolous fungi of Sweden and Norway. STB-forlaget, Lund, Sweden.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111554, 5287, 1, NULL, 'Xanthoria fulva (Hoffm.) Poelt & Petut.', 'Xanthoria', 'fulva', NULL, 'sp.', '(Hoffm.) Poelt & Petut.', 'Petutschnig, W.', 'Teloschistaceae', 'ZAHLBRUCKNER, A. 1921 - 1940. Catalogus Lichenum Universalis 1-1O. Borntraeger, Leipzig & Berlin.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111556, 14204, 1, '2003-09-16 00:00:00', 'Pelargonium acerifolium subsp. arbiales', 'Pelargonium', 'acerifolium', 'arbiales', 'subsp.', 'L.', 'A.Gentsch', 'Geraniaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
INSERT INTO "public"."identifications" ("ID", "UnitID", "PreferedFlag", "DateText", "NameAuthorYearString", "Genus", "FirstEpithet", "SecondEpithet", "Rank", "Author", "IdentificationAuthor", "HigherTaxon", "IdentificationRef") VALUES(111557, 14204, 0, '2001-09-16 00:00:00', 'Luzula acerifolium subsp. arbiales', 'Luzula', 'mirellis', NULL, 'sp.', 'J.Torre', 'J.Torre', 'Juncaceae', 'COMMONWEALTH MYCOLOGICAL INSTITUTE. 1971 onwards. Index of Fungi 4, 5. Kew.');
-- Dumping COLUMNS COMMENT



-- Dumping Table Triggers


--

-- Dumping Table: images
--
CREATE TABLE "public"."images" 
(
	"ID" int8 NOT NULL,
	"UnitID" int8,
	"FileURI" varchar(250),
	"ProductURI" varchar(255),
	"ImageTermsOfUse" text,
	CONSTRAINT "IX_images_pkey" PRIMARY KEY ("ID"),
	CONSTRAINT "FK_biocase_training_herbariumsheets_images" FOREIGN KEY ("UnitID") REFERENCES "images" ("UnitID")
);
CREATE INDEX "HerbariumSheetsImages" ON images USING btree ("UnitID");

-- Dumping Data
INSERT INTO "public"."images" ("ID", "UnitID", "FileURI", "ProductURI", "ImageTermsOfUse") VALUES(1, 14204, 'http://ww2.bgbm.org/herbarium/images/B/-W/12/46/B_-W_12469%20-02%200.JPG', 'http://ww2.bgbm.org/herbarium/view_biocase.cfm?SpecimenPK=31842', 'Access is granted under the following conditions:\r\nThe images may not passed on to any third party without our written consent and due mention of the copyright restrictions, and may not be used for commercial or non-scientific purposes. Reproduction in scientific publications is authorized on the condition that the source and the copyright are fully acknowledged:\r\n Botanischer Garten und Botanisches Museum Berlin-Dahlem, FU Berlin.');
-- Dumping COLUMNS COMMENT



-- Dumping Table Triggers



-- Dumping VIEWS

CREATE VIEW "information_schema"."applicable_roles" AS 
CREATE VIEW "information_schema"."check_constraints" AS 
CREATE VIEW "information_schema"."column_domain_usage" AS 
CREATE VIEW "information_schema"."column_privileges" AS 
CREATE VIEW "information_schema"."column_udt_usage" AS 
CREATE VIEW "information_schema"."columns" AS 
CREATE VIEW "information_schema"."constraint_column_usage" AS 
CREATE VIEW "information_schema"."constraint_table_usage" AS 
CREATE VIEW "information_schema"."data_type_privileges" AS 
CREATE VIEW "information_schema"."domain_constraints" AS 
CREATE VIEW "information_schema"."domain_udt_usage" AS 
CREATE VIEW "information_schema"."domains" AS 
CREATE VIEW "information_schema"."element_types" AS 
CREATE VIEW "information_schema"."enabled_roles" AS 
CREATE VIEW "information_schema"."information_schema_catalog_name" AS 
CREATE VIEW "information_schema"."key_column_usage" AS 
CREATE VIEW "information_schema"."parameters" AS 
CREATE VIEW "information_schema"."referential_constraints" AS 
CREATE VIEW "information_schema"."role_column_grants" AS 
CREATE VIEW "information_schema"."role_routine_grants" AS 
CREATE VIEW "information_schema"."role_table_grants" AS 
CREATE VIEW "information_schema"."role_usage_grants" AS 
CREATE VIEW "information_schema"."routine_privileges" AS 
CREATE VIEW "information_schema"."routines" AS 
CREATE VIEW "information_schema"."schemata" AS 
CREATE VIEW "information_schema"."table_constraints" AS 
CREATE VIEW "information_schema"."table_privileges" AS 
CREATE VIEW "information_schema"."tables" AS 
CREATE VIEW "information_schema"."triggered_update_columns" AS 
CREATE VIEW "information_schema"."triggers" AS 
CREATE VIEW "information_schema"."usage_privileges" AS 
CREATE VIEW "information_schema"."view_column_usage" AS 
CREATE VIEW "information_schema"."view_table_usage" AS 
CREATE VIEW "information_schema"."views" AS 

-- End of Database Dumping.